/**
 * \file
 *
 * \brief SAM D20ъ荞ײ
 *
 * 쌠 (c) 2013 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef SYSTEM_INTERRUPT_FEATURES_H_INCLUDED
#define SYSTEM_INTERRUPT_FEATURES_H_INCLUDED

#if !defined(__DOXYGEN__)

/* ^ꂽPʕ^ƎwWɑ΂Ċ荞޸\񋓈ꗗo^𐶐
   (Ⴆ΁A"SYSTEM_INTERRUPT_MODULE_TC0 = TC0_IRQn,") */
#  define _MODULE_IRQn(n, module) \
		SYSTEM_INTERRUPT_MODULE_##module##n = module##n##_IRQn,

/* I޲ŗ^ꂽPʕ^̑SĂ̎̂ɑ΂Ċ荞޸\񋓈ꗗo
   ^𐶐 */
#  define _SYSTEM_INTERRUPT_MODULES(name) \
		MREPEAT(name##_INST_NUM, _MODULE_IRQn, name)

#  define _SYSTEM_INTERRUPT_IPSR_MASK				0x0000003f
#  define _SYSTEM_INTERRUPT_PRIORITY_MASK			0x00000007

#  define _SYSTEM_INTERRUPT_EXTERNAL_VECTOR_START	0

#  define _SYSTEM_INTERRUPT_SYSTICK_PRI_POS			29
#endif

/**
 * \addtogroup asfdoc_sam0_system_interrupt_group
 * @{
 */

/**
 * \brief \ȼъ荞/O޸ԍ̕\
 *
 * SAMD20޲ŗp\ȑSĂ̊荞݂ƗO޸wW̕\
 */
#if defined(__DOXYGEN__)
/** \note ۂ̗񋓖"system_interrupt_vector"łB */
enum system_interrupt_vector_samd20 {
#else
enum system_interrupt_vector {
#endif
	SYSTEM_INTERRUPT_NON_MASKABLE		= NonMaskableInt_IRQn,	/**< NMI荞ݗp荞޸wW */
	SYSTEM_INTERRUPT_HARD_FAULT			= HardFault_IRQn,		/**< ʰޏQ Op荞޸wW */
	SYSTEM_INTERRUPT_SV_CALL			= SVCall_IRQn,			/**< ǗҌĂяoOp荞޸wW */
	SYSTEM_INTERRUPT_PENDING_SV			= PendSV_IRQn,			/**< ۗǗҊ荞ݗp荞޸wW */
	SYSTEM_INTERRUPT_SYSTICK			= SysTick_IRQn,			/** Interrupt vector index for a System Tick interrupt. */

	SYSTEM_INTERRUPT_MODULE_PM			= PM_IRQn,				/**< d͊ǗӋ@\荞ݗp荞޸wW */
	SYSTEM_INTERRUPT_MODULE_SYSCTRL		= SYSCTRL_IRQn,			/**< ѐӋ@\荞ݗp荞޸wW */
	SYSTEM_INTERRUPT_MODULE_WDT			= WDT_IRQn,				/**< ޯގӋ@\荞ݗp荞޸wW */
	SYSTEM_INTERRUPT_MODULE_RTC			= RTC_IRQn,				/**< ԸۯӋ@\荞ݗp荞޸wW */
	SYSTEM_INTERRUPT_MODULE_EIC			= EIC_IRQn,				/**< O荞ݎӋ@\荞ݗp荞޸wW */
	SYSTEM_INTERRUPT_MODULE_NVMCTRL		= NVMCTRL_IRQn,			/**< sؐ튄荞ݗp荞޸wW */
	SYSTEM_INTERRUPT_MODULE_EVSYS		= EVSYS_IRQn,			/**< ۼъ荞ݗp荞޸wW */
#if defined(__DOXYGEN__)
	/** SERCOMӋ@\荞ݗp荞޸wW
	 *
	 *  ̊e޲͂SERCOMӋ@\܂ނꂸAePʕ
	 *  ͓o^"n"ɑ΂đւ̔ԍƋɕ\łꎩg̓o^
	 *  (Ⴆ΁A\c SYSTEM_INTERRUPT_MODULE_SERCOM0)B
	 */
	SYSTEM_INTERRUPT_MODULE_SERCOMn		= SERCOMn_IRQn,
	/** /Ӌ@\荞݊荞޸wW
	 *
	 *  ̊e޲͂TCӋ@\܂ނꂸAePʕ͓̂o
	 *  ^"n"ɑ΂đւ̔ԍƋɕ\łꎩg̓o^܂
	 *  (Ⴆ΁A\c SYSTEM_INTERRUPT_MODULE_TC0)B
	 */
	SYSTEM_INTERRUPT_MODULE_TCn			= TCn_IRQn,
#else
	_SYSTEM_INTERRUPT_MODULES(SERCOM)
	_SYSTEM_INTERRUPT_MODULES(TC)
#endif
	SYSTEM_INTERRUPT_MODULE_AC			= AC_IRQn,				/**< ۸ޔrӋ@\荞ݗp荞޸wW */
	SYSTEM_INTERRUPT_MODULE_ADC			= ADC_IRQn,				/**< ADCӋ@\荞ݗp荞޸wW */
	SYSTEM_INTERRUPT_MODULE_DAC			= DAC_IRQn,				/**< DACӋ@\荞ݗp荞޸wW */
};

/** @} */

#endif
