/**
 * \file
 *
 * \brief SAM D20/D21/R21ݑdײ
 *
 * 쌠 (c) 2012 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef PINMUX_H_INCLUDED
#define PINMUX_H_INCLUDED

/**
 * \defgroup asfdoc_sam0_system_pinmux_group SAM D20/D21/R21 ݑdײ(SYSTEM PINMUX)
 *
 * SAM D20/D21/R21޲p̂ײނ͕Ɠ/쓮ς邽łȂ
 * ݎӋ@\dI`Ԑݒ肷邽߂́A޲̕II/Ǒ݂`Ԑݒ
 * Ǘp̲̪񋟂܂B
 *
 * ̒PʕɂĈȉ̎Ӌ@\gp܂B:
 *
 *  - PORT(߰I/OǗ)
 *
 * IɁA̒Pʕ͈ȉ̍\}Ŏ悤޲őݐڑ܂B:
 *
 * ̎̊Tv͎̒ʂłB:
 *  - \ref asfdoc_sam0_system_pinmux_prerequisites
 *  - \ref asfdoc_sam0_system_pinmux_module_overview
 *  - \ref asfdoc_sam0_system_pinmux_special_considerations
 *  - \ref asfdoc_sam0_system_pinmux_extra_info
 *  - \ref asfdoc_sam0_system_pinmux_examples
 *  - \ref asfdoc_sam0_system_pinmux_api_overview
 *
 *
 * \section asfdoc_sam0_system_pinmux_prerequisites OKv
 *
 * ̒Pʕɑ΂鎖OKv͂܂B
 *
 *
 * \section asfdoc_sam0_system_pinmux_module_overview PʕTv
 *
 * SAM D20/D21/R21޲͊Oтɑ΂Ďgp҉p_HƓʰ޳Ӌ@
 * \̪̂Ɏgp鑽̔ėpo݂܂݂܂Bݑd
 * (PINMUX)ײނ͑݋@\IԂ߂ɌݎӋ@\d`Ԑݒ肷
 * @񋟂܂B
 *
 * \subsection asfdoc_sam0_system_pinmux_physical_logical_pins IƘ_IGPIO
 * SAM D20/D21/R21޲޲̓o݂ɑ΂2̖KgpA1
 * ͕Ił1͘_IłB޲ꊇł̊e݂͕I߰Ă݂
 * ̎ʎq(Ⴆ΁A"PORTA.0")łȂAP̘_GPIOԍ(Ⴆ΁A
 * "GPIO0")ɂ蓖Ă܂BO҂I݂̕I޲P
 * ɒuŁAȑf̂߂ɂײނ̐݌v͑ɘ_IGPIO
 * gp܂B
 *
 * \subsection asfdoc_sam0_system_pinmux_peripheral_muxing Ӌ@\d
 * SAM D20/D21/R21޲޲̊eI/O݂ɑ΂ČʂɐłMUXӋ@\
 * ܂݂܂BMUXӋ@\͕Iȕ݂̋@\IԁAꂪgpҐ\
 * GPIO݂ƂĐ䂳邩ǂA܂͂ꂪI(I<SUP>2</SUP>CPʕ
 * 悤)̎Ӌ@\Pʕ1ɐڑ邩ǂA܂B݂
 * GPIOŌ`Ԑݒ肳ƁA݂ɐڑꂽ̎Ӌ@\͋֎~܂B
 *
 * \subsection asfdoc_sam0_system_pinmux_pad_characteristics ߯ޓ
 * ޲1ȏI/O݂őIԂƂł邢̓ꓮ삪A߯
 * ނ̓͂Əo͂̓ς܂B:
 *
 * \subsubsection asfdoc_sam0_system_pinmux_drive_strength 쓮\
 * 쓮\͂߯ނ̏o͋쓮̔\͂`Ԑݒ肵܂BʏAeI/O݂Sɋ
 * ł̓d܂AI/O߯ނ͑d͏
 * ]ɂĂI/O݂ɑ΂Ă̐𑝂荂쓮񋟂܂B
 *
 * \subsubsection asfdoc_sam0_system_pinmux_slew_rate حڰ
 * حڰĂ߯ޏo͓dԂƋɕωł鑬x𐧌Ao͋쓮̽ح
 * ڰĂ`Ԑݒ肵܂B
 *
 * \subsubsection asfdoc_sam0_system_pinmux_input_sample_mode ͍̎擮
 * ͍̎擮߯ނ͍̓̎敔ɏՕ`Ԑݒ肵܂BɂA͊ɏ
 * "߂ɉ"AAgp҉p͊ɏՕǂƂ鎞ɂ̎
 * ܂B͍̓łd͌IłA߰ ۯ2ۯɂē͍
 * ̒x𑝂܂Bx炷߁Aɓd͏]ɂĊe߰ ۯ
 * œ͊ɏՕɍ̎悷悤ɓ͍̎敔`Ԑݒ肷邱Ƃł
 * B
 *
 * \subsection asfdoc_sam0_system_pinmux_module_overview_physical IȐڑ
 *
 * \ref asfdoc_sam0_system_pinmux_intconnections "}"͂̒Pʕ޲
 * ǂݐڑ邩܂B:
 *
 * \anchor asfdoc_sam0_system_pinmux_intconnections
 * \dot
 * digraph overview {
 *   node [label="Port Pad" shape=square] pad;
 *
 *   subgraph driver {
 *     node [label="Peripheral Mux" shape=trapezium] pinmux;
 *     node [label="GPIO Module" shape=ellipse shape=ellipse style=filled fillcolor=lightgray] gpio;
 *     node [label="Other Peripheral Modules" shape=ellipse style=filled fillcolor=lightgray] peripherals;
 *   }
 *
 *   pinmux -> gpio;
 *   pad    -> pinmux;
 *   pinmux -> peripherals;
 * }
 * \enddot
 *
 * \section asfdoc_sam0_system_pinmux_special_considerations ʂȍl
 *
 * SAM D20/D21/R21߰ ݓ͍̎擮4̕Ǐ݂QŐݒ肳A8
 * I/O݂̕Q̂ǂ݂̍̎擮ݒQŜ̍̎擮`Ԑݒ肵܂B
 *
 * 쓮\͏o͋쓮޲̑S݂ŗp\ł͂ȂA޲ް
 * QƂĂB
 *
 *
 * \section asfdoc_sam0_system_pinmux_extra_info ǉ
 *
 * ǉɂĂ\ref asfdoc_sam0_system_pinmux_extraB
 * ȉ܂݂܂B
 *  - \ref asfdoc_sam0_system_pinmux_extra_acronyms
 *  - \ref asfdoc_sam0_system_pinmux_extra_dependencies
 *  - \ref asfdoc_sam0_system_pinmux_extra_errata
 *  - \ref asfdoc_sam0_system_pinmux_extra_history
 *
 *
 * \section asfdoc_sam0_system_pinmux_examples 
 *
 * ײނɊ֘ÄꗗɂĂ\ref asfdoc_sam0_system_pinmux_exqsg
 * B
 *
 *
 * \section asfdoc_sam0_system_pinmux_api_overview APITv
 * @{
 */

#include <compiler.h>

#ifdef __cplusplus
extern "C" {
#endif

/** ݂ɑ΂GPIOIԂ߂̎Ӌ@\dwW */
#define SYSTEM_PINMUX_GPIO		(1 << 7)

/**
 * \brief ߰ ݕ`Ԑݒ
 *
 * ݂gpׂ߰ ݌`Ԑݒ\̂̉\ݕݒp
 */
enum system_pinmux_pin_dir {
	SYSTEM_PINMUX_PIN_DIR_INPUT,				/**< ݓ͊ɏՕݏԂǂ߂悤ɋׂłB */
	SYSTEM_PINMUX_PIN_DIR_OUTPUT,				/**< ݓ͊ɏՕݏԂݒł(ǂǂݖ߂Ȃ)悤ɋׂłB */
	SYSTEM_PINMUX_PIN_DIR_OUTPUT_WITH_READBACK,	/**< ݓ͊ɏՕݏԂݒ肵ēǂݖ߂悤ɗׂłB */
};

/**
 * \brief ߰ ݓ͈݌`Ԑݒ
 *
 * ݂gp_و݂̌`߰ ݌`Ԑݒ݈ݐݒp
 * 
 */
enum system_pinmux_pin_pull {
	SYSTEM_PINMUX_PIN_PULL_NONE,	/**< _݂݂ɓKp܂B */
	SYSTEM_PINMUX_PIN_PULL_UP,		/**< ݂ͱَٱ߂ׂłB */
	SYSTEM_PINMUX_PIN_PULL_DOWN,	/**< ݂ͱَ޳ׂ݂łB */
};

/**
 * \brief ߰  ޼͍ٓ̎擮
 *
 * gp߰ ݍ̎̌`߰ ݌`Ԑݒ\̂ɑ΂͍̎擮p
 * 
 */
enum system_pinmux_pin_sample {
	SYSTEM_PINMUX_PIN_SAMPLE_CONTINUOUS,	/**< ݓ͊ɏՕ͌pIݏԂ̎悷ׂłB */
	SYSTEM_PINMUX_PIN_SAMPLE_ONDEMAND,		/**< ݓ͊ɏՕINڼ޽ǂ܂鎞ɋׂłB */
};

/**
 * \brief ߰ ݌`Ԑݒ\
 *
 * ߰ ݎ̗p`Ԑݒ\́B̍\͎̂gp҉pɂĕύXO
 * \ref system_pinmux_get_config_defaults()֐ɂďׂłB
 */
struct system_pinmux_config {
	/** Ӌ@\䂪]܂ꍇA̎Ӌ@\MUXwW݂𐧌䂷ׂ
	 *  BGPIOgpɂāA\ref SYSTEM_PINMUX_GPIOɐݒ肷ׂ
	 *  B */
	uint8_t mux_position;

	enum system_pinmux_pin_dir direction;	/**< ߰ĊɏՕ/o͕ */

	enum system_pinmux_pin_pull input_pull;	/**< ͊ɏՕ̘_و */

	/** ݂ł̉\ȍŒd͏Ԃ
	 *
	 *  \note ̑SĂ̌`Ԑݒ͖A݂͋֎~܂B
	 */
	bool powersave;
};

/** \name `ԐݒƏ
 * @{
 */

/**
 * \brief ߰ ݌`Ԑݒ\̂ɏ
 *
 * ^ꂽ߰ ݌`Ԑݒ\̂m̊l̑gɏ܂B̊֐
 * gp҉pɂĕύXOɂ̌`Ԑݒ\̂̐VSĂ̎̂Ō
 * ΂ׂłB
 *
 * `Ԑݒ͎̒ʂłB:
 *  \li 䂳Ӌ@\Ȃ(AGPIO)
 *  \li ꂽٱ߂͓
 *
 * \param[out]  config lɏ`Ԑݒ\
 */
static inline void system_pinmux_get_config_defaults(
		struct system_pinmux_config *const config)
{
	/*  */
	Assert(config);

	/* `Ԑݒl */
	config->mux_position = SYSTEM_PINMUX_GPIO;
	config->direction    = SYSTEM_PINMUX_PIN_DIR_INPUT;
	config->input_pull   = SYSTEM_PINMUX_PIN_PULL_UP;
	config->powersave    = false;
}

void system_pinmux_pin_set_config(
		const uint8_t gpio_pin,
		const struct system_pinmux_config *const config);

void system_pinmux_group_set_config(
		PortGroup *const port,
		const uint32_t mask,
		const struct system_pinmux_config *const config);

/** @} */

/** \name ꓮ`Ԑݒ(IȌQu)
 *  @{
 */

/**
 * \brief ^ꂽGPIOݔԍPORTPʕQ̂擾
 *
 * ^ꂽ_GPIOݔԍƒgPORTPʕQ̂擾܂B
 *
 * \param[in]  gpio_pin ϊGPIO݂̎wW
 *
 * \return gPORTPʕ̊ڽ
 */
static inline PortGroup* system_pinmux_get_group_from_gpio_pin(
		const uint8_t gpio_pin)
{
	uint8_t port_index  = (gpio_pin / 128);
	uint8_t group_index = (gpio_pin / 32);

	/* p\߰Ă̔z */
	Port *const ports[PORT_INST_NUM] = PORT_INSTS;

	if (port_index < PORT_INST_NUM) {
		return &(ports[port_index]->Group[group_index]);
	} else {
		Assert(false);
		return NULL;
	}
}

void system_pinmux_group_set_input_sample_mode(
		PortGroup *const port,
		const uint32_t mask,
		const enum system_pinmux_pin_sample mode);

/** @} */

/** \name ꓮ`Ԑݒ(_ݎu)
 *  @{
 */

/**
 * \brief _݂̌ݑI΂ꂽMUXʒu擾
 *
 * ^ꂽ_GPIO݂őI΂ĂMUCӋ@\擾܂B
 *
 * \param[in]  gpio_pin 擾GPIO݂̎wW
 *
 * \return w肵݂̌ݑI΂ĂӋ@\wW
 */
static inline uint8_t system_pinmux_pin_get_mux_position(
		const uint8_t gpio_pin)
{
	PortGroup *const port = system_pinmux_get_group_from_gpio_pin(gpio_pin);
	uint32_t pin_index = (gpio_pin % 32);

	if (!(port->PINCFG[pin_index].reg & PORT_PINCFG_PMUXEN)) {
		return SYSTEM_PINMUX_GPIO;
	}

	uint32_t pmux_reg = port->PMUX[pin_index / 2].reg;

	if (pin_index & 1) {
		return (pmux_reg & PORT_PMUX_PMUXO_Msk) >> PORT_PMUX_PMUXO_Pos;
	}
	else {
		return (pmux_reg & PORT_PMUX_PMUXE_Msk) >> PORT_PMUX_PMUXE_Pos;
	}
}

/**
 * \brief GPIO݂ɑ΂ē͍̎擮`Ԑݒ
 *
 * I/Oݒl̎悳ϲ ۰דŊi[鎞𐧌䂷邽߁AGPIO
 * ɑ΂͍̎擮`Ԑݒ肵܂B
 *
 * \param[in]  gpio_pin `Ԑݒ肷GPIO݂̎wW
 * \param[in]  mode     `Ԑݒ肷Vݍ̎擮
 */
static inline void system_pinmux_pin_set_input_sample_mode(
		const uint8_t gpio_pin,
		const enum system_pinmux_pin_sample mode)
{
	PortGroup* const port = system_pinmux_get_group_from_gpio_pin(gpio_pin);
	uint32_t pin_index = (gpio_pin % 32);

	if (mode == SYSTEM_PINMUX_PIN_SAMPLE_ONDEMAND) {
		port->CTRL.reg |= (1 << pin_index);
	} else {
		port->CTRL.reg &= ~(1 << pin_index);
	}
}

/** @} */

#ifdef __cplusplus
}
#endif

/** @} */

/**
 * \page asfdoc_sam0_system_pinmux_extra SYSTEM PINMUXײޗpǉ
 *
 * \section asfdoc_sam0_system_pinmux_extra_acronyms 
 * \͂̒PʕŎgp铪\܂B:
 *
 * <table>
 *	<tr>
 *		<th></th>
 *		<th></th>
 *	</tr>
 *	<tr>
 *		<td>GPIO</td>
 *		<td>ėpo(General Purpose Input/Output)</td>
 *	</tr>
 *	<tr>
 *		<td>MUX</td>
 *		<td>d(Multiplexer)</td>
 *	</tr>
 * </table>
 *
 *
 * \section asfdoc_sam0_system_pinmux_extra_dependencies ˑ
 * ײނ͈ȉ̈ˑ܂B
 *
 *  - Ȃ
 *
 *
 * \section asfdoc_sam0_system_pinmux_extra_errata Q
 * ײނɊ֘AQ͂܂B
 *
 *
 * \section asfdoc_sam0_system_pinmux_extra_history Pʕ
 * Pʕ̊Tv͏JPʕōsꂽƏC̏ڍׂƋɉ\ŕ\
 * ܂B̌ݔł͕\̍ŐVłɑΉ܂B
 *
 * <table>
 *	<tr>
 *		<th>ύXL^</th>
 *	</tr>
 *	<tr>
 *		<td> ڲ݁AحڰĐA쓮\͋@\̺ނ폜</td>
 *	</tr>
 *	<tr>
 *		<td>޲ڼ޽ɕsȌ`Ԑݒlꂽ̎擮֐
 *		    C</td>
 *	</tr>
 *	<tr>
 *		<td>PORTײފ֐ɑ΂Ď咣鎸ꂽNULL߲ǉ</td>
 *	</tr>
 *	<tr>
 *		<td>J</td>
 *	</tr>
 * </table>
 */

/**
 * \page asfdoc_sam0_system_pinmux_exqsg SYSTEM PINMUXײޗp
 *
 * \ref asfdoc_sam0_system_pinmux_groupɑ΂ėp\ȑJn̎
 * (QSG)Ɨ቞p̈ꗗłBQSG͎gpʂ̑Iłײނ`Ԑݒ肵Ďgp
 * 邽߂̒iKIȎwł̊ȒPȗłBQSG͓Ɨ^pƂĺ߲فA܂͎g
 * p҉pɒǉ邱Ƃł邱ƂɒӂĂB
 *
 *  - \subpage asfdoc_sam0_system_pinmux_basic_use_case
 *
 * \page asfdoc_sam0_system_pinmux_document_revision_history 
 *
 * <table>
 *	<tr>
 *		<th></td>
 *		<th>t</td>
 *		<th></td>
 *	</tr>
 *	<tr>
 *		<td>E</td>
 *		<td>2014N2</td>
 *		<td>SAMR21xǉ</td>
 *	</tr>
 *	<tr>
 *		<td>D</td>
 *		<td>2014N1</td>
 *		<td>SAMD21xǉ</td>
 *	</tr>
 *	<tr>
 *		<td>C</td>
 *		<td>2013N9</td>
 *		<td>޲ ݍ̎擮ɑ΂sȕC</td>
 *	</tr>
 *	<tr>
 *		<td>B</td>
 *		<td>2013N6</td>
 *		<td>AC</td>
 *	</tr>
 *	<tr>
 *		<td>A</td>
 *		<td>2013N6</td>
 *		<td>J</td>
 *	</tr>
 * </table>
 */

#endif
