/**
 * \file
 *
 * \brief SAM D20/D21/R21 TC - v/vĂі߂ײ
 *
 * 쌠 (c) 2013 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#include "tc_interrupt.h"

void *_tc_instances[TC_INST_NUM];

void _tc_interrupt_handler(uint8_t instance);

/**
 * \brief Ăі߂o^
 *
 * gp҂ɂĎꂽĂі߂֐o^܂B
 *
 * \note Ăі߂^ɑ΂Ɋ荞ݏĂԂ߂ɁAĂ
 *       ߂\ref tc_enable_callbackɂċȂ΂Ȃ܂B
 *
 * \param[in]  module        TCĳ̍\̂ւ̈ʒuwq
 * \param[in]  callback_func Ăі߂֐ւ̈ʒuwq
 * \param[in]  callback_type 񋓂ɂė^Ăі߂^
 */
enum status_code tc_register_callback(
		struct tc_module *const module,
		tc_callback_t callback_func,
		const enum tc_callback callback_type)
{
	/*  */
	Assert(module);
	Assert(callback_func);

	/* Ăі߂֐o^ */
	module->callback[callback_type] = callback_func;

	/* callback_typeɑΉޯĂݒ */
	if (callback_type == TC_CALLBACK_CC_CHANNEL0) {
		module->register_callback_mask |= TC_INTFLAG_MC(1);
	}
	else if (callback_type == TC_CALLBACK_CC_CHANNEL1) {
		module->register_callback_mask |= TC_INTFLAG_MC(2);
	}
	else {
		module->register_callback_mask |= (1 << callback_type);
	}
	return STATUS_OK;
}

/**
 * \brief Ăі߂o^
 *
 * gp҂ɂĎꂽĂі߂֐o^܂BĂі߂͂ꂪo^
 * Oɋ֎~ׂłB
 *
 * \param[in]  module        TCĳ̍\̂ւ̈ʒuwq
 * \param[in]  callback_type 񋓂ɂė^Ăі߂^
 */
enum status_code tc_unregister_callback(
		struct tc_module *const module,
		const enum tc_callback callback_type)
{
	/*  */
	Assert(module);

	/* Ăі߂֐o^ */
	module->callback[callback_type] = NULL;

	/* callback_typeɑΉޯĂ */
	if (callback_type == TC_CALLBACK_CC_CHANNEL0) {
		module->register_callback_mask &= ~TC_INTFLAG_MC(1);
	}
	else if (callback_type == TC_CALLBACK_CC_CHANNEL1) {
		module->register_callback_mask &= ~TC_INTFLAG_MC(2);
	}
	else {
		module->register_callback_mask &= ~(1 << callback_type);
	}
	return STATUS_OK;
}

/**
 * \internal TCpISR
 *
 * ޲̊eTCɑ΂銄荞ݏ̑g܂B
 */
#define _TC_INTERRUPT_HANDLER(n, m) \
		void TC##n##_Handler(void) \
		{ \
			_tc_interrupt_handler(m); \
		}

MRECURSION(TC_INST_NUM, _TC_INTERRUPT_HANDLER, TC_INST_MAX_ID)


/**
 * \internal TCPʕp荞ݏ
 *
 * ꂪN鎞Ɋ荞݂Ao^ċꂽĂі߂֐𑖂点
 * ܂B
 *
 * \param[in]  instance 荞ݏĂTĈID
 */
void _tc_interrupt_handler(
		uint8_t instance)
{
	/* ꎞϐ */
	uint8_t interrupt_and_callback_status_mask;

	/* Qƕ\޲̂擾 */
	struct tc_module *module
			= (struct tc_module *)_tc_instances[instance];

	/* 荞׸ ڼ޽ǂŎՕ */
	interrupt_and_callback_status_mask = module->hw->COUNT8.INTFLAG.reg &
			module->register_callback_mask &
			module->enable_callback_mask;

	/* ꊄ荞݂N */
	if (interrupt_and_callback_status_mask & TC_INTFLAG_OVF) {
		/* o^ċꂽĂі߂֐Ăяo */
		(module->callback[TC_CALLBACK_OVERFLOW])(module);
		/* 荞׸ނ */
		module->hw->COUNT8.INTFLAG.reg = TC_INTFLAG_OVF;
	}

	/* ُ튄荞݂N */
	if (interrupt_and_callback_status_mask & TC_INTFLAG_ERR) {
		/* o^ċꂽĂі߂֐Ăяo */
		(module->callback[TC_CALLBACK_ERROR])(module);
		/* 荞׸ނ */
		module->hw->COUNT8.INTFLAG.reg = TC_INTFLAG_ERR;
	}

	/* v/ߊl0荞݂N */
	if (interrupt_and_callback_status_mask & TC_INTFLAG_MC(1)) {
		/* o^ċꂽĂі߂֐Ăяo */
		(module->callback[TC_CALLBACK_CC_CHANNEL0])(module);
		/* 荞׸ނ */
		module->hw->COUNT8.INTFLAG.reg = TC_INTFLAG_MC(1);
	}

	/* v/ߊl1荞݂N */
	if (interrupt_and_callback_status_mask & TC_INTFLAG_MC(2)) {
		/* o^ċꂽĂі߂֐Ăяo */
		(module->callback[TC_CALLBACK_CC_CHANNEL1])(module);
		/* 荞׸ނ */
		module->hw->COUNT8.INTFLAG.reg = TC_INTFLAG_MC(2);
	}
}
