/**
 * \file
 *
 * \brief HAL(ʰ޳ۑw)
 *
 * 쌠 (c) 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#include "dali_top.h"
#include "dali_hal.h"

extern struct tc_module tc2_instance, tc3_instance;

void dali_hal_forward_enable_backward_disable(void)
{
	/* DALIް͌o */
	extint_chan_enable_callback(DALI_INPUT_EIC_LINE,
	EXTINT_CALLBACK_TYPE_DETECT);
	/* DALIް͌v֎~ */
	REG_TC0_INTENCLR |= 1<<TC_CALLBACK_OVERFLOW;
}

void dali_hal_forward_disable_backward_enable(void)
{
	/* DALIް͌o֎~ */
	extint_chan_disable_callback(DALI_INPUT_EIC_LINE,
			EXTINT_CALLBACK_TYPE_DETECT);
	/* DALIްo͌v틖 */		
	REG_TC0_INTENSET |= 1<<TC_CALLBACK_OVERFLOW;
}

void dali_hal_disable_fading_interrupt(void)
{
	/* TC2ꊄ荞݋֎~ */
	REG_TC2_INTENCLR |= 1<<TC_CALLBACK_OVERFLOW;
}

void dali_hal_enable_fading_interrupt(void)
{
	/* TC2ꊄ荞݋ */
	REG_TC2_INTENSET |= 1<<TC_CALLBACK_OVERFLOW;
}

bool dali_hal_get_dali_input_level(void)
{
	return (port_pin_get_input_level(DALI_INPUT_PIN));
}

void dali_hal_disable_frame_timer_interrupt(void)
{
	/* TC1ꊄ荞݋֎~ */
	REG_TC1_INTENCLR |= 1<<TC_CALLBACK_OVERFLOW;
}

void dali_hal_enable_frame_timer_interrupt(void)
{
	/* TC1ꊄ荞݋ */
	REG_TC1_INTENSET |= 1<<TC_CALLBACK_OVERFLOW;
}

void dali_hal_update_pwm_output(uint16_t pwm_value)
{
	/* TC2CC1lXV */
	tc_set_compare_value(&tc2_instance, 1, pwm_value);
}

uint32_t dali_hal_get_seed0_value(void)
{
	/* ƂTC2vڼ޽ */
	return tc_get_count_value(&tc2_instance);
}

uint32_t dali_hal_get_seed1_value(void)
{
	/* ƂTC3vڼ޽ */
	return tc_get_count_value(&tc3_instance);
}

uint8_t dali_hal_read_check_data(uint8_t logical_page, uint8_t *buffer, uint8_t size)
{
	return dali_read_check_eeprom(logical_page, buffer, size);
}