/**
 * \file
 *
 * \brief SAM D21/R21 TCC - 䉞ppv/v(񕜉\Q𔺂)Ăі߂֐
 *
 * 쌠 (c) 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

/**
 * \page asfdoc_sam0_tcc_faultn_use_case TCCpJn̎ - 񕜉\Q
 *
 * xĈꗗ:
 *    - SAM D21/R21 Xplained Pro
 *
 * ̎gpʂŁATCCޭè ىςPWMM𐶐̂Ɏgp܂B
 * ٽ͌vvݒ肵rlƈv鎞ɑ܂BPWMo
 * 𐧌䂷񕜉\Q͂ȀQ(Low)̎PWMo͓͂~
 * (ωȂON܂OFF)܂BQ(High)ƁAPWMo
 * ͂̌㓮ONɂȂ܂B
 *
 * PWMo͂LEDɐڑƁALEDɂ̌ς܂BQ͂tȂA
 * t鎞LED͓~ČωAtJɓONɂ
 * ܂BPWMg`݂邽߁A۽߂Kv܂B
 *
 * PWMo͂ƏQ̗͂lɍ\ݒ肳܂B:
 * <table>
 *  <tr><th>       </td><th> </td><th> ڑ </td></tr>
 *  <tr><td>SAMD21 Xpro</td><td>PB30</td><td>LED0    </td></tr>
 *  <tr><td>SAMD21 Xpro</td><td>PA15</td><td>SW0     </td></tr>
 *  <tr><td>SAMR21 Xpro</td><td>PA06</td><td>EXT13</td></tr>
 *  <tr><td>SAMR21 Xpro</td><td>PA28</td><td>SW0     </td></tr>
 * </table>
 *
 * TCCPʕ͎̗lɍ\ݒ肳܂B:
 * - GCLK0(GCLK)ۯ
 * - APIʂTOPArAlݒ肷鎞2dɏՏ݂gp
 * - v܂͔rłިނȂ
 * - OuȂ
 * - PXPWMg`
 * - GCLKĐݒ芈
 * - ޲ősȂB
 * - g`gȂ
 * - g`o͂̔]Ȃ
 * - ߊlȂ
 * - ㏸v
 * - PsȂ
 * - 0ۂĎۓ͂Ȃ
 * - ۊȂ
 * - ېȂ
 * - 0ŌvJn
 * - 񕜉\QA0ۓ͂琶AQ~Ϳĳ~ƂēA
 *   ̊CӑI͑Sċ֎~܂B
 *
 * \section asfdoc_sam0_tcc_faultn_use_case_setup Jn
 *
 * \subsection asfdoc_sam0_tcc_faultn_use_case_prereq OKv
 * ̎gpʂɂĎOKv͂܂B
 *
 * \subsection asfdoc_sam0_tcc_faultn_use_case_setup_code 
 *
 * gp鷯Ăɏ]āAǂ̊֐ɂ旧Ď剞p ̧Ɉȉǉ܂B:
 * - SAM D21 Xplained Pro:
 *   \snippet samd21_xplained_pro/conf_quick_start_faultn.h definition_pwm
 *   \snippet samd21_xplained_pro/conf_quick_start_faultn.h definition_fault
 * - SAM R21 Xplained Pro:
 *   \snippet samd21_xplained_pro/conf_quick_start_faultn.h definition_pwm
 *   \snippet samd21_xplained_pro/conf_quick_start_faultn.h definition_fault
 *
 * ǂ̊֐ɂ旧Ď剞p ̧Ɉȉǉ܂B:
 * \snippet qs_tcc_faultn.c additional_include
 *
 * ̊֐̊Oňȉ剞p ̧قɒǉ܂B:
 * \snippet qs_tcc_faultn.c module_inst
 * \snippet qs_tcc_faultn.c events_resource
 *
 * ȉ̌Ăі߂֐ނgp҉pɕ/\t܂B:
 * \snippet qs_tcc_faultn.c callback_funcs
 * \snippet qs_tcc_faultn.c callback_eic
 *
 * ȉ̍\ݒ躰ނgp҉pɕ/\t܂B:
 * \snippet qs_tcc_faultn.c setup
 * \snippet qs_tcc_faultn.c config_eic
 * \snippet qs_tcc_faultn.c config_event
 *
 * gp҉p(ʓI\c main()̎n)ɒǉ܂B
 * \snippet qs_tcc_faultn.c setup_init
 *
 * \subsection asfdoc_sam0_tcc_faultn_use_case_setup_flow Ƃ̗
 * \subsubsection asfdoc_sam0_tcc_faultn_use_case_setup_flow_tcc TCC`Ԑݒ
 * -# ꂪgpԂTCCײނ̏Ԃi[邽߂TCCPʕpPʕĳ
 *    ̍\̂쐬܂B
 *    \snippet qs_tcc_faultn.c module_inst
 *    \note ͒PʕgpĂ茈ĉ͈͊OɂȂׂł͂
 *          ܂Bwǂ̏ꍇł͑SłB
 *
 * -# ITCCӋ@\̌`Ԑݒ𒲐邽߂ɋL邱ƂłTCCP
 *    `Ԑݒ\̂쐬܂B
 *    \snippet qs_tcc_faultn.c setup_config
 * -# Pʕ̊lTCC`Ԑݒ\̂܂B
 *    \snippet qs_tcc_faultn.c setup_config_defaults
 *    \note ͑SĂ̒lm̊lɏ邱Ƃۏ؂邽߂Ɍ`
 *          ݒ\̂ĝɐ旧ďɎsׂłB
 *
 * -# v핝Ag`Ar0lAQCӐݒ`Ԑݒ肷悤TCC
 *    ݒς܂Bŉ񕜉\Q͂AQ(~Ԃ
 *    ̂ɿĳgpȂ΂ȂȂ)ĳɐݒ肳܂B
 *    \snippet qs_tcc_faultn.c setup_change_config
 *    \snippet qs_tcc_faultn.c setup_change_config_faults
 * -# ޲ ݂łPWMo͂`Ԑݒ肷悤TCCݒς܂B
 *    \snippet qs_tcc_faultn.c setup_change_config_pwm
 * -# ]ސݒTCCPʕ`Ԑݒ肵܂B
 *    \snippet qs_tcc_faultn.c setup_set_config
 *
 * -# ۂ/֎~Ďېݒ`Ԑݒ肽߂ɋL邱ƂłTCCی`
 *    Ԑݒ\̂쐬܂BSĂ̗̈0ؾĂ܂B
 *    \snippet qs_tcc_faultn.c setup_events
 * -# ېCӑIύXĎۊύX邽߂ɁA]ސݒ/֎~
 *    悤TCCۂς܂Bَ0͂񕜉\Q̋Ƃ
 *    ċ܂B
 *    \snippet qs_tcc_faultn.c setup_change_events_faults
 * -# ېݒēKp܂B
 *    \snippet qs_tcc_faultn.c setup_events_enable
 *
 * -# vJnPWMMn߂邽߂TCCPʕ܂B
 *    \snippet qs_tcc_faultn.c setup_enable
 *
 *  -# ײނŔr0vĂі߂֐o^܂B
 *    \snippet qs_tcc_faultn.c setup_register_callback
 *  -# K؂ȎײނɂČĂ΂悤ɔr0vĂі߂܂B
 *    \snippet qs_tcc_faultn.c setup_enable_callback
 *
 * \subsubsection asfdoc_sam0_tcc_faultn_use_case_setup_flow_eic Q͗pEXTINT`Ԑݒ
 * -# PO荞ق̌`Ԑݒ𒲐̂ɋL邱ƂłEXTINTP
 *    ʕٌ`Ԑݒ\̂쐬܂B
 *    \snippet qs_tcc_faultn.c eic_setup_1
 * -# Pʕ̊lٌ`Ԑݒ\̂܂B
 *    \snippet qs_tcc_faultn.c eic_setup_2
 *    \note ͑SĂ̒lm̊lɏ邱Ƃۏ؂邽߂Ɍ`
 *          ݒ\̂ĝɐ旧ďɎsׂłB
 *
 * -# (]ޕ݂_قɔz邽߂)MUX̖tɌ`Ԑݒ肵A㏸
 *    Ɖ~̗[o߂ق`Ԑݒ肷悤Ɍ`Ԑݒ\̂𒲐
 *    B
 *    \snippet qs_tcc_faultn.c eic_setup_3
 * -# ]ِݒŊO荞ق`Ԑݒ肵܂B
 *    \snippet qs_tcc_faultn.c eic_setup_4
 *
 * -# ۂ/֎~邽߂ɋL邱ƂłEXTINTی`Ԑݒ\̂
 *    ܂BSĂ̗̈0ؾĂ܂B
 *    \snippet qs_tcc_faultn.c eic_event_setup_1
 * -# `Ԑݒ\̂𒲐ċق\c trueɐݒ肵܂BŊ
 *    tɑ΂قgp܂B
 *    \snippet qs_tcc_faultn.c eic_event_setup_2
 * -# ۂ܂B
 *    \snippet qs_tcc_faultn.c eic_event_setup_3
 *
 * -# ۔oɎnEXTINTĂі߂`܂B̗ɂĂ͏
 *    Q鎞TCCQԂPWMONɂȂ悤ɉ܂B
 *    \snippet qs_tcc_faultn.c callback_eic
 * -# O荞ݐ(EIC)̌o邽߂
 *    \c eic_callback_to_clear_halt()Ăі߂֐o^܂B
 *    \snippet qs_tcc_faultn.c eic_callback_setup_1
 * -# ق[oɒPʕɂČĂ΂悤Ɍ`Ԑݒ肵O荞
 *    قɑ΂ēo^Ăі߂֐܂B
 *    \snippet qs_tcc_faultn.c eic_callback_setup_2
 *
 * \subsubsection asfdoc_sam0_tcc_faultn_use_case_setup_flow_evt Q͗pEVSYS`Ԑݒ
 * -# i[邽߂EVSYSPʕpێ̍\̂쐬܂B
 *    \snippet qs_tcc_faultn.c events_resource
 *    \note ͒PʕgpĂ茈ĉ͈͊OɂȂׂł͂
 *          ܂Bwǂ̏ꍇł͑SłB
 * -# Pꎖق̌`Ԑݒ𒲐邽߂ɋL邱Ƃł鎖ٌ`Ԑ
 *    \̂쐬܂B
 *    \snippet qs_tcc_faultn.c event_setup_1
 *  -# Pʕ̊lŎٌ`Ԑݒ\̂܂B
 *    \snippet qs_tcc_faultn.c event_setup_2
 *    \note ͑SĂ̒lm̊lɏ邱Ƃۏ؂邽߂Ɍ`
 *          ݒ\̂ĝɐ旧ďɎsׂłB
 *
 * -# w肵ېɎtقƎgp񓯊یoHv
 *    邽߂Ɍ`Ԑݒ\̂𒲐܂BŊ̖tɐڑEICق͎
 *    ېłB
 *    \snippet qs_tcc_faultn.c event_setup_3
 * -# `Ԑݒ\̂pق蓖ĂČ`Ԑݒ肵܂B
 *    \snippet qs_tcc_faultn.c event_setup_4
 *    \note ݒ肩ςꂽǂ̒lgp҉pɂčlA
 *          ̌`Ԑݒ\̂Ďgp邩܂B
 *
 * -# gpقɎt܂BŎgp͉񕜉\Q̓͂ƂČ`Ԑ
 *    肳ꂽTCC0ۂłB
 *    \snippet qs_tcc_faultn.c event_setup_5
 *
 * \section asfdoc_sam0_tcc_faultn_use_case_main gp
 *
 * \subsection asfdoc_sam0_tcc_faultn_use_case_main_code 
 * ȉ̺ނgp҉pɕ/\t܂B:
 * \snippet qs_tcc_callback.c main
 *
 * \subsection asfdoc_sam0_tcc_faultn_use_case_main_flow Workflow
 * -# TCCPʕoRPWMg`ԖJԂɈڍs܂B
 *  \snippet qs_tcc_callback.c main_loop
 */


#include <asf.h>
#include <conf_clocks.h>