/**
 * \file
 *
 * \brief SAM D21/R21 TCC - 䉞ppv/vײ
 *
 * 쌠 (c) 2013 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#include "tcc.h"

#if TCC_ASYNC == true
#  include "tcc_callback.h"
#  include <system_interrupt.h>

/** \internal
 * ^ꂽTCwW̊荞޸wWɕϊ
 */
#  define _TCC_INTERRUPT_VECT_NUM(n, unused) \
		SYSTEM_INTERRUPT_MODULE_TCC##n,
#endif

#define _SIZE_MAX(size) ((size==32u) ? 0xFFFFFFFF : ( \
		(1u << size) - 1))

#define _SIZE_MAX_WITH_DITHER 0x03FFFFFF

/* gx蓖ޯ */
#define _TCC_DITHERING_B				16u
#define _TCC_PG_B						8u
#define _TCC_SWAP_B						4u
#define _TCC_DTI_B						2u
#define _TCC_OTMX_B						1u

#if !defined(__DOXYGEN__)

#  define _TCC_GCLK_ID(n,unused)		TPASTE3(TCC,n,_GCLK_ID),
#  define _TCC_PM_APBCMASK(n,unused)	TPASTE2(PM_APBCMASK_TCC,n),

#  define _TCC_SIZE(n,unused)			TPASTE3(TCC,n,_SIZE),
#  define _TCC_MAX(n,unused)			_SIZE_MAX(TPASTE3(TCC,n,_SIZE)),
#  define _TCC_EXT(n,unused)			TPASTE3(TCC,n,_EXT),
#  define _TCC_CC_NUM(n,unused)			min(TPASTE3(TCC,n,_CC_NUM),TCC_NUM_CHANNELS),
#  define _TCC_OW_NUM(n,unused)			min(TPASTE3(TCC,n,_OW_NUM),TCC_NUM_WAVE_OUTPUTS),

#  define TCC_GCLK_IDS					{ MREPEAT(TCC_INST_NUM, _TCC_GCLK_ID, 0) }
#  define TCC_PM_APBCMASKS				{ MREPEAT(TCC_INST_NUM, _TCC_PM_APBCMASK, 0) }

#  define TCC_SIZES						{ MREPEAT(TCC_INST_NUM, _TCC_SIZE, 0) }
#  define TCC_MAXS						{ MREPEAT(TCC_INST_NUM, _TCC_MAX, 0) }
#  define TCC_EXTS						{ MREPEAT(TCC_INST_NUM, _TCC_EXT, 0) }
#  define TCC_CC_NUMS					{ MREPEAT(TCC_INST_NUM, _TCC_CC_NUM, 0) }
#  define TCC_OW_NUMS					{ MREPEAT(TCC_INST_NUM, _TCC_OW_NUM, 0) }

#endif

/* p\TCCPʕ̈ꗗ */
const Tcc *const tcc_modules[TCC_INST_NUM] = TCC_INSTS;

/* TCC GCLK ID̈ꗗ */
const uint8_t _tcc_gclk_ids[TCC_INST_NUM] = TCC_GCLK_IDS;

/* TCC PM APBCՕ̈ꗗ */
const uint32_t _tcc_pm_apbcmasks[TCC_INST_NUM] = TCC_PM_APBCMASKS;

/* TCCPʕ̊gẍꗗ */
const uint8_t _tcc_exts[TCC_INST_NUM] = TCC_EXTS;

/* TCCPʕ̑傫ẍꗗ. */
const uint8_t _tcc_sizes[TCC_INST_NUM] = TCC_SIZES;

/* TCCPʕ̎xől̈ꗗ. */
const uint32_t _tcc_maxs[TCC_INST_NUM] = TCC_MAXS;

/* TCCPʕ̗p\ٔԍ̈ꗗ */
const uint8_t _tcc_cc_nums[TCC_INST_NUM] = TCC_CC_NUMS;

/* TCCPʕ̗p\ȏo͔ԍ̈ꗗ */
const uint8_t _tcc_ow_nums[TCC_INST_NUM] = TCC_OW_NUMS;

/**
 * \internal ^ꂽTCCPʕ̂̎wWB
 *
 * \param[in]  hw TCCPʕ̈ʒuwq
 *
 * \return ^ꂽTCCPʕ̂̎wW
 */
uint8_t _tcc_get_inst_index(
		Tcc *const hw)
{
	/* TCC̗pwWB */
	for (uint32_t i = 0; i < TCC_INST_NUM; i++) {
		if (hw == tcc_modules[i]) {
			return i;
		}
	}

	/* ^ꂽް */
	Assert(false);
	return 0;
}

/**
 * \brief \ߒ`ꂽlŌ`Ԑݒ
 *
 * ̊֐͗^ꂽTCC`Ԑݒ\̂m̊l̑gɏ܂B
 * ֐͎gp҉pɂĕύXOɌ`Ԑݒ\̂̐Vǂ̎̂łĂ
 * ׂłB
 *
 * `Ԑݒ͎̒ʂłB:
 *  \li ޲ősȂB
 *  \li APIɂTOPArAlݒ莞2dɏՏ݂sB
 *  \li {IȌv/v`Ԑݒ:
 *     - GCLK0ۯ
 *     - OuȂ
 *     - GCLKĐݒ芈
 *     - ㏸v
 *     - PsȂB
 *     - 0ŌvJn
 *     - /TOPl͍őɐݒ
 *  \li r/ߊl`Ԑݒ:
 *     - SĂ̔r/ߊlْl0ɐݒ
 *     - ߊlȂ(Sقr@\Ɏgp)
 *     - Wgg`
 *     - g`ɐ0ɐݒ
 *     - XONg`sȂB
 *  \li g`g`Ԑݒ:
 *     - 񕜉\Q͋ꂸAQ͋֎~Ahg0ɐݒ
 *     - 񕜕s\Qԏo͂͋ꂸAhg0
 *     - g`o͂̔]ȂB
 *  \li ُo͂Ȃ
 *  \li PWMo͂Ȃ
 *  \li ݂MUX̌`Ԑݒݒ肵ȂB
 *
 * \param[out]  config ݒ肷TCCPʕ`Ԑݒ\
 * \param[in]   hw     TCCʰ޳Pʕւ̈ʒuwq
 *
 */
void tcc_get_config_defaults(
		struct tcc_config *const config,
		Tcc *const hw)
{
	/* TCC̎wW */
	uint8_t module_index = _tcc_get_inst_index(hw);

	/* {v */
	config->counter.count                  = 0;

	config->counter.period                 = _tcc_maxs[module_index];

	config->counter.clock_source           = GCLK_GENERATOR_0;
	config->counter.clock_prescaler        = TCC_CLOCK_PRESCALER_DIV1;
	config->counter.reload_action          = TCC_RELOAD_ACTION_GCLK;

	config->counter.direction              = TCC_COUNT_DIRECTION_UP;
	config->counter.oneshot                = false;

	/* r/ߊl */
#  define _TCC_CHANNEL_MATCH_VALUE_INIT(n, value) \
		config->compare.match[n] = value;
	MREPEAT(TCC_NUM_CHANNELS,
		_TCC_CHANNEL_MATCH_VALUE_INIT, 0)
#  undef _TCC_CHANNEL_MATCH_VALUE_INIT

	/* g`ɐ */
#  define _TCC_CHANNEL_WAVE_POLARITY_INIT(n, value) \
		config->compare.wave_polarity[n] = value;
	MREPEAT(TCC_NUM_CHANNELS,
		_TCC_CHANNEL_WAVE_POLARITY_INIT, TCC_WAVE_POLARITY_0)
#  undef _TCC_CHANNEL_WAVE_POLARITY_INIT

	config->compare.wave_generation = TCC_WAVE_GENERATION_NORMAL_FREQ;
	config->compare.wave_ramp       = TCC_RAMP_RAMP1;

#  define _TCC_CHANNEL_FUNCTION_INIT(n, value) \
		config->compare.channel_function[n] = value;
	MREPEAT(TCC_NUM_CHANNELS,
			_TCC_CHANNEL_FUNCTION_INIT, TCC_CHANNEL_FUNCTION_COMPARE)
#  undef _TCC_CHANNEL_FUNCTION_INIT

	/* 񕜉\Q */
#  define _TCC_FAULT_FUNCTION_INIT(n, dummy) \
		config->wave_ext.recoverable_fault[n].filter_value = 0;      \
		config->wave_ext.recoverable_fault[n].blanking_cycles = 0;   \
		config->wave_ext.recoverable_fault[n].restart = false;       \
		config->wave_ext.recoverable_fault[n].keep = false;          \
		config->wave_ext.recoverable_fault[n].qualification = false; \
		config->wave_ext.recoverable_fault[n].source = TCC_FAULT_SOURCE_DISABLE;           \
		config->wave_ext.recoverable_fault[n].blanking = TCC_FAULT_BLANKING_DISABLE;       \
		config->wave_ext.recoverable_fault[n].halt_action = TCC_FAULT_HALT_ACTION_DISABLE; \
		config->wave_ext.recoverable_fault[n].capture_action = TCC_FAULT_CAPTURE_DISABLE;  \
		config->wave_ext.recoverable_fault[n].capture_channel = TCC_FAULT_CAPTURE_CHANNEL_0;
	MREPEAT(TCC_NUM_FAULTS, _TCC_FAULT_FUNCTION_INIT, 0)
#  undef _TCC_FAULT_FUNCTION_INIT

	/* 񕜕s\Q */
#  define _TCC_NRF_FUNCTION_INIT(n, dummy) \
		config->wave_ext.non_recoverable_fault[n].filter_value = 0; \
		config->wave_ext.non_recoverable_fault[n].output = TCC_FAULT_STATE_OUTPUT_OFF;
	MREPEAT(TCC_NUM_WAVE_OUTPUTS, _TCC_NRF_FUNCTION_INIT, 0)
#  undef _TCC_NRF_FUNCTION_INIT

	/* o͔] */
#  define _TCC_OUT_INVERT_INIT(n, value) \
		config->wave_ext.invert[n] = value;
	MREPEAT(TCC_NUM_WAVE_OUTPUTS, _TCC_OUT_INVERT_INIT, false)
#  undef _TCC_OUT_INVERT_INIT

#  define _TCC_CHANNEL_OUT_PIN_INIT(n, dummy) \
		config->pins.enable_wave_out_pin[n]                = false;\
		config->pins.wave_out_pin[TCC_WAVE_OUTPUT_##n]     = 0;    \
		config->pins.wave_out_pin_mux[TCC_WAVE_OUTPUT_##n] = 0;
	MREPEAT(TCC_NUM_WAVE_OUTPUTS, _TCC_CHANNEL_OUT_PIN_INIT, 0)
#  undef _TCC_CHANNEL_OUT_PIN_INIT

	config->double_buffering_enabled  = true;
	config->run_in_standby            = false;
}


/**
 * \brief `Ԑݒ肩CTRLAڼ޽l\z
 *
 * \param[in]   module_index ĳPʕ̎wW
 * \param[in]   config       TCC`ԐݒCӑI\̂ւ̈ʒuwq
 * \param[out]  value_buffer \zlŖɏՕւ̈ʒuwq
 *
 * \return `ԐݒmF
 *
 * \retval STATUS_OK              `Ԑݒl͗ǍDڼ޽l͍\zĊɏՕɕ
 *                                
 * \retval STATUS_ERR_INVALID_ARG Ұ: 蓖Ăꂽިޓ삪P
 *                                ʕɑ΂Ė; gpߊlقPʕ
 *                                ΂Ė
 */
static inline enum status_code _tcc_build_ctrla(
		const uint8_t module_index,
		const struct tcc_config *const config,
		uint32_t *value_buffer)
{
	uint32_t ctrla = 0;

	int i;
	for (i = 0; i < TCC_NUM_CHANNELS; i ++) {
		if (config->capture.channel_function[i] ==
			TCC_CHANNEL_FUNCTION_CAPTURE) {

			if (i > _tcc_cc_nums[module_index]) {
				/* xȂ */
				return STATUS_ERR_INVALID_ARG;
			}
			ctrla |= (TCC_CTRLA_CPTEN0 << i);
		}
	}

	if (config->run_in_standby) {
		ctrla |= TCC_CTRLA_RUNSTDBY;
	}
	ctrla |= config->counter.reload_action << TCC_CTRLA_PRESCSYNC_Pos;
	ctrla |= config->counter.clock_prescaler << TCC_CTRLA_PRESCALER_Pos;

	*value_buffer = ctrla;
	return STATUS_OK;
}

/**
 * \brief `Ԑݒ肩CTRLBڼ޽l\z
 *
 * \param[in]   module_index ĳPʕ̎wW
 * \param[in]   config       TCC`ԐݒCӑI\̂ւ̈ʒuwq
 * \param[out]  value_buffer \zlŖɏՕւ̈ʒuwq
 */
static inline void _tcc_build_ctrlb(
		const uint8_t module_index,
		const struct tcc_config *const config,
		uint8_t *value_buffer)
{
	uint8_t ctrlb = 0;

	if (config->counter.oneshot) {
		ctrlb |= TCC_CTRLBSET_ONESHOT;
	}
	if (config->counter.direction == TCC_COUNT_DIRECTION_DOWN) {
		ctrlb |= TCC_CTRLBSET_DIR;
	}

	*value_buffer = ctrlb;
}

/**
 * \brief `Ԑݒ肩FAULTx޽l\z
 *
 * \param[in]  module_index ĳPʕ̎wW
 * \param[in]  config       TCC`ԐݒCӑI\̂ւ̈ʒuwq
 * \param[out] value_buffer \zlŖɏՕւ̈ʒuwqs
 *
 * \retval STATUS_OK              `Ԑݒl͗ǍDڼ޽l͍\zĊɏՕɕ
 *                                
 * \retval STATUS_ERR_INVALID_ARG Ұ: 蓖ĂꂽQߊl
 *                                ; 蓖Ăꂽhgl
 */
static inline enum status_code _tcc_build_faults(
		const uint8_t module_index,
		const struct tcc_config *const config,
		uint32_t *value_buffer)
{
	struct tcc_recoverable_fault_config *cfg;
	uint8_t cc_num = _tcc_cc_nums[module_index];
	uint32_t fault;
	int i;
	for (i = 0; i < TCC_NUM_FAULTS; i ++) {
		cfg = (struct tcc_recoverable_fault_config *)
				&config->wave_ext.recoverable_fault[i];
		if (cfg->capture_channel >= cc_num) {
			return STATUS_ERR_INVALID_ARG;
		}
		if (cfg->filter_value > 0xF) {
			return STATUS_ERR_INVALID_ARG;
		}
		fault = TCC_FCTRLA_FILTERVAL(cfg->filter_value)
				| TCC_FCTRLA_BLANKVAL(cfg->blanking_cycles)
				| (cfg->restart ? TCC_FCTRLA_RESTART : 0)
				| (cfg->keep ? TCC_FCTRLA_KEEP : 0)
				| (cfg->qualification ? TCC_FCTRLA_QUAL : 0)
				| TCC_FCTRLA_SRC(cfg->source)
				| TCC_FCTRLA_BLANK(cfg->blanking)
				| TCC_FCTRLA_HALT(cfg->halt_action)
				| TCC_FCTRLA_CAPTURE(cfg->capture_action)
				| TCC_FCTRLA_CHSEL(cfg->capture_channel);
		value_buffer[i] = fault;
	}
	return STATUS_OK;
}

/**
 * \brief `Ԑݒ肩DRVCTRL޽l\z
 *
 * \param[in]  module_index ĳPʕ̎wW
 * \param[in]  config       TCC`ԐݒCӑI\̂ւ̈ʒuwq
 * \param[out] value_buffer \zlŖɏՕւ̈ʒuwq
 *
 * \retval STATUS_OK              `Ԑݒl͗ǍDڼ޽l͍\zĊɏՕɕ
 *                                
 * \retval STATUS_ERR_INVALID_ARG Ұ: 蓖Ăꂽo͐;
 *                                hgl
 */
static inline enum status_code _tcc_build_drvctrl(
		const uint8_t module_index,
		const struct tcc_config *const config,
		uint32_t *value_buffer)
{
	uint32_t i;
	uint8_t ow_num = _tcc_ow_nums[module_index];
	uint32_t drvctrl;

	drvctrl = 0;

	for (i = 0; i < TCC_NUM_WAVE_OUTPUTS; i ++) {
		if (config->wave_ext.invert[i]) {
			if (i >= ow_num) {
				return STATUS_ERR_INVALID_ARG;
			}
			drvctrl |= (TCC_DRVCTRL_INVEN0 << i);
		}
		if (config->wave_ext.non_recoverable_fault[i].output !=
			TCC_FAULT_STATE_OUTPUT_OFF) {
			if (i >= ow_num) {
				return STATUS_ERR_INVALID_ARG;
			}
			if (config->wave_ext.non_recoverable_fault[i].output ==
				TCC_FAULT_STATE_OUTPUT_1) {
				drvctrl |= (TCC_DRVCTRL_NRE0 | TCC_DRVCTRL_NRV0) << i;
			} else {
				drvctrl |= (TCC_DRVCTRL_NRE0) << i;
			}
		}
	}
	*value_buffer = drvctrl;
	return STATUS_OK;
}

/**
 * \brief `Ԑݒ肩WAVEWAVEB̼޽l\z
 *
 * \param[in]  module_index ĳPʕ̎wW
 * \param[in]  config       TCC`ԐݒCӑI\̂ւ̈ʒuwq
 * \param[out] value_buffer \zlŖɏՕւ̈ʒuwq
 *
 * \retval STATUS_OK              `Ԑݒl͗ǍDڼ޽l͍\zĊɏՕɕ
 *                                
 * \retval STATUS_ERR_INVALID_ARG Ұ: 蓖Ăꂽo͐;
 *                                zƊɏՂՓ; 蓖Ăꂽ֐Pʕ
 *                                ŎxȂ
 */
static inline enum status_code _tcc_build_waves(
		const uint8_t module_index,
		const struct tcc_config *const config,
		uint32_t *value_buffer)
{
	int n;

	uint8_t cc_num = _tcc_cc_nums[module_index];
	struct tcc_match_wave_config const *wav_cfg = &config->compare;

	uint32_t wave;

	wave = TCC_WAVE_RAMP(wav_cfg->wave_ramp) |
			TCC_WAVE_WAVEGEN(wav_cfg->wave_generation);

	for (n = 0; n < TCC_NUM_CHANNELS; n++) {
		if (wav_cfg->wave_polarity[n]) {
			if (n >= cc_num) {
				return STATUS_ERR_INVALID_ARG;
			}
			wave |= (TCC_WAVE_POL0 << n);
		}
	}

	value_buffer[0] = wave;

	return STATUS_OK;
}

/**
 * \brief ʰ޳TCCPʕ̂
 *
 * ^ꂽ`ԐݒlɊÂĸۯė^ꂽTCCPʕ
 * B
 *
 * \param[in,out]  module_inst ĳPʕ̍\̂ւ̈ʒuwq
 * \param[in]      hw          TCCʰ޳Pʕւ̈ʒuwq
 * \param[in]      config      TCC`ԐݒCӑI\̂ւ̈ʒuwq
 *
 * \return 葱̏
 *
 * \retval STATUS_OK          Pʕ͐ɏ܂B
 * \retval STATUS_BUSY        葱݂ꂽʰ޳Pʕ͑Z
 *                            B
 * \retval STATUS_INVALID_ARG Ȍ`ԐݒCӑI܂͈܂B
 * \retval STATUS_ERR_DENIED  ʰ޳PʕɋĂ܂B
 */
enum status_code tcc_init(
		struct tcc_module *const module_inst,
		Tcc *const hw,
		const struct tcc_config *const config)
{
	int i;

	/*  */
	Assert(hw);
	Assert(module_inst);
	Assert(config);

	/* TCC̎wW */
	uint8_t module_index = _tcc_get_inst_index(hw);

	/* PMŎgpҲ̪ ۯ */
	system_apb_clock_set_mask(SYSTEM_CLOCK_APB_APBC,
			_tcc_pm_apbcmasks[module_index]);

	/* ꂪĂ邩 */
	if (hw->CTRLA.reg & TCC_CTRLA_ENABLE) {
		return STATUS_ERR_DENIED;
	}
	/* ꂪؾĂĂ邩 */
	if (hw->CTRLA.reg & TCC_CTRLA_SWRST) {
		return STATUS_ERR_DENIED;
	}

	enum status_code status;

	/* COUNT,PER,CCx */
	uint32_t count_max  = _tcc_maxs[module_index];

	/* Svl𒲍 */
	if ((config->counter.count > count_max)
		|| (config->counter.period > count_max)
		) {
		return STATUS_ERR_INVALID_ARG;
	}

	/* Sْl𒲍 */
	for (i = 0; i < TCC_NUM_CHANNELS; i ++) {
		if ((config->compare.match[i] > count_max)
			) {
			return STATUS_ERR_INVALID_ARG;
		}
	}

	/* So͂𒲍 */
	for (i = 0; i < TCC_NUM_WAVE_OUTPUTS; i ++) {
		if (!config->pins.enable_wave_out_pin[i]) {
			continue;
		}
		/* o͐xȂB */
		if (i >= _tcc_ow_nums[module_index]) {
			return STATUS_ERR_INVALID_ARG;
		}
	}

	/* CTRLAݒ */
	uint32_t ctrla = 0;
	status = _tcc_build_ctrla(module_index, config, &ctrla);
	if (STATUS_OK != status) {
		return status;
	}

	/* CTRLBݒ */
	uint8_t ctrlb;
	_tcc_build_ctrlb(module_index, config, &ctrlb);

	/* FAULTsݒ */
	uint32_t faults[TCC_NUM_FAULTS];

	status = _tcc_build_faults(module_index, config, faults);
	if (STATUS_OK != status) {
		return status;
	}

	/* DRVCTRL */
	uint32_t drvctrl = 0;

	status = _tcc_build_drvctrl(module_index, config, &drvctrl);
	if (STATUS_OK != status) {
		return status;
	}

	/* WAVE */
	uint32_t waves[1];

	status = _tcc_build_waves(module_index, config, waves);
	if (STATUS_OK != status) {
		return status;
	}

	/* Pʕ */
#if TCC_ASYNC
	/* Ұ */
	for (i = 0; i < TCC_CALLBACK_N; i ++) {
		module_inst->callback[i] = NULL;
	}
	module_inst->register_callback_mask = 0;
	module_inst->enable_callback_mask = 0;
	_tcc_instances[module_index] = module_inst;
#endif

	module_inst->hw = hw;

	module_inst->double_buffering_enabled = config->double_buffering_enabled;

	/* Pʕpۯ\ݒ */
	struct system_gclk_chan_config gclk_chan_config;
	system_gclk_chan_get_config_defaults(&gclk_chan_config);
	gclk_chan_config.source_generator = config->counter.clock_source;
	system_gclk_chan_set_config(_tcc_gclk_ids[module_index], &gclk_chan_config);
	system_gclk_chan_enable(_tcc_gclk_ids[module_index]);

	/* ݏ */
	struct system_pinmux_config pin_config;
	for (i = 0; i <  _tcc_ow_nums[module_index]; i ++) {
		if (!config->pins.enable_wave_out_pin[i]) {
			continue;
		}

		system_pinmux_get_config_defaults(&pin_config);
		pin_config.mux_position = config->pins.wave_out_pin_mux[i];
		pin_config.direction = SYSTEM_PINMUX_PIN_DIR_OUTPUT;
		system_pinmux_pin_set_config(
				config->pins.wave_out_pin[i], &pin_config);
	}

	/* ڼ޽֏ */

	hw->CTRLA.reg = ctrla;
	while (hw->SYNCBUSY.reg & TCC_SYNCBUSY_CTRLB) {
		/* ҂ */
	}

	hw->CTRLBCLR.reg = 0xFF;
	while (hw->SYNCBUSY.reg & TCC_SYNCBUSY_CTRLB) {
		/* ҂ */
	}
	hw->CTRLBSET.reg = ctrlb;

	hw->FCTRLA.reg = faults[0];
	hw->FCTRLB.reg = faults[1];

	hw->DRVCTRL.reg = drvctrl;

	while (hw->SYNCBUSY.reg & (TCC_SYNCBUSY_WAVE | TCC_SYNCBUSY_WAVEB)) {
		/* ҂ */
	}
	hw->WAVE.reg = waves[0];

	while (hw->SYNCBUSY.reg & TCC_SYNCBUSY_COUNT) {
		/* ҂ */
	}
	hw->COUNT.reg = config->counter.count;

	while (hw->SYNCBUSY.reg & (TCC_SYNCBUSY_PER | TCC_SYNCBUSY_PERB)) {
		/* ҂ */
	}
	hw->PER.reg = (config->counter.period);

	for (i = 0; i <  _tcc_cc_nums[module_index]; i ++) {
		while (hw->SYNCBUSY.reg & (
			(TCC_SYNCBUSY_CC0 | TCC_SYNCBUSY_CCB0) << i)) {
			/* ҂ */
		}
		hw->CC[i].reg = (config->compare.match[i]);
	}

	return STATUS_OK;
}


/**
 * \brief TCCPʕۓ͂܂͏o͂
 *
 * TCCPʕɑ΂1ȏ̎ۂ̓͂܂͏o͂܂B
 * ̒Pʕx鎖ۂ̈ꗗɂĂ\ref tcc_eventsB
 *
 * \note PʕĂԁAۂ͕ς邱Ƃł܂B
 *
 * \param[in]  module_inst ĳPʕ̍\̂ւ̈ʒuwq
 * \param[in]  events      ܂͌`Ԗ肷鎖ۂ׸ނ܂ލ\
 *
 * \return ۍ\ݒ葱̏
 *
 * \retval STATUS_OK          Pʕ͐ɏ܂B
 * \retval STATUS_INVALID_ARG Ȍ`ԐݒCӑI܂͈܂B
 */
enum status_code tcc_enable_events(
		struct tcc_module *const module_inst,
		struct tcc_events *const events)
{
	/*  */
	Assert(module_inst);
	Assert(module_inst->hw);
	Assert(events);

	Tcc *const tcc_module = module_inst->hw;

	/* ꂪ܂ؾĂĂ邩 */
	if (tcc_module->CTRLA.reg & (TCC_CTRLA_ENABLE | TCC_CTRLA_SWRST)) {
		return STATUS_ERR_DENIED;
	}

	uint32_t evctrl = tcc_module->EVCTRL.reg;

	/* ۏo͊\ݒ */
	if (events->output_config.modify_generation_selection) {
		evctrl &= ~ TCC_EVCTRL_CNTSEL_Msk;
		switch(events->output_config.generation_selection) {
		case TCC_EVENT_GENERATION_SELECTION_START:
			evctrl |= TCC_EVCTRL_CNTSEL_START;
			break;
		case TCC_EVENT_GENERATION_SELECTION_END:
			evctrl |= TCC_EVCTRL_CNTSEL_END;
			break;
		case TCC_EVENT_GENERATION_SELECTION_BETWEEN:
			evctrl |= TCC_EVCTRL_CNTSEL_BETWEEN;
			break;
		case TCC_EVENT_GENERATION_SELECTION_BOUNDARY:
			evctrl |= TCC_EVCTRL_CNTSEL_BOUNDARY;
			break;
		default:
			Assert(false);
			/* sȍ\ݒ */
			return STATUS_ERR_INVALID_ARG;
		}
	}
	/* ͎0\ݒ */
	if (events->on_input_event_perform_action[0]) {
		evctrl |= TCC_EVCTRL_TCEI0;
	}
	if (events->input_config[0].invert) {
		evctrl |= TCC_EVCTRL_TCINV0;
	}
	if (events->input_config[0].modify_action) {
		evctrl &= ~ TCC_EVCTRL_EVACT0_Msk;
		switch(events->input_config[0].action) {
		case TCC_EVENT0_ACTION_OFF:
			evctrl |= TCC_EVCTRL_EVACT0_OFF;
			break;
		case TCC_EVENT0_ACTION_RETRIGGER:
			evctrl |= TCC_EVCTRL_EVACT0_RETRIGGER;
			break;
		case TCC_EVENT0_ACTION_COUNT_EVENT:
			evctrl |= TCC_EVCTRL_EVACT0_COUNTEV;
			break;
		case TCC_EVENT0_ACTION_START:
			evctrl |= TCC_EVCTRL_EVACT0_START;
			break;
		case TCC_EVENT0_ACTION_INCREMENT:
			evctrl |= TCC_EVCTRL_EVACT0_INC;
			break;
		case TCC_EVENT0_ACTION_COUNT_DURING_ACTIVE:
			evctrl |= TCC_EVCTRL_EVACT0_COUNT;
			break;
		case TCC_EVENT0_ACTION_NON_RECOVERABLE_FAULT:
			evctrl |= TCC_EVCTRL_EVACT0_FAULT;
			break;
		default:
			Assert(false);
			/* sȍ\ݒ */
			return STATUS_ERR_INVALID_ARG;
		}
	}
	/* ͎1\ݒ */
	if (events->on_input_event_perform_action[1]) {
		evctrl |= TCC_EVCTRL_TCEI1;
	}
	if (events->input_config[1].invert) {
		evctrl |= TCC_EVCTRL_TCINV1;
	}
	if (events->input_config[1].modify_action) {
		evctrl &= ~ TCC_EVCTRL_EVACT1_Msk;
		switch(events->input_config[1].action) {
		case TCC_EVENT1_ACTION_OFF:
			evctrl |= TCC_EVCTRL_EVACT1_OFF;
			break;
		case TCC_EVENT1_ACTION_RETRIGGER:
			evctrl |= TCC_EVCTRL_EVACT1_RETRIGGER;
			break;
		case TCC_EVENT1_ACTION_DIR_CONTROL:
			evctrl |= TCC_EVCTRL_EVACT1_DIR;
			break;
		case TCC_EVENT1_ACTION_STOP:
			evctrl |= TCC_EVCTRL_EVACT1_STOP;
			break;
		case TCC_EVENT1_ACTION_DECREMENT:
			evctrl |= TCC_EVCTRL_EVACT1_DEC;
			break;
		case TCC_EVENT1_ACTION_PERIOD_PULSE_WIDTH_CAPTURE:
			evctrl |= TCC_EVCTRL_EVACT1_PPW |
					TCC_EVCTRL_MCEI0 | TCC_EVCTRL_MCEI1;
			break;
		case TCC_EVENT1_ACTION_PULSE_WIDTH_PERIOD_CAPTURE:
			evctrl |= TCC_EVCTRL_EVACT1_PWP |
					TCC_EVCTRL_MCEI0 | TCC_EVCTRL_MCEI1;
			break;
		case TCC_EVENT1_ACTION_NON_RECOVERABLE_FAULT:
			evctrl |= TCC_EVCTRL_EVACT1_FAULT;
			break;
		default:
			Assert(false);
			/* sȍ\ݒ */
			return STATUS_ERR_INVALID_ARG;
		}
	}
	uint32_t ch;
	for(ch = 0; ch < TCC_NUM_CHANNELS; ch ++) {
		if (events->generate_event_on_channel[ch]) {
			evctrl |= (TCC_EVCTRL_MCEO(1) << ch);
		}
		if (events->on_event_perform_channel_action[ch]) {
			evctrl |= (TCC_EVCTRL_MCEI(1) << ch);
		}
	}
	if (events->generate_event_on_counter_overflow) {
		evctrl |= TCC_EVCTRL_OVFEO;
	}
	if (events->generate_event_on_counter_retrigger) {
		evctrl |= TCC_EVCTRL_TRGEO;
	}
	if (events->generate_event_on_counter_event) {
		evctrl |= TCC_EVCTRL_CNTEO;
	}

	tcc_module->EVCTRL.reg = evctrl;

	return STATUS_OK;
}

/**
 * \brief TCĈ̎ۂ̓͂܂͏o͂֎~
 *
 * ^ꂽTCCPʕɑ΂1ȏ̓͂܂͏o͂̎ۂ֎~܂B
 * ̒Pʕx鎖ۂ̈ꗗɂĂ\ref tcc_eventsB
 *
 * \note PʕĂԁAۂ͕ς邱Ƃł܂B
 *
 * \param[in]  module_inst ĳPʕ̍\̂ւ̈ʒuwq
 * \param[in]  events      ֎~鎖ۂ׸ނ܂ލ\
 */
void tcc_disable_events(
		struct tcc_module *const module_inst,
		struct tcc_events *const events)
{
	/*  */
	Assert(module_inst);
	Assert(module_inst->hw);
	Assert(events);

	Tcc *const tcc_module = module_inst->hw;

	/* ܂ؾĂĂ邩 */
	if (tcc_module->CTRLA.reg & (TCC_CTRLA_ENABLE | TCC_CTRLA_SWRST)) {
		return;
	}


	uint32_t evctrl = 0;
	uint32_t ch;
	for(ch = 0; ch < TCC_NUM_CHANNELS; ch ++) {
		if (events->generate_event_on_channel[ch]) {
			evctrl |= (TCC_EVCTRL_MCEO(1) << ch);
		}
		if (events->on_event_perform_channel_action[ch]) {
			evctrl |= (TCC_EVCTRL_MCEI(1) << ch);
		}
	}
	if (events->generate_event_on_counter_overflow) {
		evctrl |= TCC_EVCTRL_OVFEO;
	}
	if (events->generate_event_on_counter_retrigger) {
		evctrl |= TCC_EVCTRL_TRGEO;
	}
	if (events->generate_event_on_counter_event) {
		evctrl |= TCC_EVCTRL_CNTEO;
	}
	if (events->on_input_event_perform_action[0]) {
		evctrl |= TCC_EVCTRL_TCEI0;
	}
	if (events->on_input_event_perform_action[1]) {
		evctrl |= TCC_EVCTRL_TCEI1;
	}
	if (events->input_config[0].invert) {
		evctrl |= TCC_EVCTRL_TCINV0;
	}
	if (events->input_config[1].invert) {
		evctrl |= TCC_EVCTRL_TCINV1;
	}

	tcc_module->EVCTRL.reg &= ~evctrl;
}



/**
 * \brief ^ꂽTCCPʕɑ΂Čvlݒ
 *
 * TCCPʕ̌vvlݒ肵܂Bw肵TCCPʕ͑s܂
 * ~ɗ܂邱Ƃł܂B
 *
 * \param[in]  module_inst ĳPʕ̍\̂ւ̈ʒuwq
 * \param[in]  count       ݒ肷Vvvl
 *
 * \return Vlݒ肳ꂽǂ
 *
 * \retval STATUS_OK              vv͐ɍXV܂B
 * \retval STATUS_ERR_INVALID_ARG Ȍvv̑傫w肳܂B
 */
enum status_code tcc_set_count_value(
		const struct tcc_module *const module_inst,
		const uint32_t count)
{
	/*  */
	Assert(module_inst);
	Assert(module_inst->hw);

	/* Pʕʰ޳̂ւ̈ʒuwq擾 */
	Tcc *const tcc_module = module_inst->hw;
	/* Pʕ̎wW擾 */
	uint8_t module_index = _tcc_get_inst_index(tcc_module);

	uint32_t max_count = _tcc_maxs[module_index];

	if (count > max_count) {
		return STATUS_ERR_INVALID_ARG;
	}

	while (tcc_module->SYNCBUSY.bit.COUNT) {
		/* ҂ */
	}

	/* TCCިނɊÂď */
	tcc_module->COUNT.reg = (count);

	return STATUS_OK;
}

/**
 * \brief ^ꂽTCCPʕ̌vl擾
 *
 * TCCPʕ݂̌̌vl擾܂Bw肵TCCPʕ͑s܂͒~ɗ
 * 邱Ƃł܂B
 *
 * \param[in] module_inst ĳPʕ̍\̂ւ̈ʒuwq
 *
 * \return w肵TCCPʕ̌vl
 */
uint32_t tcc_get_count_value(
		const struct tcc_module *const module_inst)
{
	/*  */
	Assert(module_inst);
	Assert(module_inst->hw);

	/* Pʕʰ޳̂ւ̈ʒuwq擾*/
	Tcc *const tcc_module = module_inst->hw;
	uint32_t last_cmd;

	/* Ō̎wߏI҂ */
	do {
		while (tcc_module->SYNCBUSY.bit.CTRLB) {
			/* ҂ */
		}
		last_cmd = tcc_module->CTRLBSET.reg & TCC_CTRLBSET_CMD_Msk;
		if (TCC_CTRLBSET_CMD_NONE == last_cmd) {
			/* ǂݍݎwߔsƒf */
			tcc_module->CTRLBSET.bit.CMD = TCC_CTRLBSET_CMD_READSYNC_Val;
			break;
		} else if (TCC_CTRLBSET_CMD_READSYNC == last_cmd) {
			/* wߔsς */
			break;
		}
	} while (1);

	while (tcc_module->SYNCBUSY.bit.COUNT) {
		/* ҂ */
	}
	return (tcc_module->COUNT.reg);
}



/**
 * \brief TCCPʕߊll擾
 *
 * ꂽTCCPʕߊlق̕ߊll擾
 *
 * \param[in]  module_inst   ĳPʕ̍\̂ւ̈ʒuwq
 * \param[in]  channel_index ǂޔr/ߊlق̎wW
 *
 * \return w肵vقɊi[ꂽߊll
 */
uint32_t tcc_get_capture_value(
		const struct tcc_module *const module_inst,
		const enum tcc_match_capture_channel channel_index)
{
	/*  */
	Assert(module_inst);
	Assert(module_inst->hw);

	Assert(channel_index < _tcc_cc_nums[_tcc_get_inst_index(module_inst->hw)]);

	/* Pʕʰ޳̂ւ̈ʒuwq擾 */
	Tcc *const tcc_module = module_inst->hw;

	while(tcc_module->SYNCBUSY.reg  & (TCC_SYNCBUSY_CC0 << channel_index)) {
		/* ҂ */
	}

	return tcc_module->CC[channel_index].reg;
}

/**
 * \internal
 * \brief TCCPʕrl/ɏՕݒ
 *
 * ^ꂽTCCPʕr/ߊlق܂͊ɏՕɔrl܂B
 *
 * \param[in]  module_inst              ĳPʕ̍\̂ւ̈ʒuwq
 * \param[in]  channel_index            rق̎wW
 * \param[in]  compare                  ݒ肷Vrl/ɏՒl
 * \param[in]  double_buffering_enabled CCBxɏɂ\c trueɐݒ
 *
 * \return rXV葱̏
 *
 * \retval  STATUS_OK              rl͐ɍXV܂B
 * \retval  STATUS_ERR_INVALID_ARG َwWꂽA܂͕@\𒴂
 *                                 rl
 */
static enum status_code _tcc_set_compare_value(
		const struct tcc_module *const module_inst,
		const enum tcc_match_capture_channel channel_index,
		const uint32_t compare,
		const bool double_buffering_enabled)
{
	/*  */
	Assert(module_inst);
	Assert(module_inst->hw);

	/* Pʕʰ޳̂ւ̈ʒuwq擾 */
	Tcc *const tcc_module = module_inst->hw;
	/* Pʕ̎wW擾 */
	uint8_t module_index = _tcc_get_inst_index(tcc_module);

	/* wW */
	if (channel_index >= _tcc_cc_nums[module_index]) {
		return STATUS_ERR_INVALID_ARG;
	}

	uint32_t max_count = _tcc_maxs[module_index];

	/* rl */
	if (compare > max_count) {
		return STATUS_ERR_INVALID_ARG;
	}

	if (double_buffering_enabled) {
		while(tcc_module->SYNCBUSY.reg  &
				(TCC_SYNCBUSY_CCB0 << channel_index)) {
			/* ҂ */
		}
		tcc_module->CCB[channel_index].reg = compare;
	} else {
		while(tcc_module->SYNCBUSY.reg  & (TCC_SYNCBUSY_CC0 << channel_index)) {
			/* ҂ */
		}
		tcc_module->CC[channel_index].reg = compare;
	}
	return STATUS_OK;
}


/**
 * \brief TCCPʕrlݒ
 *
 * ^ꂽTCCPʕr/ߊlقɔrl܂B
 *
 * 2dɏՂꍇA͏Ɋɏڼ޽ɏ܂Bl͂̌
 * \ref tcc_force_double_buffer_update()ĂԂƂɂĒɍXV邩A
 * ܂͍XV{ޯĂUPDATENɍXV܂B
 *
 * \param[in]  module_inst   ĳPʕ̍\̂ւ̈ʒuwq
 * \param[in]  channel_index rق̎wW
 * \param[in]  compare       ݒ肷Vrl
 *
 * \return rXV葱̏
 *
 * \retval  STATUS_OK              rl͐ɍXV܂B
 * \retval  STATUS_ERR_INVALID_ARG sَwWꂽA@\𒴂
 *                                 rl
 */
enum status_code tcc_set_compare_value(
		const struct tcc_module *const module_inst,
		const enum tcc_match_capture_channel channel_index,
		const uint32_t compare)
{
	/*  */
	Assert(module_inst);

	return _tcc_set_compare_value(module_inst, channel_index, compare,
			module_inst->double_buffering_enabled);
}

/**
 * \brief TCCPʕrlƊɏՒlݒ
 *
 * rlƊɏՕ^ꂽTCCPʕr/ߊlقɏ܂BʏA2dɏ՗p
 * A܂͏z2dɏ(zɏ)̂߂łB
 *
 * \param[in]  module_inst    ĳPʕ̍\̂ւ̈ʒuwq
 * \param[in]  channel_index  rق̎wW
 * \param[in]  compare        ݒ肷Vrl
 * \param[in]  compare_buffer ݒ肷VrɏՒl
 *
 * \return rXV葱̏
 *
 * \retval  STATUS_OK              rl͐ɍXV܂B
 * \retval  STATUS_ERR_INVALID_ARG sَwWꂽA@\𒴂
 *                                 rl
 */
enum status_code tcc_set_double_buffer_compare_values(
		struct tcc_module *const module_inst,
		const enum tcc_match_capture_channel channel_index,
		const uint32_t compare, const uint32_t compare_buffer)
{
	/*  */
	Assert(module_inst);

	enum status_code status;
	status = _tcc_set_compare_value(module_inst, channel_index, compare, false);
	if (status != STATUS_OK) {
		return status;
	}
	return _tcc_set_compare_value(module_inst, channel_index, compare_buffer,
			true);
}


/**
 * \internal
 * \brief vTOP/PERIODɏՒlݒ
 *
 * ̊֐͗^ꂽlPER/PERBڼ޽ɏ܂B
 *
 * \param[in]  module_inst              ĳPʕ̍\̂ւ̈ʒuwq
 * \param[in]  top_value                PER/PERBڼ޽ɐݒ肷Vl
 * \param[in]  double_buffering_enabled PERBɏɂ\c trueݒ
 *
 * \return TOPݒ葱̏
 *
 * \retval STATUS_OK              vTOPl͐ɍXV܂B
 * \retval STATUS_ERR_INVALID_ARG sَwWꂽA@\𒴂
 *                                TOP/l
 */
static enum status_code _tcc_set_top_value(
		const struct tcc_module *const module_inst,
		const uint32_t top_value,
		const bool double_buffering_enabled)
{
	/*  */
	Assert(module_inst);
	Assert(module_inst->hw);

	/* Pʕʰ޳̂ւ̈ʒuwq擾 */
	Tcc *const tcc_module = module_inst->hw;
	/* Pʕ̎wW擾 */
	uint8_t module_index = _tcc_get_inst_index(tcc_module);

	uint32_t max_count = _tcc_maxs[module_index];

	/* rl */
	if (top_value > max_count) {
		return STATUS_ERR_INVALID_ARG;
	}

	if (double_buffering_enabled) {
		while(tcc_module->SYNCBUSY.reg  & TCC_SYNCBUSY_PERB) {
			/* ҂ */
		}
		tcc_module->PERB.reg = top_value;
	} else {
		while(tcc_module->SYNCBUSY.reg  & TCC_SYNCBUSY_PER) {
			/* ҂ */
		}
		tcc_module->PER.reg = top_value;
	}
	return STATUS_OK;
}


/**
 * \brief vTOP/PERIODɏՒlݒ
 *
 * ̊֐͗^ꂽlPER/PERBڼ޽ɏ܂B
 *
 * 2dɏՂꍇA͏Ɋɏڼ޽ɏ܂Bl͂̌
 * \ref tcc_force_double_buffer_update()ĂԂƂɂĒɍXV邩A
 * ܂͍XV{ޯĂUPDATENɍXV܂B
 *
 * MFRQgpATOPlCC0ڼ޽lɂĒ`APERl͖A]Ă̏
 * ɎۂTOPlύXɂ͂̊֐̑ 
 * \ref tcc_set_compare_value(module,channel_0,value)gpȂ΂Ȃ܂
 * B̑SĂ̔g`ɂTOPlPERڼ޽lɂĒ`܂B
 *
 * \param[in]  module_inst  ĳPʕ̍\̂ւ̈ʒuwq
 * \param[in]  top_value    PER/PERBڼ޽ɐݒ肷Vl
 *
 * \return TOPݒ葱̏
 *
 * \retval STATUS_OK              vTOPl͐ɍXV܂B
 * \retval STATUS_ERR_INVALID_ARG sَwWꂽA@\𒴂
 *                                TOP/l
 */
enum status_code tcc_set_top_value(
		const struct tcc_module *const module_inst,
		const uint32_t top_value)
{
	/*  */
	Assert(module_inst);

	return _tcc_set_top_value(module_inst, top_value,
			module_inst->double_buffering_enabled);
}

/**
 * \brief vTOP/PERIODlƊɏՒlݒ
 *
 * ̊֐͗^ꂽlPERPERBڼ޽ɏ܂BʏAʏA2dɏ՗p
 * A܂͏z2dɏ(zɏ)̂߂łB
 *
 * MFRQgpATOPlCC0CCB0ɂĒ`APERPERB̒l͖A]
 * Ă̏ꍇɎۂTOPlύXɂ͂̊֐̑ 
 * \ref tcc_set_double_buffer_compare_values(module,channel_0,value,buffer)g
 * pȂ΂Ȃ܂B̑SĂ̔g`ɂTOPlPERPERBڼ޽
 * lɂĒ`܂B
 *
 * \param[in]  module_inst      ĳPʕ̍\̂ւ̈ʒuwq
 * \param[in]  top_value        PERڼ޽ɐݒ肷Vl
 * \param[in]  top_buffer_value PERBڼ޽ɐݒ肷Vl
 *
 * \return TOPݒ葱̏
 *
 * \retval STATUS_OK              vTOPl͐ɍXV܂B
 * \retval STATUS_ERR_INVALID_ARG sَwWꂽA@\𒴂
 *                                TOP/l
 */
enum status_code tcc_set_double_buffer_top_values(
		const struct tcc_module *const module_inst,
		const uint32_t top_value, const uint32_t top_buffer_value)
{
	/*  */
	Assert(module_inst);

	enum status_code status;
	status = _tcc_set_top_value(module_inst, top_value, false);
	if (status != STATUS_OK) {
		return status;
	}
	return _tcc_set_top_value(module_inst, top_buffer_value, true);
}


/**
 * \brief TCCPʕg`o͗lݒ
 *
 * w肵l(0,1܂͌󂻂̂܂)𐶐悤ɔg`o͐܂B
 *
 * 2dɏՂꍇAɊɏڼ޽ɏ܂Bl͂̌
 * \ref tcc_force_double_buffer_update()ĂяoɂĒɍXV邩A
 * ͍XV{ޯĂUPDATEԂNɍXV܂B
 *
 * \param[in]  module_inst ĳPʕ̍\̂ւ̈ʒuwq
 * \param[in]  line_index  o͐wW
 * \param[in]  pattern     gpo͗l(\ref tcc_output_pattern)
 *
 * \return lݒ葱̏
 *
 * \retval  STATUS_OK              PATT޽͐ɍXV܂B
 * \retval  STATUS_ERR_INVALID_ARG ȐwW܂B
 */
enum status_code tcc_set_pattern(
		const struct tcc_module *const module_inst,
		const uint32_t line_index,
		const enum tcc_output_pattern pattern)
{
	/*  */
	Assert(module_inst);
	Assert(module_inst->hw);

	/* Pʕʰ޳̂ւ̈ʒuwq擾 */
	Tcc *const tcc_module = module_inst->hw;
	/* Pʕ̎wW擾 */
	uint8_t module_index = _tcc_get_inst_index(tcc_module);
	/* o͐擾 */
	uint8_t ow_num = _tcc_ow_nums[module_index];

	/* ԍOK */
	if (line_index >= ow_num) {
		return STATUS_ERR_INVALID_ARG;
	}

	uint32_t patt_value;

	while(tcc_module->SYNCBUSY.reg  & TCC_SYNCBUSY_PATT) {
		/* ҂ */
	}
	patt_value = tcc_module->PATT.reg;
	if (TCC_OUTPUT_PATTERN_DISABLE == pattern) {
		patt_value &= ~(TCC_PATT_PGE0 << line_index);
	} else if (TCC_OUTPUT_PATTERN_0 == pattern) {
		patt_value &= ~(TCC_PATT_PGV0 << line_index);
		patt_value |=  (TCC_PATT_PGE0 << line_index);
	} else {
		patt_value |=  ((TCC_PATT_PGE0 | TCC_PATT_PGV0) << line_index);
	}

	if (module_inst->double_buffering_enabled) {
		while(tcc_module->SYNCBUSY.reg  & TCC_SYNCBUSY_PATTB) {
			/* ҂ */
		}
		tcc_module->PATTB.reg = patt_value;
	} else {
		tcc_module->PATT.reg = patt_value;
	}
	return STATUS_OK;
}

/**
 * \brief ݂̒PʕԂ擾
 *
 * Ŝ̏ԏ^Pʕ̏Ԃ擾
 *
 * \param[in]  module_inst TCCĳ̍\̂ւ̈ʒuwq
 *
 * \return \c TCC_STATUS_*׸ނޯĎՕ
 *
 * \retval TCC_STATUS_CHANNEL_MATCH_CAPTURE(n)         nv/rNB
 * \retval TCC_STATUS_CHANNEL_OUTPUT(n)                nv/ro͏
 * \retval TCC_STATUS_NON_RECOVERABLE_FAULT_OCCUR(x)   񕜕s\QxNB
 * \retval TCC_STATUS_RECOVERABLE_FAULT_OCCUR(n)       񕜉\QnNB
 * \retval TCC_STATUS_NON_RECOVERABLE_FAULT_PRESENT(x) 񕜕s\Qx͑
 * \retval TCC_STATUS_RECOVERABLE_FAULT_PRESENT(n)     񕜉\Qn͑
 * \retval TCC_STATUS_SYNC_READY                       ǂڼ޽ĂȂB
 * \retval TCC_STATUS_CAPTURE_OVERFLOW                 vߊlްꂽB
 * \retval TCC_STATUS_COUNTER_EVENT                    vv펖ۂNB
 * \retval TCC_STATUS_COUNT_OVERFLOW                   vvlꂽB
 * \retval TCC_STATUS_COUNTER_RETRIGGERED              vvċNꂽB
 * \retval TCC_STATUS_STOP                             vv킪~B
 * \retval TCC_STATUS_RAMP_CYCLE_INDEX                 pg`XΎwW
 */
uint32_t tcc_get_status(
		struct tcc_module *const module_inst)
{
	/*  */
	Assert(module_inst);
	Assert(module_inst->hw);

	uint32_t int_flags = module_inst->hw->INTFLAG.reg;
	uint32_t status_flags = module_inst->hw->STATUS.reg;
	uint32_t status = 0;
	int i;

	/*  */
	if (module_inst->hw->SYNCBUSY.reg == 0) {
		status |= TCC_STATUS_SYNC_READY;
	}

	/*  */
	for (i = 0; i < TCC_NUM_CHANNELS; i++) {
		if (int_flags & TCC_INTFLAG_MC(i)) {
			status |= TCC_STATUS_CHANNEL_MATCH_CAPTURE(i);
		}
		if (status_flags & TCC_STATUS_CMP(i)) {
			status |= TCC_STATUS_CHANNEL_OUTPUT(i);
		}
	}
	/* 񕜕s\Q */
	if ((int_flags & TCC_INTFLAG_FAULT1) ||
		(status_flags & TCC_STATUS_FAULT1)) {
		status |= TCC_STATUS_NON_RECOVERABLE_FAULT_OCCUR(1);
	}
	if ((int_flags & TCC_INTFLAG_FAULT0) ||
		(status_flags & TCC_STATUS_FAULT0)) {
		status |= TCC_STATUS_NON_RECOVERABLE_FAULT_OCCUR(0);
	}
	/* 񕜕s\Q */
	if (status_flags & TCC_STATUS_FAULT0IN) {
		status |= TCC_STATUS_NON_RECOVERABLE_FAULT_PRESENT(0);
	}
	if (status_flags & TCC_STATUS_FAULT1IN) {
		status |= TCC_STATUS_NON_RECOVERABLE_FAULT_PRESENT(1);
	}
	/* 񕜉\Q */
	if ((int_flags & TCC_INTFLAG_FAULTB) ||
		(status_flags & TCC_STATUS_FAULTB)) {
		status |= TCC_STATUS_RECOVERABLE_FAULT_OCCUR(1);
	}
	if ((int_flags & TCC_INTFLAG_FAULTA) ||
		(status_flags & TCC_STATUS_FAULTA)) {
		status |= TCC_STATUS_RECOVERABLE_FAULT_OCCUR(0);
	}
	/* 񕜉\Q */
	if (status_flags & TCC_STATUS_FAULTAIN) {
		status |= TCC_STATUS_NON_RECOVERABLE_FAULT_PRESENT(0);
	}
	if (status_flags & TCC_STATUS_FAULTBIN) {
		status |= TCC_STATUS_NON_RECOVERABLE_FAULT_PRESENT(1);
	}

	/* TCCߊl꒲ */
	if (int_flags & TCC_INTFLAG_ERR) {
		status |= TCC_STATUS_CAPTURE_OVERFLOW;
	}
	/* TCCvv풲 */
	if (int_flags & TCC_INTFLAG_CNT) {
		status |= TCC_STATUS_COUNTER_EVENT;
	}
	/* TCCvċN */
	if (int_flags & TCC_INTFLAG_TRG) {
		status |= TCC_STATUS_COUNTER_RETRIGGERED;
	}
	/* TCCv꒲ */
	if (int_flags & TCC_INTFLAG_OVF) {
		status |= TCC_STATUS_COUNT_OVERFLOW;
	}
	/* TCCv~ */
	if (status_flags & TCC_STATUS_STOP) {
		status |= TCC_STATUS_STOPPED;
	}
	return status;
}

/**
 * \brief Pʕ׸މ
 *
 * ^ꂽPʕ̏׸ނ܂B
 *
 * \param[in]  module_inst  TCCĳ̍\̂ւ̈ʒuwq
 * \param[in]  status_flags \c TCC_STATUS_*׸ނޯĎՕ
 */
void tcc_clear_status(
		struct tcc_module *const module_inst,
		const uint32_t status_flags)
{
	/*  */
	Assert(module_inst);
	Assert(module_inst->hw);

	uint32_t int_clr = 0;
	uint32_t status_clr = 0;
	int i;

	/*  */
	for (i = 0; i < TCC_NUM_CHANNELS; i++) {
		if (status_flags & TCC_STATUS_CHANNEL_MATCH_CAPTURE(i)) {
			int_clr |= TCC_INTFLAG_MC(i);
		}
	}
	/* Q */
	if (status_flags & TCC_STATUS_NON_RECOVERABLE_FAULT_OCCUR(1)) {
		int_clr |= TCC_INTFLAG_FAULT1;
		status_clr |= TCC_STATUS_FAULT1;
	}
	if (status_flags & TCC_STATUS_NON_RECOVERABLE_FAULT_OCCUR(0)) {
		int_clr |= TCC_INTFLAG_FAULT0;
		status_clr |= TCC_STATUS_FAULT0;
	}
	if (status_flags & TCC_STATUS_RECOVERABLE_FAULT_OCCUR(1)) {
		int_clr |= TCC_INTFLAG_FAULTB;
		status_clr |= TCC_STATUS_FAULTB;
	}
	if (status_flags & TCC_STATUS_RECOVERABLE_FAULT_OCCUR(0)) {
		int_clr |= TCC_INTFLAG_FAULTA;
		status_clr |= TCC_STATUS_FAULTA;
	}
	/* TCCߊl꒲ */
	if (status_flags & TCC_STATUS_CAPTURE_OVERFLOW) {
		int_clr |= TCC_INTFLAG_ERR;
	}
	/* TCCvv풲 */
	if (status_flags & TCC_STATUS_COUNTER_EVENT) {
		int_clr |= TCC_INTFLAG_CNT;
	}
	/* TCCvċN */
	if (status_flags & TCC_STATUS_COUNTER_RETRIGGERED) {
		int_clr = TCC_INTFLAG_TRG;
	}
	/* TCCv꒲ */
	if (status_flags & TCC_STATUS_COUNT_OVERFLOW) {
		int_clr |= TCC_INTFLAG_OVF;
	}
	/* ׸މ */
	module_inst->hw->STATUS.reg = status_clr;
	/* 荞׸މ */
	module_inst->hw->INTFLAG.reg = int_clr;
}

/**
 * \brief 2dɏՂꂽrlpzCӑI
 *
 * 2dɏՂꂽٔrlɑ΂ďzCӑI܂BeUPDATEŁACCBx
 * CCx̓e؂ւACCBx̓eCCxɓ]ACCx̓eCCBxɓ]
 * 邱ƂӖ܂B
 *
 * \param[in]  module_inst   TCCĳ̍\̂ւ̈ʒuwq
 * \param[in]  channel_index ݒ肷rق̎wW
 *
 * \retval STATUS_OK          Pʕ͐ɏ܂B
 * \retval STATUS_INVALID_ARG َgp܂B
 */
enum status_code tcc_enable_circular_buffer_compare(
		struct tcc_module *const module_inst,
		enum tcc_match_capture_channel channel_index)
{
	/*  */
	Assert(module_inst);
	Assert(module_inst->hw);

	/* Pʕʰ޳̂ւ̈ʒuwq擾 */
	Tcc *const tcc_module = module_inst->hw;
	/* Pʕ̎wW擾 */
	uint8_t module_index = _tcc_get_inst_index(tcc_module);

	/* wW */
	if (channel_index > 3) {
		return STATUS_ERR_INVALID_ARG;
	}
	if (channel_index >= _tcc_cc_nums[module_index]) {
		return STATUS_ERR_INVALID_ARG;
	}

	tcc_module->WAVE.reg |=  (TCC_WAVE_CICCEN0 << channel_index);

	return STATUS_OK;
}

/**
 * \brief 2dɏՂꂽrlpzCӑI֎~
 *
 * 2dɏՂrl̏z~܂B
 *
 * \param[in]  module_inst   TCCĳ̍\̂ւ̈ʒuwq
 * \param[in]  channel_index ݒ肷rق̎wW
 *
 * \retval STATUS_OK          Pʕ͐ɏ܂B
 * \retval STATUS_INVALID_ARG َgp܂B
 */
enum status_code tcc_disable_circular_buffer_compare(
		struct tcc_module *const module_inst,
		enum tcc_match_capture_channel channel_index)
{
	/*  */
	Assert(module_inst);
	Assert(module_inst->hw);

	/* Pʕʰ޳̂ւ̈ʒuwq擾 */
	Tcc *const tcc_module = module_inst->hw;
	/* Pʕ̎wW擾 */
	uint8_t module_index = _tcc_get_inst_index(tcc_module);

	/* wW */
	if (channel_index > 3) {
		return STATUS_ERR_INVALID_ARG;
	}
	if (channel_index >= _tcc_cc_nums[module_index]) {
		return STATUS_ERR_INVALID_ARG;
	}

	tcc_module->WAVE.reg &= ~(TCC_WAVE_CICCEN0 << channel_index);

	return STATUS_OK;
}
