/**
 * \file
 *
 * \brief DMACp\iLq
 *
 * 쌠 (c) 2013 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAMD21_DMAC_COMPONENT_
#define _SAMD21_DMAC_COMPONENT_

/* ========================================================================== */
/** DMACpĳAPI` */
/* ========================================================================== */
/** \addtogroup SAMD21_DMAC ؓo͐ */
/*@{*/

#define DMAC_U2223
#define REV_DMAC							0x100

/* -------- DMAC_CTRL : (DMACψ:0x00) (R/W 16) -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t SWRST:1;			/*!< ޯ     0: ĳ ؾ */
    uint16_t DMAENABLE:1;		/*!< ޯ     1: DMA */
    uint16_t CRCENABLE:1;		/*!< ޯ     2: CRC */
    uint16_t :5;				/*!< ޯ 3` 7: \ */
    uint16_t LVLEN0:1;			/*!< ޯ     8: D0 */
    uint16_t LVLEN1:1;			/*!< ޯ     9: D1 */
    uint16_t LVLEN2:1;			/*!< ޯ    10: D2 */
    uint16_t LVLEN3:1;			/*!< ޯ    11: D3 */
    uint16_t :4;				/*!< ޯ12`15: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint16_t :8;				/*!< ޯ 0` 7: \ */
    uint16_t LVLEN:4;			/*!< ޯ 8`11: Dx */
    uint16_t :4;				/*!< ޯ12`15: \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} DMAC_CTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DMAC_CTRL_OFFSET					0x00			/**< \brief (DMAC_CTRL offset) */
#define DMAC_CTRL_RESETVALUE				0x0000			/**< \brief (DMAC_CTRL reset_value) */

#define DMAC_CTRL_SWRST_Pos					0				/**< \brief (DMAC_CTRL)ĳ ؾ */
#define DMAC_CTRL_SWRST						(0x1u << DMAC_CTRL_SWRST_Pos)
#define DMAC_CTRL_DMAENABLE_Pos				1				/**< \brief (DMAC_CTRL)DMA */
#define DMAC_CTRL_DMAENABLE					(0x1u << DMAC_CTRL_DMAENABLE_Pos)
#define DMAC_CTRL_CRCENABLE_Pos				2				/**< \brief (DMAC_CTRL)CRC */
#define DMAC_CTRL_CRCENABLE					(0x1u << DMAC_CTRL_CRCENABLE_Pos)
#define DMAC_CTRL_LVLEN0_Pos				8				/**< \brief (DMAC_CTRL)D0 */
#define DMAC_CTRL_LVLEN0					(1 << DMAC_CTRL_LVLEN0_Pos)
#define DMAC_CTRL_LVLEN1_Pos				9				/**< \brief (DMAC_CTRL)D1 */
#define DMAC_CTRL_LVLEN1					(1 << DMAC_CTRL_LVLEN1_Pos)
#define DMAC_CTRL_LVLEN2_Pos				10				/**< \brief (DMAC_CTRL)D2 */
#define DMAC_CTRL_LVLEN2					(1 << DMAC_CTRL_LVLEN2_Pos)
#define DMAC_CTRL_LVLEN3_Pos				11				/**< \brief (DMAC_CTRL)D3 */
#define DMAC_CTRL_LVLEN3					(1 << DMAC_CTRL_LVLEN3_Pos)
#define DMAC_CTRL_LVLEN_Pos					8				/**< \brief (DMAC_CTRL)Dx */
#define DMAC_CTRL_LVLEN_Msk					(0xFu << DMAC_CTRL_LVLEN_Pos)
#define DMAC_CTRL_LVLEN(value)				((DMAC_CTRL_LVLEN_Msk & ((value) << DMAC_CTRL_LVLEN_Pos)))
#define DMAC_CTRL_MASK						0x0F07u			/**< \brief (DMAC_CTRL)Օڼ޽ */

/* -------- DMAC_CRCCTRL : (DMACψ:0x02) (R/W 16)CRC -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t CRCBEATSIZE:2;		/*!< ޯ  0,1: CRC@o傫 */
    uint16_t CRCPOLY:2;			/*!< ޯ  2,3: CRC^ */
    uint16_t :4;				/*!< ޯ4` 7: \ */
    uint16_t CRCSRC:6;			/*!< ޯ8`13: CRC͌ */
    uint16_t :2;				/*!< ޯ14,15: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} DMAC_CRCCTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DMAC_CRCCTRL_OFFSET					0x02			/**< \brief (DMAC_CRCCTRL offset)CRC */
#define DMAC_CRCCTRL_RESETVALUE				0x0000			/**< \brief (DMAC_CRCCTRL reset_value)CRC */

#define DMAC_CRCCTRL_CRCBEATSIZE_Pos		0				/**< \brief (DMAC_CRCCTRL)CRC@o傫 */
#define DMAC_CRCCTRL_CRCBEATSIZE_Msk		(0x3u << DMAC_CRCCTRL_CRCBEATSIZE_Pos)
#define DMAC_CRCCTRL_CRCBEATSIZE(value)		((DMAC_CRCCTRL_CRCBEATSIZE_Msk & ((value) << DMAC_CRCCTRL_CRCBEATSIZE_Pos)))
#define   DMAC_CRCCTRL_CRCBEATSIZE_BYTE_Val		0x0u			/**< \brief (DMAC_CRCCTRL)޲ ޽  */
#define   DMAC_CRCCTRL_CRCBEATSIZE_HWORD_Val	0x1u			/**< \brief (DMAC_CRCCTRL)޽  */
#define   DMAC_CRCCTRL_CRCBEATSIZE_WORD_Val		0x2u			/**< \brief (DMAC_CRCCTRL)޽  */
#define DMAC_CRCCTRL_CRCBEATSIZE_BYTE		(DMAC_CRCCTRL_CRCBEATSIZE_BYTE_Val	<< DMAC_CRCCTRL_CRCBEATSIZE_Pos)
#define DMAC_CRCCTRL_CRCBEATSIZE_HWORD		(DMAC_CRCCTRL_CRCBEATSIZE_HWORD_Val	<< DMAC_CRCCTRL_CRCBEATSIZE_Pos)
#define DMAC_CRCCTRL_CRCBEATSIZE_WORD		(DMAC_CRCCTRL_CRCBEATSIZE_WORD_Val	<< DMAC_CRCCTRL_CRCBEATSIZE_Pos)
#define DMAC_CRCCTRL_CRCPOLY_Pos			2				/**< \brief (DMAC_CRCCTRL)CRC^ */
#define DMAC_CRCCTRL_CRCPOLY_Msk			(0x3u << DMAC_CRCCTRL_CRCPOLY_Pos)
#define DMAC_CRCCTRL_CRCPOLY(value)			((DMAC_CRCCTRL_CRCPOLY_Msk & ((value) << DMAC_CRCCTRL_CRCPOLY_Pos)))
#define   DMAC_CRCCTRL_CRCPOLY_CRC16_Val		0x0u			/**< \brief (DMAC_CRCCTRL)CRC-16(CRC-CCITT) */
#define   DMAC_CRCCTRL_CRCPOLY_CRC32_Val		0x1u			/**< \brief (DMAC_CRCCTRL)CRC32(IEEE 802.3) */
#define DMAC_CRCCTRL_CRCPOLY_CRC16			(DMAC_CRCCTRL_CRCPOLY_CRC16_Val	<< DMAC_CRCCTRL_CRCPOLY_Pos)
#define DMAC_CRCCTRL_CRCPOLY_CRC32			(DMAC_CRCCTRL_CRCPOLY_CRC32_Val	<< DMAC_CRCCTRL_CRCPOLY_Pos)
#define DMAC_CRCCTRL_CRCSRC_Pos				8				/**< \brief (DMAC_CRCCTRL)CRC͌ */
#define DMAC_CRCCTRL_CRCSRC_Msk				(0x3Fu << DMAC_CRCCTRL_CRCSRC_Pos)
#define DMAC_CRCCTRL_CRCSRC(value)			((DMAC_CRCCTRL_CRCSRC_Msk & ((value) << DMAC_CRCCTRL_CRCSRC_Pos)))
#define   DMAC_CRCCTRL_CRCSRC_NOACT_Val			0x0u			/**< \brief (DMAC_CRCCTRL)Ȃ */
#define   DMAC_CRCCTRL_CRCSRC_IO_Val			0x1u			/**< \brief (DMAC_CRCCTRL)I/O̪ */
#define DMAC_CRCCTRL_CRCSRC_NOACT			(DMAC_CRCCTRL_CRCSRC_NOACT_Val	<< DMAC_CRCCTRL_CRCSRC_Pos)
#define DMAC_CRCCTRL_CRCSRC_IO				(DMAC_CRCCTRL_CRCSRC_IO_Val		<< DMAC_CRCCTRL_CRCSRC_Pos)
#define DMAC_CRCCTRL_MASK					0x3F0Fu			/**< \brief (DMAC_CRCCTRL)Օڼ޽ */

/* -------- DMAC_CRCDATAIN : (DMACψ:0x04) (R/W 32)CRCް -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t CRCDATAIN:32;		/*!< ޯ0`31: CRCް */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} DMAC_CRCDATAIN_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DMAC_CRCDATAIN_OFFSET				0x04			/**< \brief (DMAC_CRCDATAIN offset)CRCް */
#define DMAC_CRCDATAIN_RESETVALUE			0x00000000		/**< \brief (DMAC_CRCDATAIN reset_value)CRCް */

#define DMAC_CRCDATAIN_CRCDATAIN_Pos		0				/**< \brief (DMAC_CRCDATAIN)CRCް */
#define DMAC_CRCDATAIN_CRCDATAIN_Msk		(0xFFFFFFFFu << DMAC_CRCDATAIN_CRCDATAIN_Pos)
#define DMAC_CRCDATAIN_CRCDATAIN(value)		((DMAC_CRCDATAIN_CRCDATAIN_Msk & ((value) << DMAC_CRCDATAIN_CRCDATAIN_Pos)))
#define DMAC_CRCDATAIN_MASK					0xFFFFFFFFu		/**< \brief (DMAC_CRCDATAIN)Օڼ޽ */

/* -------- DMAC_CRCCHKSUM : (DMACψ:0x08) (R/W 32)CRC -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t CRCCHKSUM:32;		/*!< ޯ0`31: CRC */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} DMAC_CRCCHKSUM_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DMAC_CRCCHKSUM_OFFSET				0x08			/**< \brief (DMAC_CRCCHKSUM offset)CRC */
#define DMAC_CRCCHKSUM_RESETVALUE			0x00000000		/**< \brief (DMAC_CRCCHKSUM reset_value)CRC */

#define DMAC_CRCCHKSUM_CRCCHKSUM_Pos		0				/**< \brief (DMAC_CRCCHKSUM)CRC */
#define DMAC_CRCCHKSUM_CRCCHKSUM_Msk		(0xFFFFFFFFu << DMAC_CRCCHKSUM_CRCCHKSUM_Pos)
#define DMAC_CRCCHKSUM_CRCCHKSUM(value)		((DMAC_CRCCHKSUM_CRCCHKSUM_Msk & ((value) << DMAC_CRCCHKSUM_CRCCHKSUM_Pos)))
#define DMAC_CRCCHKSUM_MASK					0xFFFFFFFFu		/**< \brief (DMAC_CRCCHKSUM)Օڼ޽ */

/* -------- DMAC_CRCSTATUS : (DMACψ:0x0C) (R/W  8)CRC -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  CRCBUSY:1;			/*!< ޯ   0: CRCPʕZ */
    uint8_t  CRCZERO:1;			/*!< ޯ   1: CRC 0 */
    uint8_t  :6;				/*!< ޯ2`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg; 					/*!< ڼ޽ Ɏgp^ */
} DMAC_CRCSTATUS_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DMAC_CRCSTATUS_OFFSET				0x0C			/**< \brief (DMAC_CRCSTATUS offset)CRC */
#define DMAC_CRCSTATUS_RESETVALUE			0x00			/**< \brief (DMAC_CRCSTATUS reset_value)CRC */

#define DMAC_CRCSTATUS_CRCBUSY_Pos			0				/**< \brief (DMAC_CRCSTATUS)CRCPʕZ */
#define DMAC_CRCSTATUS_CRCBUSY				(0x1u << DMAC_CRCSTATUS_CRCBUSY_Pos)
#define DMAC_CRCSTATUS_CRCZERO_Pos			1				/**< \brief (DMAC_CRCSTATUS)CRC 0 */
#define DMAC_CRCSTATUS_CRCZERO				(0x1u << DMAC_CRCSTATUS_CRCZERO_Pos)
#define DMAC_CRCSTATUS_MASK					0x03u 			/**< \brief (DMAC_CRCSTATUS)Օڼ޽ */

/* -------- DMAC_DBGCTRL : (DMACψ:0x0D) (R/W  8)ޯސ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  DBGRUN:1;			/*!< ޯ   0: ޯޑs */
    uint8_t  :7;				/*!< ޯ1`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg; 					/*!< ڼ޽ Ɏgp^ */
} DMAC_DBGCTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DMAC_DBGCTRL_OFFSET					0x0D			/**< \brief (DMAC_DBGCTRL offset)ޯސ */
#define DMAC_DBGCTRL_RESETVALUE				0x00			/**< \brief (DMAC_DBGCTRL reset_value)ޯސ */

#define DMAC_DBGCTRL_DBGRUN_Pos				0				/**< \brief (DMAC_DBGCTRL)ޯޑs */
#define DMAC_DBGCTRL_DBGRUN					(0x1u << DMAC_DBGCTRL_DBGRUN_Pos)
#define DMAC_DBGCTRL_MASK					0x01u 			/**< \brief (DMAC_DBGCTRL)Օڼ޽ */

/* -------- DMAC_SWTRIGCTRL : (DMACψ:0x10) (R/W 32)ĳN -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t SWTRIG0:1;			/*!< ޯ     0: 0ĳN */
    uint32_t SWTRIG1:1;			/*!< ޯ     1: 1ĳN */
    uint32_t SWTRIG2:1;			/*!< ޯ     2: 2ĳN */
    uint32_t SWTRIG3:1;			/*!< ޯ     3: 3ĳN */
    uint32_t SWTRIG4:1;			/*!< ޯ     4: 4ĳN */
    uint32_t SWTRIG5:1;			/*!< ޯ     5: 5ĳN */
    uint32_t SWTRIG6:1;			/*!< ޯ     6: 6ĳN */
    uint32_t SWTRIG7:1;			/*!< ޯ     7: 7ĳN */
    uint32_t SWTRIG8:1;			/*!< ޯ     8: 8ĳN */
    uint32_t SWTRIG9:1;			/*!< ޯ     9: 9ĳN */
    uint32_t SWTRIG10:1;		/*!< ޯ    10: 10ĳN */
    uint32_t SWTRIG11:1;		/*!< ޯ    11: 11ĳN */
    uint32_t :20;				/*!< ޯ12`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint32_t SWTRIG:12;			/*!< ޯ 0`11:  0..11 xĳN */
    uint32_t :20;				/*!< ޯ12`31: 12..31 \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} DMAC_SWTRIGCTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DMAC_SWTRIGCTRL_OFFSET				0x10			/**< \brief (DMAC_SWTRIGCTRL offset)ĳN */
#define DMAC_SWTRIGCTRL_RESETVALUE			0x00000000		/**< \brief (DMAC_SWTRIGCTRL reset_value)ĳN */

#define DMAC_SWTRIGCTRL_SWTRIG0_Pos			0				/**< \brief (DMAC_SWTRIGCTRL)0ĳN */
#define DMAC_SWTRIGCTRL_SWTRIG0				(1 << DMAC_SWTRIGCTRL_SWTRIG0_Pos)
#define DMAC_SWTRIGCTRL_SWTRIG1_Pos			1				/**< \brief (DMAC_SWTRIGCTRL)1ĳN */
#define DMAC_SWTRIGCTRL_SWTRIG1				(1 << DMAC_SWTRIGCTRL_SWTRIG1_Pos)
#define DMAC_SWTRIGCTRL_SWTRIG2_Pos			2				/**< \brief (DMAC_SWTRIGCTRL)2ĳN */
#define DMAC_SWTRIGCTRL_SWTRIG2				(1 << DMAC_SWTRIGCTRL_SWTRIG2_Pos)
#define DMAC_SWTRIGCTRL_SWTRIG3_Pos			3				/**< \brief (DMAC_SWTRIGCTRL)3ĳN */
#define DMAC_SWTRIGCTRL_SWTRIG3				(1 << DMAC_SWTRIGCTRL_SWTRIG3_Pos)
#define DMAC_SWTRIGCTRL_SWTRIG4_Pos			4				/**< \brief (DMAC_SWTRIGCTRL)4ĳN */
#define DMAC_SWTRIGCTRL_SWTRIG4				(1 << DMAC_SWTRIGCTRL_SWTRIG4_Pos)
#define DMAC_SWTRIGCTRL_SWTRIG5_Pos			5				/**< \brief (DMAC_SWTRIGCTRL)5ĳN */
#define DMAC_SWTRIGCTRL_SWTRIG5				(1 << DMAC_SWTRIGCTRL_SWTRIG5_Pos)
#define DMAC_SWTRIGCTRL_SWTRIG6_Pos			6				/**< \brief (DMAC_SWTRIGCTRL)6ĳN */
#define DMAC_SWTRIGCTRL_SWTRIG6				(1 << DMAC_SWTRIGCTRL_SWTRIG6_Pos)
#define DMAC_SWTRIGCTRL_SWTRIG7_Pos			7				/**< \brief (DMAC_SWTRIGCTRL)7ĳN */
#define DMAC_SWTRIGCTRL_SWTRIG7				(1 << DMAC_SWTRIGCTRL_SWTRIG7_Pos)
#define DMAC_SWTRIGCTRL_SWTRIG8_Pos			8				/**< \brief (DMAC_SWTRIGCTRL)8ĳN */
#define DMAC_SWTRIGCTRL_SWTRIG8				(1 << DMAC_SWTRIGCTRL_SWTRIG8_Pos)
#define DMAC_SWTRIGCTRL_SWTRIG9_Pos			9				/**< \brief (DMAC_SWTRIGCTRL)9ĳN */
#define DMAC_SWTRIGCTRL_SWTRIG9				(1 << DMAC_SWTRIGCTRL_SWTRIG9_Pos)
#define DMAC_SWTRIGCTRL_SWTRIG10_Pos		10				/**< \brief (DMAC_SWTRIGCTRL)10ĳN */
#define DMAC_SWTRIGCTRL_SWTRIG10			(1 << DMAC_SWTRIGCTRL_SWTRIG10_Pos)
#define DMAC_SWTRIGCTRL_SWTRIG11_Pos		11				/**< \brief (DMAC_SWTRIGCTRL)11ĳN */
#define DMAC_SWTRIGCTRL_SWTRIG11			(1 << DMAC_SWTRIGCTRL_SWTRIG11_Pos)
#define DMAC_SWTRIGCTRL_SWTRIG_Pos			0				/**< \brief (DMAC_SWTRIGCTRL)xĳN */
#define DMAC_SWTRIGCTRL_SWTRIG_Msk			(0xFFFu << DMAC_SWTRIGCTRL_SWTRIG_Pos)
#define DMAC_SWTRIGCTRL_SWTRIG(value)		((DMAC_SWTRIGCTRL_SWTRIG_Msk & ((value) << DMAC_SWTRIGCTRL_SWTRIG_Pos)))
#define DMAC_SWTRIGCTRL_MASK				0x00000FFFu		/**< \brief (DMAC_SWTRIGCTRL)Օڼ޽ */

/* -------- DMAC_PRICTRL0 : (DMACψ:0x14) (R/W 32)è0 -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t LVLPRI0:4;			/*!< ޯ 0` 3: 0ٗD挠ԍ */
    uint32_t :3;				/*!< ޯ 4` 6: \ */
    uint32_t RRLVLEN0:1;		/*!< ޯ     7: 0׳݌v拖 */
    uint32_t LVLPRI1:4;			/*!< ޯ 8`11: 1ٗD挠ԍ */
    uint32_t :3;				/*!< ޯ12`14: \ */
    uint32_t RRLVLEN1:1;		/*!< ޯ    15: 1׳݌v拖 */
    uint32_t LVLPRI2:4;			/*!< ޯ16`19: 2ٗD挠ԍ */
    uint32_t :3;				/*!< ޯ20`22: \ */
    uint32_t RRLVLEN2:1;		/*!< ޯ    23: 2׳݌v拖 */
    uint32_t LVLPRI3:4;			/*!< ޯ24`27: 3ٗD挠ԍ */
    uint32_t :3;				/*!< ޯ28`30: \ */
    uint32_t RRLVLEN3:1;		/*!< ޯ    31: 3׳݌v拖 */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} DMAC_PRICTRL0_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DMAC_PRICTRL0_OFFSET				0x14			/**< \brief (DMAC_PRICTRL0 offset)è0 */
#define DMAC_PRICTRL0_RESETVALUE			0x00000000		/**< \brief (DMAC_PRICTRL0 reset_value)è0 */

#define DMAC_PRICTRL0_LVLPRI0_Pos			0				/**< \brief (DMAC_PRICTRL0)0ٗD挠ԍ */
#define DMAC_PRICTRL0_LVLPRI0_Msk			(0xFu << DMAC_PRICTRL0_LVLPRI0_Pos)
#define DMAC_PRICTRL0_LVLPRI0(value)		((DMAC_PRICTRL0_LVLPRI0_Msk & ((value) << DMAC_PRICTRL0_LVLPRI0_Pos)))
#define DMAC_PRICTRL0_RRLVLEN0_Pos			7				/**< \brief (DMAC_PRICTRL0)0׳݌v拖 */
#define DMAC_PRICTRL0_RRLVLEN0				(0x1u << DMAC_PRICTRL0_RRLVLEN0_Pos)
#define DMAC_PRICTRL0_LVLPRI1_Pos			8				/**< \brief (DMAC_PRICTRL0)1ٗD挠ԍ */
#define DMAC_PRICTRL0_LVLPRI1_Msk			(0xFu << DMAC_PRICTRL0_LVLPRI1_Pos)
#define DMAC_PRICTRL0_LVLPRI1(value)		((DMAC_PRICTRL0_LVLPRI1_Msk & ((value) << DMAC_PRICTRL0_LVLPRI1_Pos)))
#define DMAC_PRICTRL0_RRLVLEN1_Pos			15				/**< \brief (DMAC_PRICTRL0)1׳݌v拖 */
#define DMAC_PRICTRL0_RRLVLEN1				(0x1u << DMAC_PRICTRL0_RRLVLEN1_Pos)
#define DMAC_PRICTRL0_LVLPRI2_Pos			16				/**< \brief (DMAC_PRICTRL0)2ٗD挠ԍ */
#define DMAC_PRICTRL0_LVLPRI2_Msk			(0xFu << DMAC_PRICTRL0_LVLPRI2_Pos)
#define DMAC_PRICTRL0_LVLPRI2(value)		((DMAC_PRICTRL0_LVLPRI2_Msk & ((value) << DMAC_PRICTRL0_LVLPRI2_Pos)))
#define DMAC_PRICTRL0_RRLVLEN2_Pos			23				/**< \brief (DMAC_PRICTRL0)2׳݌v拖 */
#define DMAC_PRICTRL0_RRLVLEN2				(0x1u << DMAC_PRICTRL0_RRLVLEN2_Pos)
#define DMAC_PRICTRL0_LVLPRI3_Pos			24				/**< \brief (DMAC_PRICTRL0)3ٗD挠ԍ */
#define DMAC_PRICTRL0_LVLPRI3_Msk			(0xFu << DMAC_PRICTRL0_LVLPRI3_Pos)
#define DMAC_PRICTRL0_LVLPRI3(value)		((DMAC_PRICTRL0_LVLPRI3_Msk & ((value) << DMAC_PRICTRL0_LVLPRI3_Pos)))
#define DMAC_PRICTRL0_RRLVLEN3_Pos			31				/**< \brief (DMAC_PRICTRL0)3׳݌v拖 */
#define DMAC_PRICTRL0_RRLVLEN3				(0x1u << DMAC_PRICTRL0_RRLVLEN3_Pos)
#define DMAC_PRICTRL0_MASK					0x8F8F8F8Fu		/**< \brief (DMAC_PRICTRL0)Օڼ޽ */

/* -------- DMAC_INTPEND : (DMACψ:0x20) (R/W 16)荞ݕۗ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t ID:4;				/*!< ޯ 0`3: ID */
    uint16_t :4;				/*!< ޯ 4`7: \ */
    uint16_t TERR:1;			/*!< ޯ    8: ]ُ */
    uint16_t TCMPL:1;			/*!< ޯ    9: ] */
    uint16_t SUSP:1;			/*!< ޯ   10: ًx~ */
    uint16_t :2;				/*!< ޯ11,12: \ */
    uint16_t FERR:1;			/*!< ޯ   13: 擾ُ */
    uint16_t BUSY:1;			/*!< ޯ   14: Z */
    uint16_t PEND:1;			/*!< ޯ   15: ۗ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} DMAC_INTPEND_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DMAC_INTPEND_OFFSET					0x20			/**< \brief (DMAC_INTPEND offset)荞ݕۗ */
#define DMAC_INTPEND_RESETVALUE				0x0000			/**< \brief (DMAC_INTPEND reset_value)荞ݕۗ */

#define DMAC_INTPEND_ID_Pos					0				/**< \brief (DMAC_INTPEND)ID */
#define DMAC_INTPEND_ID_Msk					(0xFu << DMAC_INTPEND_ID_Pos)
#define DMAC_INTPEND_ID(value)				((DMAC_INTPEND_ID_Msk & ((value) << DMAC_INTPEND_ID_Pos)))
#define DMAC_INTPEND_TERR_Pos				8				/**< \brief (DMAC_INTPEND)]ُ */
#define DMAC_INTPEND_TERR					(0x1u << DMAC_INTPEND_TERR_Pos)
#define DMAC_INTPEND_TCMPL_Pos				9				/**< \brief (DMAC_INTPEND)] */
#define DMAC_INTPEND_TCMPL					(0x1u << DMAC_INTPEND_TCMPL_Pos)
#define DMAC_INTPEND_SUSP_Pos				10				/**< \brief (DMAC_INTPEND)ًx~ */
#define DMAC_INTPEND_SUSP					(0x1u << DMAC_INTPEND_SUSP_Pos)
#define DMAC_INTPEND_FERR_Pos				13				/**< \brief (DMAC_INTPEND)擾ُ */
#define DMAC_INTPEND_FERR					(0x1u << DMAC_INTPEND_FERR_Pos)
#define DMAC_INTPEND_BUSY_Pos				14				/**< \brief (DMAC_INTPEND)Z */
#define DMAC_INTPEND_BUSY					(0x1u << DMAC_INTPEND_BUSY_Pos)
#define DMAC_INTPEND_PEND_Pos				15				/**< \brief (DMAC_INTPEND)ۗ */
#define DMAC_INTPEND_PEND					(0x1u << DMAC_INTPEND_PEND_Pos)
#define DMAC_INTPEND_MASK					0xE70Fu			/**< \brief (DMAC_INTPEND)Օڼ޽ */

/* -------- DMAC_INTSTATUS : (DMACψ:0x24) (R/  32)荞ݏ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t CHINT0:1;			/*!< ޯ     0: 0ۗ荞 */
    uint32_t CHINT1:1;			/*!< ޯ     1: 1ۗ荞 */
    uint32_t CHINT2:1;			/*!< ޯ     2: 2ۗ荞 */
    uint32_t CHINT3:1;			/*!< ޯ     3: 3ۗ荞 */
    uint32_t CHINT4:1;			/*!< ޯ     4: 4ۗ荞 */
    uint32_t CHINT5:1;			/*!< ޯ     5: 5ۗ荞 */
    uint32_t CHINT6:1;			/*!< ޯ     6: 6ۗ荞 */
    uint32_t CHINT7:1;			/*!< ޯ     7: 7ۗ荞 */
    uint32_t CHINT8:1;			/*!< ޯ     8: 8ۗ荞 */
    uint32_t CHINT9:1;			/*!< ޯ     9: 9ۗ荞 */
    uint32_t CHINT10:1;			/*!< ޯ    10: 10ۗ荞 */
    uint32_t CHINT11:1;			/*!< ޯ    11: 11ۗ荞 */
    uint32_t :20;				/*!< ޯ12`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint32_t CHINT:12;			/*!< ޯ 0`11:  0..11 xۗ荞 */
    uint32_t :20;				/*!< ޯ12`31: 12..31 \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} DMAC_INTSTATUS_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DMAC_INTSTATUS_OFFSET				0x24			/**< \brief (DMAC_INTSTATUS offset)荞ݏ */
#define DMAC_INTSTATUS_RESETVALUE			0x00000000		/**< \brief (DMAC_INTSTATUS reset_value)荞ݏ */

#define DMAC_INTSTATUS_CHINT0_Pos			0				/**< \brief (DMAC_INTSTATUS)0ۗ荞 */
#define DMAC_INTSTATUS_CHINT0				(1 << DMAC_INTSTATUS_CHINT0_Pos)
#define DMAC_INTSTATUS_CHINT1_Pos			1				/**< \brief (DMAC_INTSTATUS)1ۗ荞 */
#define DMAC_INTSTATUS_CHINT1				(1 << DMAC_INTSTATUS_CHINT1_Pos)
#define DMAC_INTSTATUS_CHINT2_Pos			2				/**< \brief (DMAC_INTSTATUS)2ۗ荞 */
#define DMAC_INTSTATUS_CHINT2				(1 << DMAC_INTSTATUS_CHINT2_Pos)
#define DMAC_INTSTATUS_CHINT3_Pos			3				/**< \brief (DMAC_INTSTATUS)3ۗ荞 */
#define DMAC_INTSTATUS_CHINT3				(1 << DMAC_INTSTATUS_CHINT3_Pos)
#define DMAC_INTSTATUS_CHINT4_Pos			4				/**< \brief (DMAC_INTSTATUS)4ۗ荞 */
#define DMAC_INTSTATUS_CHINT4				(1 << DMAC_INTSTATUS_CHINT4_Pos)
#define DMAC_INTSTATUS_CHINT5_Pos			5				/**< \brief (DMAC_INTSTATUS)5ۗ荞 */
#define DMAC_INTSTATUS_CHINT5				(1 << DMAC_INTSTATUS_CHINT5_Pos)
#define DMAC_INTSTATUS_CHINT6_Pos			6				/**< \brief (DMAC_INTSTATUS)6ۗ荞 */
#define DMAC_INTSTATUS_CHINT6				(1 << DMAC_INTSTATUS_CHINT6_Pos)
#define DMAC_INTSTATUS_CHINT7_Pos			7				/**< \brief (DMAC_INTSTATUS)7ۗ荞 */
#define DMAC_INTSTATUS_CHINT7				(1 << DMAC_INTSTATUS_CHINT7_Pos)
#define DMAC_INTSTATUS_CHINT8_Pos			8				/**< \brief (DMAC_INTSTATUS)8ۗ荞 */
#define DMAC_INTSTATUS_CHINT8				(1 << DMAC_INTSTATUS_CHINT8_Pos)
#define DMAC_INTSTATUS_CHINT9_Pos			9				/**< \brief (DMAC_INTSTATUS)9ۗ荞 */
#define DMAC_INTSTATUS_CHINT9				(1 << DMAC_INTSTATUS_CHINT9_Pos)
#define DMAC_INTSTATUS_CHINT10_Pos			10				/**< \brief (DMAC_INTSTATUS)10ۗ荞 */
#define DMAC_INTSTATUS_CHINT10				(1 << DMAC_INTSTATUS_CHINT10_Pos)
#define DMAC_INTSTATUS_CHINT11_Pos			11				/**< \brief (DMAC_INTSTATUS)11ۗ荞 */
#define DMAC_INTSTATUS_CHINT11				(1 << DMAC_INTSTATUS_CHINT11_Pos)
#define DMAC_INTSTATUS_CHINT_Pos			0				/**< \brief (DMAC_INTSTATUS)xۗ荞 */
#define DMAC_INTSTATUS_CHINT_Msk			(0xFFFu << DMAC_INTSTATUS_CHINT_Pos)
#define DMAC_INTSTATUS_CHINT(value)			((DMAC_INTSTATUS_CHINT_Msk & ((value) << DMAC_INTSTATUS_CHINT_Pos)))
#define DMAC_INTSTATUS_MASK					0x00000FFFu		/**< \brief (DMAC_INTSTATUS)Օڼ޽ */

/* -------- DMAC_BUSYCH : (DMACψ:0x28) (R/  32)Z -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t BUSYCH0:1;			/*!< ޯ     0: 0Z */
    uint32_t BUSYCH1:1;			/*!< ޯ     1: 1Z */
    uint32_t BUSYCH2:1;			/*!< ޯ     2: 2Z */
    uint32_t BUSYCH3:1;			/*!< ޯ     3: 3Z */
    uint32_t BUSYCH4:1;			/*!< ޯ     4: 4Z */
    uint32_t BUSYCH5:1;			/*!< ޯ     5: 5Z */
    uint32_t BUSYCH6:1;			/*!< ޯ     6: 6Z */
    uint32_t BUSYCH7:1;			/*!< ޯ     7: 7Z */
    uint32_t BUSYCH8:1;			/*!< ޯ     8: 8Z */
    uint32_t BUSYCH9:1;			/*!< ޯ     9: 9Z */
    uint32_t BUSYCH10:1;		/*!< ޯ    10: 10Z */
    uint32_t BUSYCH11:1;		/*!< ޯ    11: 11Z */
    uint32_t :20;				/*!< ޯ12`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint32_t BUSYCH:12;			/*!< ޯ 0`11:  0..11 xZ */
    uint32_t :20;				/*!< ޯ12`31: 12..31 \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} DMAC_BUSYCH_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DMAC_BUSYCH_OFFSET					0x28			/**< \brief (DMAC_BUSYCH offset)Z */
#define DMAC_BUSYCH_RESETVALUE				0x00000000		/**< \brief (DMAC_BUSYCH reset_value)Z */

#define DMAC_BUSYCH_BUSYCH0_Pos				0				/**< \brief (DMAC_BUSYCH)0Z */
#define DMAC_BUSYCH_BUSYCH0					(1 << DMAC_BUSYCH_BUSYCH0_Pos)
#define DMAC_BUSYCH_BUSYCH1_Pos				1				/**< \brief (DMAC_BUSYCH)1Z */
#define DMAC_BUSYCH_BUSYCH1					(1 << DMAC_BUSYCH_BUSYCH1_Pos)
#define DMAC_BUSYCH_BUSYCH2_Pos				2				/**< \brief (DMAC_BUSYCH)2Z */
#define DMAC_BUSYCH_BUSYCH2					(1 << DMAC_BUSYCH_BUSYCH2_Pos)
#define DMAC_BUSYCH_BUSYCH3_Pos				3				/**< \brief (DMAC_BUSYCH)3Z */
#define DMAC_BUSYCH_BUSYCH3					(1 << DMAC_BUSYCH_BUSYCH3_Pos)
#define DMAC_BUSYCH_BUSYCH4_Pos				4				/**< \brief (DMAC_BUSYCH)4Z */
#define DMAC_BUSYCH_BUSYCH4					(1 << DMAC_BUSYCH_BUSYCH4_Pos)
#define DMAC_BUSYCH_BUSYCH5_Pos				5				/**< \brief (DMAC_BUSYCH)5Z */
#define DMAC_BUSYCH_BUSYCH5					(1 << DMAC_BUSYCH_BUSYCH5_Pos)
#define DMAC_BUSYCH_BUSYCH6_Pos				6				/**< \brief (DMAC_BUSYCH)6Z */
#define DMAC_BUSYCH_BUSYCH6					(1 << DMAC_BUSYCH_BUSYCH6_Pos)
#define DMAC_BUSYCH_BUSYCH7_Pos				7				/**< \brief (DMAC_BUSYCH)7Z */
#define DMAC_BUSYCH_BUSYCH7					(1 << DMAC_BUSYCH_BUSYCH7_Pos)
#define DMAC_BUSYCH_BUSYCH8_Pos				8				/**< \brief (DMAC_BUSYCH)8Z */
#define DMAC_BUSYCH_BUSYCH8					(1 << DMAC_BUSYCH_BUSYCH8_Pos)
#define DMAC_BUSYCH_BUSYCH9_Pos				9				/**< \brief (DMAC_BUSYCH)9Z */
#define DMAC_BUSYCH_BUSYCH9					(1 << DMAC_BUSYCH_BUSYCH9_Pos)
#define DMAC_BUSYCH_BUSYCH10_Pos			10				/**< \brief (DMAC_BUSYCH)10Z */
#define DMAC_BUSYCH_BUSYCH10				(1 << DMAC_BUSYCH_BUSYCH10_Pos)
#define DMAC_BUSYCH_BUSYCH11_Pos			11				/**< \brief (DMAC_BUSYCH)11Z */
#define DMAC_BUSYCH_BUSYCH11				(1 << DMAC_BUSYCH_BUSYCH11_Pos)
#define DMAC_BUSYCH_BUSYCH_Pos				0				/**< \brief (DMAC_BUSYCH)xZ */
#define DMAC_BUSYCH_BUSYCH_Msk				(0xFFFu << DMAC_BUSYCH_BUSYCH_Pos)
#define DMAC_BUSYCH_BUSYCH(value)			((DMAC_BUSYCH_BUSYCH_Msk & ((value) << DMAC_BUSYCH_BUSYCH_Pos)))
#define DMAC_BUSYCH_MASK					0x00000FFFu		/**< \brief (DMAC_BUSYCH)Օڼ޽ */

/* -------- DMAC_PENDCH : (DMACψ:0x2C) (R/  32)ۗ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t PENDCH0:1;			/*!< ޯ     0: 0ۗ */
    uint32_t PENDCH1:1;			/*!< ޯ     1: 1ۗ */
    uint32_t PENDCH2:1;			/*!< ޯ     2: 2ۗ */
    uint32_t PENDCH3:1;			/*!< ޯ     3: 3ۗ */
    uint32_t PENDCH4:1;			/*!< ޯ     4: 4ۗ */
    uint32_t PENDCH5:1;			/*!< ޯ     5: 5ۗ */
    uint32_t PENDCH6:1;			/*!< ޯ     6: 6ۗ */
    uint32_t PENDCH7:1;			/*!< ޯ     7: 7ۗ */
    uint32_t PENDCH8:1;			/*!< ޯ     8: 8ۗ */
    uint32_t PENDCH9:1;			/*!< ޯ     9: 9ۗ */
    uint32_t PENDCH10:1;		/*!< ޯ    10: 10ۗ */
    uint32_t PENDCH11:1;		/*!< ޯ    11: 11ۗ */
    uint32_t :20;				/*!< ޯ12`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint32_t PENDCH:12;			/*!< ޯ 0`11:  0..11 xۗ */
    uint32_t :20;				/*!< ޯ12`31: 12..31 \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} DMAC_PENDCH_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DMAC_PENDCH_OFFSET					0x2C			/**< \brief (DMAC_PENDCH offset)ۗ */
#define DMAC_PENDCH_RESETVALUE				0x00000000		/**< \brief (DMAC_PENDCH reset_value)ۗ */

#define DMAC_PENDCH_PENDCH0_Pos				0				/**< \brief (DMAC_PENDCH)0ۗ */
#define DMAC_PENDCH_PENDCH0					(1 << DMAC_PENDCH_PENDCH0_Pos)
#define DMAC_PENDCH_PENDCH1_Pos				1				/**< \brief (DMAC_PENDCH)1ۗ */
#define DMAC_PENDCH_PENDCH1					(1 << DMAC_PENDCH_PENDCH1_Pos)
#define DMAC_PENDCH_PENDCH2_Pos				2				/**< \brief (DMAC_PENDCH)2ۗ */
#define DMAC_PENDCH_PENDCH2					(1 << DMAC_PENDCH_PENDCH2_Pos)
#define DMAC_PENDCH_PENDCH3_Pos				3				/**< \brief (DMAC_PENDCH)3ۗ */
#define DMAC_PENDCH_PENDCH3					(1 << DMAC_PENDCH_PENDCH3_Pos)
#define DMAC_PENDCH_PENDCH4_Pos				4				/**< \brief (DMAC_PENDCH)4ۗ */
#define DMAC_PENDCH_PENDCH4					(1 << DMAC_PENDCH_PENDCH4_Pos)
#define DMAC_PENDCH_PENDCH5_Pos				5				/**< \brief (DMAC_PENDCH)5ۗ */
#define DMAC_PENDCH_PENDCH5					(1 << DMAC_PENDCH_PENDCH5_Pos)
#define DMAC_PENDCH_PENDCH6_Pos				6				/**< \brief (DMAC_PENDCH)6ۗ */
#define DMAC_PENDCH_PENDCH6					(1 << DMAC_PENDCH_PENDCH6_Pos)
#define DMAC_PENDCH_PENDCH7_Pos				7				/**< \brief (DMAC_PENDCH)7ۗ */
#define DMAC_PENDCH_PENDCH7					(1 << DMAC_PENDCH_PENDCH7_Pos)
#define DMAC_PENDCH_PENDCH8_Pos				8				/**< \brief (DMAC_PENDCH)8ۗ */
#define DMAC_PENDCH_PENDCH8					(1 << DMAC_PENDCH_PENDCH8_Pos)
#define DMAC_PENDCH_PENDCH9_Pos				9				/**< \brief (DMAC_PENDCH)9ۗ */
#define DMAC_PENDCH_PENDCH9					(1 << DMAC_PENDCH_PENDCH9_Pos)
#define DMAC_PENDCH_PENDCH10_Pos			10				/**< \brief (DMAC_PENDCH)10ۗ */
#define DMAC_PENDCH_PENDCH10				(1 << DMAC_PENDCH_PENDCH10_Pos)
#define DMAC_PENDCH_PENDCH11_Pos			11				/**< \brief (DMAC_PENDCH)11ۗ */
#define DMAC_PENDCH_PENDCH11				(1 << DMAC_PENDCH_PENDCH11_Pos)
#define DMAC_PENDCH_PENDCH_Pos				0				/**< \brief (DMAC_PENDCH)xۗ */
#define DMAC_PENDCH_PENDCH_Msk				(0xFFFu << DMAC_PENDCH_PENDCH_Pos)
#define DMAC_PENDCH_PENDCH(value)			((DMAC_PENDCH_PENDCH_Msk & ((value) << DMAC_PENDCH_PENDCH_Pos)))
#define DMAC_PENDCH_MASK					0x00000FFFu		/**< \brief (DMAC_PENDCH)Օڼ޽ */

/* -------- DMAC_ACTIVE : (DMACψ:0x30) (R/  32)ق -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t LVLEX0:1;			/*!< ޯ     0: 0ًNvs */
    uint32_t LVLEX1:1;			/*!< ޯ     1: 1ًNvs */
    uint32_t LVLEX2:1;			/*!< ޯ     2: 2ًNvs */
    uint32_t LVLEX3:1;			/*!< ޯ     3: 3ًNvs */
    uint32_t :4;				/*!< ޯ 4` 7: \ */
    uint32_t ID:5;				/*!< ޯ 8`13: ID */
    uint32_t :2;				/*!< ޯ 13,14: \ */
    uint32_t ABUSY:1;			/*!< ޯ    15: ّZ */
    uint32_t BTCNT:16;			/*!< ޯ16`31: ى] */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint32_t LVLEX:4;			/*!< ޯ 0` 3:  0.. 3 xًNvs */
    uint32_t :28;				/*!< ޯ 4`31:  4..31 \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} DMAC_ACTIVE_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DMAC_ACTIVE_OFFSET					0x30			/**< \brief (DMAC_ACTIVE offset)ق */
#define DMAC_ACTIVE_RESETVALUE				0x00000000		/**< \brief (DMAC_ACTIVE reset_value)ق */

#define DMAC_ACTIVE_LVLEX0_Pos				0				/**< \brief (DMAC_ACTIVE)0ًNvs */
#define DMAC_ACTIVE_LVLEX0					(1 << DMAC_ACTIVE_LVLEX0_Pos)
#define DMAC_ACTIVE_LVLEX1_Pos				1				/**< \brief (DMAC_ACTIVE)1ًNvs */
#define DMAC_ACTIVE_LVLEX1					(1 << DMAC_ACTIVE_LVLEX1_Pos)
#define DMAC_ACTIVE_LVLEX2_Pos				2				/**< \brief (DMAC_ACTIVE)2ًNvs */
#define DMAC_ACTIVE_LVLEX2					(1 << DMAC_ACTIVE_LVLEX2_Pos)
#define DMAC_ACTIVE_LVLEX3_Pos				3				/**< \brief (DMAC_ACTIVE)3ًNvs */
#define DMAC_ACTIVE_LVLEX3					(1 << DMAC_ACTIVE_LVLEX3_Pos)
#define DMAC_ACTIVE_LVLEX_Pos				0				/**< \brief (DMAC_ACTIVE)xًNvs */
#define DMAC_ACTIVE_LVLEX_Msk				(0xFu << DMAC_ACTIVE_LVLEX_Pos)
#define DMAC_ACTIVE_LVLEX(value)			((DMAC_ACTIVE_LVLEX_Msk & ((value) << DMAC_ACTIVE_LVLEX_Pos)))
#define DMAC_ACTIVE_ID_Pos					8				/**< \brief (DMAC_ACTIVE)ID */
#define DMAC_ACTIVE_ID_Msk					(0x1Fu << DMAC_ACTIVE_ID_Pos)
#define DMAC_ACTIVE_ID(value)				((DMAC_ACTIVE_ID_Msk & ((value) << DMAC_ACTIVE_ID_Pos)))
#define DMAC_ACTIVE_ABUSY_Pos				15				/**< \brief (DMAC_ACTIVE)ّZ */
#define DMAC_ACTIVE_ABUSY					(0x1u << DMAC_ACTIVE_ABUSY_Pos)
#define DMAC_ACTIVE_BTCNT_Pos				16				/**< \brief (DMAC_ACTIVE)ى] */
#define DMAC_ACTIVE_BTCNT_Msk				(0xFFFFu << DMAC_ACTIVE_BTCNT_Pos)
#define DMAC_ACTIVE_BTCNT(value)			((DMAC_ACTIVE_BTCNT_Msk & ((value) << DMAC_ACTIVE_BTCNT_Pos)))
#define DMAC_ACTIVE_MASK					0xFFFF9F0Fu		/**< \brief (DMAC_ACTIVE)Օڼ޽ */

/* -------- DMAC_BASEADDR : (DMACψ:0x34) (R/W 32)Lqqؗ̈ڽ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t BASEADDR:32;		/*!< ޯ0`31: Lqq؊ڽ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} DMAC_BASEADDR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DMAC_BASEADDR_OFFSET				0x34			/**< \brief (DMAC_BASEADDR offset)Lqqؗ̈ڽ */
#define DMAC_BASEADDR_RESETVALUE			0x00000000		/**< \brief (DMAC_BASEADDR reset_value)Lqqؗ̈ڽ */

#define DMAC_BASEADDR_BASEADDR_Pos			0				/**< \brief (DMAC_BASEADDR)Lqq؊ڽ */
#define DMAC_BASEADDR_BASEADDR_Msk			(0xFFFFFFFFu << DMAC_BASEADDR_BASEADDR_Pos)
#define DMAC_BASEADDR_BASEADDR(value)		((DMAC_BASEADDR_BASEADDR_Msk & ((value) << DMAC_BASEADDR_BASEADDR_Pos)))
#define DMAC_BASEADDR_MASK					0xFFFFFFFFu		/**< \brief (DMAC_BASEADDR)Օڼ޽ */

/* -------- DMAC_WRBADDR : (DMACψ:0x38) (R/W 32)ײޯ ؗ̈ڽ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t WRBADDR:32;		/*!< ޯ0`31: ײޯ ؊ڽ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} DMAC_WRBADDR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DMAC_WRBADDR_OFFSET					0x38			/**< \brief (DMAC_WRBADDR offset)ײޯ ؗ̈ڽ */
#define DMAC_WRBADDR_RESETVALUE				0x00000000		/**< \brief (DMAC_WRBADDR reset_value)ײޯ ؗ̈ڽ */

#define DMAC_WRBADDR_WRBADDR_Pos			0				/**< \brief (DMAC_WRBADDR)ײޯ ؊ڽ */
#define DMAC_WRBADDR_WRBADDR_Msk			(0xFFFFFFFFu << DMAC_WRBADDR_WRBADDR_Pos)
#define DMAC_WRBADDR_WRBADDR(value)			((DMAC_WRBADDR_WRBADDR_Msk & ((value) << DMAC_WRBADDR_WRBADDR_Pos)))
#define DMAC_WRBADDR_MASK					0xFFFFFFFFu		/**< \brief (DMAC_WRBADDR)Օڼ޽ */

/* -------- DMAC_CHID : (DMACψ:0x3F) (R/W  8)ID -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  ID:4;				/*!< ޯ0`3: ID */
    uint8_t  :4;				/*!< ޯ4`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg; 					/*!< ڼ޽ Ɏgp^ */
} DMAC_CHID_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DMAC_CHID_OFFSET					0x3F			/**< \brief (DMAC_CHID offset)ID */
#define DMAC_CHID_RESETVALUE				0x00			/**< \brief (DMAC_CHID reset_value)ID */

#define DMAC_CHID_ID_Pos					0				/**< \brief (DMAC_CHID)ID */
#define DMAC_CHID_ID_Msk					(0xFu << DMAC_CHID_ID_Pos)
#define DMAC_CHID_ID(value)					((DMAC_CHID_ID_Msk & ((value) << DMAC_CHID_ID_Pos)))
#define DMAC_CHID_MASK						0x0Fu 			/**< \brief (DMAC_CHID)Օڼ޽ */

/* -------- DMAC_CHCTRLA : (DMACψ:0x40) (R/W  8)ِA -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  SWRST:1;			/*!< ޯ   0:  ĳ ؾ */
    uint8_t  ENABLE:1;			/*!< ޯ   1: ً */
    uint8_t  :6;				/*!< ޯ2`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg; 					/*!< ڼ޽ Ɏgp^ */
} DMAC_CHCTRLA_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DMAC_CHCTRLA_OFFSET					0x40			/**< \brief (DMAC_CHCTRLA offset)ِA */
#define DMAC_CHCTRLA_RESETVALUE				0x00			/**< \brief (DMAC_CHCTRLA reset_value)ِA */

#define DMAC_CHCTRLA_SWRST_Pos				0				/**< \brief (DMAC_CHCTRLA) ĳ ؾ */
#define DMAC_CHCTRLA_SWRST					(0x1u << DMAC_CHCTRLA_SWRST_Pos)
#define DMAC_CHCTRLA_ENABLE_Pos				1				/**< \brief (DMAC_CHCTRLA)ً */
#define DMAC_CHCTRLA_ENABLE					(0x1u << DMAC_CHCTRLA_ENABLE_Pos)
#define DMAC_CHCTRLA_MASK					0x03u 			/**< \brief (DMAC_CHCTRLA)Օڼ޽ */

/* -------- DMAC_CHCTRLB : (DMACψ:0x44) (R/W 32)ِB -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t EVACT:3;			/*!< ޯ 0` 2: ۓ͊ */
    uint32_t EVIE:1;			/*!< ޯ     3: َۓ͋ */
    uint32_t EVOE:1;			/*!< ޯ     4: َۏo͋ */
    uint32_t LVL:2;				/*!< ޯ   5,6: ْ */
    uint32_t :1;				/*!< ޯ     7: \ */
    uint32_t TRIGSRC:6;			/*!< ޯ 8`13: Ӌ@\N */
    uint32_t :8;				/*!< ޯ14`21: \ */
    uint32_t TRIGACT:2;			/*!< ޯ 22,23: N */
    uint32_t CMD:2;				/*!< ޯ 24,25: ĳw */
    uint32_t :6;				/*!< ޯ26`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} DMAC_CHCTRLB_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DMAC_CHCTRLB_OFFSET					0x44			/**< \brief (DMAC_CHCTRLB offset)ِB */
#define DMAC_CHCTRLB_RESETVALUE				0x00000000		/**< \brief (DMAC_CHCTRLB reset_value)ِB */

#define DMAC_CHCTRLB_EVACT_Pos				0				/**< \brief (DMAC_CHCTRLB)ۓ͊ */
#define DMAC_CHCTRLB_EVACT_Msk				(0x7u << DMAC_CHCTRLB_EVACT_Pos)
#define DMAC_CHCTRLB_EVACT(value)			((DMAC_CHCTRLB_EVACT_Msk & ((value) << DMAC_CHCTRLB_EVACT_Pos)))
#define   DMAC_CHCTRLB_EVACT_NOACT_Val			0x0u			/**< \brief (DMAC_CHCTRLB)Ȃ */
#define   DMAC_CHCTRLB_EVACT_TRIG_Val			0x1u			/**< \brief (DMAC_CHCTRLB)]ƎI]N */
#define   DMAC_CHCTRLB_EVACT_CTRIG_Val			0x2u			/**< \brief (DMAC_CHCTRLB)t]N */
#define   DMAC_CHCTRLB_EVACT_CBLOCK_Val			0x3u			/**< \brief (DMAC_CHCTRLB)t] */
#define   DMAC_CHCTRLB_EVACT_SUSPEND_Val		0x4u			/**< \brief (DMAC_CHCTRLB)ًx~ */
#define   DMAC_CHCTRLB_EVACT_RESUME_Val			0x5u			/**< \brief (DMAC_CHCTRLB)ٍĊJ */
#define   DMAC_CHCTRLB_EVACT_SSKIP_Val			0x6u			/**< \brief (DMAC_CHCTRLB)̉x~΂ */
#define DMAC_CHCTRLB_EVACT_NOACT			(DMAC_CHCTRLB_EVACT_NOACT_Val	<< DMAC_CHCTRLB_EVACT_Pos)
#define DMAC_CHCTRLB_EVACT_TRIG				(DMAC_CHCTRLB_EVACT_TRIG_Val	<< DMAC_CHCTRLB_EVACT_Pos)
#define DMAC_CHCTRLB_EVACT_CTRIG			(DMAC_CHCTRLB_EVACT_CTRIG_Val	<< DMAC_CHCTRLB_EVACT_Pos)
#define DMAC_CHCTRLB_EVACT_CBLOCK			(DMAC_CHCTRLB_EVACT_CBLOCK_Val	<< DMAC_CHCTRLB_EVACT_Pos)
#define DMAC_CHCTRLB_EVACT_SUSPEND			(DMAC_CHCTRLB_EVACT_SUSPEND_Val	<< DMAC_CHCTRLB_EVACT_Pos)
#define DMAC_CHCTRLB_EVACT_RESUME			(DMAC_CHCTRLB_EVACT_RESUME_Val	<< DMAC_CHCTRLB_EVACT_Pos)
#define DMAC_CHCTRLB_EVACT_SSKIP			(DMAC_CHCTRLB_EVACT_SSKIP_Val	<< DMAC_CHCTRLB_EVACT_Pos)
#define DMAC_CHCTRLB_EVIE_Pos				3				/**< \brief (DMAC_CHCTRLB)َۓ͋ */
#define DMAC_CHCTRLB_EVIE					(0x1u << DMAC_CHCTRLB_EVIE_Pos)
#define DMAC_CHCTRLB_EVOE_Pos				4				/**< \brief (DMAC_CHCTRLB)َۏo͋ */
#define DMAC_CHCTRLB_EVOE					(0x1u << DMAC_CHCTRLB_EVOE_Pos)
#define DMAC_CHCTRLB_LVL_Pos				5				/**< \brief (DMAC_CHCTRLB)ْ */
#define DMAC_CHCTRLB_LVL_Msk				(0x3u << DMAC_CHCTRLB_LVL_Pos)
#define DMAC_CHCTRLB_LVL(value)				((DMAC_CHCTRLB_LVL_Msk & ((value) << DMAC_CHCTRLB_LVL_Pos)))
#define DMAC_CHCTRLB_TRIGSRC_Pos			8				/**< \brief (DMAC_CHCTRLB)Ӌ@\N */
#define DMAC_CHCTRLB_TRIGSRC_Msk			(0x3Fu << DMAC_CHCTRLB_TRIGSRC_Pos)
#define DMAC_CHCTRLB_TRIGSRC(value)			((DMAC_CHCTRLB_TRIGSRC_Msk & ((value) << DMAC_CHCTRLB_TRIGSRC_Pos)))
#define   DMAC_CHCTRLB_TRIGSRC_DISABLE_Val		0x0u			/**< \brief (DMAC_CHCTRLB)ĳ/ۋN̂ */
#define DMAC_CHCTRLB_TRIGSRC_DISABLE		(DMAC_CHCTRLB_TRIGSRC_DISABLE_Val << DMAC_CHCTRLB_TRIGSRC_Pos)
#define DMAC_CHCTRLB_TRIGACT_Pos			22				/**< \brief (DMAC_CHCTRLB)N */
#define DMAC_CHCTRLB_TRIGACT_Msk			(0x3u << DMAC_CHCTRLB_TRIGACT_Pos)
#define DMAC_CHCTRLB_TRIGACT(value)			((DMAC_CHCTRLB_TRIGACT_Msk & ((value) << DMAC_CHCTRLB_TRIGACT_Pos)))
#define   DMAC_CHCTRLB_TRIGACT_BLOCK_Val		0x0u			/**< \brief (DMAC_CHCTRLB)e]ɕKvƂ1̋N */
#define   DMAC_CHCTRLB_TRIGACT_BEAT_Val			0x2u			/**< \brief (DMAC_CHCTRLB)e@o]ɕKvƂ1̋N */
#define   DMAC_CHCTRLB_TRIGACT_TRANSACTION_Val	0x3u			/**< \brief (DMAC_CHCTRLB)ePʓ]ɕKvƂ1̋N */
#define DMAC_CHCTRLB_TRIGACT_BLOCK			(DMAC_CHCTRLB_TRIGACT_BLOCK_Val << DMAC_CHCTRLB_TRIGACT_Pos)
#define DMAC_CHCTRLB_TRIGACT_BEAT			(DMAC_CHCTRLB_TRIGACT_BEAT_Val << DMAC_CHCTRLB_TRIGACT_Pos)
#define DMAC_CHCTRLB_TRIGACT_TRANSACTION	(DMAC_CHCTRLB_TRIGACT_TRANSACTION_Val << DMAC_CHCTRLB_TRIGACT_Pos)
#define DMAC_CHCTRLB_CMD_Pos				24				/**< \brief (DMAC_CHCTRLB)ĳw */
#define DMAC_CHCTRLB_CMD_Msk				(0x3u << DMAC_CHCTRLB_CMD_Pos)
#define DMAC_CHCTRLB_CMD(value)				((DMAC_CHCTRLB_CMD_Msk & ((value) << DMAC_CHCTRLB_CMD_Pos)))
#define   DMAC_CHCTRLB_CMD_NOACT_Val			0x0u			/**< \brief (DMAC_CHCTRLB)Ȃ */
#define   DMAC_CHCTRLB_CMD_SUSPEND_Val			0x1u			/**< \brief (DMAC_CHCTRLB)ًx~ */
#define   DMAC_CHCTRLB_CMD_RESUME_Val			0x2u			/**< \brief (DMAC_CHCTRLB)ٍĊJ */
#define DMAC_CHCTRLB_CMD_NOACT				(DMAC_CHCTRLB_CMD_NOACT_Val		<< DMAC_CHCTRLB_CMD_Pos)
#define DMAC_CHCTRLB_CMD_SUSPEND			(DMAC_CHCTRLB_CMD_SUSPEND_Val	<< DMAC_CHCTRLB_CMD_Pos)
#define DMAC_CHCTRLB_CMD_RESUME				(DMAC_CHCTRLB_CMD_RESUME_Val	<< DMAC_CHCTRLB_CMD_Pos)
#define DMAC_CHCTRLB_MASK					0x03C03F7Fu		/**< \brief (DMAC_CHCTRLB)Օڼ޽ */

/* -------- DMAC_CHINTENCLR : (DMACψ:0x4C) (R/W  8)ي荞݋ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  TERR:1;			/*!< ޯ   0: ]ُ튄荞݋ */
    uint8_t  TCMPL:1;			/*!< ޯ   1: ]荞݋ */
    uint8_t  SUSP:1;			/*!< ޯ   2: ًx~荞݋ */
    uint8_t  :5;				/*!< ޯ3`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg; 					/*!< ڼ޽ Ɏgp^ */
} DMAC_CHINTENCLR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DMAC_CHINTENCLR_OFFSET				0x4C			/**< \brief (DMAC_CHINTENCLR offset)ي荞݋ */
#define DMAC_CHINTENCLR_RESETVALUE			0x00			/**< \brief (DMAC_CHINTENCLR reset_value)ي荞݋ */

#define DMAC_CHINTENCLR_TERR_Pos			0				/**< \brief (DMAC_CHINTENCLR)]ُ튄荞݋ */
#define DMAC_CHINTENCLR_TERR				(0x1u << DMAC_CHINTENCLR_TERR_Pos)
#define DMAC_CHINTENCLR_TCMPL_Pos			1				/**< \brief (DMAC_CHINTENCLR)]荞݋ */
#define DMAC_CHINTENCLR_TCMPL				(0x1u << DMAC_CHINTENCLR_TCMPL_Pos)
#define DMAC_CHINTENCLR_SUSP_Pos			2				/**< \brief (DMAC_CHINTENCLR)ًx~荞݋ */
#define DMAC_CHINTENCLR_SUSP				(0x1u << DMAC_CHINTENCLR_SUSP_Pos)
#define DMAC_CHINTENCLR_MASK				0x07u 			/**< \brief (DMAC_CHINTENCLR)Օڼ޽ */

/* -------- DMAC_CHINTENSET : (DMACψ:0x4D) (R/W  8)ي荞݋ݒ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  TERR:1;			/*!< ޯ   0: ]ُ튄荞݋    */
    uint8_t  TCMPL:1;			/*!< ޯ   1: ]荞݋ */
    uint8_t  SUSP:1;			/*!< ޯ   2: ًx~荞݋   */
    uint8_t  :5;				/*!< ޯ3`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg; 					/*!< ڼ޽ Ɏgp^ */
} DMAC_CHINTENSET_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DMAC_CHINTENSET_OFFSET				0x4D			/**< \brief (DMAC_CHINTENSET offset)ي荞݋ݒ */
#define DMAC_CHINTENSET_RESETVALUE			0x00			/**< \brief (DMAC_CHINTENSET reset_value)ي荞݋ݒ */

#define DMAC_CHINTENSET_TERR_Pos			0				/**< \brief (DMAC_CHINTENSET)]ُ튄荞݋ */
#define DMAC_CHINTENSET_TERR				(0x1u << DMAC_CHINTENSET_TERR_Pos)
#define DMAC_CHINTENSET_TCMPL_Pos			1				/**< \brief (DMAC_CHINTENSET)]荞݋ */
#define DMAC_CHINTENSET_TCMPL				(0x1u << DMAC_CHINTENSET_TCMPL_Pos)
#define DMAC_CHINTENSET_SUSP_Pos			2				/**< \brief (DMAC_CHINTENSET)ًx~荞݋ */
#define DMAC_CHINTENSET_SUSP				(0x1u << DMAC_CHINTENSET_SUSP_Pos)
#define DMAC_CHINTENSET_MASK				0x07u 			/**< \brief (DMAC_CHINTENSET)Օڼ޽ */

/* -------- DMAC_CHINTFLAG : (DMACψ:0x4E) (R/W  8)ي荞׸/ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  TERR:1;			/*!< ޯ   0: ]ُ */
    uint8_t  TCMPL:1;			/*!< ޯ   1: ] */
    uint8_t  SUSP:1;			/*!< ޯ   2: ًx~ */
    uint8_t  :5;				/*!< ޯ3`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg; 					/*!< ڼ޽ Ɏgp^ */
} DMAC_CHINTFLAG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DMAC_CHINTFLAG_OFFSET				0x4E			/**< \brief (DMAC_CHINTFLAG offset)ي荞׸/ */
#define DMAC_CHINTFLAG_RESETVALUE			0x00			/**< \brief (DMAC_CHINTFLAG reset_value)ي荞׸/ */

#define DMAC_CHINTFLAG_TERR_Pos				0				/**< \brief (DMAC_CHINTFLAG)]ُ */
#define DMAC_CHINTFLAG_TERR					(0x1u << DMAC_CHINTFLAG_TERR_Pos)
#define DMAC_CHINTFLAG_TCMPL_Pos			1				/**< \brief (DMAC_CHINTFLAG)] */
#define DMAC_CHINTFLAG_TCMPL				(0x1u << DMAC_CHINTFLAG_TCMPL_Pos)
#define DMAC_CHINTFLAG_SUSP_Pos				2				/**< \brief (DMAC_CHINTFLAG)ًx~ */
#define DMAC_CHINTFLAG_SUSP					(0x1u << DMAC_CHINTFLAG_SUSP_Pos)
#define DMAC_CHINTFLAG_MASK					0x07u 			/**< \brief (DMAC_CHINTFLAG)Օڼ޽ */

/* -------- DMAC_CHSTATUS : (DMACψ:0x4F) (R/   8)ُ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  PEND:1;			/*!< ޯ   0: ٕۗ */
    uint8_t  BUSY:1;			/*!< ޯ   1: ّZ */
    uint8_t  FERR:1;			/*!< ޯ   2: 擾ُ */
    uint8_t  :5;				/*!< ޯ3`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg; 					/*!< ڼ޽ Ɏgp^ */
} DMAC_CHSTATUS_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DMAC_CHSTATUS_OFFSET				0x4F			/**< \brief (DMAC_CHSTATUS offset)ُ */
#define DMAC_CHSTATUS_RESETVALUE			0x00			/**< \brief (DMAC_CHSTATUS reset_value)ُ */

#define DMAC_CHSTATUS_PEND_Pos				0				/**< \brief (DMAC_CHSTATUS)ٕۗ */
#define DMAC_CHSTATUS_PEND					(0x1u << DMAC_CHSTATUS_PEND_Pos)
#define DMAC_CHSTATUS_BUSY_Pos				1				/**< \brief (DMAC_CHSTATUS)ّZ */
#define DMAC_CHSTATUS_BUSY					(0x1u << DMAC_CHSTATUS_BUSY_Pos)
#define DMAC_CHSTATUS_FERR_Pos				2				/**< \brief (DMAC_CHSTATUS)擾ُ */
#define DMAC_CHSTATUS_FERR					(0x1u << DMAC_CHSTATUS_FERR_Pos)
#define DMAC_CHSTATUS_MASK					0x07u 			/**< \brief (DMAC_CHSTATUS)Օڼ޽ */

/* -------- DMAC_BTCTRL : (DMACψ:0x00) (R/W 16)] -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t VALID:1;			/*!< ޯ     0: LqqL */
    uint16_t EVOSEL:2;			/*!< ޯ   1,2: ۏo͑I */
    uint16_t BLOCKACT:2;		/*!< ޯ   3,4: 򊈓 */
    uint16_t :3;				/*!< ޯ  5`7: \ */
    uint16_t BEATSIZE:2;		/*!< ޯ   8,9: @ȏ傫 */
    uint16_t SRCINC:1;			/*!< ޯ    10: ]ڽ */
    uint16_t DSTINC:1;			/*!< ޯ    11: ]ڽ */
    uint16_t STEPSEL:1;			/*!< ޯ    12: ~I */
    uint16_t STEPSIZE:3;		/*!< ޯ13`15: ڽiK̑傫 */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} DMAC_BTCTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DMAC_BTCTRL_OFFSET					0x00			/**< \brief (DMAC_BTCTRL offset)] */

#define DMAC_BTCTRL_VALID_Pos				0				/**< \brief (DMAC_BTCTRL)LqqL */
#define DMAC_BTCTRL_VALID					(0x1u << DMAC_BTCTRL_VALID_Pos)
#define DMAC_BTCTRL_EVOSEL_Pos				1				/**< \brief (DMAC_BTCTRL)ۏo͑I */
#define DMAC_BTCTRL_EVOSEL_Msk				(0x3u << DMAC_BTCTRL_EVOSEL_Pos)
#define DMAC_BTCTRL_EVOSEL(value)			((DMAC_BTCTRL_EVOSEL_Msk & ((value) << DMAC_BTCTRL_EVOSEL_Pos)))
#define   DMAC_BTCTRL_EVOSEL_DISABLE_Val		0x0u			/**< \brief (DMAC_BTCTRL)ې֎~ */
#define   DMAC_BTCTRL_EVOSEL_BLOCK_Val			0x1u			/**< \brief (DMAC_BTCTRL)]Ɏ۽۰ */
#define   DMAC_BTCTRL_EVOSEL_BEAT_Val			0x3u			/**< \brief (DMAC_BTCTRL)@o]Ɏ۽۰ */
#define DMAC_BTCTRL_EVOSEL_DISABLE			(DMAC_BTCTRL_EVOSEL_DISABLE_Val	<< DMAC_BTCTRL_EVOSEL_Pos)
#define DMAC_BTCTRL_EVOSEL_BLOCK			(DMAC_BTCTRL_EVOSEL_BLOCK_Val	<< DMAC_BTCTRL_EVOSEL_Pos)
#define DMAC_BTCTRL_EVOSEL_BEAT				(DMAC_BTCTRL_EVOSEL_BEAT_Val	<< DMAC_BTCTRL_EVOSEL_Pos)
#define DMAC_BTCTRL_BLOCKACT_Pos			3				/**< \brief (DMAC_BTCTRL)򊈓 */
#define DMAC_BTCTRL_BLOCKACT_Msk			(0x3u << DMAC_BTCTRL_BLOCKACT_Pos)
#define DMAC_BTCTRL_BLOCKACT(value)			((DMAC_BTCTRL_BLOCKACT_Msk & ((value) << DMAC_BTCTRL_BLOCKACT_Pos)))
#define   DMAC_BTCTRL_BLOCKACT_NOACT_Val		0x0u			/**< \brief (DMAC_BTCTRL)Ȃ */
#define   DMAC_BTCTRL_BLOCKACT_INT_Val			0x1u			/**< \brief (DMAC_BTCTRL)WłقƉ򊄂荞 */
#define   DMAC_BTCTRL_BLOCKACT_SUSPEND_Val		0x2u			/**< \brief (DMAC_BTCTRL)ًx~슮 */
#define   DMAC_BTCTRL_BLOCKACT_BOTH_Val			0x3u			/**< \brief (DMAC_BTCTRL)x~Ɖ򊄂荞݂̗ */
#define DMAC_BTCTRL_BLOCKACT_NOACT			(DMAC_BTCTRL_BLOCKACT_NOACT_Val		<< DMAC_BTCTRL_BLOCKACT_Pos)
#define DMAC_BTCTRL_BLOCKACT_INT			(DMAC_BTCTRL_BLOCKACT_INT_Val		<< DMAC_BTCTRL_BLOCKACT_Pos)
#define DMAC_BTCTRL_BLOCKACT_SUSPEND		(DMAC_BTCTRL_BLOCKACT_SUSPEND_Val	<< DMAC_BTCTRL_BLOCKACT_Pos)
#define DMAC_BTCTRL_BLOCKACT_BOTH			(DMAC_BTCTRL_BLOCKACT_BOTH_Val		<< DMAC_BTCTRL_BLOCKACT_Pos)
#define DMAC_BTCTRL_BEATSIZE_Pos			8				/**< \brief (DMAC_BTCTRL)@ȏ傫 */
#define DMAC_BTCTRL_BEATSIZE_Msk			(0x3u << DMAC_BTCTRL_BEATSIZE_Pos)
#define DMAC_BTCTRL_BEATSIZE(value)			((DMAC_BTCTRL_BEATSIZE_Msk & ((value) << DMAC_BTCTRL_BEATSIZE_Pos)))
#define   DMAC_BTCTRL_BEATSIZE_BYTE_Val			0x0u			/**< \brief (DMAC_BTCTRL)8ޯ  */
#define   DMAC_BTCTRL_BEATSIZE_HWORD_Val		0x1u			/**< \brief (DMAC_BTCTRL)16ޯ  */
#define   DMAC_BTCTRL_BEATSIZE_WORD_Val			0x2u			/**< \brief (DMAC_BTCTRL)32ޯ  */
#define DMAC_BTCTRL_BEATSIZE_BYTE			(DMAC_BTCTRL_BEATSIZE_BYTE_Val	<< DMAC_BTCTRL_BEATSIZE_Pos)
#define DMAC_BTCTRL_BEATSIZE_HWORD			(DMAC_BTCTRL_BEATSIZE_HWORD_Val	<< DMAC_BTCTRL_BEATSIZE_Pos)
#define DMAC_BTCTRL_BEATSIZE_WORD			(DMAC_BTCTRL_BEATSIZE_WORD_Val	<< DMAC_BTCTRL_BEATSIZE_Pos)
#define DMAC_BTCTRL_SRCINC_Pos				10				/**< \brief (DMAC_BTCTRL)]ڽ */
#define DMAC_BTCTRL_SRCINC					(0x1u << DMAC_BTCTRL_SRCINC_Pos)
#define DMAC_BTCTRL_DSTINC_Pos				11				/**< \brief (DMAC_BTCTRL)]ڽ */
#define DMAC_BTCTRL_DSTINC					(0x1u << DMAC_BTCTRL_DSTINC_Pos)
#define DMAC_BTCTRL_STEPSEL_Pos				12				/**< \brief (DMAC_BTCTRL)~I */
#define DMAC_BTCTRL_STEPSEL					(0x1u << DMAC_BTCTRL_STEPSEL_Pos)
#define   DMAC_BTCTRL_STEPSEL_DST_Val					0x0u			/**< \brief (DMAC_BTCTRL)]ڽɓKpiK̑傫ݒ */
#define   DMAC_BTCTRL_STEPSEL_SRC_Val					0x1u			/**< \brief (DMAC_BTCTRL)]ڽɓKpiK̑傫ݒ */
#define DMAC_BTCTRL_STEPSEL_DST				(DMAC_BTCTRL_STEPSEL_DST_Val << DMAC_BTCTRL_STEPSEL_Pos)
#define DMAC_BTCTRL_STEPSEL_SRC				(DMAC_BTCTRL_STEPSEL_SRC_Val << DMAC_BTCTRL_STEPSEL_Pos)
#define DMAC_BTCTRL_STEPSIZE_Pos			13				/**< \brief (DMAC_BTCTRL)ڽiK̑傫 */
#define DMAC_BTCTRL_STEPSIZE_Msk			(0x7u << DMAC_BTCTRL_STEPSIZE_Pos)
#define DMAC_BTCTRL_STEPSIZE(value)			((DMAC_BTCTRL_STEPSIZE_Msk & ((value) << DMAC_BTCTRL_STEPSIZE_Pos)))
#define   DMAC_BTCTRL_STEPSIZE_X1_Val			0x0u			/**< \brief (DMAC_BTCTRL)ADDRADDR+BEATSIZE~1 */
#define   DMAC_BTCTRL_STEPSIZE_X2_Val			0x1u			/**< \brief (DMAC_BTCTRL)ADDRADDR+BEATSIZE~2 */
#define   DMAC_BTCTRL_STEPSIZE_X4_Val			0x2u			/**< \brief (DMAC_BTCTRL)ADDRADDR+BEATSIZE~4 */
#define   DMAC_BTCTRL_STEPSIZE_X8_Val			0x3u			/**< \brief (DMAC_BTCTRL)ADDRADDR+BEATSIZE~8 */
#define   DMAC_BTCTRL_STEPSIZE_X16_Val			0x4u			/**< \brief (DMAC_BTCTRL)ADDRADDR+BEATSIZE~16 */
#define   DMAC_BTCTRL_STEPSIZE_X32_Val			0x5u			/**< \brief (DMAC_BTCTRL)ADDRADDR+BEATSIZE~32 */
#define   DMAC_BTCTRL_STEPSIZE_X64_Val			0x6u			/**< \brief (DMAC_BTCTRL)ADDRADDR+BEATSIZE~64 */
#define   DMAC_BTCTRL_STEPSIZE_X128_Val			0x7u			/**< \brief (DMAC_BTCTRL)ADDRADDR+BEATSIZE~128 */
#define DMAC_BTCTRL_STEPSIZE_X1				(DMAC_BTCTRL_STEPSIZE_X1_Val	<< DMAC_BTCTRL_STEPSIZE_Pos)
#define DMAC_BTCTRL_STEPSIZE_X2				(DMAC_BTCTRL_STEPSIZE_X2_Val	<< DMAC_BTCTRL_STEPSIZE_Pos)
#define DMAC_BTCTRL_STEPSIZE_X4				(DMAC_BTCTRL_STEPSIZE_X4_Val	<< DMAC_BTCTRL_STEPSIZE_Pos)
#define DMAC_BTCTRL_STEPSIZE_X8				(DMAC_BTCTRL_STEPSIZE_X8_Val	<< DMAC_BTCTRL_STEPSIZE_Pos)
#define DMAC_BTCTRL_STEPSIZE_X16			(DMAC_BTCTRL_STEPSIZE_X16_Val	<< DMAC_BTCTRL_STEPSIZE_Pos)
#define DMAC_BTCTRL_STEPSIZE_X32			(DMAC_BTCTRL_STEPSIZE_X32_Val	<< DMAC_BTCTRL_STEPSIZE_Pos)
#define DMAC_BTCTRL_STEPSIZE_X64			(DMAC_BTCTRL_STEPSIZE_X64_Val	<< DMAC_BTCTRL_STEPSIZE_Pos)
#define DMAC_BTCTRL_STEPSIZE_X128			(DMAC_BTCTRL_STEPSIZE_X128_Val	<< DMAC_BTCTRL_STEPSIZE_Pos)
#define DMAC_BTCTRL_MASK					0xFF1Fu			/**< \brief (DMAC_BTCTRL)Օڼ޽ */

/* -------- DMAC_BTCNT : (DMACψ:0x02) (R/W 16)] -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t BTCNT:16;			/*!< ޯ0`15: ] */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} DMAC_BTCNT_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DMAC_BTCNT_OFFSET					0x02			/**< \brief (DMAC_BTCNT offset)] */

#define DMAC_BTCNT_BTCNT_Pos				0				/**< \brief (DMAC_BTCNT)] */
#define DMAC_BTCNT_BTCNT_Msk				(0xFFFFu << DMAC_BTCNT_BTCNT_Pos)
#define DMAC_BTCNT_BTCNT(value)				((DMAC_BTCNT_BTCNT_Msk & ((value) << DMAC_BTCNT_BTCNT_Pos)))
#define DMAC_BTCNT_MASK						0xFFFFu			/**< \brief (DMAC_BTCNT)Օڼ޽ */

/* -------- DMAC_SRCADDR : (DMACψ:0x04) (R/W 32)]ڽ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t SRCADDR:32;		/*!< ޯ0`31: ]ڽ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} DMAC_SRCADDR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DMAC_SRCADDR_OFFSET					0x04			/**< \brief (DMAC_SRCADDR offset)]ڽ */

#define DMAC_SRCADDR_SRCADDR_Pos			0				/**< \brief (DMAC_SRCADDR)]ڽ */
#define DMAC_SRCADDR_SRCADDR_Msk			(0xFFFFFFFFu << DMAC_SRCADDR_SRCADDR_Pos)
#define DMAC_SRCADDR_SRCADDR(value)			((DMAC_SRCADDR_SRCADDR_Msk & ((value) << DMAC_SRCADDR_SRCADDR_Pos)))
#define DMAC_SRCADDR_MASK					0xFFFFFFFFu		/**< \brief (DMAC_SRCADDR)Օڼ޽ */

/* -------- DMAC_DSTADDR : (DMACψ:0x08) (R/W 32)]ڽ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t DSTADDR:32;		/*!< ޯ0`31: ]ڽ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} DMAC_DSTADDR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DMAC_DSTADDR_OFFSET					0x08			/**< \brief (DMAC_DSTADDR offset)]ڽ */

#define DMAC_DSTADDR_DSTADDR_Pos			0				/**< \brief (DMAC_DSTADDR)]ڽ */
#define DMAC_DSTADDR_DSTADDR_Msk			(0xFFFFFFFFu << DMAC_DSTADDR_DSTADDR_Pos)
#define DMAC_DSTADDR_DSTADDR(value)			((DMAC_DSTADDR_DSTADDR_Msk & ((value) << DMAC_DSTADDR_DSTADDR_Pos)))
#define DMAC_DSTADDR_MASK					0xFFFFFFFFu		/**< \brief (DMAC_DSTADDR)Օڼ޽ */

/* -------- DMAC_DESCADDR : (DMACψ:0x0C) (R/W 32)̋Lqqڽ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t DESCADDR:32;		/*!< ޯ0`31: ̋Lqqڽ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} DMAC_DESCADDR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DMAC_DESCADDR_OFFSET				0x0C			/**< \brief (DMAC_DESCADDR offset)̋Lqqڽ */

#define DMAC_DESCADDR_DESCADDR_Pos			0				/**< \brief (DMAC_DESCADDR)̋Lqqڽ */
#define DMAC_DESCADDR_DESCADDR_Msk			(0xFFFFFFFFu << DMAC_DESCADDR_DESCADDR_Pos)
#define DMAC_DESCADDR_DESCADDR(value)		((DMAC_DESCADDR_DESCADDR_Msk & ((value) << DMAC_DESCADDR_DESCADDR_Pos)))
#define DMAC_DESCADDR_MASK					0xFFFFFFFFu		/**< \brief (DMAC_DESCADDR)Օڼ޽ */

/** \brief DMAC APBʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  __IO DMAC_CTRL_Type			CTRL;			/**< \briefψ:0x00 (R/W 16) */
  __IO DMAC_CRCCTRL_Type		CRCCTRL;		/**< \briefψ:0x02 (R/W 16)CRC */
  __IO DMAC_CRCDATAIN_Type		CRCDATAIN;		/**< \briefψ:0x04 (R/W 32)CRCް */
  __IO DMAC_CRCCHKSUM_Type		CRCCHKSUM;		/**< \briefψ:0x08 (R/W 32)CRC */
  __IO DMAC_CRCSTATUS_Type		CRCSTATUS;		/**< \briefψ:0x0C (R/W  8)CRC */
  __IO DMAC_DBGCTRL_Type		DBGCTRL;		/**< \briefψ:0x0D (R/W  8)ޯސ */
	   RoReg8					Reserved1[0x2];
  __IO DMAC_SWTRIGCTRL_Type		SWTRIGCTRL;		/**< \briefψ:0x10 (R/W 32)ĳN */
  __IO DMAC_PRICTRL0_Type		PRICTRL0;		/**< \briefψ:0x14 (R/W 32)è0 */
	   RoReg8					Reserved2[0x8];
  __IO DMAC_INTPEND_Type		INTPEND;		/**< \briefψ:0x20 (R/W 16)荞ݕۗ */
	   RoReg8					Reserved3[0x2];
  __I  DMAC_INTSTATUS_Type		INTSTATUS;		/**< \briefψ:0x24 (R/  32)荞ݏ */
  __I  DMAC_BUSYCH_Type			BUSYCH;			/**< \briefψ:0x28 (R/  32)Z */
  __I  DMAC_PENDCH_Type			PENDCH;			/**< \briefψ:0x2C (R/  32)ۗ */
  __I  DMAC_ACTIVE_Type			ACTIVE;			/**< \briefψ:0x30 (R/  32)ق */
  __IO DMAC_BASEADDR_Type		BASEADDR;		/**< \briefψ:0x34 (R/W 32)Lqqؗ̈ڽ */
  __IO DMAC_WRBADDR_Type		WRBADDR;		/**< \briefψ:0x38 (R/W 32)ײޯ ؗ̈ڽ */
	   RoReg8					Reserved4[0x3];
  __IO DMAC_CHID_Type			CHID;			/**< \briefψ:0x3F (R/W  8)ID */
  __IO DMAC_CHCTRLA_Type		CHCTRLA;		/**< \briefψ:0x40 (R/W  8)ِA */
	   RoReg8					Reserved5[0x3];
  __IO DMAC_CHCTRLB_Type		CHCTRLB;		/**< \briefψ:0x44 (R/W 32)ِB */
	   RoReg8					Reserved6[0x4];
  __IO DMAC_CHINTENCLR_Type		CHINTENCLR;		/**< \briefψ:0x4C (R/W  8)ي荞݋ */
  __IO DMAC_CHINTENSET_Type		CHINTENSET;		/**< \briefψ:0x4D (R/W  8)ي荞݋ݒ */
  __IO DMAC_CHINTFLAG_Type		CHINTFLAG;		/**< \briefψ:0x4E (R/W  8)ي荞׸/ */
  __I  DMAC_CHSTATUS_Type		CHSTATUS;		/**< \briefψ:0x4F (R/   8)ُ */
} Dmac;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/** \brief DMACLqqʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  __IO DMAC_BTCTRL_Type			BTCTRL;			/**< \briefψ:0x00 (R/W 16)] */
  __IO DMAC_BTCNT_Type			BTCNT;			/**< \briefψ:0x02 (R/W 16)] */
  __IO DMAC_SRCADDR_Type		SRCADDR;		/**< \briefψ:0x04 (R/W 32)]ڽ */
  __IO DMAC_DSTADDR_Type		DSTADDR;		/**< \briefψ:0x08 (R/W 32)]ڽ */
  __IO DMAC_DESCADDR_Type		DESCADDR;		/**< \briefψ:0x0C (R/W 32)̋Lqqڽ */
} DmacDescriptor
#ifdef __GNUC__
  __attribute__ ((aligned (8)))
#endif
;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#ifdef __GNUC__
 #define SECTION_DMAC_DESCRIPTOR
#endif

/*@}*/

#endif /* _SAMD21_DMAC_COMPONENT_ */
