/**
 * \file
 *
 * \brief EICp\iLq
 *
 * 쌠 (c) 2013 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAMD21_EIC_COMPONENT_
#define _SAMD21_EIC_COMPONENT_

/* ========================================================================== */
/** EICpĳAPI` */
/* ========================================================================== */
/** \addtogroup SAMD21_EIC O荞ݐ */
/*@{*/

#define EIC_U2217
#define REV_EIC						0x101

/* -------- EIC_CTRL : (EICψ:0x00) (R/W  8) -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  SWRST:1;			/*!< ޯ   0: ĳ ؾ */
    uint8_t  ENABLE:1;			/*!< ޯ   1:  */
    uint8_t  :6;				/*!< ޯ2`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} EIC_CTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EIC_CTRL_OFFSET				0x00			/**< \brief (EIC_CTRL offset) */
#define EIC_CTRL_RESETVALUE			0x00			/**< \brief (EIC_CTRL reset_value) */

#define EIC_CTRL_SWRST_Pos			0				/**< \brief (EIC_CTRL)ĳ ؾ */
#define EIC_CTRL_SWRST				(0x1u << EIC_CTRL_SWRST_Pos)
#define EIC_CTRL_ENABLE_Pos			1				/**< \brief (EIC_CTRL) */
#define EIC_CTRL_ENABLE				(0x1u << EIC_CTRL_ENABLE_Pos)
#define EIC_CTRL_MASK				0x03u			/**< \brief (EIC_CTRL)Օڼ޽ */

/* -------- EIC_STATUS : (EICψ:0x01) (R/   8) -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  :7;				/*!< ޯ0`6: \ */
    uint8_t  SYNCBUSY:1;		/*!< ޯ   7: Z */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} EIC_STATUS_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EIC_STATUS_OFFSET			0x01			/**< \brief (EIC_STATUS offset) */
#define EIC_STATUS_RESETVALUE		0x00			/**< \brief (EIC_STATUS reset_value) */

#define EIC_STATUS_SYNCBUSY_Pos		7				/**< \brief (EIC_STATUS)Z */
#define EIC_STATUS_SYNCBUSY			(0x1u << EIC_STATUS_SYNCBUSY_Pos)
#define EIC_STATUS_MASK				0x80u			/**< \brief (EIC_STATUS)Օڼ޽ */

/* -------- EIC_NMICTRL : (EICψ:0x02) (R/W  8)Օs荞ݐ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  NMISENSE:3;		/*!< ޯ0`2: Օs荞݊m */
    uint8_t  NMIFILTEN:1;		/*!< ޯ   3: Օs荞hg틖 */
    uint8_t  :4;				/*!< ޯ4`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} EIC_NMICTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EIC_NMICTRL_OFFSET			0x02			/**< \brief (EIC_NMICTRL offset)Օs荞ݐ */
#define EIC_NMICTRL_RESETVALUE		0x00			/**< \brief (EIC_NMICTRL reset_value)Օs荞ݐ */

#define EIC_NMICTRL_NMISENSE_Pos	0				/**< \brief (EIC_NMICTRL)Օs */
#define EIC_NMICTRL_NMISENSE_Msk	(0x7u << EIC_NMICTRL_NMISENSE_Pos)
#define EIC_NMICTRL_NMISENSE(value)	((EIC_NMICTRL_NMISENSE_Msk & ((value) << EIC_NMICTRL_NMISENSE_Pos)))
#define   EIC_NMICTRL_NMISENSE_NONE_Val	0x0u			/**< \brief (EIC_NMICTRL)oȂ */
#define   EIC_NMICTRL_NMISENSE_RISE_Val	0x1u			/**< \brief (EIC_NMICTRL)㏸[o */
#define   EIC_NMICTRL_NMISENSE_FALL_Val	0x2u			/**< \brief (EIC_NMICTRL)~[o */
#define   EIC_NMICTRL_NMISENSE_BOTH_Val	0x3u			/**< \brief (EIC_NMICTRL)[o */
#define   EIC_NMICTRL_NMISENSE_HIGH_Val	0x4u			/**< \brief (EIC_NMICTRL)Highٌo */
#define   EIC_NMICTRL_NMISENSE_LOW_Val	0x5u			/**< \brief (EIC_NMICTRL)Lowٌo */
#define EIC_NMICTRL_NMISENSE_NONE	(EIC_NMICTRL_NMISENSE_NONE_Val	<< EIC_NMICTRL_NMISENSE_Pos)
#define EIC_NMICTRL_NMISENSE_RISE	(EIC_NMICTRL_NMISENSE_RISE_Val	<< EIC_NMICTRL_NMISENSE_Pos)
#define EIC_NMICTRL_NMISENSE_FALL	(EIC_NMICTRL_NMISENSE_FALL_Val	<< EIC_NMICTRL_NMISENSE_Pos)
#define EIC_NMICTRL_NMISENSE_BOTH	(EIC_NMICTRL_NMISENSE_BOTH_Val	<< EIC_NMICTRL_NMISENSE_Pos)
#define EIC_NMICTRL_NMISENSE_HIGH	(EIC_NMICTRL_NMISENSE_HIGH_Val	<< EIC_NMICTRL_NMISENSE_Pos)
#define EIC_NMICTRL_NMISENSE_LOW 	(EIC_NMICTRL_NMISENSE_LOW_Val	<< EIC_NMICTRL_NMISENSE_Pos)
#define EIC_NMICTRL_NMIFILTEN_Pos	3				/**< \brief (EIC_NMICTRL)Օs荞hg틖 */
#define EIC_NMICTRL_NMIFILTEN		(0x1u << EIC_NMICTRL_NMIFILTEN_Pos)
#define EIC_NMICTRL_MASK			0x0Fu			/**< \brief (EIC_NMICTRL)Օڼ޽ */

/* -------- EIC_NMIFLAG : (EICψ:0x03) (R/W  8)Օs荞׸ޏ/ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  NMI:1;				/*!< ޯ   0: Օs荞 */
    uint8_t  :7;				/*!< ޯ1`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} EIC_NMIFLAG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EIC_NMIFLAG_OFFSET			0x03			/**< \brief (EIC_NMIFLAG offset)Օs荞׸ޏ/ */
#define EIC_NMIFLAG_RESETVALUE		0x00			/**< \brief (EIC_NMIFLAG reset_value)Օs荞׸ޏ/ */

#define EIC_NMIFLAG_NMI_Pos			0				/**< \brief (EIC_NMIFLAG)Օs荞 */
#define EIC_NMIFLAG_NMI				(0x1u << EIC_NMIFLAG_NMI_Pos)
#define EIC_NMIFLAG_MASK			0x01u			/**< \brief (EIC_NMIFLAG)Օڼ޽ */

/* -------- EIC_EVCTRL : (EICψ:0x04) (R/W 32)ې -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t EXTINTEO0:1;		/*!< ޯ     0: O荞0ۏo͋ */
    uint32_t EXTINTEO1:1;		/*!< ޯ     1: O荞1ۏo͋ */
    uint32_t EXTINTEO2:1;		/*!< ޯ     2: O荞2ۏo͋ */
    uint32_t EXTINTEO3:1;		/*!< ޯ     3: O荞3ۏo͋ */
    uint32_t EXTINTEO4:1;		/*!< ޯ     4: O荞4ۏo͋ */
    uint32_t EXTINTEO5:1;		/*!< ޯ     5: O荞5ۏo͋ */
    uint32_t EXTINTEO6:1;		/*!< ޯ     6: O荞6ۏo͋ */
    uint32_t EXTINTEO7:1;		/*!< ޯ     7: O荞7ۏo͋ */
    uint32_t EXTINTEO8:1;		/*!< ޯ     8: O荞8ۏo͋ */
    uint32_t EXTINTEO9:1;		/*!< ޯ     9: O荞9ۏo͋ */
    uint32_t EXTINTEO10:1;		/*!< ޯ    10: O荞10ۏo͋ */
    uint32_t EXTINTEO11:1;		/*!< ޯ    11: O荞11ۏo͋ */
    uint32_t EXTINTEO12:1;		/*!< ޯ    12: O荞12ۏo͋ */
    uint32_t EXTINTEO13:1;		/*!< ޯ    13: O荞13ۏo͋ */
    uint32_t EXTINTEO14:1;		/*!< ޯ    14: O荞14ۏo͋ */
    uint32_t EXTINTEO15:1;		/*!< ޯ    15: O荞15ۏo͋ */
    uint32_t :16;				/*!< ޯ16`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint32_t EXTINTEO:16;		/*!< ޯ 0`15: O荞xۏo͋ */
    uint32_t :16;				/*!< ޯ16`31: \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} EIC_EVCTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EIC_EVCTRL_OFFSET			0x04			/**< \brief (EIC_EVCTRL offset)ې */
#define EIC_EVCTRL_RESETVALUE		0x00000000		/**< \brief (EIC_EVCTRL reset_value)ې */

#define EIC_EVCTRL_EXTINTEO0_Pos	0				/**< \brief (EIC_EVCTRL)O荞0ۏo͋ */
#define EIC_EVCTRL_EXTINTEO0		(1 << EIC_EVCTRL_EXTINTEO0_Pos)
#define EIC_EVCTRL_EXTINTEO1_Pos	1				/**< \brief (EIC_EVCTRL)O荞1ۏo͋ */
#define EIC_EVCTRL_EXTINTEO1		(1 << EIC_EVCTRL_EXTINTEO1_Pos)
#define EIC_EVCTRL_EXTINTEO2_Pos	2				/**< \brief (EIC_EVCTRL)O荞2ۏo͋ */
#define EIC_EVCTRL_EXTINTEO2		(1 << EIC_EVCTRL_EXTINTEO2_Pos)
#define EIC_EVCTRL_EXTINTEO3_Pos	3				/**< \brief (EIC_EVCTRL)O荞3ۏo͋ */
#define EIC_EVCTRL_EXTINTEO3		(1 << EIC_EVCTRL_EXTINTEO3_Pos)
#define EIC_EVCTRL_EXTINTEO4_Pos	4				/**< \brief (EIC_EVCTRL)O荞4ۏo͋ */
#define EIC_EVCTRL_EXTINTEO4		(1 << EIC_EVCTRL_EXTINTEO4_Pos)
#define EIC_EVCTRL_EXTINTEO5_Pos	5				/**< \brief (EIC_EVCTRL)O荞5ۏo͋ */
#define EIC_EVCTRL_EXTINTEO5		(1 << EIC_EVCTRL_EXTINTEO5_Pos)
#define EIC_EVCTRL_EXTINTEO6_Pos	6				/**< \brief (EIC_EVCTRL)O荞6ۏo͋ */
#define EIC_EVCTRL_EXTINTEO6		(1 << EIC_EVCTRL_EXTINTEO6_Pos)
#define EIC_EVCTRL_EXTINTEO7_Pos	7				/**< \brief (EIC_EVCTRL)O荞7ۏo͋ */
#define EIC_EVCTRL_EXTINTEO7		(1 << EIC_EVCTRL_EXTINTEO7_Pos)
#define EIC_EVCTRL_EXTINTEO8_Pos	8				/**< \brief (EIC_EVCTRL)O荞8ۏo͋ */
#define EIC_EVCTRL_EXTINTEO8		(1 << EIC_EVCTRL_EXTINTEO8_Pos)
#define EIC_EVCTRL_EXTINTEO9_Pos	9				/**< \brief (EIC_EVCTRL)O荞9ۏo͋ */
#define EIC_EVCTRL_EXTINTEO9		(1 << EIC_EVCTRL_EXTINTEO9_Pos)
#define EIC_EVCTRL_EXTINTEO10_Pos	10				/**< \brief (EIC_EVCTRL)O荞10ۏo͋ */
#define EIC_EVCTRL_EXTINTEO10		(1 << EIC_EVCTRL_EXTINTEO10_Pos)
#define EIC_EVCTRL_EXTINTEO11_Pos	11				/**< \brief (EIC_EVCTRL)O荞11ۏo͋ */
#define EIC_EVCTRL_EXTINTEO11		(1 << EIC_EVCTRL_EXTINTEO11_Pos)
#define EIC_EVCTRL_EXTINTEO12_Pos	12				/**< \brief (EIC_EVCTRL)O荞12ۏo͋ */
#define EIC_EVCTRL_EXTINTEO12		(1 << EIC_EVCTRL_EXTINTEO12_Pos)
#define EIC_EVCTRL_EXTINTEO13_Pos	13				/**< \brief (EIC_EVCTRL)O荞13ۏo͋ */
#define EIC_EVCTRL_EXTINTEO13		(1 << EIC_EVCTRL_EXTINTEO13_Pos)
#define EIC_EVCTRL_EXTINTEO14_Pos	14				/**< \brief (EIC_EVCTRL)O荞14ۏo͋ */
#define EIC_EVCTRL_EXTINTEO14		(1 << EIC_EVCTRL_EXTINTEO14_Pos)
#define EIC_EVCTRL_EXTINTEO15_Pos	15				/**< \brief (EIC_EVCTRL)O荞15ۏo͋ */
#define EIC_EVCTRL_EXTINTEO15		(1 << EIC_EVCTRL_EXTINTEO15_Pos)
#define EIC_EVCTRL_EXTINTEO_Pos		0				/**< \brief (EIC_EVCTRL)O荞xۏo͋ */
#define EIC_EVCTRL_EXTINTEO_Msk		(0xFFFFu << EIC_EVCTRL_EXTINTEO_Pos)
#define EIC_EVCTRL_EXTINTEO(value)	((EIC_EVCTRL_EXTINTEO_Msk & ((value) << EIC_EVCTRL_EXTINTEO_Pos)))
#define EIC_EVCTRL_MASK				0x0000FFFFu		/**< \brief (EIC_EVCTRL)Օڼ޽ */

/* -------- EIC_INTENCLR : (EICψ:0x08) (R/W 32)荞݋ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t EXTINT0:1;			/*!< ޯ     0: O荞0 */
    uint32_t EXTINT1:1;			/*!< ޯ     1: O荞1 */
    uint32_t EXTINT2:1;			/*!< ޯ     2: O荞2 */
    uint32_t EXTINT3:1;			/*!< ޯ     3: O荞3 */
    uint32_t EXTINT4:1;			/*!< ޯ     4: O荞4 */
    uint32_t EXTINT5:1;			/*!< ޯ     5: O荞5 */
    uint32_t EXTINT6:1;			/*!< ޯ     6: O荞6 */
    uint32_t EXTINT7:1;			/*!< ޯ     7: O荞7 */
    uint32_t EXTINT8:1;			/*!< ޯ     8: O荞8 */
    uint32_t EXTINT9:1;			/*!< ޯ     9: O荞9 */
    uint32_t EXTINT10:1;		/*!< ޯ    10: O荞10 */
    uint32_t EXTINT11:1;		/*!< ޯ    11: O荞11 */
    uint32_t EXTINT12:1;		/*!< ޯ    12: O荞12 */
    uint32_t EXTINT13:1;		/*!< ޯ    13: O荞13 */
    uint32_t EXTINT14:1;		/*!< ޯ    14: O荞14 */
    uint32_t EXTINT15:1;		/*!< ޯ    15: O荞15 */
    uint32_t :16;				/*!< ޯ16`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint32_t EXTINT:16;			/*!< ޯ 0`15: O荞x */
    uint32_t :16;				/*!< ޯ16`31: \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} EIC_INTENCLR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EIC_INTENCLR_OFFSET			0x08			/**< \brief (EIC_INTENCLR offset)荞݋ */
#define EIC_INTENCLR_RESETVALUE		0x00000000		/**< \brief (EIC_INTENCLR reset_value)荞݋ */

#define EIC_INTENCLR_EXTINT0_Pos	0				/**< \brief (EIC_INTENCLR)O荞0 */
#define EIC_INTENCLR_EXTINT0		(1 << EIC_INTENCLR_EXTINT0_Pos)
#define EIC_INTENCLR_EXTINT1_Pos	1				/**< \brief (EIC_INTENCLR)O荞1 */
#define EIC_INTENCLR_EXTINT1		(1 << EIC_INTENCLR_EXTINT1_Pos)
#define EIC_INTENCLR_EXTINT2_Pos	2				/**< \brief (EIC_INTENCLR)O荞2 */
#define EIC_INTENCLR_EXTINT2		(1 << EIC_INTENCLR_EXTINT2_Pos)
#define EIC_INTENCLR_EXTINT3_Pos	3				/**< \brief (EIC_INTENCLR)O荞3 */
#define EIC_INTENCLR_EXTINT3		(1 << EIC_INTENCLR_EXTINT3_Pos)
#define EIC_INTENCLR_EXTINT4_Pos	4				/**< \brief (EIC_INTENCLR)O荞4 */
#define EIC_INTENCLR_EXTINT4		(1 << EIC_INTENCLR_EXTINT4_Pos)
#define EIC_INTENCLR_EXTINT5_Pos	5				/**< \brief (EIC_INTENCLR)O荞5 */
#define EIC_INTENCLR_EXTINT5		(1 << EIC_INTENCLR_EXTINT5_Pos)
#define EIC_INTENCLR_EXTINT6_Pos	6				/**< \brief (EIC_INTENCLR)O荞6 */
#define EIC_INTENCLR_EXTINT6		(1 << EIC_INTENCLR_EXTINT6_Pos)
#define EIC_INTENCLR_EXTINT7_Pos	7				/**< \brief (EIC_INTENCLR)O荞7 */
#define EIC_INTENCLR_EXTINT7		(1 << EIC_INTENCLR_EXTINT7_Pos)
#define EIC_INTENCLR_EXTINT8_Pos	8				/**< \brief (EIC_INTENCLR)O荞8 */
#define EIC_INTENCLR_EXTINT8		(1 << EIC_INTENCLR_EXTINT8_Pos)
#define EIC_INTENCLR_EXTINT9_Pos	9				/**< \brief (EIC_INTENCLR)O荞9 */
#define EIC_INTENCLR_EXTINT9		(1 << EIC_INTENCLR_EXTINT9_Pos)
#define EIC_INTENCLR_EXTINT10_Pos	10				/**< \brief (EIC_INTENCLR)O荞10 */
#define EIC_INTENCLR_EXTINT10		(1 << EIC_INTENCLR_EXTINT10_Pos)
#define EIC_INTENCLR_EXTINT11_Pos	11				/**< \brief (EIC_INTENCLR)O荞11 */
#define EIC_INTENCLR_EXTINT11		(1 << EIC_INTENCLR_EXTINT11_Pos)
#define EIC_INTENCLR_EXTINT12_Pos	12				/**< \brief (EIC_INTENCLR)O荞12 */
#define EIC_INTENCLR_EXTINT12		(1 << EIC_INTENCLR_EXTINT12_Pos)
#define EIC_INTENCLR_EXTINT13_Pos	13				/**< \brief (EIC_INTENCLR)O荞13 */
#define EIC_INTENCLR_EXTINT13		(1 << EIC_INTENCLR_EXTINT13_Pos)
#define EIC_INTENCLR_EXTINT14_Pos	14				/**< \brief (EIC_INTENCLR)O荞14 */
#define EIC_INTENCLR_EXTINT14		(1 << EIC_INTENCLR_EXTINT14_Pos)
#define EIC_INTENCLR_EXTINT15_Pos	15				/**< \brief (EIC_INTENCLR)O荞15 */
#define EIC_INTENCLR_EXTINT15		(1 << EIC_INTENCLR_EXTINT15_Pos)
#define EIC_INTENCLR_EXTINT_Pos		0				/**< \brief (EIC_INTENCLR)O荞x */
#define EIC_INTENCLR_EXTINT_Msk		(0xFFFFu << EIC_INTENCLR_EXTINT_Pos)
#define EIC_INTENCLR_EXTINT(value)	((EIC_INTENCLR_EXTINT_Msk & ((value) << EIC_INTENCLR_EXTINT_Pos)))
#define EIC_INTENCLR_MASK			0x0000FFFFu		/**< \brief (EIC_INTENCLR)Օڼ޽ */

/* -------- EIC_INTENSET : (EICψ:0x0C) (R/W 32)荞݋ݒ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t EXTINT0:1;			/*!< ޯ     0: O荞0 */
    uint32_t EXTINT1:1;			/*!< ޯ     1: O荞1 */
    uint32_t EXTINT2:1;			/*!< ޯ     2: O荞2 */
    uint32_t EXTINT3:1;			/*!< ޯ     3: O荞3 */
    uint32_t EXTINT4:1;			/*!< ޯ     4: O荞4 */
    uint32_t EXTINT5:1;			/*!< ޯ     5: O荞5 */
    uint32_t EXTINT6:1;			/*!< ޯ     6: O荞6 */
    uint32_t EXTINT7:1;			/*!< ޯ     7: O荞7 */
    uint32_t EXTINT8:1;			/*!< ޯ     8: O荞8 */
    uint32_t EXTINT9:1;			/*!< ޯ     9: O荞9 */
    uint32_t EXTINT10:1;		/*!< ޯ    10: O荞10 */
    uint32_t EXTINT11:1;		/*!< ޯ    11: O荞11 */
    uint32_t EXTINT12:1;		/*!< ޯ    12: O荞12 */
    uint32_t EXTINT13:1;		/*!< ޯ    13: O荞13 */
    uint32_t EXTINT14:1;		/*!< ޯ    14: O荞14 */
    uint32_t EXTINT15:1;		/*!< ޯ    15: O荞15 */
    uint32_t :16;				/*!< ޯ16`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint32_t EXTINT:16;			/*!< ޯ 0`15: O荞x */
    uint32_t :16;				/*!< ޯ16`31: \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} EIC_INTENSET_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EIC_INTENSET_OFFSET			0x0C			/**< \brief (EIC_INTENSET offset)荞݋ݒ */
#define EIC_INTENSET_RESETVALUE		0x00000000		/**< \brief (EIC_INTENSET reset_value)荞݋ݒ */

#define EIC_INTENSET_EXTINT0_Pos	0				/**< \brief (EIC_INTENSET)O荞0 */
#define EIC_INTENSET_EXTINT0		(1 << EIC_INTENSET_EXTINT0_Pos)
#define EIC_INTENSET_EXTINT1_Pos	1				/**< \brief (EIC_INTENSET)O荞1 */
#define EIC_INTENSET_EXTINT1		(1 << EIC_INTENSET_EXTINT1_Pos)
#define EIC_INTENSET_EXTINT2_Pos	2				/**< \brief (EIC_INTENSET)O荞2 */
#define EIC_INTENSET_EXTINT2		(1 << EIC_INTENSET_EXTINT2_Pos)
#define EIC_INTENSET_EXTINT3_Pos	3				/**< \brief (EIC_INTENSET)O荞3 */
#define EIC_INTENSET_EXTINT3		(1 << EIC_INTENSET_EXTINT3_Pos)
#define EIC_INTENSET_EXTINT4_Pos	4				/**< \brief (EIC_INTENSET)O荞4 */
#define EIC_INTENSET_EXTINT4		(1 << EIC_INTENSET_EXTINT4_Pos)
#define EIC_INTENSET_EXTINT5_Pos	5				/**< \brief (EIC_INTENSET)O荞5 */
#define EIC_INTENSET_EXTINT5		(1 << EIC_INTENSET_EXTINT5_Pos)
#define EIC_INTENSET_EXTINT6_Pos	6				/**< \brief (EIC_INTENSET)O荞6 */
#define EIC_INTENSET_EXTINT6		(1 << EIC_INTENSET_EXTINT6_Pos)
#define EIC_INTENSET_EXTINT7_Pos	7				/**< \brief (EIC_INTENSET)O荞7 */
#define EIC_INTENSET_EXTINT7		(1 << EIC_INTENSET_EXTINT7_Pos)
#define EIC_INTENSET_EXTINT8_Pos	8				/**< \brief (EIC_INTENSET)O荞8 */
#define EIC_INTENSET_EXTINT8		(1 << EIC_INTENSET_EXTINT8_Pos)
#define EIC_INTENSET_EXTINT9_Pos	9				/**< \brief (EIC_INTENSET)O荞9 */
#define EIC_INTENSET_EXTINT9		(1 << EIC_INTENSET_EXTINT9_Pos)
#define EIC_INTENSET_EXTINT10_Pos	10				/**< \brief (EIC_INTENSET)O荞10 */
#define EIC_INTENSET_EXTINT10		(1 << EIC_INTENSET_EXTINT10_Pos)
#define EIC_INTENSET_EXTINT11_Pos	11				/**< \brief (EIC_INTENSET)O荞11 */
#define EIC_INTENSET_EXTINT11		(1 << EIC_INTENSET_EXTINT11_Pos)
#define EIC_INTENSET_EXTINT12_Pos	12				/**< \brief (EIC_INTENSET)O荞12 */
#define EIC_INTENSET_EXTINT12		(1 << EIC_INTENSET_EXTINT12_Pos)
#define EIC_INTENSET_EXTINT13_Pos	13				/**< \brief (EIC_INTENSET)O荞13 */
#define EIC_INTENSET_EXTINT13		(1 << EIC_INTENSET_EXTINT13_Pos)
#define EIC_INTENSET_EXTINT14_Pos	14				/**< \brief (EIC_INTENSET)O荞14 */
#define EIC_INTENSET_EXTINT14		(1 << EIC_INTENSET_EXTINT14_Pos)
#define EIC_INTENSET_EXTINT15_Pos	15				/**< \brief (EIC_INTENSET)O荞15 */
#define EIC_INTENSET_EXTINT15		(1 << EIC_INTENSET_EXTINT15_Pos)
#define EIC_INTENSET_EXTINT_Pos		0				/**< \brief (EIC_INTENSET)O荞x */
#define EIC_INTENSET_EXTINT_Msk		(0xFFFFu << EIC_INTENSET_EXTINT_Pos)
#define EIC_INTENSET_EXTINT(value)	((EIC_INTENSET_EXTINT_Msk & ((value) << EIC_INTENSET_EXTINT_Pos)))
#define EIC_INTENSET_MASK			0x0000FFFFu		/**< \brief (EIC_INTENSET)Օڼ޽ */

/* -------- EIC_INTFLAG : (EICψ:0x10) (R/W 32)荞׸ޏ/ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t EXTINT0:1;			/*!< ޯ     0: O荞0׸ */
    uint32_t EXTINT1:1;			/*!< ޯ     1: O荞1׸ */
    uint32_t EXTINT2:1;			/*!< ޯ     2: O荞2׸ */
    uint32_t EXTINT3:1;			/*!< ޯ     3: O荞3׸ */
    uint32_t EXTINT4:1;			/*!< ޯ     4: O荞4׸ */
    uint32_t EXTINT5:1;			/*!< ޯ     5: O荞5׸ */
    uint32_t EXTINT6:1;			/*!< ޯ     6: O荞6׸ */
    uint32_t EXTINT7:1;			/*!< ޯ     7: O荞7׸ */
    uint32_t EXTINT8:1;			/*!< ޯ     8: O荞8׸ */
    uint32_t EXTINT9:1;			/*!< ޯ     9: O荞9׸ */
    uint32_t EXTINT10:1;		/*!< ޯ    10: O荞10׸ */
    uint32_t EXTINT11:1;		/*!< ޯ    11: O荞11׸ */
    uint32_t EXTINT12:1;		/*!< ޯ    12: O荞12׸ */
    uint32_t EXTINT13:1;		/*!< ޯ    13: O荞13׸ */
    uint32_t EXTINT14:1;		/*!< ޯ    14: O荞14׸ */
    uint32_t EXTINT15:1;		/*!< ޯ    15: O荞15׸ */
    uint32_t :16;				/*!< ޯ16`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint32_t EXTINT:16;			/*!< ޯ 0`15: O荞x׸ */
    uint32_t :16;				/*!< ޯ16`31: \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} EIC_INTFLAG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EIC_INTFLAG_OFFSET			0x10			/**< \brief (EIC_INTFLAG offset)荞׸ޏ/ */
#define EIC_INTFLAG_RESETVALUE		0x00000000		/**< \brief (EIC_INTFLAG reset_value)荞׸ޏ/ */

#define EIC_INTFLAG_EXTINT0_Pos		0				/**< \brief (EIC_INTFLAG)O荞0׸ */
#define EIC_INTFLAG_EXTINT0			(1 << EIC_INTFLAG_EXTINT0_Pos)
#define EIC_INTFLAG_EXTINT1_Pos		1				/**< \brief (EIC_INTFLAG)O荞1׸ */
#define EIC_INTFLAG_EXTINT1			(1 << EIC_INTFLAG_EXTINT1_Pos)
#define EIC_INTFLAG_EXTINT2_Pos		2				/**< \brief (EIC_INTFLAG)O荞2׸ */
#define EIC_INTFLAG_EXTINT2			(1 << EIC_INTFLAG_EXTINT2_Pos)
#define EIC_INTFLAG_EXTINT3_Pos		3				/**< \brief (EIC_INTFLAG)O荞3׸ */
#define EIC_INTFLAG_EXTINT3			(1 << EIC_INTFLAG_EXTINT3_Pos)
#define EIC_INTFLAG_EXTINT4_Pos		4				/**< \brief (EIC_INTFLAG)O荞4׸ */
#define EIC_INTFLAG_EXTINT4			(1 << EIC_INTFLAG_EXTINT4_Pos)
#define EIC_INTFLAG_EXTINT5_Pos		5				/**< \brief (EIC_INTFLAG)O荞5׸ */
#define EIC_INTFLAG_EXTINT5			(1 << EIC_INTFLAG_EXTINT5_Pos)
#define EIC_INTFLAG_EXTINT6_Pos		6				/**< \brief (EIC_INTFLAG)O荞6׸ */
#define EIC_INTFLAG_EXTINT6			(1 << EIC_INTFLAG_EXTINT6_Pos)
#define EIC_INTFLAG_EXTINT7_Pos		7				/**< \brief (EIC_INTFLAG)O荞7׸ */
#define EIC_INTFLAG_EXTINT7			(1 << EIC_INTFLAG_EXTINT7_Pos)
#define EIC_INTFLAG_EXTINT8_Pos		8				/**< \brief (EIC_INTFLAG)O荞8׸ */
#define EIC_INTFLAG_EXTINT8			(1 << EIC_INTFLAG_EXTINT8_Pos)
#define EIC_INTFLAG_EXTINT9_Pos		9				/**< \brief (EIC_INTFLAG)O荞9׸ */
#define EIC_INTFLAG_EXTINT9			(1 << EIC_INTFLAG_EXTINT9_Pos)
#define EIC_INTFLAG_EXTINT10_Pos	10				/**< \brief (EIC_INTFLAG)O荞10׸*/
#define EIC_INTFLAG_EXTINT10		(1 << EIC_INTFLAG_EXTINT10_Pos)
#define EIC_INTFLAG_EXTINT11_Pos	11				/**< \brief (EIC_INTFLAG)O荞11׸ */
#define EIC_INTFLAG_EXTINT11		(1 << EIC_INTFLAG_EXTINT11_Pos)
#define EIC_INTFLAG_EXTINT12_Pos	12				/**< \brief (EIC_INTFLAG)O荞12׸ */
#define EIC_INTFLAG_EXTINT12		(1 << EIC_INTFLAG_EXTINT12_Pos)
#define EIC_INTFLAG_EXTINT13_Pos	13				/**< \brief (EIC_INTFLAG)O荞13׸ */
#define EIC_INTFLAG_EXTINT13		(1 << EIC_INTFLAG_EXTINT13_Pos)
#define EIC_INTFLAG_EXTINT14_Pos	14				/**< \brief (EIC_INTFLAG)O荞14׸ */
#define EIC_INTFLAG_EXTINT14		(1 << EIC_INTFLAG_EXTINT14_Pos)
#define EIC_INTFLAG_EXTINT15_Pos	15				/**< \brief (EIC_INTFLAG)O荞15׸ */
#define EIC_INTFLAG_EXTINT15		(1 << EIC_INTFLAG_EXTINT15_Pos)
#define EIC_INTFLAG_EXTINT_Pos		0				/**< \brief (EIC_INTFLAG)O荞x׸ */
#define EIC_INTFLAG_EXTINT_Msk		(0xFFFFu << EIC_INTFLAG_EXTINT_Pos)
#define EIC_INTFLAG_EXTINT(value)	((EIC_INTFLAG_EXTINT_Msk & ((value) << EIC_INTFLAG_EXTINT_Pos)))
#define EIC_INTFLAG_MASK			0x0000FFFFu		/**< \brief (EIC_INTFLAG)Օڼ޽ */

/* -------- EIC_WAKEUP : (EICψ:0x14) (R/W 32)N -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t WAKEUPEN0:1;		/*!< ޯ     0: O荞0N */
    uint32_t WAKEUPEN1:1;		/*!< ޯ     1: O荞1N */
    uint32_t WAKEUPEN2:1;		/*!< ޯ     2: O荞2N */
    uint32_t WAKEUPEN3:1;		/*!< ޯ     3: O荞3N */
    uint32_t WAKEUPEN4:1;		/*!< ޯ     4: O荞4N */
    uint32_t WAKEUPEN5:1;		/*!< ޯ     5: O荞5N */
    uint32_t WAKEUPEN6:1;		/*!< ޯ     6: O荞6N */
    uint32_t WAKEUPEN7:1;		/*!< ޯ     7: O荞7N */
    uint32_t WAKEUPEN8:1;		/*!< ޯ     8: O荞8N */
    uint32_t WAKEUPEN9:1;		/*!< ޯ     9: O荞9N */
    uint32_t WAKEUPEN10:1;		/*!< ޯ    10: O荞10N */
    uint32_t WAKEUPEN11:1;		/*!< ޯ    11: O荞11N */
    uint32_t WAKEUPEN12:1;		/*!< ޯ    12: O荞12N */
    uint32_t WAKEUPEN13:1;		/*!< ޯ    13: O荞13N */
    uint32_t WAKEUPEN14:1;		/*!< ޯ    14: O荞14N */
    uint32_t WAKEUPEN15:1;		/*!< ޯ    15: O荞15N */
    uint32_t :16;				/*!< ޯ16`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint32_t WAKEUPEN:16;		/*!< ޯ 0`15: O荞xN */
    uint32_t :16;				/*!< ޯ16`31: \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} EIC_WAKEUP_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EIC_WAKEUP_OFFSET			0x14			/**< \brief (EIC_WAKEUP offset)N */
#define EIC_WAKEUP_RESETVALUE		0x00000000		/**< \brief (EIC_WAKEUP reset_value)N */

#define EIC_WAKEUP_WAKEUPEN0_Pos	0				/**< \brief (EIC_WAKEUP)O荞0N */
#define EIC_WAKEUP_WAKEUPEN0		(1 << EIC_WAKEUP_WAKEUPEN0_Pos)
#define EIC_WAKEUP_WAKEUPEN1_Pos	1				/**< \brief (EIC_WAKEUP)O荞1N */
#define EIC_WAKEUP_WAKEUPEN1		(1 << EIC_WAKEUP_WAKEUPEN1_Pos)
#define EIC_WAKEUP_WAKEUPEN2_Pos	2				/**< \brief (EIC_WAKEUP)O荞2N */
#define EIC_WAKEUP_WAKEUPEN2		(1 << EIC_WAKEUP_WAKEUPEN2_Pos)
#define EIC_WAKEUP_WAKEUPEN3_Pos	3				/**< \brief (EIC_WAKEUP)O荞3N */
#define EIC_WAKEUP_WAKEUPEN3		(1 << EIC_WAKEUP_WAKEUPEN3_Pos)
#define EIC_WAKEUP_WAKEUPEN4_Pos	4				/**< \brief (EIC_WAKEUP)O荞4N */
#define EIC_WAKEUP_WAKEUPEN4		(1 << EIC_WAKEUP_WAKEUPEN4_Pos)
#define EIC_WAKEUP_WAKEUPEN5_Pos	5				/**< \brief (EIC_WAKEUP)O荞5N */
#define EIC_WAKEUP_WAKEUPEN5		(1 << EIC_WAKEUP_WAKEUPEN5_Pos)
#define EIC_WAKEUP_WAKEUPEN6_Pos	6				/**< \brief (EIC_WAKEUP)O荞6N */
#define EIC_WAKEUP_WAKEUPEN6		(1 << EIC_WAKEUP_WAKEUPEN6_Pos)
#define EIC_WAKEUP_WAKEUPEN7_Pos	7				/**< \brief (EIC_WAKEUP)O荞7N */
#define EIC_WAKEUP_WAKEUPEN7		(1 << EIC_WAKEUP_WAKEUPEN7_Pos)
#define EIC_WAKEUP_WAKEUPEN8_Pos	8				/**< \brief (EIC_WAKEUP)O荞8N */
#define EIC_WAKEUP_WAKEUPEN8		(1 << EIC_WAKEUP_WAKEUPEN8_Pos)
#define EIC_WAKEUP_WAKEUPEN9_Pos	9				/**< \brief (EIC_WAKEUP)O荞9N */
#define EIC_WAKEUP_WAKEUPEN9		(1 << EIC_WAKEUP_WAKEUPEN9_Pos)
#define EIC_WAKEUP_WAKEUPEN10_Pos	10				/**< \brief (EIC_WAKEUP)O荞10N */
#define EIC_WAKEUP_WAKEUPEN10		(1 << EIC_WAKEUP_WAKEUPEN10_Pos)
#define EIC_WAKEUP_WAKEUPEN11_Pos	11				/**< \brief (EIC_WAKEUP)O荞11N */
#define EIC_WAKEUP_WAKEUPEN11		(1 << EIC_WAKEUP_WAKEUPEN11_Pos)
#define EIC_WAKEUP_WAKEUPEN12_Pos	12				/**< \brief (EIC_WAKEUP)O荞12N */
#define EIC_WAKEUP_WAKEUPEN12		(1 << EIC_WAKEUP_WAKEUPEN12_Pos)
#define EIC_WAKEUP_WAKEUPEN13_Pos	13				/**< \brief (EIC_WAKEUP)O荞13N */
#define EIC_WAKEUP_WAKEUPEN13		(1 << EIC_WAKEUP_WAKEUPEN13_Pos)
#define EIC_WAKEUP_WAKEUPEN14_Pos	14				/**< \brief (EIC_WAKEUP)O荞14N */
#define EIC_WAKEUP_WAKEUPEN14		(1 << EIC_WAKEUP_WAKEUPEN14_Pos)
#define EIC_WAKEUP_WAKEUPEN15_Pos	15				/**< \brief (EIC_WAKEUP)O荞15N */
#define EIC_WAKEUP_WAKEUPEN15		(1 << EIC_WAKEUP_WAKEUPEN15_Pos)
#define EIC_WAKEUP_WAKEUPEN_Pos		0				/**< \brief (EIC_WAKEUP)O荞xN */
#define EIC_WAKEUP_WAKEUPEN_Msk		(0xFFFFu << EIC_WAKEUP_WAKEUPEN_Pos)
#define EIC_WAKEUP_WAKEUPEN(value)	((EIC_WAKEUP_WAKEUPEN_Msk & ((value) << EIC_WAKEUP_WAKEUPEN_Pos)))
#define EIC_WAKEUP_MASK				0x0000FFFFu		/**< \brief (EIC_WAKEUP)Օڼ޽ */

/* -------- EIC_CONFIG : (EICψ:0x18) (R/W 32)`Ԑݒn -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t SENSE0:3;			/*!< ޯ0` 2: ͊mn`Ԑݒ */
    uint32_t FILTEN0:1;			/*!< ޯ    3: hgn */
    uint32_t :28;				/*!< ޯ4`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} EIC_CONFIG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EIC_CONFIG_OFFSET			0x18			/**< \brief (EIC_CONFIG offset)`Ԑݒn */
#define EIC_CONFIG_RESETVALUE		0x00000000		/**< \brief (EIC_CONFIG reset_value)`Ԑݒn */

#define EIC_CONFIG_SENSE0_Pos		0				/**< \brief (EIC_CONFIG)͊mn`Ԑݒ */
#define EIC_CONFIG_SENSE0_Msk		(0x7u << EIC_CONFIG_SENSE0_Pos)
#define EIC_CONFIG_SENSE0(value)	((EIC_CONFIG_SENSE0_Msk & ((value) << EIC_CONFIG_SENSE0_Pos)))
#define   EIC_CONFIG_SENSE0_NONE_Val	0x0u			/**< \brief (EIC_CONFIG)oȂ */
#define   EIC_CONFIG_SENSE0_RISE_Val	0x1u			/**< \brief (EIC_CONFIG)㏸[o */
#define   EIC_CONFIG_SENSE0_FALL_Val	0x2u			/**< \brief (EIC_CONFIG)~[o */
#define   EIC_CONFIG_SENSE0_BOTH_Val	0x3u			/**< \brief (EIC_CONFIG)[o */
#define   EIC_CONFIG_SENSE0_HIGH_Val	0x4u			/**< \brief (EIC_CONFIG)Highٌo */
#define   EIC_CONFIG_SENSE0_LOW_Val		0x5u			/**< \brief (EIC_CONFIG)Lowٌo */
#define EIC_CONFIG_SENSE0_NONE		(EIC_CONFIG_SENSE0_NONE_Val	<< EIC_CONFIG_SENSE0_Pos)
#define EIC_CONFIG_SENSE0_RISE		(EIC_CONFIG_SENSE0_RISE_Val	<< EIC_CONFIG_SENSE0_Pos)
#define EIC_CONFIG_SENSE0_FALL		(EIC_CONFIG_SENSE0_FALL_Val	<< EIC_CONFIG_SENSE0_Pos)
#define EIC_CONFIG_SENSE0_BOTH		(EIC_CONFIG_SENSE0_BOTH_Val	<< EIC_CONFIG_SENSE0_Pos)
#define EIC_CONFIG_SENSE0_HIGH		(EIC_CONFIG_SENSE0_HIGH_Val	<< EIC_CONFIG_SENSE0_Pos)
#define EIC_CONFIG_SENSE0_LOW		(EIC_CONFIG_SENSE0_LOW_Val	<< EIC_CONFIG_SENSE0_Pos)
#define EIC_CONFIG_FILTEN0_Pos		3				/**< \brief (EIC_CONFIG)hgn */
#define EIC_CONFIG_FILTEN0			(0x1u << EIC_CONFIG_FILTEN0_Pos)
#define EIC_CONFIG_MASK				0x0000000Fu		/**< \brief (EIC_CONFIG)Օڼ޽ */

/** \brief EICʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  __IO EIC_CTRL_Type		CTRL;		/**< \briefψ:0x00 (R/W  8) */
  __I  EIC_STATUS_Type		STATUS;		/**< \briefψ:0x01 (R/   8) */
  __IO EIC_NMICTRL_Type		NMICTRL;	/**< \briefψ:0x02 (R/W  8)Օs荞ݐ */
  __IO EIC_NMIFLAG_Type		NMIFLAG;	/**< \briefψ:0x03 (R/W  8)Օs荞׸ޏ/ */
  __IO EIC_EVCTRL_Type		EVCTRL;		/**< \briefψ:0x04 (R/W 32)ې */
  __IO EIC_INTENCLR_Type	INTENCLR;	/**< \briefψ:0x08 (R/W 32)荞݋ */
  __IO EIC_INTENSET_Type	INTENSET;	/**< \briefψ:0x0C (R/W 32)荞݋ݒ */
  __IO EIC_INTFLAG_Type		INTFLAG;	/**< \briefψ:0x10 (R/W 32)荞׸ޏ/ */
  __IO EIC_WAKEUP_Type		WAKEUP;		/**< \briefψ:0x14 (R/W 32)N */
  __IO EIC_CONFIG_Type		CONFIG[2];	/**< \briefψ:0x18 (R/W 32)`Ԑݒn [CONFIG_NUM] */
} Eic;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

#endif /* _SAMD21_EIC_COMPONENT_ */
