/**
 * \file
 *
 * \brief BOD33͓dOFF̑OEEPROMްi[Ɏgp܂B
 *
 * 쌠 (c) 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#include "dali_top.h"

/* BOD level is 3V */
#define	BOD_3V_LEVEL 43

void dali_bod33_init(void)
{
	struct bod_config config_bod33;

	bod_get_config_defaults(&config_bod33);

	config_bod33.level = BOD_3V_LEVEL;
	config_bod33.action = BOD_ACTION_INTERRUPT;
	bod_set_config(BOD_BOD33, &config_bod33);

	bod_enable(BOD_BOD33);

	/* 荞ݐݒ */
	SYSCTRL->INTENSET.bit.BOD33DET = true;	
	system_interrupt_enable(SYSTEM_INTERRUPT_MODULE_SYSCTRL);
}

/* dOFFOEEPROMްi[邽߂BOD33 ISR */
void SYSCTRL_Handler(void)
{
	uint8_t tmp;

	if (bod_is_detected(BOD_BOD33)) {
		tmp = dali_get_eeprom_flag_from_stack();
		if(tmp & PAGE0_UPDATE){
			dali_check_write_eeprom(0, dali_get_page0_data_addr_from_stack(),
					dali_get_page0_data_size_from_stack());
		}
		if(tmp & PAGE1_UPDATE){
			dali_check_write_eeprom(1, dali_get_page1_data_addr_from_stack(),
					dali_get_page1_data_size_from_stack());
		}
		dali_set_eeprom_flag_to_stack(0);
		bod_clear_detected(BOD_BOD33);
	}
}