/**
 * \file
 *
 * \brief DALI]uTC`Ԑݒ
 *
 * 쌠 (c) 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#include "dali_top.h"

// PWMoݒ`
#define DALI_PWM_OUT_PIN		PIN_PB30E_TCC0_WO0
#define DALI_PWM_OUT_MUX		MUX_PB30E_TCC0_WO0
#define DALI_PWM_OUTPUT			0
#define DALI_PWM_CHANNEL		0

struct tc_module tc0_instance, tc1_instance, tc2_instance;
struct tcc_module tcc0_instance;

void dali_tc_init(void)
{
	struct tc_config config_tc;
	struct tcc_config config_tcc;

	tc_get_config_defaults(&config_tc);

	/* DALIޯĕ/ɎgpTC3 */
	config_tc.clock_source = GCLK_GENERATOR_1;
	config_tc.counter_size    = TC_COUNTER_SIZE_8BIT;
	config_tc.wave_generation = TC_WAVE_GENERATION_MATCH_FREQ;
	config_tc.counter_8_bit.compare_capture_channel[0] = TC3_TOP;

	tc_init(&tc0_instance, DALI_BIT_MODULE, &config_tc);
	tc_enable(&tc0_instance);
	tc_register_callback(
			&tc0_instance,
			tc_callback_dali_bit_timer,
			TC_CALLBACK_OVERFLOW);

	tc_enable_callback(&tc0_instance, TC_CALLBACK_OVERFLOW);
	/* ŏ͂̊荞݂ȂB */
	REG_TC3_INTENCLR |= 1<<TC_CALLBACK_OVERFLOW;

	/* DALIڰ ݸނɎgpTC4 */
	config_tc.counter_size    = TC_COUNTER_SIZE_16BIT;
	config_tc.counter_16_bit.compare_capture_channel[0] = TC4_TOP;

	tc_init(&tc1_instance, DALI_FRAME_MODULE, &config_tc);
	tc_enable(&tc1_instance);
	tc_register_callback(
			&tc1_instance,
			tc_callback_dali_frame_timer,
			TC_CALLBACK_OVERFLOW);
	tc_enable_callback(&tc1_instance, TC_CALLBACK_OVERFLOW);

	/* OSCULP32KTC6DALIڽw̎Ɏgp܂B */
	config_tc.clock_source = GCLK_GENERATOR_4;
	tc_init(&tc2_instance, ADDR_SEED_MODULE, &config_tc);
	tc_enable(&tc2_instance);

	/* DALIω/PWMo͂ɎgpTCC0 */
	tcc_get_config_defaults(&config_tcc, DALI_FADING_MODULE);
	config_tcc.counter.clock_source = GCLK_GENERATOR_1;
	config_tcc.counter.clock_prescaler = TCC_CLOCK_PRESCALER_DIV2;
	config_tcc.compare.wave_generation = TCC_WAVE_GENERATION_SINGLE_SLOPE_PWM;
	config_tcc.counter.period = TCC0_TOP;
	config_tcc.double_buffering_enabled = true;

	config_tcc.pins.enable_wave_out_pin[DALI_PWM_OUTPUT] = true;
	config_tcc.pins.wave_out_pin[DALI_PWM_OUTPUT]        = DALI_PWM_OUT_PIN;
	config_tcc.pins.wave_out_pin_mux[DALI_PWM_OUTPUT]    = DALI_PWM_OUT_MUX;
	config_tcc.wave_ext.invert[DALI_PWM_OUTPUT] = true;

	tcc_init(&tcc0_instance, DALI_FADING_MODULE, &config_tcc);
	tcc_enable(&tcc0_instance);
	tcc_register_callback(
			&tcc0_instance,
			tc_callback_dali_fading_timer,
			(enum tcc_callback)(TCC_CALLBACK_OVERFLOW));
	tcc_enable_callback(&tcc0_instance, 
			(enum tcc_callback)(TCC_CALLBACK_OVERFLOW));
}
