/**
 * \file
 *
 * \brief SAM D20/D21/R21ۯ ײ
 *
 * 쌠 (c) 2012 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef SYSTEM_CLOCK_H_INCLUDED
#define SYSTEM_CLOCK_H_INCLUDED

#ifdef __cplusplus
extern "C" {
#endif

/**
 * \defgroup asfdoc_sam0_system_clock_group SAM D20/D21/R21 ۯǗײ(SYSTEM CLOCK)
 *
 * SAM D20/D21/R21޲pײނ޲̸ۯ֘A@\̌`ԐݒƊǗp̲
 * ̪񋟂܂B͗lXȓӋ@\ւ̸ۯ̋A֎~AI
 * AOuǗ֐Ƌ޲̗lXȸۯA޽ ۯAʸۯ
 * ܂݂܂B
 *
 * ȉ̎Ӌ@\̒PʕɂĎgp܂B:
 *
 * - GCLK(ʸۯǗ)
 * - PM(d͊Ǘ)
 * - SYSCTRL(ۯ)
 *
 * ̎̊Tv͎̒ʂłB:
 *  - \ref asfdoc_sam0_system_clock_prerequisites
 *  - \ref asfdoc_sam0_system_clock_module_overview
 *  - \ref asfdoc_sam0_system_clock_special_considerations
 *  - \ref asfdoc_sam0_system_clock_extra_info
 *  - \ref asfdoc_sam0_system_clock_examples
 *  - \ref asfdoc_sam0_system_clock_api_overview
 *
 *
 * \section asfdoc_sam0_system_clock_prerequisites OKv
 *
 * ̒Pʕɑ΂鎖OKv͂܂B
 *
 *
 * \section asfdoc_sam0_system_clock_module_overview PʕTv
 * SAM D20/D21/R21޲͎gp҉pɍő̏_^悤ɐ݌vꂽx
 * ȸۯ т܂݂܂B̼т͓̉pɑ΂2̊Ԃł̍őP̓񗥔w
 * B邽߂ɁAIȕ@޲̐\Ɠd͏𒲐邱Ƃѐ݌v
 * ҂ɋ܂B
 *
 * ײނ޲̗lXȊ֘A@\̌`ԐݒƊǗp̊֐̑g񋟂
 * B
 *
 * \subsection asfdoc_sam0_system_clock_module_features ײދ@\ϸے`
 * <table>
 *	<tr>
 *		<th>ײދ@\ϸ</th>
 *		<th>x޲</th>
 *	</tr>
 *	<tr>
 *		<td>FEATURE_SYSTEM_CLOCK_DPLL</td>
 *		<td>SAMD21, SAMR21</td>
 *	</tr>
 * </table>
 * \note ̋@\͑I޲̋@\x鎞ɂp\łB
 *
 * \subsection asfdoc_sam0_system_clock_module_overview_clock_sources ۯ
 * SAM D20/D21/R21޲͂̸ۯPʕAeX͈肵o͂
 * \͂Ǎ޲̗lXȎӋ@\ƒPʕɋ邱Ƃ
 * ܂B
 *
 * \ȸۯPʕɂ͓RCUADFLLPʕAXɊOؽٗpU
 * ۯ͂܂݂܂B
 *
 * \subsection asfdoc_sam0_system_clock_module_overview_cpu_clock CPU/޽ ۯ
 * CPUAHB/APBx޽(̒PʕŎۯƂĎQƂ)ۯɂ
 * ۯ쓮܂AAPBx޽͊eӋ@\޽ɈقȂۯx^悤ɐݒ
 * ǉ̑Ou핪܂B
 *
 * CPUƒg޽ɑ΂SʓIȎۯ`
 * \ref asfdoc_sam0_system_clock_module_clock_tree "}"Ŏ܂B
 *
 * \anchor asfdoc_sam0_system_clock_module_clock_tree
 * \dot
 * digraph overview {
 *   rankdir=LR;
 *   clk_src [label="Clock Sources", shape=none, height=0];
 *   node [label="CPU Bus" shape=ellipse] cpu_bus;
 *   node [label="AHB Bus" shape=ellipse] ahb_bus;
 *   node [label="APBA Bus" shape=ellipse] apb_a_bus;
 *   node [label="APBB Bus" shape=ellipse] apb_b_bus;
 *   node [label="APBC Bus" shape=ellipse] apb_c_bus;
 *   node [label="Main Bus\nPrescaler" shape=square] main_prescaler;
 *   node [label="APBA Bus\nPrescaler" shape=square] apb_a_prescaler;
 *   node [label="APBB Bus\nPrescaler" shape=square] apb_b_prescaler;
 *   node [label="APBC Bus\nPrescaler" shape=square] apb_c_prescaler;
 *   node [label="", shape=polygon, sides=4, distortion=0.6, orientation=90, style=filled, fillcolor=black, height=0.9, width=0.2] main_clock_mux;
 *
 *   clk_src         -> main_clock_mux;
 *   main_clock_mux  -> main_prescaler;
 *   main_prescaler  -> cpu_bus;
 *   main_prescaler  -> ahb_bus;
 *   main_prescaler  -> apb_a_prescaler;
 *   main_prescaler  -> apb_b_prescaler;
 *   main_prescaler  -> apb_c_prescaler;
 *   apb_a_prescaler -> apb_a_bus;
 *   apb_b_prescaler -> apb_b_bus;
 *   apb_c_prescaler -> apb_c_bus;
 * }
 * \enddot
 *
 * \subsection asfdoc_sam0_system_clock_module_overview_clock_masking ۯՕ
 * ߓd̂߁AAHBAPBx޽1ȏ̎Ӌ@\ւ̓͸ۯ͂ƎՕ邱
 * ƂłAՕƁAۯ͒PʕɑSn܂BgpPʕ̸ۯ
 * ~͎ՕꂽPʕւ̑SĂ̱h܂A޲Ŝɓnd͏
 * 炵܂B
 *
 * \subsection asfdoc_sam0_system_clock_module_overview_gclk ʸۯ
 * SAM D20/D21/R21޲ɂ͂̈ʸۯA͕Wꂽ@
 * ޲̗lXȎӋ@\ۯָ̈ۯ񋟂̂Ɏgp܂B1ȏ
 * ̎ۯ͎Ӌ@\ł̎gp̂߂ɓ͎gxxɑOuŗ
 * Ƃłʸۯ֓͂ƂđIԂƂł܂B
 *
 * āA޲1ȏ̎Ӌ@\ɑ΂ėlXȐo͂𑽏dƊJ
 * 邢̌ʂɑI\Ȉʸۯ ق񋟂܂B̍\ݒ͂
 * ̌ɕKvɉČʂɋ܂͋֎~邱Ƃł1قɋ
 * ƂPꋤʐɋ܂B
 *
 * \anchor asfdoc_sam0_system_clock_module_chain_overview
 * \dot
 * digraph overview {
 *   rankdir=LR;
 *   node [label="Clock\nSource a" shape=square] system_clock_source;
 *   node [label="Generator 1" shape=square] clock_gen;
 *   node [label="Channel x" shape=square] clock_chan0;
 *   node [label="Channel y" shape=square] clock_chan1;
 *   node [label="Peripheral x" shape=ellipse style=filled fillcolor=lightgray] peripheral0;
 *   node [label="Peripheral y" shape=ellipse style=filled fillcolor=lightgray] peripheral1;
 *
 *   system_clock_source -> clock_gen;
 *   clock_gen   -> clock_chan0;
 *   clock_chan0 -> peripheral0;
 *   clock_gen   -> clock_chan1;
 *   clock_chan1 -> peripheral1;
 * }
 * \enddot
 *
 * \subsubsection asfdoc_sam0_system_clock_module_chain_example ۯA
 * ޲ł̊SȸۯA̗\ݒ
 * \ref asfdoc_sam0_system_clock_module_chain_example_fig "}"Ŏ܂B
 *
 * \anchor asfdoc_sam0_system_clock_module_chain_example_fig
 * \dot
 * digraph overview {
 *   rankdir=LR;
 *   node [label="External\nOscillator" shape=square] system_clock_source0;
 *   node [label="Generator 0" shape=square] clock_gen0;
 *   node [label="Channel x" shape=square] clock_chan0;
 *   node [label="Core CPU" shape=ellipse  style=filled fillcolor=lightgray] peripheral0;
 *
 *   system_clock_source0 -> clock_gen0;
 *   clock_gen0    -> clock_chan0;
 *   clock_chan0   -> peripheral0;
 *   node [label="8MHz R/C\nOscillator (OSC8M)" shape=square fillcolor=white] system_clock_source1;
 *   node [label="Generator 1" shape=square] clock_gen1;
 *   node [label="Channel y" shape=square] clock_chan1;
 *   node [label="Channel z" shape=square] clock_chan2;
 *   node [label="SERCOM\nModule" shape=ellipse  style=filled fillcolor=lightgray] peripheral1;
 *   node [label="Timer\nModule" shape=ellipse  style=filled fillcolor=lightgray] peripheral2;
 *
 *   system_clock_source1 -> clock_gen1;
 *   clock_gen1    -> clock_chan1;
 *   clock_gen1    -> clock_chan2;
 *   clock_chan1   -> peripheral1;
 *   clock_chan2   -> peripheral2;
 * }
 * \enddot
 *
 * \subsubsection asfdoc_sam0_system_clock_module_overview_gclk_generators ʸۯ
 * ޲̊eʸۯ͒񋟂ꂽۯ1炻̓͸ۯ
 * A1Α̊֌W1ȏ̈ʸۯɑ΂ďo͂Ou邱Ƃ
 * ł܂B͏]Ă̸ۯɑ΂ĈقȂgAd͎gpAx
 * Ő邱ƂA͌QƂĕ̎Ӌ@\ւ̸ۯ֎~邽߂
 * ʂON/OFF邱Ƃł܂B
 *
 * \subsubsection asfdoc_sam0_system_clock_module_overview_gclk_channels ʸۯ 
 * ޲̎Ӌ@\Ɉʸۯڑ̂Ɉʸۯ قgp܂B
 * eӋ@\܂͎Ӌ@\Q͎Ӌ@\p̸ۯ͂ƂĈgʸۯ 
 * ق܂BӋ@\Pʕɸۯ邽߂ɁAgق͑sĂ
 * ʸۯɐڑAقȂ΂Ȃ܂B
 *
 * \section asfdoc_sam0_system_clock_special_considerations ʂȍl
 *
 * ̒Pʕɑ΂ʂȍl͂܂B
 *
 *
 * \section asfdoc_sam0_system_clock_extra_info ǉ
 *
 * ǉɂĂ\ref asfdoc_sam0_system_clock_extraB
 * ȉ܂݂܂B:
 *  - \ref asfdoc_sam0_system_clock_extra_acronyms
 *  - \ref asfdoc_sam0_system_clock_extra_dependencies
 *  - \ref asfdoc_sam0_system_clock_extra_errata
 *  - \ref asfdoc_sam0_system_clock_extra_history
 *
 *
 * \section asfdoc_sam0_system_clock_examples 
 *
 * ײނƘAg̈ꗗɂĂ
 * \ref asfdoc_sam0_system_clock_exqsgB
 *
 *
 * \section asfdoc_sam0_system_clock_api_overview APITv
 * @{
 */

#include <compiler.h>
#include <gclk.h>

/**
 * \name ײދ@\`
 * e޲nɏ]ļ ۯ@\̑g`܂B
 * @{
 */
#if (SAMD21) || (SAMR21) || defined(__DOXYGEN__)
/** ޼وʑŒ艻H(DPLL)@\x */
#  define FEATURE_SYSTEM_CLOCK_DPLL
#endif
/*@}*/

/**
 * \brief XOSC32Kɑ΂ėp\Ȏn
 *
 * OۯƂāAp\ȊO32kHzUn
 */
enum system_xosc32k_startup {
	SYSTEM_XOSC32K_STARTUP_0,		/**< ۯƌ􂳂܂0ۯҋ@ */
	SYSTEM_XOSC32K_STARTUP_32,		/**< ۯƌ􂳂܂32ۯҋ@ */
	SYSTEM_XOSC32K_STARTUP_2048,	/**< ۯƌ􂳂܂2048ۯҋ@ */
	SYSTEM_XOSC32K_STARTUP_4096,	/**< ۯƌ􂳂܂4096ۯҋ@ */
	SYSTEM_XOSC32K_STARTUP_16384,	/**< ۯƌ􂳂܂16384ۯҋ@ */
	SYSTEM_XOSC32K_STARTUP_32768,	/**< ۯƌ􂳂܂32768ۯҋ@ */
	SYSTEM_XOSC32K_STARTUP_65536,	/**< ۯƌ􂳂܂65536ۯҋ@ */
	SYSTEM_XOSC32K_STARTUP_131072,	/**< ۯƌ􂳂܂131072ۯҋ@ */
};

/**
 * \brief XOSCɑ΂ėp\Ȏn
 *
 * OۯƂāAp\ȊOUn
 */
enum system_xosc_startup {
	SYSTEM_XOSC_STARTUP_1,		/**< ۯƌ􂳂܂1ۯҋ@ */
	SYSTEM_XOSC_STARTUP_2,		/**< ۯƌ􂳂܂2ۯҋ@ */
	SYSTEM_XOSC_STARTUP_4,		/**< ۯƌ􂳂܂4ۯҋ@ */
	SYSTEM_XOSC_STARTUP_8,		/**< ۯƌ􂳂܂8ۯҋ@ */
	SYSTEM_XOSC_STARTUP_16,		/**< ۯƌ􂳂܂16ۯҋ@ */
	SYSTEM_XOSC_STARTUP_32,		/**< ۯƌ􂳂܂32ۯҋ@ */
	SYSTEM_XOSC_STARTUP_64,		/**< ۯƌ􂳂܂64ۯҋ@ */
	SYSTEM_XOSC_STARTUP_128,	/**< ۯƌ􂳂܂128ۯҋ@ */
	SYSTEM_XOSC_STARTUP_256,	/**< ۯƌ􂳂܂256ۯҋ@ */
	SYSTEM_XOSC_STARTUP_512,	/**< ۯƌ􂳂܂512ۯҋ@ */
	SYSTEM_XOSC_STARTUP_1024,	/**< ۯƌ􂳂܂1024ۯҋ@ */
	SYSTEM_XOSC_STARTUP_2048,	/**< ۯƌ􂳂܂2048ۯҋ@ */
	SYSTEM_XOSC_STARTUP_4096,	/**< ۯƌ􂳂܂4096ۯҋ@ */
	SYSTEM_XOSC_STARTUP_8192,	/**< ۯƌ􂳂܂8192ۯҋ@ */
	SYSTEM_XOSC_STARTUP_16384,	/**< ۯƌ􂳂܂16384ۯҋ@ */
	SYSTEM_XOSC_STARTUP_32768,	/**< ۯƌ􂳂܂32768ۯҋ@ */
};

/**
 * \brief OSC32Kɑ΂ėp\Ȏn
 *
 * OSC32KۯƂāAp\ȓ32kHzUn
 */
enum system_osc32k_startup {
	SYSTEM_OSC32K_STARTUP_3,	/**< ۯƌ􂳂܂3ۯҋ@ */
	SYSTEM_OSC32K_STARTUP_4,	/**< ۯƌ􂳂܂4ۯҋ@ */
	SYSTEM_OSC32K_STARTUP_6,	/**< ۯƌ􂳂܂6ۯҋ@ */
	SYSTEM_OSC32K_STARTUP_10,	/**< ۯƌ􂳂܂10ۯҋ@ */
	SYSTEM_OSC32K_STARTUP_18,	/**< ۯƌ􂳂܂18ۯҋ@ */
	SYSTEM_OSC32K_STARTUP_34,	/**< ۯƌ􂳂܂34ۯҋ@ */
	SYSTEM_OSC32K_STARTUP_66,	/**< ۯƌ􂳂܂66ۯҋ@ */
	SYSTEM_OSC32K_STARTUP_130,	/**< ۯƌ􂳂܂130ۯҋ@ */
};

/**
 * \brief 8MHz ۯpOu핪
 *
 * ()8MHz ۯɑ΂ėp\ȑOu
 */
enum system_osc8m_div {
	SYSTEM_OSC8M_DIV_1,		/**< 8MHz RCUo͕Ȃ */
	SYSTEM_OSC8M_DIV_2,		/**< 8MHz RCUo2 */
	SYSTEM_OSC8M_DIV_4,		/**< 8MHz RCUo4 */
	SYSTEM_OSC8M_DIV_8,		/**< 8MHz RCUo8 */
};

/**
 * \brief 8MHz RCUpg͈
 *
 * 8MHz RCUpg͈͐ݒ
 */
enum system_osc8m_frequency_range {
	SYSTEM_OSC8M_FREQUENCY_RANGE_4_TO_6,	/**< 4`6MHz̎g͈ */
	SYSTEM_OSC8M_FREQUENCY_RANGE_6_TO_8,	/**< 6`8MHz̎g͈ */
	SYSTEM_OSC8M_FREQUENCY_RANGE_8_TO_11,	/**< 8`11MHz̎g͈ */
	SYSTEM_OSC8M_FREQUENCY_RANGE_11_TO_15,	/**< 11`15MHz̎g͈ */
};

/**
 * \brief CPUAPB/AHB޽ ۯOul
 *
 * CPUAPB/AHB޽ ۯɑ΂ėp\ȕ
 */
enum system_main_clock_div {
	SYSTEM_MAIN_CLOCK_DIV_1,	/**< ۯ1 */
	SYSTEM_MAIN_CLOCK_DIV_2,	/**< ۯ2 */
	SYSTEM_MAIN_CLOCK_DIV_4,	/**< ۯ4 */
	SYSTEM_MAIN_CLOCK_DIV_8,	/**< ۯ8 */
	SYSTEM_MAIN_CLOCK_DIV_16,	/**< ۯ16 */
	SYSTEM_MAIN_CLOCK_DIV_32,	/**< ۯ32 */
	SYSTEM_MAIN_CLOCK_DIV_64,	/**< ۯ64 */
	SYSTEM_MAIN_CLOCK_DIV_128,	/**< ۯ128 */
};

/**
 * \brief Oۯ^
 *
 * p\ȊOۯ^
 */
enum system_clock_external {
	SYSTEM_CLOCK_EXTERNAL_CRYSTAL,	/**> Oۯ͸ؽٗpU */
	SYSTEM_CLOCK_EXTERNAL_CLOCK,	/**> Oۯ͊O_ ۯM */
};

/**
 * \brief DFLLۯ̓`
 *
 * DFLLۯPʕ̗p\ȓ`
 */
enum system_clock_dfll_loop_mode {
	SYSTEM_CLOCK_DFLL_LOOP_MODE_OPEN,									/**< DFLL͋A҂Ȃ̊JHœ܂B */
	SYSTEM_CLOCK_DFLL_LOOP_MODE_CLOSED = SYSCTRL_DFLLCTRL_MODE,			/**< DFLL͒gۯ̎gA҂Hœ܂B */
	SYSTEM_CLOCK_DFLL_LOOP_MODE_USB_RECOVERY = SYSCTRL_DFLLCTRL_USBCRM,	/**< DFLLUSB SOF̎gA҂USBœ܂B */
};

/**
 * \brief ޲Nオ蒆DFLLɑ΂Œ艻̓
 *
 * x~޲NオłDFLLŒ艻̓
 */
enum system_clock_dfll_wakeup_lock {
	SYSTEM_CLOCK_DFLL_WAKEUP_LOCK_KEEP,							/**< ޲x~Nオ鎞DFLLŒ艻ێ */
	SYSTEM_CLOCK_DFLL_WAKEUP_LOCK_LOSE = SYSCTRL_DFLLCTRL_LLAW,	/**< ޲x~Nオ鎞DFLLŒ艻 */
};

/**
 * \brief UŒ艻ꂽDFLLɑ΂鐸ǔ̓
 *
 * Œ艻ꂽDFLLǔ̓
 */
enum system_clock_dfll_stable_tracking {
	SYSTEM_CLOCK_DFLL_STABLE_TRACKING_TRACK_AFTER_LOCK,							/**< DFLLŒ艻𓾂ɒǔێ */
	SYSTEM_CLOCK_DFLL_STABLE_TRACKING_FIX_AFTER_LOCK = SYSCTRL_DFLLCTRL_STABLE,	/**< DFLLŒ艻𓾂ɒǔ~ */
};

/**
 * \brief DFLLPʕ̓̓
 *
 * DFLLPʕDFLL̓B͓͸ۯł̕ύẌo
 * ͂ɋ߂ɁADFLLo͎gPʕő肳Ȃ̊ԂłB
 */
enum system_clock_dfll_chill_cycle {
	SYSTEM_CLOCK_DFLL_CHILL_CYCLE_ENABLE,							/**< DFLLo͎g肳Ȃ */
	SYSTEM_CLOCK_DFLL_CHILL_CYCLE_DISABLE = SYSCTRL_DFLLCTRL_CCDIS,	/**< DFLLo͎g肳Ȃ֎~ */
};

/**
 * \brief DFLLPʕpvŒ艻ݒ
 *
 * x]ɂDFLLo͎ĝ葬Œ艻߂DFLLPʕpDFLLv
 * Œ艻ݒB
 */
enum system_clock_dfll_quick_lock {
	SYSTEM_CLOCK_DFLL_QUICK_LOCK_ENABLE,							/**< DFLLł̊ɂŒ艻̂߂ɐvŒ艻@\ */
	SYSTEM_CLOCK_DFLL_QUICK_LOCK_DISABLE = SYSCTRL_DFLLCTRL_QLDIS,	/**< DFLLł̌ȌŒ艻̂߂ɐvŒ艻@\֎~ */
};

/**
 * \brief тŗp\ȸۯ
 *
 * GCLKɗp\ȸۯ
 */
enum system_clock_source {
	SYSTEM_CLOCK_SOURCE_OSC8M    = GCLK_SOURCE_OSC8M,		/**< 8MHz RCU */
	SYSTEM_CLOCK_SOURCE_OSC32K   = GCLK_SOURCE_OSC32K,		/**< 32kHz RCU */
	SYSTEM_CLOCK_SOURCE_XOSC     = GCLK_SOURCE_XOSC ,		/**< OU */
	SYSTEM_CLOCK_SOURCE_XOSC32K  = GCLK_SOURCE_XOSC32K,		/**< O32kHzU */
	SYSTEM_CLOCK_SOURCE_DFLL     = GCLK_SOURCE_DFLL48M,		/**< ޼َgŒ艻H(DFLL) */
	SYSTEM_CLOCK_SOURCE_ULP32K   = GCLK_SOURCE_OSCULP32K,	/**< d32kHzU */
#ifdef FEATURE_SYSTEM_CLOCK_DPLL
	SYSTEM_CLOCK_SOURCE_DPLL     = GCLK_SOURCE_FDPLL,	/**< ޼ʑŒ艻H(DPLL)
														  *< ǂ޲x邩\c FEATURE_SYSTEM_CLOCK_DPLL𒲂ׂĂB */
#endif
};

/**
 * \brief APBӋ@\޽̈ꗗ
 *
 * APB޽ŗp\޽ ۯ̈
 */
enum system_clock_apb_bus {
	SYSTEM_CLOCK_APB_APBA,	/**< PAB޽ł̎Ӌ@\޽A */
	SYSTEM_CLOCK_APB_APBB,	/**< PAB޽ł̎Ӌ@\޽B */
	SYSTEM_CLOCK_APB_APBC,	/**< PAB޽ł̎Ӌ@\޽C */
};

/**
 * \brief XOSCp`Ԑݒ\
 *
 * OUۯ`Ԑݒ\
 */
struct system_clock_source_xosc_config {
	enum system_clock_external external_clock;	/**< Oۯ^ */
	enum system_xosc_startup startup_time;		/**< ؽٗpUn */
	bool auto_gain_control;						/**< U䋖 */
	uint32_t frequency;							/**< Oۯ/ؽَg */
	bool run_in_standby;						/**< ޲x~ŋꂽXOSCێ */
	bool on_demand;								/**< ߂ɉđsBꂪݒ肳ꂽȂAXOSC͎Ӌ@\v܂œ܂B */
};

/**
 * \brief XOSC32Kp`Ԑݒ\
 *
 * O32kHzUۯ`Ԑݒ\
 */
struct system_clock_source_xosc32k_config {
	enum system_clock_external external_clock;	/**< Oۯ^ */
	enum system_xosc32k_startup startup_time;	/**< ؽٗpUn */
	bool auto_gain_control;						/**< U䋖 */
	bool enable_1khz_output;					/**< 1kHzo͋ */
	bool enable_32khz_output;					/**< 32kHzo͋ */
	uint32_t frequency;							/**< Oۯ/ؽَg */
	bool run_in_standby;						/**< ޲x~ŋꂽXOSC32Kێ */
	bool on_demand;								/**< ߂ɉđsBꂪݒȂAӋ@\ɂėv܂XOSC32K͓܂B */
	bool write_once;							/**< ꂽɌ`Ԑݒ{A޲ ؾĂ{J */
};

/**
 * \brief OSC8Mp`Ԑݒ\
 *
 * ()8MHzU`Ԑݒ\
 */
struct system_clock_source_osc8m_config {
	enum system_osc8m_div prescaler;	/**< 8MHz RCUOu */
	bool run_in_standby;				/**< ޲x~ŋꂽOSC8Mێ */
	bool on_demand;						/**< ߂ɉđsBꂪݒȂAӋ@\ɂėv܂OSC8M͓܂B */
};

/**
 * \brief OSC32Kp`Ԑݒ\
 *
 * ()32kHzU`Ԑݒ\
 */
struct system_clock_source_osc32k_config {
	enum system_osc32k_startup startup_time;	/**< n */
	bool enable_1khz_output;					/**< 1kHzo͋ */
	bool enable_32khz_output;					/**< 32kHzo͋ */
	bool run_in_standby;						/**< ޲x~ŋꂽOSC32Kێ */
	bool on_demand;								/**< ߂ɉđsBꂪݒȂAӋ@\ɂėv܂OSC32K͓܂B */
	bool write_once;							/**< ꂽɌ`Ԑݒ{A޲ ؾĂ{J */
};

/**
 * \brief DFLLp`Ԑݒ\
 *
 * DFLLU`Ԑݒ\
 */
struct system_clock_source_dfll_config {
	enum system_clock_dfll_loop_mode loop_mode;				/**< JH/H */
	bool on_demand;											/**< ߂ɉđsBꂪݒȂAӋ@\ɂėv܂DFLL͓܂B */
	enum system_clock_dfll_quick_lock quick_lock;			/**< vŒ艻 */
	enum system_clock_dfll_chill_cycle chill_cycle;			/**<  */
	enum system_clock_dfll_wakeup_lock wakeup_lock;			/**< NオDFLLŒ艻 */
	enum system_clock_dfll_stable_tracking stable_tracking;	/**< Œ艻DFLLǔ */
	uint8_t coarse_value;									/**< aZl(JH) */
	uint16_t fine_value;									/**< Zl(JH) */
	uint8_t coarse_max_step;								/**< aőiK(H) */
	uint16_t fine_max_step;									/**< őiK(H) */
	uint16_t multiply_factor;								/**< DFLL{W(H) */
};

/**
 * \name OUǗ
 * @{
 */

/**
 * \brief XOSCp`Ԑݒ擾
 *
 * OUPʕp`ԐݒŌ`Ԑݒ\̂𖞂B
 *   - Oؽ
 *   - 16384Oۯ̎n
 *   - ꂽؽٗ䓮
 *   - 12MHz̎g
 *   - ޲x~œȂB
 *   - Ӌ@\ɂėvꂽɂs(߂ɉ)
 *
 * \param[out]  config lŖ`Ԑݒ\
 */
static inline void system_clock_source_xosc_get_config_defaults(
		struct system_clock_source_xosc_config *const config)
{
	Assert(config);

	config->external_clock    = SYSTEM_CLOCK_EXTERNAL_CRYSTAL;
	config->startup_time      = SYSTEM_XOSC_STARTUP_16384;
	config->auto_gain_control = true;
	config->frequency         = 12000000UL;
	config->run_in_standby    = false;
	config->on_demand         = true;
}

void system_clock_source_xosc_set_config(
		struct system_clock_source_xosc_config *const config);

/**
 * @}
 */


/**
 * \name O32kHzUǗ
 * @{
 */

/**
 * \brief XOSC32Kp`Ԑݒ擾
 *
 * O32kHzUPʕp`ԐݒŌ`Ԑݒ\̂𖞂B
 *   - Oؽ
 *   - 16384Oۯ̎n
 *   - ֎~ꂽؽٗ䓮
 *   - 32.768kHz̎g
 *   - ֎~ꂽ1kHzۯo
 *   - ꂽ32kHzۯo
 *   - ޲x~œȂB
 *   - Ӌ@\ɂėvꂽɂs(߂ɉ)
 *   - `Ԑݒ肪ꂽڼ޽{ȂB
 *
 * \param[out]  config lŖ`Ԑݒ\
 */
static inline void system_clock_source_xosc32k_get_config_defaults(
		struct system_clock_source_xosc32k_config *const config)
{
	Assert(config);

	config->external_clock      = SYSTEM_CLOCK_EXTERNAL_CRYSTAL;
	config->startup_time        = SYSTEM_XOSC32K_STARTUP_16384;
	config->auto_gain_control   = false;
	config->frequency           = 32768UL;
	config->enable_1khz_output  = false;
	config->enable_32khz_output = true;
	config->run_in_standby      = false;
	config->on_demand           = true;
	config->write_once          = false;
}

void system_clock_source_xosc32k_set_config(
		struct system_clock_source_xosc32k_config *const config);
/**
 * @}
 */


/**
 * \name 32kHzUǗ
 * @{
 */

/**
 * \brief OSC32Kp`Ԑݒ擾
 *
 * 32kHzUPʕp`ԐݒŌ`Ԑݒ\̂𖞂B
 *   - ꂽ1kHzۯo
 *   - ꂽ32kHzۯo
 *   - ޲x~œȂB
 *   - Ӌ@\ɂėvꂽɂs(߂ɉ)
 *   - nԂ130ɐݒ
 *   - `Ԑݒ肪ꂽڼ޽{ȂB
 *
 * \param[out]  config lŖ`Ԑݒ\
 */
static inline void system_clock_source_osc32k_get_config_defaults(
		struct system_clock_source_osc32k_config *const config)
{
	Assert(config);

	config->enable_1khz_output  = true;
	config->enable_32khz_output = true;
	config->run_in_standby      = false;
	config->on_demand           = true;
	config->startup_time        = SYSTEM_OSC32K_STARTUP_130;
	config->write_once          = false;
}

void system_clock_source_osc32k_set_config(
		struct system_clock_source_osc32k_config *const config);

/**
 * @}
 */


/**
 * \name 8MHzUǗ
 * @{
 */

/**
 * \brief OSC8Mp`Ԑݒ擾
 *
 * ()8MHzUPʕp`ԐݒŌ`Ԑݒ\̂𖞂B
 *   - 8ꂽۯo͎g
 *   - ޲x~œȂB
 *   - Ӌ@\ɂėvꂽɂs(߂ɉ)
 *
 * \param[out]  config lŖ`Ԑݒ\
 */
static inline void system_clock_source_osc8m_get_config_defaults(
		struct system_clock_source_osc8m_config *const config)
{
	Assert(config);

	config->prescaler      = SYSTEM_OSC8M_DIV_8;
	config->run_in_standby = false;
	config->on_demand      = true;
}

void system_clock_source_osc8m_set_config(
		struct system_clock_source_osc8m_config *const config);

/**
 * @}
 */


/**
 * \name DFLLǗ
 * @{
 */

/**
 * \brief DFLLp`Ԑݒ擾
 *
 * DFLLUPʕp`ԐݒŌ`Ԑݒ\̂𖞂B
 *   - JH
 *   - ꂽvŒ艻
 *   - ꂽ
 *   - ޲Nオ蒆Ɉێo͎gŒ艻
 *   - o͎ǧpǔ
 *   - aƔ̗̒ǔҰp_ł̊ǔl
 *   - ޲x~œȂB
 *   - Ӌ@\ɂėvꂽɂs(߂ɉ)
 *
 * \param[out]  config lŖ`Ԑݒ\
 */
static inline void system_clock_source_dfll_get_config_defaults(
		struct system_clock_source_dfll_config *const config)
{
	Assert(config);

	config->loop_mode       = SYSTEM_CLOCK_DFLL_LOOP_MODE_OPEN;
	config->quick_lock      = SYSTEM_CLOCK_DFLL_QUICK_LOCK_ENABLE;
	config->chill_cycle     = SYSTEM_CLOCK_DFLL_CHILL_CYCLE_ENABLE;
	config->wakeup_lock     = SYSTEM_CLOCK_DFLL_WAKEUP_LOCK_KEEP;
	config->stable_tracking = SYSTEM_CLOCK_DFLL_STABLE_TRACKING_TRACK_AFTER_LOCK;
	config->on_demand       = true;

	/* JHZl */
	config->coarse_value    = 0x1f / 4;	/* _ */
	config->fine_value      = 0xff / 4;	/* _ */

	/* H */
	config->coarse_max_step = 1;
	config->fine_max_step   = 1;
	config->multiply_factor = 6;		/* 48MHz𓾂邽߂8MHz6{ */
}

void system_clock_source_dfll_set_config(
		struct system_clock_source_dfll_config *const config);

/**
 * @}
 */

/**
 * \name ۯǗ
 * @{
 */
enum status_code system_clock_source_write_calibration(
		const enum system_clock_source system_clock_source,
		const uint16_t calibration_value,
		const uint8_t freq_range);

enum status_code system_clock_source_enable(
		const enum system_clock_source system_clock_source);

enum status_code system_clock_source_disable(
		const enum system_clock_source clk_source);

bool system_clock_source_is_ready(
		const enum system_clock_source clk_source);

uint32_t system_clock_source_get_hz(
		const enum system_clock_source clk_source);

/**
 * @}
 */

/**
 * \name ۯǗ
 * @{
 */

#ifdef FEATURE_SYSTEM_CLOCK_FAILURE_DETECT
/**
 * \brief ۯQo܂͋֎~
 *
 * ̋@\͎ۯOFFƌ􂳂鎞ɎۯSRCSYSۯւ̎IȐ
 * ւ܂B
 *
 * ͗ႦΊOؽقۯ̸ۯƂđI΂ĸؽق񂾎ɋN邩
 * ܂Bdg݂RCSYSɍŒ1̎ۯ̏㏸[o邱Ƃ
 * B㏸[SȂꍇɸۯ̏Ⴕƌ􂳂܂Bo킪
 * ƒɁAۯQo(CFD)ꂽۯĎ܂BۯQ
 * oƁAۯ͎IRCSYSۯɐ؂ւAĂCFD
 * ݂܂B
 *
 * \note xۯż ۯŝmM邽߁AQoͼ 
 *       ۯ32kHzƓxꍇɋ֎~Ȃ΂Ȃ܂B
 *
 * \param[in]  enable ްْlŌoɂ\c trueA֎~ɂ\c false
 */
static inline void system_main_clock_set_failure_detect(
		const bool enable)
{
	if (enable) {
		PM->CTRL.reg |=  PM_CTRL_CFDEN;
	} else {
		PM->CTRL.reg &= ~PM_CTRL_CFDEN;
	}
}
#endif

/**
 * \brief CPUۯlݒ
 *
 * CPUۯ񋟂ۯŎgpۯlݒ
 *
 * \param[in]  divider ݒ肷CPUۯl
 */
static inline void system_cpu_clock_set_divider(
		const enum system_main_clock_div divider)
{
	Assert(((uint32_t)divider & PM_CPUSEL_CPUDIV_Msk) == divider);
	PM->CPUSEL.reg = (uint32_t)divider;
}

/**
 * \brief CPUǰݎg擾
 *
 * ʸۯCPU޽l瓾CPUj̓g擾
 *
 * \return Hzł݂̌CPUg
 */
static inline uint32_t system_cpu_clock_get_hz(void)
{
	return (system_gclk_gen_get_hz(GCLK_GENERATOR_0) >> PM->CPUSEL.reg);
}

/**
 * \brief APBxۯlݒ
 *
 * ^ꂽAPBx޽ɑ΂ĸۯ񋟂ۯŎgpۯlݒ
 *
 * \param[in]  divider ݒ肷APBx޽l
 * \param[in]  bus     lݒ肷APBx޽
 *
 * \returns ۯύX̏
 *
 * \retval STATUS_ERR_INVALID_ARG ޽ID^ꂽB
 * \retval STATUS_OK              APBxۯɐݒ肳܂B
 */
static inline enum status_code system_apb_clock_set_divider(
		const enum system_clock_apb_bus bus,
		const enum system_main_clock_div divider)
{
	switch (bus) {
		case SYSTEM_CLOCK_APB_APBA:
			PM->APBASEL.reg = (uint32_t)divider;
			break;
		case SYSTEM_CLOCK_APB_APBB:
			PM->APBBSEL.reg = (uint32_t)divider;
			break;
		case SYSTEM_CLOCK_APB_APBC:
			PM->APBCSEL.reg = (uint32_t)divider;
			break;
		default:
			Assert(false);
			return STATUS_ERR_INVALID_ARG;
	}

	return STATUS_OK;
}

/**
 * \brief APBx̌ݎg擾
 *
 * ʸۯAPBx޽lݒ肩瓾ꂽAPBx޽̓g擾
 *
 * \return Hzł݂̌APBx޽g
 */
static inline uint32_t system_apb_clock_get_hz(
		const enum system_clock_apb_bus bus)
{
	uint16_t bus_divider = 0;

	switch (bus) {
		case SYSTEM_CLOCK_APB_APBA:
			bus_divider = PM->APBASEL.reg;
			break;
		case SYSTEM_CLOCK_APB_APBB:
			bus_divider = PM->APBBSEL.reg;
			break;
		case SYSTEM_CLOCK_APB_APBC:
			bus_divider = PM->APBCSEL.reg;
			break;
		default:
			Assert(false);
			return 0;
	}

	return (system_gclk_gen_get_hz(GCLK_GENERATOR_0) >> bus_divider);
}


/**
 * @}
 */

/**
 * \name ޽ ۯՕ
 * @{
 */

/**
 * \brief AHB޽pۯՕޯĂݒ
 *
 * ̊֐AHB޽pۯՕޯĂݒ肵܂BǂޯĂ1ݒۯA
 * Օ0ޯĂ͖܂B
 *
 * \param[in]  ahb_mask AHBۯՕ
 */
static inline void system_ahb_clock_set_mask(
		const uint32_t ahb_mask)
{
	PM->AHBMASK.reg |= ahb_mask;
}

/**
 * \brief AHB޽pۯՕޯĂ
 *
 * ̊֐AHB޽pۯՕޯĂ܂BǂޯĂ1ݒۯ֎~A
 * Օ0ޯĂ͖܂B
 *
 * \param[in]  ahb_mask ֎~AHBۯՕ
 */
static inline void system_ahb_clock_clear_mask(
		const uint32_t ahb_mask)
{
	PM->AHBMASK.reg &= ~ahb_mask;
}

/**
 * \brief APBx޽pۯՕޯĂݒ
 *
 * ̊֐APBx޽pۯՕޯĂݒ肵܂BǂޯĂ1ݒΉP
 * ۯAՕ0ޯĂ͖܂B
 *
 * \param[in]  mask APBxۯՕB޲ ͯ ̧ق\c SYSTEM_CLOCK_APB_APBx
 *                  萔
 * \param[in]  bus  ۯՕޯĂݒ肷޽B޲ ͯ ̧ق
 *                  \c PM_APBxMASK_*萔̎Օ
 *
 * \returns ۯՕύX̌ʂ
 *
 * \retval STATUS_ERR_INVALID_ARG ^ꂽ޽
 * \retval STATUS_OK              ۯՕ͐ɐݒ肳܂B
 */
static inline enum status_code system_apb_clock_set_mask(
		const enum system_clock_apb_bus bus,
		const uint32_t mask)
{
	switch (bus) {
		case SYSTEM_CLOCK_APB_APBA:
			PM->APBAMASK.reg |= mask;
			break;

		case SYSTEM_CLOCK_APB_APBB:
			PM->APBBMASK.reg |= mask;
			break;

		case SYSTEM_CLOCK_APB_APBC:
			PM->APBCMASK.reg |= mask;
			break;

		default:
			Assert(false);
			return STATUS_ERR_INVALID_ARG;

	}

	return STATUS_OK;
}

/**
 * \brief APBx޽pۯՕޯĂ
 *
 * ̊֐APBx޽pۯՕޯĂ܂BǂޯĂ1ݒΉP
 * ۯ֎~AՕ0ޯĂ͖܂B
 *
 * \param[in]  mask APBxۯՕB޲ ͯ ̧ق\c SYSTEM_CLOCK_APB_APBx
 *                  萔
 * \param[in]  bus  ۯՕޯĂ޽B
 *
 * \returns ۯՕύX̌ʂ
 *
 * \retval STATUS_ERR_INVALID_ARG ^ꂽ޽
 * \retval STATUS_OK              ۯՕ͐ɕύX܂B
 */
static inline enum status_code system_apb_clock_clear_mask(
		const enum system_clock_apb_bus bus,
		const uint32_t mask)
{
	switch (bus) {
		case SYSTEM_CLOCK_APB_APBA:
			PM->APBAMASK.reg &= ~mask;
			break;

		case SYSTEM_CLOCK_APB_APBB:
			PM->APBBMASK.reg &= ~mask;
			break;

		case SYSTEM_CLOCK_APB_APBC:
			PM->APBCMASK.reg &= ~mask;
			break;

		default:
			Assert(false);
			return STATUS_ERR_INVALID_ARG;
	}

	return STATUS_OK;
}

/**
 * @}
 */

#ifdef FEATURE_SYSTEM_CLOCK_DPLL
/**
 * \brief DPLLPʕ̊ۯ
 */
enum system_clock_source_dpll_reference_clock {
	SYSTEM_CLOCK_SOURCE_DPLL_REFERENCE_CLOCK_REF0,	/**< ۯƂCLK_DPLL_REF0I */
	SYSTEM_CLOCK_SOURCE_DPLL_REFERENCE_CLOCK_REF1,	/**< ۯƂCLK_DPLL_REF1I */
	SYSTEM_CLOCK_SOURCE_DPLL_REFERENCE_CLOCK_GCLK,	/**< ۯƂGCLK_DPLLI */
};

/**
 * \brief DPLLPʕ̌Œ艻Ԓl
 */
enum system_clock_source_dpll_lock_time {
	SYSTEM_CLOCK_SOURCE_DPLL_LOCK_TIME_DEFAULT,		/**< ƂĐԂȂݒ */
	SYSTEM_CLOCK_SOURCE_DPLL_LOCK_TIME_8MS = 0x04,	/**< 8msȓɌŒ艻ȂꍇɎԒߐݒ */
	SYSTEM_CLOCK_SOURCE_DPLL_LOCK_TIME_9MS,			/**< 9msȓɌŒ艻ȂꍇɎԒߐݒ */
	SYSTEM_CLOCK_SOURCE_DPLL_LOCK_TIME_10MS,		/**< 10msȓɌŒ艻ȂꍇɎԒߐݒ */
	SYSTEM_CLOCK_SOURCE_DPLL_LOCK_TIME_11MS,		/**< 11msȓɌŒ艻ȂꍇɎԒߐݒ */
};

/**
 * \brief DPLLPʕhg`
 */
enum system_clock_source_dpll_filter {
	SYSTEM_CLOCK_SOURCE_DPLL_FILTER_DEFAULT,				/**< hg퓮 */
	SYSTEM_CLOCK_SOURCE_DPLL_FILTER_LOW_BANDWIDTH_FILTER,	/**< шhg */
	SYSTEM_CLOCK_SOURCE_DPLL_FILTER_HIGH_BANDWIDTH_FILTER,	/**< шhg */
	SYSTEM_CLOCK_SOURCE_DPLL_FILTER_HIGH_DAMPING_FILTER,	/**< Uhg */
};

/**
 * \brief DPLLp`Ԑݒ\
 *
 * DPLLU`Ԑݒ\
 */
struct system_clock_source_dpll_config {
	bool on_demand;													/**< ߂ɉđsBꂪݒȂADPLL͎Ӌ@\ɂėv܂œ܂B */
	bool run_in_standby;											/**< ޲x~ŋꂽDPLLێ */
	bool lock_bypass;												/**< Œ艻MI */
	bool wake_up_fast;												/**< NオBꂪݒȂnԌDPLLo͸ۯ܂B */
	bool low_power_enable;											/**< d͓싖 */

	uint32_t output_frequency;										/**< ۯ̏o͎g */
	uint32_t reference_frequency;									/**< ۯ̊g */
	uint16_t reference_divider;										/**< ۯ̕l */

	enum system_clock_source_dpll_filter          filter;			/**< DPLLPʕhg` */
	enum system_clock_source_dpll_lock_time       lock_time;		/**< DPLLPʕ̌Œ艻Ԓl */
	enum system_clock_source_dpll_reference_clock reference_clock;	/**< DPLLPʕ̊ۯ */
};

/**
 * \name DPLLǗ
 * @{
 */

/**
 * \brief DPLLp`Ԑݒ擾
 *
 * DPLLUPʕp`ԐݒŌ`Ԑݒ\̂𖞂B
 *   - Ӌ@\ɂėvꂽɂɂs(߂ɉ)
 *   - ޲x~œȂB
 *   - ֎~Œ艻I
 *   - ֎~鍂Nオ
 *   - ֎~d͓
 *   - o͎g48MHz
 *   - ۯg32768Hz
 *   - ۯȂ
 *   - ۯƂREF0I
 *   - Œ艻Ԃ蓮ɐݒ
 *   - hggp
 *
 * \param[out]  config lŖ`Ԑݒ\
 */
static inline void system_clock_source_dpll_get_config_defaults(
		struct system_clock_source_dpll_config *const config)
{
	config->on_demand           = true;
	config->run_in_standby      = false;
	config->lock_bypass         = false;
	config->wake_up_fast        = false;
	config->low_power_enable    = false;

	config->output_frequency    = 48000000;
	config->reference_frequency = 32768;
	config->reference_divider   = 1;
	config->reference_clock     = SYSTEM_CLOCK_SOURCE_DPLL_REFERENCE_CLOCK_REF0;

	config->lock_time           = SYSTEM_CLOCK_SOURCE_DPLL_LOCK_TIME_DEFAULT;
	config->filter              = SYSTEM_CLOCK_SOURCE_DPLL_FILTER_DEFAULT;
};

void system_clock_source_dpll_set_config(
		struct system_clock_source_dpll_config *const config);

/* @} */
#endif

/**
 * \name  ۯ
 * @{
 */

void system_clock_init(void);

/**
 * @}
 */

/**
 * \name  ׯ҂
 * @{
 */

/**
 * \brief ׯ҂Ԃݒ
 *
 * ׯ ؂ɂĎgp҂Ԑݒ肵܂B҂Ԑ޲
 * dCPUx̗Ɉˑ܂BKvƂ҂Ԑ޲̓dCI
 * Ō邱Ƃł܂B
 *
 * \param[in]  wait_states ׯg߂̑҂Ԑ
 */
static inline void system_flash_set_waitstates(uint8_t wait_states)
{
	Assert(NVMCTRL_CTRLB_RWS((uint32_t)wait_states) ==
			((uint32_t)wait_states << NVMCTRL_CTRLB_RWS_Pos));

	NVMCTRL->CTRLB.bit.RWS = wait_states;
}
/**
 * @}
 */

/**
 * @}
 */

/**
 * \page asfdoc_sam0_system_clock_extra SYSTEM CLOCKײޗpǉ
 *
 * \section asfdoc_sam0_system_clock_extra_acronyms 
 * ͂̈Ӑ}Ӗɂ̒PʕŎgp铪ꗗɂ\
 * B
 *
 * <table>
 *	<tr>
 *		<th></th>
 *		<th></th>
 *	</tr>
 *	<tr>
 *		<td>DFLL</td>
 *		<td>޼َgŒ艻H(Digital Frequency Locked Loop)</td>
 *	</tr>
 *	<tr>
 *		<td>MUX</td>
 *		<td>d(Multiplexer)</td>
 *	</tr>
 *	<tr>
 *		<td>OSC32K</td>
 *		<td>32kHzU</td>
 *	</tr>
 *	<tr>
 *		<td>OSC8M</td>
 *		<td>8MHzU</td>
 *	</tr>
 *	<tr>
 *		<td>PLL</td>
 *		<td>ʑŒ艻H(Phase Locked Loop)</td>
 *	</tr>
 *	<tr>
 *		<td>OSC</td>
 *		<td>U</td>
 *	</tr>
 *	<tr>
 *		<td>XOSC</td>
 *		<td>OU(External Oscillator)</td>
 *	</tr>
 *	<tr>
 *		<td>XOSC32K</td>
 *		<td>O32kHzU(External 32kHz Oscillator)</td>
 *	</tr>
 *	<tr>
 *		<td>AHB</td>
 *		<td>xȍ\޽(Advanced High-performance Bus)</td>
 *	</tr>
 *	<tr>
 *		<td>APB</td>
 *		<td>xȎӋ@\޽(Advanced Peripheral Bus)</td>
 *	</tr>
 *	<tr>
 *		<td>DPLL</td>
 *		<td>޼وʑŒ艻H(Digital Phase Locked Loop)</td>
 *	</tr>
 * </table>
 *
 *
 * \section asfdoc_sam0_system_clock_extra_dependencies ˑ
 * ײނ͈ȉ̈ˑ܂B
 *
 *  - Ȃ
 *
 *
 * \section asfdoc_sam0_system_clock_extra_errata Q
 *
 *	- ײނ͏Q10558ɑ΂΍܂B
 *
 *	  "SYSCTRL.INTFLAĜؾĒl͕sł(BODDFLL)B"
 *	  system_initĂ΂鎞ɂ炪gpOɂ̊荞݂ؾĂ
 *	  B

 *	- ײނ͏Q9905ɑ΂Iȑ΍܂B
 *
 *	  "DFLLۯ͌`Ԑݒ肳OɗvȂ΂Ȃ炸AȂDFLLڼ޽
 *	  ւ̏ݱ޲~܂B"
 *	  ײނONDEMANDޯĂݒ肳ODFLLČ`Ԑݒ肵܂B
 *
 *
 * \section asfdoc_sam0_system_clock_extra_history Pʕ
 * Pʕ̊Tv͏JPʕɍsꂽƏC̏CƋɉ\ŕ\
 * ܂BɌݔł͕\̍ŐVłɑΉ܂B
 *
 * <table>
 *	<tr>
 *		<th>ύXL^</th>
 *	</tr>
 *	<tr>
 *		<td>
 *			\li OSC32KnԒ`C
 *			\li OSC32KXOSC32K`Ԑݒڼ޽̎{x(:false)
 *			\li DPLLxǉAȉ̊֐ǉ:
 *			    \c system_clock_source_dpll_get_config_defaults()A
 *		        \c system_clock_source_dpll_set_config().
 *			\li GCLKَ{@\`Ԑݒ\̂̊OɈړAȉ̊֐ǉ:
 *			    \c system_gclk_chan_lock()A
 *			    \c system_gclk_chan_is_locked()A
 *			    \c system_gclk_chan_is_enabled()A
 *			    \c system_gclk_gen_is_enabled()
 *		</td>
 *	</tr>
 *  <tr>
 *		<td>قۯ̏/sɌ`Ԑݒ肳ꂽꍇɑl܂
 *		    \c system_gclk_chan_disable()C</td>
 *  </tr>
 *	<tr>
 *		<td>
 *			\li CONF_CLOCK_DFLL_ON_DEMAND̊l\c true\c false֕ύX
 *			\li ̑҂Ԑ񋟂ꂽꍇ̒fŎs
 *			    system_flash_set_waitstates()C
 *		</td>
 *	</tr>
 *	<tr>
 *		<td>
 *			\li DFLLPʕł̏Q9905ɑ΂΍悤DFLL`Ԑݒ
 *			    ֐XV
 *			\li 炪gpOɊ荞׸ނؾĂ悤
 *			    \c system_clock_init()XVAQ10558
 *			\li DFLLglԂ悤\c system_clock_source_get_hz()
 *			    C
 *		</td>
 *	</tr>
 *	<tr>
 *		<td>\li \c SYSTEM_CLOCK_SOURCE_OSC8Mɑ΂ĐԂԂȂ
 *              \c system_clock_source_is_readyC
 *          \li ASF̗]蕔ɍ킹邽߂ɗlX
 *              \c system_clock_source_*_get_default_config()֐
 *              \c system_clock_source_*_get_config_defaults()ɉ
 *          \li U킪鎞޲̎[񂩐ݒ肷OSC8MZ萔
 *              ǉ
 *          \li غݏQ̂߂Ɏ֎~悤XOSC32̊`Ԑ
 *              XV
 *      </td>
 *	</tr>
 *	<tr>
 *		<td>J</td>
 *	</tr>
 * </table>
 */

/**
 * \page asfdoc_sam0_system_clock_exqsg  ۯ ײޗp
 *
 * \ref asfdoc_sam0_system_clock_groupŗp\ȑJn̎(QSG)
 * ቞p̈ꗗłBQSG͎gpʂ̑Iłײނ`Ԑݒ肵Ďg߂̒i
 * KIȎwł̊ȒPȗłBQSG͓Ɨ^pƂĺ߲فA܂͎gp҉p
 * ǉ邱Ƃł܂B
 *
 *  - \subpage asfdoc_sam0_system_clock_basic_use_case
 *  - \subpage asfdoc_sam0_system_gclk_basic_use_case
 *
 * \page asfdoc_sam0_system_clock_document_revision_history 
 *
 * <table>
 *	<tr>
 *		<th></td>
 *		<th>t</td>
 *		<th></td>
 *	</tr>
 *	<tr>
 *		<td>D</td>
 *		<td>2014N2</td>
 *		<td>SAMR21xǉ</td>
 *	</tr>
 *	<tr>
 *		<td>C</td>
 *		<td>2014N1</td>
 *		<td>SAMD21xǉ</td>
 *	</tr>
 *	<tr>
 *		<td>B</td>
 *		<td>2013N6</td>
 *		<td>ACB{gpʑJn̎ŎĂiKC</td>
 *	</tr>
 *	<tr>
 *		<td>A</td>
 *		<td>2013N6</td>
 *		<td>J</td>
 *	</tr>
 * </table>
 */

#ifdef __cplusplus
}
#endif

#endif /* SYSTEM_CLOCK_H_INCLUDED */
