/**
 * \file
 *
 * \brief SAM D20/D21/R21ݑdײ
 *
 * 쌠 (c) 2012 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#include <pinmux.h>

/**
 * \internal
 * ߰ ݌`Ԑݒ̗^ꂽ`Ԑݒʰ޳Pʕɏo
 *
 * \note ݕo͂ƂĐݒ肳ꍇAٱ/޳ݓ͌`Ԑݒ͖
 *       ܂B
 *
 * \param[in]  port     `Ԑݒ肷PORTPʕ̊
 * \param[in]  pin_mask `Ԑݒ肷߰ ݂̎Օ
 * \param[in]  config   ݂̌`Ԑݒ̐ݒ
 */
static void _system_pinmux_config(
		PortGroup *const port,
		const uint32_t pin_mask,
		const struct system_pinmux_config *const config)
{
	Assert(port);
	Assert(config);

	/* OɌ`ԐݒޯĂꎞϐɈړ */
	uint32_t pin_cfg = 0;

	/* ܰޓ싖ŁA`Ԑݒ쐬ȂB */
	if (!config->powersave) {
		/* GPIOI΂ȂꍇݎӋ@\MUX׸ދ(MUX͌ŏ)A
		 * VMUXՕi[ */
		if (config->mux_position != SYSTEM_PINMUX_GPIO) {
			pin_cfg |= PORT_WRCONFIG_PMUXEN;
			pin_cfg |= (config->mux_position << PORT_WRCONFIG_PMUX_Pos);
		}

		/* ͊ɏՕgp҂v */
		if ((config->direction == SYSTEM_PINMUX_PIN_DIR_INPUT) ||
				(config->direction == SYSTEM_PINMUX_PIN_DIR_OUTPUT_WITH_READBACK)) {
			/* ͊ɏՕ׸ދ */
			pin_cfg |= PORT_WRCONFIG_INEN;

			/* ߂ꂽȂAٱ/޳ݐ׸ނ */
			if (config->input_pull != SYSTEM_PINMUX_PIN_PULL_NONE) {
				pin_cfg |= PORT_WRCONFIG_PULLEN;
			}

			/* o͊ɏՕ֎~邽߂߰DIRޯĂ */
			port->DIRCLR.reg = pin_mask;
		}

		/* o͊ɏՕgp҂v */
		if ((config->direction == SYSTEM_PINMUX_PIN_DIR_OUTPUT) ||
				(config->direction == SYSTEM_PINMUX_PIN_DIR_OUTPUT_WITH_READBACK)) {
			/* o͊ɏՕȂAٱ߂͎gpłAvꂽꍇA
			 * ɏՕ݂͌̏o͏Ԃ̎悷邱Ƃł܂B */
			pin_cfg &= ~PORT_WRCONFIG_PULLEN;
		}
	}

	/* `Ԑݒ菑(WRCONFIGڼ޽݂ł𕪊A216ޯĔ
	 * ɌQ邱ƂKvƂ܂B */
	uint32_t lower_pin_mask = (pin_mask & 0xFFFF);
	uint32_t upper_pin_mask = (pin_mask >> 16);

	/* Ô߂ꂪݎӋ@\d܂݁A߰Ẳ16ޯĂ]
	 * `ԐݒɌ`Ԑݒ */
	port->WRCONFIG.reg
		= (lower_pin_mask << PORT_WRCONFIG_PINMASK_Pos) |
			pin_cfg | PORT_WRCONFIG_WRPMUX | PORT_WRCONFIG_WRPINCFG;

	/* Ô߂ꂪݎӋ@\d܂݁A߰Ă̏16ޯĂ]
	 * `ԐݒɌ`Ԑݒ */
	port->WRCONFIG.reg
		= (upper_pin_mask << PORT_WRCONFIG_PINMASK_Pos) |
			pin_cfg | PORT_WRCONFIG_WRPMUX | PORT_WRCONFIG_WRPINCFG |
			PORT_WRCONFIG_HWSEL;

	if(!config->powersave) {
		/* ꂪvėL߰Č`Ԑݒ̑gɈᔽȂȂAU߰ 
		 * `Ԑݒ肳ƁAٱߏԂݒ */
		if (pin_cfg & PORT_WRCONFIG_PULLEN) {
			/* vꂽȂAٱ߂邽߂OUTڼ޽ޯĂݒ肵A
			 * ޳݂ɂ͉ */
			if (config->input_pull == SYSTEM_PINMUX_PIN_PULL_UP) {
				port->OUTSET.reg = pin_mask;
			} else {
				port->OUTCLR.reg = pin_mask;
			}
		}

		/* o͊ɏՕgp҂v */
		if ((config->direction == SYSTEM_PINMUX_PIN_DIR_OUTPUT) ||
				(config->direction == SYSTEM_PINMUX_PIN_DIR_OUTPUT_WITH_READBACK)) {
			/* o͊ɏՕ邽߂߰DIR߯Ăݒ */
			port->DIRSET.reg = pin_mask;
		}
	}
}

/**
 * \brief ߰ ݌`Ԑݒʰ޳Pʕɏ
 *
 * ߰ ݌`Ԑݒ̗^ꂽ`Ԑݒʰ޳Pʕɏo
 *
 * \note ݕo͂ƂĐݒ肳ꍇAٱ/޳ݓ͌`Ԑݒ͖
 *       ܂B
 *
 * \param[in]  gpio_pin `Ԑݒ肷GPIO݂̎wW
 * \param[in]  config   ݂̌`Ԑݒ̐ݒ
 */
void system_pinmux_pin_set_config(
		const uint8_t gpio_pin,
		const struct system_pinmux_config *const config)
{
	PortGroup *const port = system_pinmux_get_group_from_gpio_pin(gpio_pin);
	uint32_t pin_mask = (1UL << (gpio_pin % 32));

	_system_pinmux_config(port, pin_mask, config);
}

/**
 * \brief ߰ ݌Q`Ԑݒʰ޳Pʕɏ
 *
 * ߰ ݌Q`Ԑݒ̗^炦`Ԑݒʰ޳Pʕɏo
 *
 * \note ݕo͂ƂĐݒ肳ꍇAٱ/޳ݓ͌`Ԑݒ͖
 *       ܂B
 *
 * \param[in]  port   `Ԑݒ肷PORTPʕ̊
 * \param[in]  mask   `Ԑݒ肷߰ ݂̎Օ
 * \param[in]  config ݂̌`Ԑݒ̐ݒ
 */
void system_pinmux_group_set_config(
		PortGroup *const port,
		const uint32_t mask,
		const struct system_pinmux_config *const config)
{
	Assert(port);

	for (int i = 0; i < 32; i++) {
		if (mask & (1UL << i)) {
			_system_pinmux_config(port, (1UL << i), config);
		}
	}
}

/**
 * \brief ݂̌Qɑ΂ē͍̎擮`Ԑݒ
 *
 * II/Oݒl̎悳ϲ ۰דɊi[鎞𐧌䂷邽߂ɁA
 * ݂̌Qɑ΂͍̎擮`Ԑݒ肵܂B
 *
 * \param[in]  port `Ԑݒ肷PORTPʕ̊
 * \param[in]  mask `Ԑݒ肷߰ ݂̎Օ
 * \param[in]  mode `Ԑݒ肷V̎擮
 */
void system_pinmux_group_set_input_sample_mode(
		PortGroup *const port,
		const uint32_t mask,
		const enum system_pinmux_pin_sample mode)
{
	Assert(port);

	if (mode == SYSTEM_PINMUX_PIN_SAMPLE_ONDEMAND) {
		port->CTRL.reg |= mask;
	} else {
		port->CTRL.reg &= ~mask;
	}
}
