/**
 * \file
 *
 * \brief SAM D20/D21/R21 EEPROM͕핔
 *
 * 쌠 (c) 2012 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#ifndef EEPROM_H_INCLUDED
#define EEPROM_H_INCLUDED

/**
 * \defgroup asfdoc_sam0_eeprom_group SAM D20/D21/R21 EEPROM͕핔޽(EEPROM)
 *
 * SAM D20/D21/R21޲pײނ͕s؂Ŏgp҉p`Ԑݒް̋L
 * Ɖ񕜂̂߂̂޲ׯ ؓł̖͕EEPROM؋Ԃ񋟂܂B
 *
 * ȉ̎Ӌ@\̒PʕɂĎgp܂B:
 *
 *  - NVM(sؐ)
 *
 * ̎̊Tv͎̒ʂłB:
 *  - \ref asfdoc_sam0_eeprom_prerequisites
 *  - \ref asfdoc_sam0_eeprom_module_overview
 *  - \ref asfdoc_sam0_eeprom_special_considerations
 *  - \ref asfdoc_sam0_eeprom_extra_info
 *  - \ref asfdoc_sam0_eeprom_examples
 *  - \ref asfdoc_sam0_eeprom_api_overview
 *
 *
 * \section asfdoc_sam0_eeprom_prerequisites OKv
 *
 * SAM D20/D21/R21޲˭ނ͎NVMׯ ؓeEEPROM̈悪蓖Ă
 * 悤ɁAO݊܂ޯތoRŌ`Ԑݒ肳Ȃ΂Ȃ܂B
 * EEPROM͕핔ɑ΂NVM̈悪蓖ĂȂꍇA܂͖͕핔ɗ\񂳂ꂽ
 * Ԃs[ȏꍇA̒Pʕ͏Ɏs܂B
 *
 *
 * \section asfdoc_sam0_eeprom_module_overview PʕTv
 *
 * SAM D20/D21/R21޲IEEPROM؂܂܂Ȃ߁Asgpް
 * L͑޲̎ׯ ؂̓ʂȗ̈pĖ͕킳܂BEEPROM
 * ւׯ ؋Zp̎gp͐^EEPROM؂ɑ΂Ă̈Ⴂ݂Aް
 * ͌ʂ޲ ڽw\Ȃނ(޲ĊeX)̕ 
 * ߰ނƂďȂ΂Ȃ炸AVްi[Oׯ̗Ŝ
 * Ȃ΂Ȃ܂Bgp҉p痣Ă̓𒊏ۉ邽߁A
 * ͕̎dg݂ް̋LƎ擾ɊւĂƎgՂAPI񎦂悤Ɏ
 * ܂B
 *
 * ̒Pʕ͕s`Ԑݒް̓ǂݍ݂Əݗp̕W̪񋟂
 * 邽߂ɁA޲̓NVM̏㕔EEPROM͕w񋟂܂Bް
 * ޲˭ނpČ`Ԑݒ肳ꂽ傫ŁA޲̎ׯ ؋L̈
 * EEPROM͕̈ɒu܂B͕EEPROM͂ꂪgp҉płǂ̓_ɑ΂Ă
 * ǂݏ悤ɁAʏ޲NVM{ޯĂƏ܂B
 *
 * ǂݏxARAMgpʁAݸ(u)A̓𒲐邽߁Aׯ 
 * ؂pEEPORM͕Ɏgp鑽̈قȂZ@܂BʂƂāA
 * p̕Kvɑ΂čłK؂Ȏdg݂gp꓾悤ɁÄقȂ͕
 * ̎dg݂꓾܂B
 *
 * \subsection asfdoc_sam0_eeprom_module_overview_implementation ڍ
 * ȉ̏͒PʕɂĎ鎞<b>EEPROM͕̎dg1A1.0.0</b>
 * ֌W܂B̉܂͖͕̎dg݂͂̎̏ڍׂŕς邩
 * AႤݸ(u)AxA̓܂B
 *
 * \subsubsection asfdoc_sam0_eeprom_module_overview_implementation_ec ͕핔
 * ̖͕핔<b>p\ȋLƏݎ񐧌ł̍ŗǂ̐M</b>̂߂
 * ݌v܂B(gp鎞)sXV̎ۂőOް
 * Ȃ悤߰ ްIɍXV̂ۏ؂悤ɐ݌v܂B
 * ݷɏՕɷꂽްƋ̼ ؾĂ̗OŁAĂ
 * Iȕs؂ւ̍Ō݂̏s݂̎ۂŎ܂B
 *
 * ̖͕핔̎dg݂(\Ȏ)݂_EEPROM߰ނɌ`Ԑݒ肳
 * 鎞ƕ_EEPROM߰ނɓn鏑݂͕EEPROMԑŜʂĈ꒼
 * ɍs鎞ɍŗǂ̒^悤ɒ܂B
 *
 * \subsubsection asfdoc_sam0_eeprom_module_overview_implementation_pf I
 * SAM D20/D21/R21̕sׯ͊eX4̓傫ׯ ߰ނ܂ޑ
 * ̕Iȗɕ܂B߰ނ͌ʂɓǂݏł܂A߰ނ͍ď
 * ݂OɏȂ΂Ȃ炸Aɗp\ȍŏx1̒P
 * B
 *
 * ̖͕Kv̂߂ɈႤւ߰ ް̔ŊǗƈړA߰ޏ
 * ݑɂėp̂߂ɌÂ̏𐮂Ƃł͕
 * ̎dg݂ɋA܂B to
 *
 * IɁA͕EEPROM \ref asfdoc_sam0_eeprom_module_mem_layout "}"
 * Ŏ悤ɕIׯ ؂̍Ōɔzu܂B
 *
 * \anchor asfdoc_sam0_eeprom_module_mem_layout
 * \dot
 * digraph memory_layout {
 *  size="5,5"
 *  node [shape=plaintext]
 *  memory [label=<
 *   <table border="0" cellborder="1" cellspacing="0" >
 *    <tr>
 *     <td align="right" border="0">NVM؂̍Ō</td>
 *     <td rowspan="3" align="center">\񂵂EEPROM̈</td>
 *    </tr>
 *    <tr>
 *     <td align="right" border="0"> </td>
 *    </tr>
 *    <tr>
 *     <td align="right" border="0">EEPROM؂̊Jn</td>
 *    </tr>
 *    <tr>
 *     <td align="right" border="0">p؂̍Ō</td>
 *     <td rowspan="3" align="center">p̈</td>
 *    </tr>
 *    <tr>
 *     <td height="300" align="right" border="0"> </td>
 *    </tr>
 *    <tr>
 *     <td align="right" border="0">p؂̊Jn</td>
 *    </tr>
 *    <tr>
 *     <td align="right" border="0">ް۰ ؂̍Ō</td>
 *     <td rowspan="3" align="center">BOOT̈</td>
 *    </tr>
 *    <tr>
 *     <td align="right" border="0"> </td>
 *    </tr>
 *    <tr>
 *     <td align="right" border="0">NVM؂̊Jn</td>
 *    </tr>
 *   </table>
 *  >]
 * }
 * \enddot
 *
 * \subsubsection asfdoc_sam0_eeprom_module_overview_implementation_mp 
 * ͕EEPROM؋Ԃ̍Ō1̕Iׯ񂪌`Ԑݒްi[邽߂
 * ͕핔ɂĎgp悤ɗ\񂳂܂B͎gpұsŁAPɖ͕
 * ɂgp̂߂ɗ\񂳂܂B
 *
 * \subsubsection asfdoc_sam0_eeprom_module_overview_implementation_sr \
 * Ԃŕێ邱ƂKvް̂߁Aɖt̗ɏݗvs
 * 鎞ɕްp̓]ƂēPׯ񂪖gpɕۂ܂B
 * ݗvsƁAÂ񂪏ĐV\ƂċLOɁA
 * 삳邱ƂKvȖt̗ް̂ǂꂩ̘_߰ނ(XV)V
 * _߰ ްƋɗ\ɏ܂B
 *
 * \subsubsection asfdoc_sam0_eeprom_module_overview_implementation_rc e
 * eIׯ͍ŏ2̘_IEEPROM ߰ނ̓ei[܂B
 * ͖͕EEPROMɗp\ȋLԂ2ɂ܂A_߰ޓe̍XV
 * łɑ΂Ċe2߰ނ\񂷂邱ƂɂAKvƂ̑S
 * 񐔂炵܂BEEPROM͕핔̕I؂̎oIzuɂĂ
 * \ref asfdoc_sam0_eeprom_init_layout ""B
 *
 * Iȗ̘_߰ނXV邽߁AVް̎c̖gp߰
 * ɖ܂BUŜƁAVݗv͌Â񂪏
 * OɁA݂̗ɏȂ_߰ނV(XVꂽ)_߰ ް
 * \ɕʂ܂B
 *
 * ̼т͗葱KvƂOɕ؂ōő3XV邱Ƃ𓯂
 * _߰ނɋ܂BŊi[铯_EEPROM߰ނ̕
 * ̏ꍇAE[(ōׯ  ߰ ڽ)łŐVƌ􂳂܂B
 *
 * \subsubsection asfdoc_sam0_eeprom_module_overview_implementation_wc ݷ
 * \IEEPROM̎gpʂEEPROM߰ނ̈̕AIɏƂ̂
 * ߁A͕핔͂炪Iɖ߂؊i[̂߂ɏOɁAɏՕ
 * ɑ΂P_EEPORM߰ޏݷōœK܂B͈Ⴄ_
 * EEPROM ߰ނւ̐VݗvvꂽA܂͎gp҂蓮ŏ
 * ݷnɎIɈn܂B
 *
 * ݷȂŁAEEPROM ߰ނւ̊eݗv͊S߰ޏ
 * KvŁAѐ\ቺĕs؂̎Ȃ茸炵܂B
 *
 * \subsection asfdoc_sam0_eeprom_special_considerations_memlayout ؔzu
 * P_EEPROM߰ \ref asfdoc_sam0_eeprom_page_layout "}"Ŏ
 * ɕIɒP̕ׯ ߰ޓ߰ޓeƐ擪ƂĊi[܂B
 *
 * \anchor asfdoc_sam0_eeprom_page_layout
 * \image html page_layout.svg "͕EEPROM߰ނ̓IȔzu"
 *
 * NVM؋Ԃ̐擪łEEPROMؗ\̈ŁA̖͕핔͏񏉊
 * \ref asfdoc_sam0_eeprom_init_layout "}"Ŏ悤Ȕzu𐶂܂B
 *
 * \anchor asfdoc_sam0_eeprom_init_layout
 * \image html init_layout.svg "͕EEPROM؂̏zu"
 *
 * EEPROM߰ނ؂Ɉn邱ƂKvȎɁA̎̋ׯ 
 * ߰ނI΂A͗Ř_߰ނ̉E[łŐVƌ􂳂邽߁A񕜂
 * Pɂ܂BNVMւ4߰ނŁA͏KvƂOɍs
 * _߰ނւ̍ő3̍XV܂B
 * the same logical page to be made before an erase is needed.
 * \ref asfdoc_sam0_eeprom_page_write1 "}"͕؂ւ̘_EEPROM߰
 * <tt>N-1</tt>̍XVꂽł̎gpҏ݂̌ʂ܂B
 *
 * \anchor asfdoc_sam0_eeprom_page_write1
 * \image html nm1_page_write.svg "_EEPROM߰N-1ւ̍ŏ̏"
 *
 * _EEPORM߰ނ2ڂ݂̏\ref asfdoc_sam0_eeprom_page_write2 
 * "}"ŎzuɋA܂B
 *
 * \anchor asfdoc_sam0_eeprom_page_write2
 * \image html nm1_page_write2.svg "_EEPROM߰N-1ւ2ڂ̏"
 *
 * _߰ނ3ڂ݂̏͂ꂪtɂȂ邽߁AEEPROM͕핔
 * 邱ƂKvłBɐ旧A߰ނXV̂Ɠ̖
 * X߰ނ̓eXV߰ނ̐VłƋɗ\ɕʂ܂BÂ
 * (t)͂̌ɏA\ref asfdoc_sam0_eeprom_page_write3 "}"Ŏ
 * zuɋA܂B
 *
 * \anchor asfdoc_sam0_eeprom_page_write3
 * \image html nm1_page_write3.svg "_EEPROM߰N-1ւ3ڂ̏"
 *
 *
 * \section asfdoc_sam0_eeprom_special_considerations ʂȍl
 *
 * \subsection asfdoc_sam0_eeprom_special_considerations_nvm_config NVM`Ԑݒ
 * EEPROM͕핔޽͂ꎩgٰ݂̏̈ꕔƂNVMAɏ
 * ߰ނ𕨗؂Ɉn̂ɖIɏݎw߂𐧌ɑȂ΂
 * Ȃ悤ɁANVM͎蓮ݓɒu܂B̂Ɏgp҉p
 * g̖ړIɂ̂߂NVM߰ނɏƂ鎞Ɏ蓮ݎw߂KNVM
 * ɔsȂ΂Ȃ܂B
 *
 * \subsection asfdoc_sam0_eeprom_special_considerations_pagesize _EEPROM߰ނ̑傫
 * (͕޽ɂĎgp邽)؂Ř_EEPROM߰ނ̓ȇOɐ擪ŏ
 * ʂ̏񂪊i[邱ƂKvȂ߁AeEEPORM߰ނŗp\ް͑޲
 * ĂɂPNVM ߰ނ̑ʂȂȂ܂B
 *
 * \subsection asfdoc_sam0_eeprom_special_considerations_committing ݷ̈n
 * gpްi[̂ɕKvƂ镨݉񐔂炵AI؎
 * ۂ߁A߰ނɏްɏՂ̂ߓIɒP߰ޏݷ
 * gp܂BʂƂāAްȂ悤Ɋ鏑݂ۏ؂
 * ߂̏[ȓd͂p\ȂƂۏ؂邽߂ɁA<b>BODdɉ\
 * 葁</b>ݷ؂Ɉn邱ƂdvłB
 *
 * ݷ͎gp҉pNVM𒼐ڎgpĉꂩNVMs
 * ꍇɂ蓮ňnȂ΂Ȃ܂B
 *
 *
 * \section asfdoc_sam0_eeprom_extra_info ǉ
 *
 * ǉɂĂ\ref asfdoc_sam0_eeprom_extraB͈ȉ܂݂܂B:
 *  - \ref asfdoc_sam0_eeprom_extra_acronyms
 *  - \ref asfdoc_sam0_eeprom_extra_dependencies
 *  - \ref asfdoc_sam0_eeprom_extra_errata
 *  - \ref asfdoc_sam0_eeprom_extra_history
 *
 *
 * \section asfdoc_sam0_eeprom_examples 
 *
 * ײނɊ֘ÄꗗɂĂ\ref asfdoc_sam0_eeprom_exqsg
 * B
 *
 *
 * \section asfdoc_sam0_eeprom_api_overview APITv
 * @{
 */

#ifdef __cplusplus
extern "C" {
#endif

#include <compiler.h>

#if !defined(__DOXYGEN__)
#  define EEPROM_MAX_PAGES				(64 * NVMCTRL_ROW_PAGES)
#  define EEPROM_MASTER_PAGE_NUMBER		(_eeprom_instance.physical_pages - 1)
#  define EEPROM_INVALID_PAGE_NUMBER	0xFF
#  define EEPROM_INVALID_ROW_NUMBER		(EEPROM_INVALID_PAGE_NUMBER / NVMCTRL_ROW_PAGES)
#  define EEPROM_HEADER_SIZE			4
#endif


/** \name EEPROM͕핔
 * @{
 */

#define EEPROM_EMULATOR_ID		1											/**< ͕EEPROMLɎgpdg݂ʂ͕핔dgID */
#define EEPROM_MAJOR_VERSION	1											/**< ͕핔łʂ͕핔Ŕԍ */
#define EEPROM_MINOR_VERSION	0											/**< ͕핔łʂ͕핔Ŕԍ */
#define EEPROM_REVISION			0											/**< ͕핔ʂ͕핔Ŕԍ */
#define EEPROM_PAGE_SIZE		(NVMCTRL_PAGE_SIZE - EEPROM_HEADER_SIZE)	/**< ޲Ăł̊e_EEPROM߰ނ̎gpް̑傫 */

/**
 * \brief EEPROM Ұ\
 *
 * EEPROM͕PʕؔzuҰ܂ލ\
 */
struct eeprom_emulator_parameters {
	uint8_t  page_size;					/**< ͕EEPROM߰ޖ޲Đ */
	uint16_t eeprom_number_of_pages;	/**< ͕킳EEPROM߰ސ */
};

/** @} */

/** \name `ԐݒƏ
 * @{
 */

enum status_code eeprom_emulator_init(void);

void eeprom_emulator_erase_memory(void);

enum status_code eeprom_emulator_get_parameters(
		struct eeprom_emulator_parameters *const parameters);

/** @} */


/** \name _EEPROM߰ޓǂݏ
 * @{
 */

enum status_code eeprom_emulator_commit_page_buffer(void);

enum status_code eeprom_emulator_write_page(
		const uint8_t logical_page,
		const uint8_t *const data);

enum status_code eeprom_emulator_read_page(
		const uint8_t logical_page,
		uint8_t *const data);

/** @} */

/** \name ɏՕEEPROMǂݏ
 * @{
 */

enum status_code eeprom_emulator_write_buffer(
		const uint16_t offset,
		const uint8_t *const data,
		const uint16_t length);

enum status_code eeprom_emulator_read_buffer(
		const uint16_t offset,
		uint8_t *const data,
		const uint16_t length);

/** @} */

#ifdef __cplusplus
}
#endif

/** @} */

/**
 * \page asfdoc_sam0_eeprom_extra ǉ
 *
 * \section asfdoc_sam0_eeprom_extra_acronyms 
 * ͂̈Ӑ}ӖƋɂ̒PʕŎgp铪ꗗɂ\
 * B
 *
 * <table>
 *	<tr>
 *		<th></th>
 *		<th></th>
 *	</tr>
 *	<tr>
 *		<td>EEPROM</td>
 *		<td>dCI\ȓǂݍݐp(Electronically Erasable Read-Only Memory)</td>
 *	</tr>
 *	<tr>
 *		<td>NVM</td>
 *		<td>s(Non-Volatile Memory)</td>
 *	</tr>
 * </table>
 *
 *
 * \section asfdoc_sam0_eeprom_extra_dependencies ˑ
 * ײނ͈ȉ̈ˑ܂B:
 *
 *  - \ref asfdoc_sam0_nvm_group "sؐײ"
 *
 *
 * \section asfdoc_sam0_eeprom_extra_errata Q
 * ײނɊ֘AQ͂܂B
 *
 *
 * \section asfdoc_sam0_eeprom_extra_history Pʕ
 * Pʕ̊Tv͂̏JPʕɍsꂽƏC̏ڍׂƋɉ
 * \Œ񎦂܂B̌ݔł͕\̍ŐVłɑΉ܂B
 *
 * <table>
 *	<tr>
 *		<th>ύXL^</th>
 *	</tr>
  *	<tr>
 *		<td>SAM D21ɑ΂xƕ͂C</td>
 *	</tr>
 *	<tr>
 *		<td>J</td>
 *	</tr>
 * </table>
 */

/**
 * \page asfdoc_sam0_eeprom_exqsg ͕EEPROM޽p̗
 *
 * \ref asfdoc_sam0_eeprom_groupɑ΂ėp\ȑJn̎(QSG)
 * ቞p̈ꗗłBQSG͎gʂ̑Iłײނ`Ԑݒ肵Ďg߂̒iK
 * IȎwł̊ȒPȗłBQSGƗ^pƂĺ߲فA܂͎gp҉pɒ
 * 邱Ƃł邱ƂɒӂĂB
 *
 *  - \subpage asfdoc_sam0_eeprom_basic_use_case
 *
 * \page asfdoc_sam0_eeprom_document_revision_history 
 *
 * <table>
 *	<tr>
 *		<th></td>
 *		<th>t</td>
 *		<th></td>
 *	</tr>
 *	<tr>
 *		<td>D</td>
 *		<td>2014N3</td>
 *		<td>SAM R21xǉ</td>
 *	</tr>
 *	<tr>
 *		<td>C</td>
 *		<td>2014N1</td>
 *		<td>SAM D21xǉ</td>
 *	</tr>
 *  <tr>
 *	   <td>B</td>
 *	   <td>2013N11</td>
 *     <td>
 *        ASF 3.13:eeprom_emulator_write_buffer()eeprom_emulator_read_buffer()
 *        Ɋ֘A޸ނCB֐͍60̔{̕ψʂ܂B͍s
 *        ̊댯Ȃ1߰ނł܂B60̔{̱ڽ
 *        ܂B
 *     </td>
 *	</tr>
 *	<tr>
 *		<td>B</td>
 *		<td>2013N6</td>
 *		<td>Pʕ}XVƒPʕTvB͌AC</td>
 *	</tr>
 *	<tr>
 *		<td>A</td>
 *		<td>2013N6</td>
 *		<td>J</td>
 *	</tr>
 * </table>
 */

#endif /* EEPROM_H_INCLUDED */
