/**
 * \file
 *
 * \brief EICp\iLq
 *
 * 쌠 (c) 2013 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAMD20_EIC_COMPONENT_
#define _SAMD20_EIC_COMPONENT_

/* ========================================================================== */
/** EICpĳAPI` */
/* ========================================================================== */
/** \addtogroup SAMD20_EIC O荞ݐ */
/*@{*/

#define REV_EIC							0x101

/* -------- EIC_CTRL : (EICψ:0x00) (R/W  8) -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  SWRST:1;			/*!< ޯ   0: ĳ ؾ */
    uint8_t  ENABLE:1;			/*!< ޯ   1:  */
    uint8_t  :6;				/*!< ޯ2`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} EIC_CTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EIC_CTRL_OFFSET					0x00			/**< \brief (EIC_CTRL offset) */
#define EIC_CTRL_RESETVALUE				0x00			/**< \brief (EIC_CTRL reset_value) */

#define EIC_CTRL_SWRST_Pos				0				/**< \brief (EIC_CTRL)ĳ ؾ */
#define EIC_CTRL_SWRST					(0x1u << EIC_CTRL_SWRST_Pos)
#define EIC_CTRL_ENABLE_Pos				1				/**< \brief (EIC_CTRL) */
#define EIC_CTRL_ENABLE					(0x1u << EIC_CTRL_ENABLE_Pos)
#define EIC_CTRL_MASK					0x03u			/**< \brief (EIC_CTRL)Օڼ޽ */

/* -------- EIC_STATUS : (EICψ:0x01) (R/   8) -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  :7;				/*!< ޯ0`6: \ */
    uint8_t  SYNCBUSY:1;		/*!< ޯ   7: Z */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} EIC_STATUS_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EIC_STATUS_OFFSET				0x01			/**< \brief (EIC_STATUS offset) */
#define EIC_STATUS_RESETVALUE			0x00			/**< \brief (EIC_STATUS reset_value) */

#define EIC_STATUS_SYNCBUSY_Pos			7				/**< \brief (EIC_STATUS)Z */
#define EIC_STATUS_SYNCBUSY				(0x1u << EIC_STATUS_SYNCBUSY_Pos)
#define EIC_STATUS_MASK					0x80u			/**< \brief (EIC_STATUS)Օڼ޽ */

/* -------- EIC_NMICTRL : (EICψ:0x02) (R/W  8)NMI -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  NMISENSE:3;		/*!< ޯ0`2: NMI͊m`Ԑݒ */
    uint8_t  NMIFILTEN:1;		/*!< ޯ   3: NMIhg틖 */
    uint8_t  :4;				/*!< ޯ4`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} EIC_NMICTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EIC_NMICTRL_OFFSET				0x02			/**< \brief (EIC_NMICTRL offset)NMI */
#define EIC_NMICTRL_RESETVALUE			0x00			/**< \brief (EIC_NMICTRL reset_value)NMI */

#define EIC_NMICTRL_NMISENSE_Pos		0				/**< \brief (EIC_NMICTRL)NMI͊m`Ԑݒ */
#define EIC_NMICTRL_NMISENSE_Msk		(0x7u << EIC_NMICTRL_NMISENSE_Pos)
#define EIC_NMICTRL_NMISENSE(value)		((EIC_NMICTRL_NMISENSE_Msk & ((value) << EIC_NMICTRL_NMISENSE_Pos)))
#define   EIC_NMICTRL_NMISENSE_NONE_Val		0x0u			/**< \brief (EIC_NMICTRL)oȂ */
#define   EIC_NMICTRL_NMISENSE_RISE_Val		0x1u			/**< \brief (EIC_NMICTRL)㏸[o */
#define   EIC_NMICTRL_NMISENSE_FALL_Val		0x2u			/**< \brief (EIC_NMICTRL)~[o */
#define   EIC_NMICTRL_NMISENSE_BOTH_Val		0x3u			/**< \brief (EIC_NMICTRL)[o */
#define   EIC_NMICTRL_NMISENSE_HIGH_Val		0x4u			/**< \brief (EIC_NMICTRL)Highٌo */
#define   EIC_NMICTRL_NMISENSE_LOW_Val		0x5u			/**< \brief (EIC_NMICTRL)Lowٌo */
#define EIC_NMICTRL_NMISENSE_NONE		(EIC_NMICTRL_NMISENSE_NONE_Val	<< EIC_NMICTRL_NMISENSE_Pos)
#define EIC_NMICTRL_NMISENSE_RISE		(EIC_NMICTRL_NMISENSE_RISE_Val	<< EIC_NMICTRL_NMISENSE_Pos)
#define EIC_NMICTRL_NMISENSE_FALL		(EIC_NMICTRL_NMISENSE_FALL_Val	<< EIC_NMICTRL_NMISENSE_Pos)
#define EIC_NMICTRL_NMISENSE_BOTH		(EIC_NMICTRL_NMISENSE_BOTH_Val	<< EIC_NMICTRL_NMISENSE_Pos)
#define EIC_NMICTRL_NMISENSE_HIGH		(EIC_NMICTRL_NMISENSE_HIGH_Val	<< EIC_NMICTRL_NMISENSE_Pos)
#define EIC_NMICTRL_NMISENSE_LOW		(EIC_NMICTRL_NMISENSE_LOW_Val	<< EIC_NMICTRL_NMISENSE_Pos)
#define EIC_NMICTRL_NMIFILTEN_Pos		3				/**< \brief (EIC_NMICTRL)NMIhg틖 */
#define EIC_NMICTRL_NMIFILTEN			(0x1u << EIC_NMICTRL_NMIFILTEN_Pos)
#define EIC_NMICTRL_MASK				0x0Fu			/**< \brief (EIC_NMICTRL)Օڼ޽ */

/* -------- EIC_NMIFLAG : (EICψ:0x03) (R/W  8)NMI荞׸ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  NMI:1;				/*!< ޯ   0: NMI荞׸ */
    uint8_t  :7;				/*!< ޯ1`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} EIC_NMIFLAG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EIC_NMIFLAG_OFFSET				0x03			/**< \brief (EIC_NMIFLAG offset)NMI荞׸ */
#define EIC_NMIFLAG_RESETVALUE			0x00			/**< \brief (EIC_NMIFLAG reset_value)NMI荞׸ */

#define EIC_NMIFLAG_NMI_Pos				0				/**< \brief (EIC_NMIFLAG)NMI荞׸ */
#define EIC_NMIFLAG_NMI					(0x1u << EIC_NMIFLAG_NMI_Pos)
#define EIC_NMIFLAG_MASK				0x01u			/**< \brief (EIC_NMIFLAG)Օڼ޽ */

/* -------- EIC_EVCTRL : (EICψ:0x04) (R/W 32)ې -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t EXTINTEO:32;		/*!< ޯ0`31: O荞ݎۏo͋ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} EIC_EVCTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EIC_EVCTRL_OFFSET				0x04			/**< \brief (EIC_EVCTRL offset)ې */
#define EIC_EVCTRL_RESETVALUE			0x00000000		/**< \brief (EIC_EVCTRL reset_value)ې */

#define EIC_EVCTRL_EXTINTEO_Pos			0				/**< \brief (EIC_EVCTRL)O荞ݎۏo͋ */
#define EIC_EVCTRL_EXTINTEO_Msk			(0xFFFFFFFFu << EIC_EVCTRL_EXTINTEO_Pos)
#define EIC_EVCTRL_EXTINTEO(value)		((EIC_EVCTRL_EXTINTEO_Msk & ((value) << EIC_EVCTRL_EXTINTEO_Pos)))
#define EIC_EVCTRL_MASK					0xFFFFFFFFu		/**< \brief (EIC_EVCTRL)Օڼ޽ */

/* -------- EIC_INTENCLR : (EICψ:0x08) (R/W 32)荞݋ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t EXTINT:16;			/*!< ޯ 0`15: O荞݋֎~ */
    uint32_t :16;				/*!< ޯ16`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} EIC_INTENCLR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EIC_INTENCLR_OFFSET				0x08			/**< \brief (EIC_INTENCLR offset)荞݋ */
#define EIC_INTENCLR_RESETVALUE			0x00000000		/**< \brief (EIC_INTENCLR reset_value)荞݋ */

#define EIC_INTENCLR_EXTINT_Pos			0				/**< \brief (EIC_INTENCLR)O荞݋֎~ */
#define EIC_INTENCLR_EXTINT_Msk			(0xFFFFu << EIC_INTENCLR_EXTINT_Pos)
#define EIC_INTENCLR_EXTINT(value)		((EIC_INTENCLR_EXTINT_Msk & ((value) << EIC_INTENCLR_EXTINT_Pos)))
#define EIC_INTENCLR_MASK				0x0000FFFFu		/**< \brief (EIC_INTENCLR)Օڼ޽ */

/* -------- EIC_INTENSET : (EICψ:0x0C) (R/W 32)荞݋ݒ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t EXTINT:16;			/*!< ޯ 0`15: O荞݋ */
    uint32_t :16;				/*!< ޯ16`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} EIC_INTENSET_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EIC_INTENSET_OFFSET				0x0C			/**< \brief (EIC_INTENSET offset)荞݋ݒ */
#define EIC_INTENSET_RESETVALUE			0x00000000		/**< \brief (EIC_INTENSET reset_value)荞݋ݒ */

#define EIC_INTENSET_EXTINT_Pos			0				/**< \brief (EIC_INTENSET)O荞݋ */
#define EIC_INTENSET_EXTINT_Msk			(0xFFFFu << EIC_INTENSET_EXTINT_Pos)
#define EIC_INTENSET_EXTINT(value)		((EIC_INTENSET_EXTINT_Msk & ((value) << EIC_INTENSET_EXTINT_Pos)))
#define EIC_INTENSET_MASK				0x0000FFFFu		/**< \brief (EIC_INTENSET)Օڼ޽ */

/* -------- EIC_INTFLAG : (EICψ:0x10) (R/W 32)荞׸ޏ/ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t EXTINT:16;			/*!< ޯ 0`15: O荞׸ */
    uint32_t :16;				/*!< ޯ16`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} EIC_INTFLAG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EIC_INTFLAG_OFFSET				0x10			/**< \brief (EIC_INTFLAG offset)荞׸ޏ/ */
#define EIC_INTFLAG_RESETVALUE			0x00000000		/**< \brief (EIC_INTFLAG reset_value)荞׸ޏ/ */

#define EIC_INTFLAG_EXTINT_Pos			0				/**< \brief (EIC_INTFLAG)O荞׸ */
#define EIC_INTFLAG_EXTINT_Msk			(0xFFFFu << EIC_INTFLAG_EXTINT_Pos)
#define EIC_INTFLAG_EXTINT(value)		((EIC_INTFLAG_EXTINT_Msk & ((value) << EIC_INTFLAG_EXTINT_Pos)))
#define EIC_INTFLAG_MASK				0x0000FFFFu		/**< \brief (EIC_INTFLAG)Օڼ޽ */

/* -------- EIC_WAKEUP : (EICψ:0x14) (R/W 32)N -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t WAKEUPEN:16;		/*!< ޯ 0`15: O荞݋N */
    uint32_t :16;				/*!< ޯ16`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} EIC_WAKEUP_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EIC_WAKEUP_OFFSET				0x14			/**< \brief (EIC_WAKEUP offset)N */
#define EIC_WAKEUP_RESETVALUE			0x00000000		/**< \brief (EIC_WAKEUP reset_value)N */

#define EIC_WAKEUP_WAKEUPEN_Pos			0				/**< \brief (EIC_WAKEUP)O荞݋N */
#define EIC_WAKEUP_WAKEUPEN_Msk			(0xFFFFu << EIC_WAKEUP_WAKEUPEN_Pos)
#define EIC_WAKEUP_WAKEUPEN(value)		((EIC_WAKEUP_WAKEUPEN_Msk & ((value) << EIC_WAKEUP_WAKEUPEN_Pos)))
#define EIC_WAKEUP_MASK					0x0000FFFFu		/**< \brief (EIC_WAKEUP)Օڼ޽ */

/* -------- EIC_CONFIG : (EICψ:0x18) (R/W 32)`Ԑݒ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t SENSE0:3;			/*!< ޯ 0` 2: ͊m`Ԑݒ0 */
    uint32_t FILTEN0:1;			/*!< ޯ     3: hg틖0 */
    uint32_t SENSE1:3;			/*!< ޯ 4` 6: ͊m`Ԑݒ1 */
    uint32_t FILTEN1:1;			/*!< ޯ     7: hg틖1 */
    uint32_t SENSE2:3;			/*!< ޯ 8`10: ͊m`Ԑݒ2 */
    uint32_t FILTEN2:1;			/*!< ޯ    11: hg틖2 */
    uint32_t SENSE3:3;			/*!< ޯ12`14: ͊m`Ԑݒ3 */
    uint32_t FILTEN3:1;			/*!< ޯ    15: hg틖3 */
    uint32_t SENSE4:3;			/*!< ޯ16`18: ͊m`Ԑݒ4 */
    uint32_t FILTEN4:1;			/*!< ޯ    19: hg틖4 */
    uint32_t SENSE5:3;			/*!< ޯ20`22: ͊m`Ԑݒ5 */
    uint32_t FILTEN5:1;			/*!< ޯ    23: hg틖5 */
    uint32_t SENSE6:3;			/*!< ޯ24`26: ͊m`Ԑݒ6 */
    uint32_t FILTEN6:1;			/*!< ޯ    27: hg틖6 */
    uint32_t SENSE7:3;			/*!< ޯ28`30: ͊m`Ԑݒ7 */
    uint32_t FILTEN7:1;			/*!< ޯ    31: hg틖7 */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} EIC_CONFIG_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define EIC_CONFIG_OFFSET				0x18			/**< \brief (EIC_CONFIG offset)`Ԑݒ */
#define EIC_CONFIG_RESETVALUE			0x00000000		/**< \brief (EIC_CONFIG reset_value)`Ԑݒ */

#define EIC_CONFIG_SENSE0_Pos			0				/**< \brief (EIC_CONFIG)͊m`Ԑݒ0 */
#define EIC_CONFIG_SENSE0_Msk			(0x7u << EIC_CONFIG_SENSE0_Pos)
#define EIC_CONFIG_SENSE0(value)		((EIC_CONFIG_SENSE0_Msk & ((value) << EIC_CONFIG_SENSE0_Pos)))
#define   EIC_CONFIG_SENSE0_NONE_Val		0x0u			/**< \brief (EIC_CONFIG)oȂ */
#define   EIC_CONFIG_SENSE0_RISE_Val		0x1u			/**< \brief (EIC_CONFIG)㏸[o */
#define   EIC_CONFIG_SENSE0_FALL_Val		0x2u			/**< \brief (EIC_CONFIG)~[o */
#define   EIC_CONFIG_SENSE0_BOTH_Val		0x3u			/**< \brief (EIC_CONFIG)[o */
#define   EIC_CONFIG_SENSE0_HIGH_Val		0x4u			/**< \brief (EIC_CONFIG)Highٌo */
#define   EIC_CONFIG_SENSE0_LOW_Val			0x5u			/**< \brief (EIC_CONFIG)Lowٌo */
#define EIC_CONFIG_SENSE0_NONE			(EIC_CONFIG_SENSE0_NONE_Val	<< EIC_CONFIG_SENSE0_Pos)
#define EIC_CONFIG_SENSE0_RISE			(EIC_CONFIG_SENSE0_RISE_Val	<< EIC_CONFIG_SENSE0_Pos)
#define EIC_CONFIG_SENSE0_FALL			(EIC_CONFIG_SENSE0_FALL_Val	<< EIC_CONFIG_SENSE0_Pos)
#define EIC_CONFIG_SENSE0_BOTH			(EIC_CONFIG_SENSE0_BOTH_Val	<< EIC_CONFIG_SENSE0_Pos)
#define EIC_CONFIG_SENSE0_HIGH			(EIC_CONFIG_SENSE0_HIGH_Val	<< EIC_CONFIG_SENSE0_Pos)
#define EIC_CONFIG_SENSE0_LOW			(EIC_CONFIG_SENSE0_LOW_Val	<< EIC_CONFIG_SENSE0_Pos)
#define EIC_CONFIG_FILTEN0_Pos			3				/**< \brief (EIC_CONFIG)hg틖0 */
#define EIC_CONFIG_FILTEN0				(0x1u << EIC_CONFIG_FILTEN0_Pos)
#define EIC_CONFIG_SENSE1_Pos			4				/**< \brief (EIC_CONFIG)͊m`Ԑݒ1 */
#define EIC_CONFIG_SENSE1_Msk			(0x7u << EIC_CONFIG_SENSE1_Pos)
#define EIC_CONFIG_SENSE1(value)		((EIC_CONFIG_SENSE1_Msk & ((value) << EIC_CONFIG_SENSE1_Pos)))
#define   EIC_CONFIG_SENSE1_NONE_Val		0x0u			/**< \brief (EIC_CONFIG)oȂ */
#define   EIC_CONFIG_SENSE1_RISE_Val		0x1u			/**< \brief (EIC_CONFIG)㏸[o */
#define   EIC_CONFIG_SENSE1_FALL_Val		0x2u			/**< \brief (EIC_CONFIG)~[o */
#define   EIC_CONFIG_SENSE1_BOTH_Val		0x3u			/**< \brief (EIC_CONFIG)[o */
#define   EIC_CONFIG_SENSE1_HIGH_Val		0x4u			/**< \brief (EIC_CONFIG)Highٌo */
#define   EIC_CONFIG_SENSE1_LOW_Val			0x5u			/**< \brief (EIC_CONFIG)Lowٌo */
#define EIC_CONFIG_SENSE1_NONE			(EIC_CONFIG_SENSE1_NONE_Val	<< EIC_CONFIG_SENSE1_Pos)
#define EIC_CONFIG_SENSE1_RISE			(EIC_CONFIG_SENSE1_RISE_Val	<< EIC_CONFIG_SENSE1_Pos)
#define EIC_CONFIG_SENSE1_FALL			(EIC_CONFIG_SENSE1_FALL_Val	<< EIC_CONFIG_SENSE1_Pos)
#define EIC_CONFIG_SENSE1_BOTH			(EIC_CONFIG_SENSE1_BOTH_Val	<< EIC_CONFIG_SENSE1_Pos)
#define EIC_CONFIG_SENSE1_HIGH			(EIC_CONFIG_SENSE1_HIGH_Val	<< EIC_CONFIG_SENSE1_Pos)
#define EIC_CONFIG_SENSE1_LOW			(EIC_CONFIG_SENSE1_LOW_Val	<< EIC_CONFIG_SENSE1_Pos)
#define EIC_CONFIG_FILTEN1_Pos			7				/**< \brief (EIC_CONFIG)hg틖1 */
#define EIC_CONFIG_FILTEN1				(0x1u << EIC_CONFIG_FILTEN1_Pos)
#define EIC_CONFIG_SENSE2_Pos			8				/**< \brief (EIC_CONFIG)͊m`Ԑݒ2 */
#define EIC_CONFIG_SENSE2_Msk			(0x7u << EIC_CONFIG_SENSE2_Pos)
#define EIC_CONFIG_SENSE2(value)		((EIC_CONFIG_SENSE2_Msk & ((value) << EIC_CONFIG_SENSE2_Pos)))
#define   EIC_CONFIG_SENSE2_NONE_Val		0x0u			/**< \brief (EIC_CONFIG)oȂ */
#define   EIC_CONFIG_SENSE2_RISE_Val		0x1u			/**< \brief (EIC_CONFIG)㏸[o */
#define   EIC_CONFIG_SENSE2_FALL_Val		0x2u			/**< \brief (EIC_CONFIG)~[o */
#define   EIC_CONFIG_SENSE2_BOTH_Val		0x3u			/**< \brief (EIC_CONFIG)[o */
#define   EIC_CONFIG_SENSE2_HIGH_Val		0x4u			/**< \brief (EIC_CONFIG)Highٌo */
#define   EIC_CONFIG_SENSE2_LOW_Val			0x5u			/**< \brief (EIC_CONFIG)Lowٌo */
#define EIC_CONFIG_SENSE2_NONE			(EIC_CONFIG_SENSE2_NONE_Val	<< EIC_CONFIG_SENSE2_Pos)
#define EIC_CONFIG_SENSE2_RISE			(EIC_CONFIG_SENSE2_RISE_Val	<< EIC_CONFIG_SENSE2_Pos)
#define EIC_CONFIG_SENSE2_FALL			(EIC_CONFIG_SENSE2_FALL_Val	<< EIC_CONFIG_SENSE2_Pos)
#define EIC_CONFIG_SENSE2_BOTH			(EIC_CONFIG_SENSE2_BOTH_Val	<< EIC_CONFIG_SENSE2_Pos)
#define EIC_CONFIG_SENSE2_HIGH			(EIC_CONFIG_SENSE2_HIGH_Val	<< EIC_CONFIG_SENSE2_Pos)
#define EIC_CONFIG_SENSE2_LOW			(EIC_CONFIG_SENSE2_LOW_Val	<< EIC_CONFIG_SENSE2_Pos)
#define EIC_CONFIG_FILTEN2_Pos			11				/**< \brief (EIC_CONFIG)hg틖2 */
#define EIC_CONFIG_FILTEN2				(0x1u << EIC_CONFIG_FILTEN2_Pos)
#define EIC_CONFIG_SENSE3_Pos			12				/**< \brief (EIC_CONFIG)͊m`Ԑݒ3 */
#define EIC_CONFIG_SENSE3_Msk			(0x7u << EIC_CONFIG_SENSE3_Pos)
#define EIC_CONFIG_SENSE3(value)		((EIC_CONFIG_SENSE3_Msk & ((value) << EIC_CONFIG_SENSE3_Pos)))
#define   EIC_CONFIG_SENSE3_NONE_Val		0x0u			/**< \brief (EIC_CONFIG)oȂ */
#define   EIC_CONFIG_SENSE3_RISE_Val		0x1u			/**< \brief (EIC_CONFIG)㏸[o */
#define   EIC_CONFIG_SENSE3_FALL_Val		0x2u			/**< \brief (EIC_CONFIG)~[o */
#define   EIC_CONFIG_SENSE3_BOTH_Val		0x3u			/**< \brief (EIC_CONFIG)[o */
#define   EIC_CONFIG_SENSE3_HIGH_Val		0x4u			/**< \brief (EIC_CONFIG)Highٌo */
#define   EIC_CONFIG_SENSE3_LOW_Val			0x5u			/**< \brief (EIC_CONFIG)Lowٌo */
#define EIC_CONFIG_SENSE3_NONE			(EIC_CONFIG_SENSE3_NONE_Val	<< EIC_CONFIG_SENSE3_Pos)
#define EIC_CONFIG_SENSE3_RISE			(EIC_CONFIG_SENSE3_RISE_Val	<< EIC_CONFIG_SENSE3_Pos)
#define EIC_CONFIG_SENSE3_FALL			(EIC_CONFIG_SENSE3_FALL_Val	<< EIC_CONFIG_SENSE3_Pos)
#define EIC_CONFIG_SENSE3_BOTH			(EIC_CONFIG_SENSE3_BOTH_Val	<< EIC_CONFIG_SENSE3_Pos)
#define EIC_CONFIG_SENSE3_HIGH			(EIC_CONFIG_SENSE3_HIGH_Val	<< EIC_CONFIG_SENSE3_Pos)
#define EIC_CONFIG_SENSE3_LOW			(EIC_CONFIG_SENSE3_LOW_Val	<< EIC_CONFIG_SENSE3_Pos)
#define EIC_CONFIG_FILTEN3_Pos			15				/**< \brief (EIC_CONFIG)hg틖3 */
#define EIC_CONFIG_FILTEN3				(0x1u << EIC_CONFIG_FILTEN3_Pos)
#define EIC_CONFIG_SENSE4_Pos			16				/**< \brief (EIC_CONFIG)͊m`Ԑݒ4 */
#define EIC_CONFIG_SENSE4_Msk			(0x7u << EIC_CONFIG_SENSE4_Pos)
#define EIC_CONFIG_SENSE4(value)		((EIC_CONFIG_SENSE4_Msk & ((value) << EIC_CONFIG_SENSE4_Pos)))
#define   EIC_CONFIG_SENSE4_NONE_Val		0x0u			/**< \brief (EIC_CONFIG)oȂ */
#define   EIC_CONFIG_SENSE4_RISE_Val		0x1u			/**< \brief (EIC_CONFIG)㏸[o */
#define   EIC_CONFIG_SENSE4_FALL_Val		0x2u			/**< \brief (EIC_CONFIG)~[o */
#define   EIC_CONFIG_SENSE4_BOTH_Val		0x3u			/**< \brief (EIC_CONFIG)[o */
#define   EIC_CONFIG_SENSE4_HIGH_Val		0x4u			/**< \brief (EIC_CONFIG)Highٌo */
#define   EIC_CONFIG_SENSE4_LOW_Val			0x5u			/**< \brief (EIC_CONFIG)Lowٌo */
#define EIC_CONFIG_SENSE4_NONE			(EIC_CONFIG_SENSE4_NONE_Val	<< EIC_CONFIG_SENSE4_Pos)
#define EIC_CONFIG_SENSE4_RISE			(EIC_CONFIG_SENSE4_RISE_Val	<< EIC_CONFIG_SENSE4_Pos)
#define EIC_CONFIG_SENSE4_FALL			(EIC_CONFIG_SENSE4_FALL_Val	<< EIC_CONFIG_SENSE4_Pos)
#define EIC_CONFIG_SENSE4_BOTH			(EIC_CONFIG_SENSE4_BOTH_Val	<< EIC_CONFIG_SENSE4_Pos)
#define EIC_CONFIG_SENSE4_HIGH			(EIC_CONFIG_SENSE4_HIGH_Val	<< EIC_CONFIG_SENSE4_Pos)
#define EIC_CONFIG_SENSE4_LOW			(EIC_CONFIG_SENSE4_LOW_Val	<< EIC_CONFIG_SENSE4_Pos)
#define EIC_CONFIG_FILTEN4_Pos			19				/**< \brief (EIC_CONFIG)hg틖4 */
#define EIC_CONFIG_FILTEN4				(0x1u << EIC_CONFIG_FILTEN4_Pos)
#define EIC_CONFIG_SENSE5_Pos			20				/**< \brief (EIC_CONFIG)͊m`Ԑݒ5 */
#define EIC_CONFIG_SENSE5_Msk			(0x7u << EIC_CONFIG_SENSE5_Pos)
#define EIC_CONFIG_SENSE5(value)		((EIC_CONFIG_SENSE5_Msk & ((value) << EIC_CONFIG_SENSE5_Pos)))
#define   EIC_CONFIG_SENSE5_NONE_Val		0x0u			/**< \brief (EIC_CONFIG)oȂ */
#define   EIC_CONFIG_SENSE5_RISE_Val		0x1u			/**< \brief (EIC_CONFIG)㏸[o */
#define   EIC_CONFIG_SENSE5_FALL_Val		0x2u			/**< \brief (EIC_CONFIG)~[o */
#define   EIC_CONFIG_SENSE5_BOTH_Val		0x3u			/**< \brief (EIC_CONFIG)[o */
#define   EIC_CONFIG_SENSE5_HIGH_Val		0x4u			/**< \brief (EIC_CONFIG)Highٌo */
#define   EIC_CONFIG_SENSE5_LOW_Val			0x5u			/**< \brief (EIC_CONFIG)Lowٌo */
#define EIC_CONFIG_SENSE5_NONE			(EIC_CONFIG_SENSE5_NONE_Val	<< EIC_CONFIG_SENSE5_Pos)
#define EIC_CONFIG_SENSE5_RISE			(EIC_CONFIG_SENSE5_RISE_Val	<< EIC_CONFIG_SENSE5_Pos)
#define EIC_CONFIG_SENSE5_FALL			(EIC_CONFIG_SENSE5_FALL_Val	<< EIC_CONFIG_SENSE5_Pos)
#define EIC_CONFIG_SENSE5_BOTH			(EIC_CONFIG_SENSE5_BOTH_Val	<< EIC_CONFIG_SENSE5_Pos)
#define EIC_CONFIG_SENSE5_HIGH			(EIC_CONFIG_SENSE5_HIGH_Val	<< EIC_CONFIG_SENSE5_Pos)
#define EIC_CONFIG_SENSE5_LOW			(EIC_CONFIG_SENSE5_LOW_Val	<< EIC_CONFIG_SENSE5_Pos)
#define EIC_CONFIG_FILTEN5_Pos			23				/**< \brief (EIC_CONFIG)hg틖5 */
#define EIC_CONFIG_FILTEN5				(0x1u << EIC_CONFIG_FILTEN5_Pos)
#define EIC_CONFIG_SENSE6_Pos			24				/**< \brief (EIC_CONFIG)͊m`Ԑݒ6 */
#define EIC_CONFIG_SENSE6_Msk			(0x7u << EIC_CONFIG_SENSE6_Pos)
#define EIC_CONFIG_SENSE6(value)		((EIC_CONFIG_SENSE6_Msk & ((value) << EIC_CONFIG_SENSE6_Pos)))
#define   EIC_CONFIG_SENSE6_NONE_Val		0x0u			/**< \brief (EIC_CONFIG)oȂ */
#define   EIC_CONFIG_SENSE6_RISE_Val		0x1u			/**< \brief (EIC_CONFIG)㏸[o */
#define   EIC_CONFIG_SENSE6_FALL_Val		0x2u			/**< \brief (EIC_CONFIG)~[o */
#define   EIC_CONFIG_SENSE6_BOTH_Val		0x3u			/**< \brief (EIC_CONFIG)[o */
#define   EIC_CONFIG_SENSE6_HIGH_Val		0x4u			/**< \brief (EIC_CONFIG)Highٌo */
#define   EIC_CONFIG_SENSE6_LOW_Val			0x5u			/**< \brief (EIC_CONFIG)Lowٌo */
#define EIC_CONFIG_SENSE6_NONE			(EIC_CONFIG_SENSE6_NONE_Val	<< EIC_CONFIG_SENSE6_Pos)
#define EIC_CONFIG_SENSE6_RISE			(EIC_CONFIG_SENSE6_RISE_Val	<< EIC_CONFIG_SENSE6_Pos)
#define EIC_CONFIG_SENSE6_FALL			(EIC_CONFIG_SENSE6_FALL_Val	<< EIC_CONFIG_SENSE6_Pos)
#define EIC_CONFIG_SENSE6_BOTH			(EIC_CONFIG_SENSE6_BOTH_Val	<< EIC_CONFIG_SENSE6_Pos)
#define EIC_CONFIG_SENSE6_HIGH			(EIC_CONFIG_SENSE6_HIGH_Val	<< EIC_CONFIG_SENSE6_Pos)
#define EIC_CONFIG_SENSE6_LOW			(EIC_CONFIG_SENSE6_LOW_Val	<< EIC_CONFIG_SENSE6_Pos)
#define EIC_CONFIG_FILTEN6_Pos			27				/**< \brief (EIC_CONFIG)hg틖6 */
#define EIC_CONFIG_FILTEN6				(0x1u << EIC_CONFIG_FILTEN6_Pos)
#define EIC_CONFIG_SENSE7_Pos			28				/**< \brief (EIC_CONFIG)͊m`Ԑݒ7 */
#define EIC_CONFIG_SENSE7_Msk			(0x7u << EIC_CONFIG_SENSE7_Pos)
#define EIC_CONFIG_SENSE7(value)		((EIC_CONFIG_SENSE7_Msk & ((value) << EIC_CONFIG_SENSE7_Pos)))
#define   EIC_CONFIG_SENSE7_NONE_Val		0x0u			/**< \brief (EIC_CONFIG)oȂ */
#define   EIC_CONFIG_SENSE7_RISE_Val		0x1u			/**< \brief (EIC_CONFIG)㏸[o */
#define   EIC_CONFIG_SENSE7_FALL_Val		0x2u			/**< \brief (EIC_CONFIG)~[o */
#define   EIC_CONFIG_SENSE7_BOTH_Val		0x3u			/**< \brief (EIC_CONFIG)[o */
#define   EIC_CONFIG_SENSE7_HIGH_Val		0x4u			/**< \brief (EIC_CONFIG)Highٌo */
#define   EIC_CONFIG_SENSE7_LOW_Val			0x5u			/**< \brief (EIC_CONFIG)Lowٌo */
#define EIC_CONFIG_SENSE7_NONE			(EIC_CONFIG_SENSE7_NONE_Val	<< EIC_CONFIG_SENSE7_Pos)
#define EIC_CONFIG_SENSE7_RISE			(EIC_CONFIG_SENSE7_RISE_Val	<< EIC_CONFIG_SENSE7_Pos)
#define EIC_CONFIG_SENSE7_FALL			(EIC_CONFIG_SENSE7_FALL_Val	<< EIC_CONFIG_SENSE7_Pos)
#define EIC_CONFIG_SENSE7_BOTH			(EIC_CONFIG_SENSE7_BOTH_Val	<< EIC_CONFIG_SENSE7_Pos)
#define EIC_CONFIG_SENSE7_HIGH			(EIC_CONFIG_SENSE7_HIGH_Val	<< EIC_CONFIG_SENSE7_Pos)
#define EIC_CONFIG_SENSE7_LOW			(EIC_CONFIG_SENSE7_LOW_Val	<< EIC_CONFIG_SENSE7_Pos)
#define EIC_CONFIG_FILTEN7_Pos			31				/**< \brief (EIC_CONFIG)hg틖7 */
#define EIC_CONFIG_FILTEN7				(0x1u << EIC_CONFIG_FILTEN7_Pos)
#define EIC_CONFIG_MASK					0xFFFFFFFFu		/**< \brief (EIC_CONFIG)Օڼ޽ */

/** \brief EICʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  __IO EIC_CTRL_Type		CTRL;		/**< \briefψ:0x00 (R/W  8) */
  __I  EIC_STATUS_Type		STATUS;		/**< \briefψ:0x01 (R/   8) */
  __IO EIC_NMICTRL_Type		NMICTRL;	/**< \briefψ:0x02 (R/W  8)NMI */
  __IO EIC_NMIFLAG_Type		NMIFLAG;	/**< \briefψ:0x03 (R/W  8)NMI荞׸ */
  __IO EIC_EVCTRL_Type		EVCTRL;		/**< \briefψ:0x04 (R/W 32)ې */
  __IO EIC_INTENCLR_Type	INTENCLR;	/**< \briefψ:0x08 (R/W 32)荞݋ */
  __IO EIC_INTENSET_Type	INTENSET;	/**< \briefψ:0x0C (R/W 32)荞݋ݒ */
  __IO EIC_INTFLAG_Type		INTFLAG;	/**< \briefψ:0x10 (R/W 32)荞׸ޏ/ */
  __IO EIC_WAKEUP_Type		WAKEUP;		/**< \briefψ:0x14 (R/W 32)N */
  __IO EIC_CONFIG_Type		CONFIG[2];	/**< \briefψ:0x18 (R/W 32)`Ԑݒ [NUMBER_OF_CONFIG_REGS] */
} Eic;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

#endif /* _SAMD20_EIC_COMPONENT_ */
