/**
 * \file
 *
 * \brief SAM D20/D21/R21O荞ײ
 *
 * 쌠 (c) 2012 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */
#include "extint.h"
#include <system.h>
#include <system_interrupt.h>

/**
 * \internal
 * ײ ޲̍\
 */
struct _extint_module _extint_dev;

/**
 * \brief WۯKvƂ邩f
 *
 * \param[in]  filter_input_signal Gh߂ɐ͐Mhg
 * \param[in]  detection_criteria  gp[o(\ref extint_detect)
 */
#define _extint_is_gclk_required(filter_input_signal, detection_criteria) \
		((filter_input_signal) ? true : (\
			(EXTINT_DETECT_RISING == (detection_criteria)) ? true : (\
			(EXTINT_DETECT_FALLING == (detection_criteria)) ? true : (\
			(EXTINT_DETECT_BOTH == (detection_criteria)) ? true : false))))

static void _extint_enable(void);
static void _extint_disable(void);

/**
 * \internal
 * \brief O荞ײނ̏Ƌ
 *
 * O荞ײނŎgpۯ
 *
 * O荞ײނؾāASĂʰ޳Pʕڼ޽̓dONؾ
 * Ă̌ɍXȂgp̂߂ɂ
 *
 * Ăі߂삪gpꍇɌĂі߂ꗗؾ
 *
 * ̊֐͉ꂩNMI܂͕WO荞ي֐gp悤ƂOɌ
 * ΂Ȃ΂Ȃ܂B
 *
 * \note SYSTEMPʕgpƁAPʕݸٰނꍇɂ̊֐
 * \ref system_init()ɂĎIɌĂяo܂B
 */
void _system_extint_init(void);
void _system_extint_init(void)
{
	Eic *const eics[EIC_INST_NUM] = EIC_INSTS;

	/* ޼ ̪ ۯON */
	system_apb_clock_set_mask(SYSTEM_CLOCK_APB_APBA, PM_APBAMASK_EIC);

	/* PʕpWۯ`Ԑݒ肵Ă */
	struct system_gclk_chan_config gclk_chan_conf;
	system_gclk_chan_get_config_defaults(&gclk_chan_conf);
	gclk_chan_conf.source_generator = EXTINT_CLOCK_SOURCE;
	system_gclk_chan_set_config(EIC_GCLK_ID, &gclk_chan_conf);

	/* O荞ײނɂĂꂪ߂邱ƂKvƂ邽߁AƂɂ
	 * ۯ */
	system_gclk_chan_enable(EIC_GCLK_ID);

	/* SĂEICʰ޳Pʕؾ */
	for (uint32_t i = 0; i < EIC_INST_NUM; i++) {
		eics[i]->CTRL.reg |= EIC_CTRL_SWRST;
	}

	while (extint_is_syncing()) {
		/* SĂʰ޳PʕS҂ */
	}

	/* ĳPʕؾ */
#if EXTINT_CALLBACK_MODE == true
	/* Ăі߂o^\ */
	for (uint8_t j = 0; j < EIC_NUMBER_OF_INTERRUPTS; j++) {
		_extint_dev.callbacks[j] = NULL;
	}
	system_interrupt_enable(SYSTEM_INTERRUPT_MODULE_EIC);
#endif

	/* XȂgp̂߂ײނ */
	_extint_enable();
}

/**
 * \internal
 * \brief O荞ײދ
 *
 * EICPʕ
 * Ăі߂삪gpꍇɓo^ꂽĂі߂ꗗ͉eyڂ܂B
 */
void _extint_enable(void)
{
	Eic *const eics[EIC_INST_NUM] = EIC_INSTS;

	/* SĂEICʰ޳Pʕ */
	for (uint32_t i = 0; i < EIC_INST_NUM; i++) {
		eics[i]->CTRL.reg |= EIC_CTRL_ENABLE;
	}

	while (extint_is_syncing()) {
		/* SĂʰ޳PʕS҂ */
	}
}

/**
 * \internal
 * \brief O荞ײދ֎~
 *
 * \ref _extint_enable()ĂяooRňȑOɊJnꂽEICPʕ֎~
 * Ăі߂삪gpꍇɓo^ꂽĂі߂ꗗ͉eyڂ܂B
 */
void _extint_disable(void)
{
	Eic *const eics[EIC_INST_NUM] = EIC_INSTS;

	/* SĂEICʰ޳Pʕ֎~ */
	for (uint32_t i = 0; i < EIC_INST_NUM; i++) {
		eics[i]->CTRL.reg &= ~EIC_CTRL_ENABLE;
	}

	while (extint_is_syncing()) {
		/* SĂʰ޳PʕS҂ */
	}
}

/**
 * \brief O荞ٌ`Ԑݒʰ޳Pʕɏ
 *
 * ^ꂽO荞ٌ`Ԑݒ̌`Ԑݒʰ޳Pʕɏ܂B
 * Ɍ`Ԑݒ肳ĂꍇAV`ԐݒŊ̂̂u܂B
 *
 * \param[in]  channel `Ԑݒ肷O荞
 * \param[in]  config  قɑ΂`Ԑݒ̐ݒ

 */
void extint_chan_set_config(
		const uint8_t channel,
		const struct extint_chan_conf *const config)
{
	/*  */
	Assert(config);
	/* ۯKv */
	Assert(!(!system_gclk_gen_is_enabled(EXTINT_CLOCK_SOURCE) &&
		_extint_is_gclk_required(config->filter_input_signal,
			config->detection_criteria)));

	struct system_pinmux_config pinmux_config;
	system_pinmux_get_config_defaults(&pinmux_config);

	pinmux_config.mux_position = config->gpio_pin_mux;
	pinmux_config.direction    = SYSTEM_PINMUX_PIN_DIR_INPUT;
	pinmux_config.input_pull   = (enum system_pinmux_pin_pull)config->gpio_pin_pull;
	system_pinmux_pin_set_config(config->gpio_pin, &pinmux_config);

	/* Pʕʰ޳̂ւ̈ʒuwq擾 */
	Eic *const EIC_module = _extint_get_eic_from_channel(channel);

	uint32_t config_pos = (4 * (channel % 8));
	uint32_t new_config;

	/* ق̐V[o`Ԑݒ */
	new_config = (config->detection_criteria << EIC_CONFIG_SENSE0_Pos);

	/* `ԐݒŗvꂽȂAʰ޳Mhg틖 */
	if (config->filter_input_signal) {
		new_config |= EIC_CONFIG_FILTEN0;
	}

	/* AVٌ`Ԑݒݒ */
	EIC_module->CONFIG[channel / 8].reg
		= (EIC_module->CONFIG[channel / 8].reg &
			~((EIC_CONFIG_SENSE0_Msk | EIC_CONFIG_FILTEN0) << config_pos)) |
			(new_config << config_pos);

	/* ق̐VNオݒݒ */
	if (config->wake_if_sleeping) {
		EIC_module->WAKEUP.reg |=  (1UL << channel);
	} else {
		EIC_module->WAKEUP.reg &= ~(1UL << channel);
	}
}

/**
 * \brief O荞NMIٌ`Ԑݒʰ޳Pʕɏ
 *
 *  ^ꂽO荞NMIٌ`Ԑݒ̌`Ԑݒʰ޳Pʕɏ܂B
 *  قɌ`Ԑݒ肳ĂꍇAV`ԐݒŊ̂̂u
 *  B
 *
 *  \param[in]  nmi_channel `Ԑݒ肷O荞NMI
 *  \param[in]  config      قɑ΂`Ԑݒ̐ݒ
 *
 * \returns v̐܂͎sԕ
 * \retval  STATUS_OK                  `Ԑݒ萬
 * \retval  STATUS_ERR_PIN_MUX_INVALID MUXl܂B
 * \retval  STATUS_ERR_BAD_FORMAT      Ȍo삪v܂B
 */
enum status_code extint_nmi_set_config(
		const uint8_t nmi_channel,
		const struct extint_nmi_conf *const config)
{
	/*  */
	Assert(config);
	/* ۯKv */
	Assert(!(!system_gclk_gen_is_enabled(EXTINT_CLOCK_SOURCE) &&
		_extint_is_gclk_required(config->filter_input_signal,
			config->detection_criteria)));

	struct system_pinmux_config pinmux_config;
	system_pinmux_get_config_defaults(&pinmux_config);

	pinmux_config.mux_position = config->gpio_pin_mux;
	pinmux_config.direction    = SYSTEM_PINMUX_PIN_DIR_INPUT;
	pinmux_config.input_pull   = SYSTEM_PINMUX_PIN_PULL_UP;
	pinmux_config.input_pull   = (enum system_pinmux_pin_pull)config->gpio_pin_pull;
	system_pinmux_pin_set_config(config->gpio_pin, &pinmux_config);

	/* Pʕʰ޳̂ւ̈ʒuwq擾 */
	Eic *const EIC_module = _extint_get_eic_from_channel(nmi_channel);

	uint32_t new_config;

	/* NMI̐V[o`Ԑݒ */
	new_config = (config->detection_criteria << EIC_NMICTRL_NMISENSE_Pos);

	/* `ԐݒŗvꂽȂAʰ޳Mhg틖 */
	if (config->filter_input_signal) {
		new_config |= EIC_NMICTRL_NMIFILTEN;
	}

	/* EICNMI`Ԑݒ肷邽߂̕Wۯ֎~ */
	_extint_disable();
	system_gclk_chan_disable(EIC_GCLK_ID);

	EIC_module->NMICTRL.reg = new_config;

	/* NMI`ԐݒɕWۯEIC */
	system_gclk_chan_enable(EIC_GCLK_ID);
	_extint_enable();

	return STATUS_OK;
}

/**
 * \brief O荞ݎۏo͋
 *
 *  O荞ݒPʕ1ȏ̏o͎ۂB̒Pʕx鎖ۂ
 *  ꗗɂĂ\ref extint_events ""B
 *
 *  \note ۂ͒PʕĂԂɕς邱Ƃ͂ł܂B
 *
 *  \param[in]  events 鎖ۂ׸ނ܂ލ\
 */
void extint_enable_events(
		struct extint_events *const events)
{
	/*  */
	Assert(events);

	/* p\EIC̔z */
	Eic *const eics[EIC_INST_NUM] = EIC_INSTS;

	/* eIEIĈɑ΂鎖ېڼ޽XV */
	for (uint32_t i = 0; i < EIC_INST_NUM; i++) {
		uint32_t event_mask = 0;

		/* ݂EICPʕɑ΂鋖Օ쐬 */
		for (uint32_t j = 0; j < 32; j++) {
			if (events->generate_event_on_detect[(32 * i) + j]) {
				event_mask |= (1UL << j);
			}
		}

		/* Օꂽۂ */
		eics[i]->EVCTRL.reg |= event_mask;
	}
}

/**
 * \brief O荞ݎۏo͋֎~
 *
 *  O荞ݒPʕ1ȏ̏o͎ۂ֎~B̒Pʕx鎖ۂ
 *  ꗗɂĂ\ref extint_events ""B
 *
 *  \note ۂ͒PʕĂԂɕς邱Ƃ͂ł܂B
 *
 *  \param[in]  events ֎~鎖ۂ׸ނ܂ލ\
 */
void extint_disable_events(
		struct extint_events *const events)
{
	/*  */
	Assert(events);

	/* p\EIC̔z. */
	Eic *const eics[EIC_INST_NUM] = EIC_INSTS;

	/* eIEIĈɑ΂鎖ېڼ޽XV */
	for (uint32_t i = 0; i < EIC_INST_NUM; i++) {
		uint32_t event_mask = 0;

		/* ݂EICPʕɑ΂֎~Օ쐬 */
		for (uint32_t j = 0; j < 32; j++) {
			if (events->generate_event_on_detect[(32 * i) + j]) {
				event_mask |= (1UL << j);
			}
		}

		/* Օꂽۂ֎~ */
		eics[i]->EVCTRL.reg &= ~event_mask;
	}
}
