/**
 * \file
 *
 * \brief SAM D21/R21 TCC - 䉞ppv/vײ
 *
 * 쌠 (c) 2013 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#include "tcc_callback.h"

void *_tcc_instances[TCC_INST_NUM];

void _tcc_interrupt_handler(uint8_t module_index);

const uint32_t _tcc_intflag[TCC_CALLBACK_N] = {
	TCC_INTFLAG_OVF,
	TCC_INTFLAG_TRG,
	TCC_INTFLAG_CNT,
	TCC_INTFLAG_ERR,
	TCC_INTFLAG_FAULTA,
	TCC_INTFLAG_FAULTB,
	TCC_INTFLAG_FAULT0,
	TCC_INTFLAG_FAULT1,
#define _TCC_INTFLAG_MC(n,dummy) TCC_INTFLAG_MC##n,
	/* TCC_INTFLAG_MC0 ~ ... */
	MREPEAT(TCC_NUM_CHANNELS, _TCC_INTFLAG_MC, 0)
#undef _TCC_INTFLAG_MC
};

#  define _TCC_INTERRUPT_VECT_NUM(n, unused) \
		  SYSTEM_INTERRUPT_MODULE_TCC##n,
/**
 * \internal ^ꂽ޲̂ɑ΂銄荞޸擾
 *
 * \param[in]  inst_num TCCPʕ̔ԍ
 *
 * \return ^炦ꂽTCCPʕ̂ɑ΂銄荞޸
 */
static enum system_interrupt_vector _tcc_interrupt_get_interrupt_vector(
		uint32_t inst_num)
{
	static uint8_t tcc_interrupt_vectors[TCC_INST_NUM] = {
		MREPEAT(TCC_INST_NUM, _TCC_INTERRUPT_VECT_NUM, 0)
	};

	return (enum system_interrupt_vector)tcc_interrupt_vectors[inst_num];
}

/**
 * \brief Ăі߂o^
 *
 * gp҂ɂĎĂі߂֐o^܂B
 *
 * \note Ăі߂͌Ăі߂^ɑ΂Ɋ荞ݏɑ΂Ă
 *       ĂԂ悤ɂ邽߁A\ref tcc_enable_callbackɂċȂ
 *       Ȃ܂B
 *
 * \param[in]  module        TCCĳ̍\̂ւ̈ʒuwq
 * \param[in]  callback_func Ăі߂֐ւ̈ʒuwq
 * \param[in]  callback_type 񋓂ɂė^ꂽĂі߂^
 */
enum status_code tcc_register_callback(
		struct tcc_module *const module,
		tcc_callback_t callback_func,
		const enum tcc_callback callback_type)
{
	/*  */
	Assert(module);
	Assert(callback_func);

	/* Ăі߂֐o^ */
	module->callback[callback_type] = callback_func;

	/* ΉޯĂcallback_typeɐݒ */
	module->register_callback_mask |= _tcc_intflag[callback_type];

	return STATUS_OK;
}

/**
 * \brief Ăі߂̓o^
 *
 * gp҂ɂĎꂽĂі߂֐̓o^܂Bꂪo^
 * OɌĂі߂֎~ׂłB
 *
 * \param[in]  module        TCCĳ̍\̂ւ̈ʒuwq
 * \param[in]  callback_type 񋓂ɂė^ꂽĂі߂^
 */
enum status_code tcc_unregister_callback(
		struct tcc_module *const module,
		const enum tcc_callback callback_type)
{
	/*  */
	Assert(module);

	/* Ăі߂֐̓o^ */
	module->callback[callback_type] = NULL;

	/* callback_typeɑΉޯĂ */
	module->register_callback_mask &= ~_tcc_intflag[callback_type];

	return STATUS_OK;
}

/**
 * \brief Ăі߂
 *
 * \ref tcc_register_callbackɂēo^ꂽĂі߂֐܂BĂі
 * ֐͌Ăі߂^ɑ΂Ɋ荞ݏĂ΂܂B
 * ֐͓K؂Ȋ荞݂܂B
 *
 * \param[in]  module        TCCĳ̍\̂ւ̈ʒuwq
 * \param[in]  callback_type 񋓂ɂė^ꂽĂі߂^
 */
void tcc_enable_callback(
		struct tcc_module *const module,
		const enum tcc_callback callback_type)
{
	/*  */
	Assert(module);
	Assert(module->hw);

	/* TCCPʕp荞݂ */
	system_interrupt_enable(_tcc_interrupt_get_interrupt_vector(
			_tcc_get_inst_index(module->hw)));

	/* ق܂͑̌Ăі߂ */
	module->enable_callback_mask |= _tcc_intflag[callback_type];
	module->hw->INTENSET.reg = _tcc_intflag[callback_type];
}

/**
 * \brief Ăі߂֎~
 *
 * \ref tcc_register_callbackɂēo^ꂽĂі߂֐֎~AĂі߂
 * ͊荞ٰ݂Ă΂܂B̊֐͓K؂Ȋ荞݂֎~܂B
 *
 * \param[in]  module        TCCĳ̍\̂ւ̈ʒuwq
 * \param[in]  callback_type 񋓂ɂė^ꂽĂі߂^
 */
void tcc_disable_callback(
		struct tcc_module *const module,
		const enum tcc_callback callback_type)
{
	/*  */
	Assert(module);
	Assert(module->hw);

	/* ̒Pʕp荞݂֎~ */
	system_interrupt_enable(_tcc_interrupt_get_interrupt_vector(
			_tcc_get_inst_index(module->hw)));

	/* ق܂͑̌Ăі߂֎~ */
	module->enable_callback_mask &= ~_tcc_intflag[callback_type];
	module->hw->INTENCLR.reg = _tcc_intflag[callback_type];
}


/**
 * \internal TCCpISR
 *
 * ޲̊eTCCp̊荞ݏ̑g܂B
 */
#define _TCC_INTERRUPT_HANDLER(n, m) \
		void TCC##n##_Handler(void) \
		{ \
			_tcc_interrupt_handler(n); \
		}

MREPEAT(TCC_INST_NUM, _TCC_INTERRUPT_HANDLER, 0)

/**
 * \internal TCCPʕp荞ݏ
 *
 * 炪鎞Ɋ荞݂A͓o^ċꂽĂі߂֐
 * 点܂B
 *
 * \param[in]  module_index 荞ݏĂTCĈID
 */
void _tcc_interrupt_handler(
		uint8_t module_index)
{
	int i;

	uint32_t interrupt_and_callback_status_mask;

	struct tcc_module *module =
			(struct tcc_module *)_tcc_instances[module_index];

	interrupt_and_callback_status_mask = (module->hw->INTFLAG.reg &
			module->register_callback_mask &
			module->enable_callback_mask);

	/* Ăі߂荞݂N */
	for (i = 0; i < TCC_CALLBACK_N; i ++) {
		if (interrupt_and_callback_status_mask & _tcc_intflag[i]) {
			/* o^ꂽꂽĂі߂֐Ăяo */
			(module->callback[i])(module);
			/* 荞׸މ */
			module->hw->INTFLAG.reg = _tcc_intflag[i];
		}
	}
}
