/**
 * \file
 *
 * \brief DSUp\iLq
 *
 * 쌠 (c) 2013 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAMD21_DSU_COMPONENT_
#define _SAMD21_DSU_COMPONENT_

/* ========================================================================== */
/** DSUpĳAPI` */
/* ========================================================================== */
/** \addtogroup SAMD21_DSU ޲ ޽ */
/*@{*/

#define DSU_U2209
#define REV_DSU						0x200

/* -------- DSU_CTRL : (DSUψ:0x0000) ( /W  8) -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  SWRST:1;			/*!< ޯ   0: ĳ ؾ */
    uint8_t  :1;				/*!< ޯ   1: \ */
    uint8_t  CRC:1;				/*!< ޯ   2: 32ޯď璷 */
    uint8_t  MBIST:1;			/*!< ޯ   3: ؑgݍݎȌ */
    uint8_t  CE:1;				/*!< ޯ   4: ߏ */
    uint8_t  :3;				/*!< ޯ5`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} DSU_CTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DSU_CTRL_OFFSET				0x0000			/**< \brief (DSU_CTRL offset) */
#define DSU_CTRL_RESETVALUE			0x00			/**< \brief (DSU_CTRL reset_value) */

#define DSU_CTRL_SWRST_Pos			0				/**< \brief (DSU_CTRL)ĳ ؾ */
#define DSU_CTRL_SWRST				(0x1u << DSU_CTRL_SWRST_Pos)
#define DSU_CTRL_CRC_Pos			2				/**< \brief (DSU_CTRL)32ޯď璷 */
#define DSU_CTRL_CRC				(0x1u << DSU_CTRL_CRC_Pos)
#define DSU_CTRL_MBIST_Pos			3				/**< \brief (DSU_CTRL)ؑgݍݎȌ */
#define DSU_CTRL_MBIST				(0x1u << DSU_CTRL_MBIST_Pos)
#define DSU_CTRL_CE_Pos				4				/**< \brief (DSU_CTRL)ߏ */
#define DSU_CTRL_CE					(0x1u << DSU_CTRL_CE_Pos)
#define DSU_CTRL_MASK				0x1Du 			/**< \brief (DSU_CTRL)Օڼ޽ */

/* -------- DSU_STATUSA : (DSUψ:0x0001) (R/W  8)A -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  DONE:1;			/*!< ޯ   0: I */
    uint8_t  CRSTEXT:1;			/*!< ޯ   1: CPUؾĒiKg */
    uint8_t  BERR:1;			/*!< ޯ   2: ޽ُ */
    uint8_t  FAIL:1;			/*!< ޯ   3: Q */
    uint8_t  PERR:1;			/*!< ޯ   4: یُ */
    uint8_t  :3;				/*!< ޯ5`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} DSU_STATUSA_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DSU_STATUSA_OFFSET			0x0001			/**< \brief (DSU_STATUSA offset)A */
#define DSU_STATUSA_RESETVALUE		0x00				/**< \brief (DSU_STATUSA reset_value)A */

#define DSU_STATUSA_DONE_Pos		0				/**< \brief (DSU_STATUSA)I */
#define DSU_STATUSA_DONE			(0x1u << DSU_STATUSA_DONE_Pos)
#define DSU_STATUSA_CRSTEXT_Pos		1				/**< \brief (DSU_STATUSA)CPUؾĒiKg */
#define DSU_STATUSA_CRSTEXT			(0x1u << DSU_STATUSA_CRSTEXT_Pos)
#define DSU_STATUSA_BERR_Pos		2				/**< \brief (DSU_STATUSA)޽ُ */
#define DSU_STATUSA_BERR			(0x1u << DSU_STATUSA_BERR_Pos)
#define DSU_STATUSA_FAIL_Pos		3				/**< \brief (DSU_STATUSA)Q */
#define DSU_STATUSA_FAIL			(0x1u << DSU_STATUSA_FAIL_Pos)
#define DSU_STATUSA_PERR_Pos		4				/**< \brief (DSU_STATUSA)یُ */
#define DSU_STATUSA_PERR			(0x1u << DSU_STATUSA_PERR_Pos)
#define DSU_STATUSA_MASK			0x1Fu 			/**< \brief (DSU_STATUSA)Օڼ޽ */

/* -------- DSU_STATUSB : (DSUψ:0x0002) (R/   8)B -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  PROT:1;			/*!< ޯ   0: ی */
    uint8_t  DBGPRES:1;			/*!< ޯ   1: ޯޑ */
    uint8_t  DCCD0:1;			/*!< ޯ   2: ޯޒʐM0L */
    uint8_t  DCCD1:1;			/*!< ޯ   3: ޯޒʐM1L */
    uint8_t  HPE:1;				/*!< ޯ   4: ί ׸ދ */
    uint8_t  :3;				/*!< ޯ5`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  struct {
    uint8_t  :2;				/*!< ޯ 0,1: \ */
    uint8_t  DCCD:2;			/*!< ޯ 2,3: ޯޒʐMxL */
    uint8_t  :4;				/*!< ޯ4`7: \ */
  } vec;						/*!< ޸ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} DSU_STATUSB_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DSU_STATUSB_OFFSET			0x0002			/**< \brief (DSU_STATUSB offset)B */
#define DSU_STATUSB_RESETVALUE		0x10			/**< \brief (DSU_STATUSB reset_value)B */

#define DSU_STATUSB_PROT_Pos		0				/**< \brief (DSU_STATUSB)ی */
#define DSU_STATUSB_PROT			(0x1u << DSU_STATUSB_PROT_Pos)
#define DSU_STATUSB_DBGPRES_Pos		1				/**< \brief (DSU_STATUSB)ޯޑ */
#define DSU_STATUSB_DBGPRES			(0x1u << DSU_STATUSB_DBGPRES_Pos)
#define DSU_STATUSB_DCCD0_Pos		2				/**< \brief (DSU_STATUSB)ޯޒʐM0L */
#define DSU_STATUSB_DCCD0			(1 << DSU_STATUSB_DCCD0_Pos)
#define DSU_STATUSB_DCCD1_Pos		3				/**< \brief (DSU_STATUSB)ޯޒʐM1L */
#define DSU_STATUSB_DCCD1			(1 << DSU_STATUSB_DCCD1_Pos)
#define DSU_STATUSB_DCCD_Pos		2				/**< \brief (DSU_STATUSB)ޯޒʐMxL */
#define DSU_STATUSB_DCCD_Msk		(0x3u << DSU_STATUSB_DCCD_Pos)
#define DSU_STATUSB_DCCD(value)		((DSU_STATUSB_DCCD_Msk & ((value) << DSU_STATUSB_DCCD_Pos)))
#define DSU_STATUSB_HPE_Pos			4				/**< \brief (DSU_STATUSB)ί ׸ދ */
#define DSU_STATUSB_HPE				(0x1u << DSU_STATUSB_HPE_Pos)
#define DSU_STATUSB_MASK			0x1Fu 			/**< \brief (DSU_STATUSB)Օڼ޽ */

/* -------- DSU_ADDR : (DSUψ:0x0004) (R/W 32)ڽ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t :2;				/*!< ޯ  0,1: \ */
    uint32_t ADDR:30;			/*!< ޯ2`31: ڽ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} DSU_ADDR_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DSU_ADDR_OFFSET				0x0004			/**< \brief (DSU_ADDR offset)ڽ */
#define DSU_ADDR_RESETVALUE			0x00000000		/**< \brief (DSU_ADDR reset_value)ڽ */

#define DSU_ADDR_ADDR_Pos			2				/**< \brief (DSU_ADDR)ڽ */
#define DSU_ADDR_ADDR_Msk			(0x3FFFFFFFu << DSU_ADDR_ADDR_Pos)
#define DSU_ADDR_ADDR(value)		((DSU_ADDR_ADDR_Msk & ((value) << DSU_ADDR_ADDR_Pos)))
#define DSU_ADDR_MASK				0xFFFFFFFCu		/**< \brief (DSU_ADDR)Օڼ޽ */

/* -------- DSU_LENGTH : (DSUψ:0x0008) (R/W 32) -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t :2;				/*!< ޯ  0,1: \ */
    uint32_t LENGTH:30;			/*!< ޯ2`31:  */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} DSU_LENGTH_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DSU_LENGTH_OFFSET			0x0008			/**< \brief (DSU_LENGTH offset) */
#define DSU_LENGTH_RESETVALUE		0x00000000		/**< \brief (DSU_LENGTH reset_value) */

#define DSU_LENGTH_LENGTH_Pos		2				/**< \brief (DSU_LENGTH) */
#define DSU_LENGTH_LENGTH_Msk		(0x3FFFFFFFu << DSU_LENGTH_LENGTH_Pos)
#define DSU_LENGTH_LENGTH(value)	((DSU_LENGTH_LENGTH_Msk & ((value) << DSU_LENGTH_LENGTH_Pos)))
#define DSU_LENGTH_MASK				0xFFFFFFFCu		/**< \brief (DSU_LENGTH)Օڼ޽ */

/* -------- DSU_DATA : (DSUψ:0x000C) (R/W 32)ް -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t DATA:32;			/*!< ޯ0`31: ް */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} DSU_DATA_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DSU_DATA_OFFSET				0x000C			/**< \brief (DSU_DATA offset)ް */
#define DSU_DATA_RESETVALUE			0x00000000		/**< \brief (DSU_DATA reset_value)ް */

#define DSU_DATA_DATA_Pos			0				/**< \brief (DSU_DATA)ް */
#define DSU_DATA_DATA_Msk			(0xFFFFFFFFu << DSU_DATA_DATA_Pos)
#define DSU_DATA_DATA(value)		((DSU_DATA_DATA_Msk & ((value) << DSU_DATA_DATA_Pos)))
#define DSU_DATA_MASK				0xFFFFFFFFu		/**< \brief (DSU_DATA)Օڼ޽ */

/* -------- DSU_DCC : (DSUψ:0x0010) (R/W 32)ޯޒʐMn -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t DATA:32;			/*!< ޯ0`31: ް */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} DSU_DCC_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DSU_DCC_OFFSET				0x0010			/**< \brief (DSU_DCC offset)ޯޒʐMn */
#define DSU_DCC_RESETVALUE			0x00000000		/**< \brief (DSU_DCC reset_value)ޯޒʐMn */

#define DSU_DCC_DATA_Pos			0				/**< \brief (DSU_DCC)ް */
#define DSU_DCC_DATA_Msk			(0xFFFFFFFFu << DSU_DCC_DATA_Pos)
#define DSU_DCC_DATA(value)			((DSU_DCC_DATA_Msk & ((value) << DSU_DCC_DATA_Pos)))
#define DSU_DCC_MASK				0xFFFFFFFFu		/**< \brief (DSU_DCC)Օڼ޽ */

/* -------- DSU_DID : (DSUψ:0x0018) (R/  32)޲ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t DEVSEL:8;			/*!< ޯ 0` 7: ޲I */
    uint32_t REVISION:4;		/*!< ޯ 8`11: ԍ */
    uint32_t DIE:4;				/*!< ޯ12`15: ޲ */
    uint32_t SERIES:6;			/*!< ޯ16`21: in */
    uint32_t :1;				/*!< ޯ    22: \ */
    uint32_t FAMILY:5;			/*!< ޯ23`27: in */
    uint32_t PROCESSOR:4;		/*!< ޯ28`31: ۾ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} DSU_DID_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DSU_DID_OFFSET				0x0018			/**< \brief (DSU_DID offset)޲ */

#define DSU_DID_DEVSEL_Pos			0				/**< \brief (DSU_DID)޲I */
#define DSU_DID_DEVSEL_Msk			(0xFFu << DSU_DID_DEVSEL_Pos)
#define DSU_DID_DEVSEL(value)		((DSU_DID_DEVSEL_Msk & ((value) << DSU_DID_DEVSEL_Pos)))
#define DSU_DID_REVISION_Pos		8				/**< \brief (DSU_DID)ԍ */
#define DSU_DID_REVISION_Msk		(0xFu << DSU_DID_REVISION_Pos)
#define DSU_DID_REVISION(value)		((DSU_DID_REVISION_Msk & ((value) << DSU_DID_REVISION_Pos)))
#define DSU_DID_DIE_Pos				12				/**< \brief (DSU_DID)޲ */
#define DSU_DID_DIE_Msk				(0xFu << DSU_DID_DIE_Pos)
#define DSU_DID_DIE(value)			((DSU_DID_DIE_Msk & ((value) << DSU_DID_DIE_Pos)))
#define DSU_DID_SERIES_Pos			16				/**< \brief (DSU_DID)in */
#define DSU_DID_SERIES_Msk			(0x3Fu << DSU_DID_SERIES_Pos)
#define DSU_DID_SERIES(value)		((DSU_DID_SERIES_Msk & ((value) << DSU_DID_SERIES_Pos)))
#define DSU_DID_FAMILY_Pos			23				/**< \brief (DSU_DID)in */
#define DSU_DID_FAMILY_Msk			(0x1Fu << DSU_DID_FAMILY_Pos)
#define DSU_DID_FAMILY(value)		((DSU_DID_FAMILY_Msk & ((value) << DSU_DID_FAMILY_Pos)))
#define DSU_DID_PROCESSOR_Pos		28				/**< \brief (DSU_DID)۾ */
#define DSU_DID_PROCESSOR_Msk		(0xFu << DSU_DID_PROCESSOR_Pos)
#define DSU_DID_PROCESSOR(value)	((DSU_DID_PROCESSOR_Msk & ((value) << DSU_DID_PROCESSOR_Pos)))
#define DSU_DID_MASK				0xFFBFFFFFu		/**< \brief (DSU_DID)Օڼ޽ */

/* -------- DSU_ENTRY : (DSUψ:0x1000) (R/  32)Coresight ROM\o^n -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t EPRES:1;			/*!< ޯ     0: o^ */
    uint32_t FMT:1;				/*!< ޯ     1: ̫ϯ */
    uint32_t :10;				/*!< ޯ 2`11: \ */
    uint32_t ADDOFF:20;			/*!< ޯ12`31: ڽψ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} DSU_ENTRY_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DSU_ENTRY_OFFSET			0x1000			/**< \brief (DSU_ENTRY offset)Coresight ROM\o^n */
#define DSU_ENTRY_RESETVALUE		0x00000002		/**< \brief (DSU_ENTRY reset_value)Coresight ROM\o^n */

#define DSU_ENTRY_EPRES_Pos			0				/**< \brief (DSU_ENTRY)o^ */
#define DSU_ENTRY_EPRES				(0x1u << DSU_ENTRY_EPRES_Pos)
#define DSU_ENTRY_FMT_Pos			1				/**< \brief (DSU_ENTRY)̫ϯ */
#define DSU_ENTRY_FMT				(0x1u << DSU_ENTRY_FMT_Pos)
#define DSU_ENTRY_ADDOFF_Pos		12				/**< \brief (DSU_ENTRY)ڽψ */
#define DSU_ENTRY_ADDOFF_Msk		(0xFFFFFu << DSU_ENTRY_ADDOFF_Pos)
#define DSU_ENTRY_ADDOFF(value)		((DSU_ENTRY_ADDOFF_Msk & ((value) << DSU_ENTRY_ADDOFF_Pos)))
#define DSU_ENTRY_MASK				0xFFFFF003u		/**< \brief (DSU_ENTRY)Օڼ޽ */

/* -------- DSU_END : (DSUψ:0x1008) (R/  32)Coresight ROM\I -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t END:32;			/*!< ޯ0`31: I */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} DSU_END_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DSU_END_OFFSET				0x1008			/**< \brief (DSU_END offset)Coresight ROM\I */
#define DSU_END_RESETVALUE			0x00000000		/**< \brief (DSU_END reset_value)Coresight ROM\I */

#define DSU_END_END_Pos				0				/**< \brief (DSU_END)I */
#define DSU_END_END_Msk				(0xFFFFFFFFu << DSU_END_END_Pos)
#define DSU_END_END(value)			((DSU_END_END_Msk & ((value) << DSU_END_END_Pos)))
#define DSU_END_MASK				0xFFFFFFFFu		/**< \brief (DSU_END)Օڼ޽ */

/* -------- DSU_MEMTYPE : (DSUψ:0x1FCC) (R/  32)Coresight ROM\،^ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t SMEMP:1;			/*!< ޯ    0:  ؑ */
    uint32_t :31;				/*!< ޯ1`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} DSU_MEMTYPE_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DSU_MEMTYPE_OFFSET			0x1FCC			/**< \brief (DSU_MEMTYPE offset)Coresight ROM\،^ */
#define DSU_MEMTYPE_RESETVALUE		0x00000000		/**< \brief (DSU_MEMTYPE reset_value)Coresight ROM\،^ */

#define DSU_MEMTYPE_SMEMP_Pos		0				/**< \brief (DSU_MEMTYPE) ؑ */
#define DSU_MEMTYPE_SMEMP			(0x1u << DSU_MEMTYPE_SMEMP_Pos)
#define DSU_MEMTYPE_MASK			0x00000001u		/**< \brief (DSU_MEMTYPE)Օڼ޽ */

/* -------- DSU_PID4 : (DSUψ:0x1FD0) (R/  32)Ӌ@\4 -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t JEPCC:4;			/*!< ޯ0` 3: JEP-106p */
    uint32_t FKBC:4;			/*!< ޯ4` 7: 4K޲đ */
    uint32_t :24;				/*!< ޯ8`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} DSU_PID4_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DSU_PID4_OFFSET				0x1FD0			/**< \brief (DSU_PID4 offset)Ӌ@\4 */
#define DSU_PID4_RESETVALUE			0x00000000		/**< \brief (DSU_PID4 reset_value)Ӌ@\4 */

#define DSU_PID4_JEPCC_Pos			0				/**< \brief (DSU_PID4)JEP-106p */
#define DSU_PID4_JEPCC_Msk			(0xFu << DSU_PID4_JEPCC_Pos)
#define DSU_PID4_JEPCC(value)		((DSU_PID4_JEPCC_Msk & ((value) << DSU_PID4_JEPCC_Pos)))
#define DSU_PID4_FKBC_Pos			4				/**< \brief (DSU_PID4)4K޲đ */
#define DSU_PID4_FKBC_Msk			(0xFu << DSU_PID4_FKBC_Pos)
#define DSU_PID4_FKBC(value)		((DSU_PID4_FKBC_Msk & ((value) << DSU_PID4_FKBC_Pos)))
#define DSU_PID4_MASK				0x000000FFu		/**< \brief (DSU_PID4)Օڼ޽ */

/* -------- DSU_PID0 : (DSUψ:0x1FE0) (R/  32)Ӌ@\0 -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t PARTNBL:8;			/*!< ޯ0` 7: ޲ԍ */
    uint32_t :24;				/*!< ޯ8`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} DSU_PID0_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DSU_PID0_OFFSET				0x1FE0			/**< \brief (DSU_PID0 offset)Ӌ@\0 */
#define DSU_PID0_RESETVALUE			0x000000D0		/**< \brief (DSU_PID0 reset_value)Ӌ@\0 */

#define DSU_PID0_PARTNBL_Pos		0				/**< \brief (DSU_PID0)޲ԍ */
#define DSU_PID0_PARTNBL_Msk		(0xFFu << DSU_PID0_PARTNBL_Pos)
#define DSU_PID0_PARTNBL(value)		((DSU_PID0_PARTNBL_Msk & ((value) << DSU_PID0_PARTNBL_Pos)))
#define DSU_PID0_MASK				0x000000FFu		/**< \brief (DSU_PID0)Օڼ޽ */

/* -------- DSU_PID1 : (DSUψ:0x1FE4) (R/  32)Ӌ@\1 -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t PARTNBH:4;			/*!< ޯ0` 3: ޲ԍ */
    uint32_t JEPIDCL:4;			/*!< ޯ4` 7: JEP-106ʕ̉ʕ */
    uint32_t :24;				/*!< ޯ8`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} DSU_PID1_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DSU_PID1_OFFSET				0x1FE4			/**< \brief (DSU_PID1 offset)Ӌ@\1 */
#define DSU_PID1_RESETVALUE			0x000000FC		/**< \brief (DSU_PID1 reset_value)Ӌ@\1 */

#define DSU_PID1_PARTNBH_Pos		0				/**< \brief (DSU_PID1)޲ԍ */
#define DSU_PID1_PARTNBH_Msk		(0xFu << DSU_PID1_PARTNBH_Pos)
#define DSU_PID1_PARTNBH(value)		((DSU_PID1_PARTNBH_Msk & ((value) << DSU_PID1_PARTNBH_Pos)))
#define DSU_PID1_JEPIDCL_Pos		4				/**< \brief (DSU_PID1)JEP-106ʕ̉ʕ */
#define DSU_PID1_JEPIDCL_Msk		(0xFu << DSU_PID1_JEPIDCL_Pos)
#define DSU_PID1_JEPIDCL(value)		((DSU_PID1_JEPIDCL_Msk & ((value) << DSU_PID1_JEPIDCL_Pos)))
#define DSU_PID1_MASK				0x000000FFu		/**< \brief (DSU_PID1)Օڼ޽ */

/* -------- DSU_PID2 : (DSUψ:0x1FE8) (R/  32)Ӌ@\2 -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t JEPIDCH:3;			/*!< ޯ0` 2: JEP-106ʕ */
    uint32_t JEPU:1;			/*!< ޯ    3: JEP-106ʕgp */
    uint32_t REVISION:4;		/*!< ޯ4` 7: ԍ */
    uint32_t :24;				/*!< ޯ8`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} DSU_PID2_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DSU_PID2_OFFSET				0x1FE8			/**< \brief (DSU_PID2 offset)Ӌ@\2 */
#define DSU_PID2_RESETVALUE			0x00000009		/**< \brief (DSU_PID2 reset_value)Ӌ@\2 */

#define DSU_PID2_JEPIDCH_Pos		0				/**< \brief (DSU_PID2)JEP-106ʕ */
#define DSU_PID2_JEPIDCH_Msk		(0x7u << DSU_PID2_JEPIDCH_Pos)
#define DSU_PID2_JEPIDCH(value)		((DSU_PID2_JEPIDCH_Msk & ((value) << DSU_PID2_JEPIDCH_Pos)))
#define DSU_PID2_JEPU_Pos			3				/**< \brief (DSU_PID2)JEP-106ʕgp */
#define DSU_PID2_JEPU				(0x1u << DSU_PID2_JEPU_Pos)
#define DSU_PID2_REVISION_Pos		4				/**< \brief (DSU_PID2)ԍ */
#define DSU_PID2_REVISION_Msk		(0xFu << DSU_PID2_REVISION_Pos)
#define DSU_PID2_REVISION(value)	((DSU_PID2_REVISION_Msk & ((value) << DSU_PID2_REVISION_Pos)))
#define DSU_PID2_MASK				0x000000FFu		/**< \brief (DSU_PID2)Օڼ޽ */

/* -------- DSU_PID3 : (DSUψ:0x1FEC) (R/  32)Ӌ@\3 -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t CUSMOD:4;			/*!< ޯ0` 3: ARMƎ */
    uint32_t REVAND:4;			/*!< ޯ4` 7: ԍ */
    uint32_t :24;				/*!< ޯ8`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} DSU_PID3_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DSU_PID3_OFFSET				0x1FEC			/**< \brief (DSU_PID3 offset)Ӌ@\3 */
#define DSU_PID3_RESETVALUE			0x00000000		/**< \brief (DSU_PID3 reset_value)Ӌ@\3 */

#define DSU_PID3_CUSMOD_Pos			0				/**< \brief (DSU_PID3)ARMƎ */
#define DSU_PID3_CUSMOD_Msk			(0xFu << DSU_PID3_CUSMOD_Pos)
#define DSU_PID3_CUSMOD(value)		((DSU_PID3_CUSMOD_Msk & ((value) << DSU_PID3_CUSMOD_Pos)))
#define DSU_PID3_REVAND_Pos			4				/**< \brief (DSU_PID3)ԍ */
#define DSU_PID3_REVAND_Msk			(0xFu << DSU_PID3_REVAND_Pos)
#define DSU_PID3_REVAND(value)		((DSU_PID3_REVAND_Msk & ((value) << DSU_PID3_REVAND_Pos)))
#define DSU_PID3_MASK				0x000000FFu		/**< \brief (DSU_PID3)Օڼ޽ */

/* -------- DSU_CID0 : (DSUψ:0x1FF0) (R/  32)\i0 -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t PREAMBLEB0:8;		/*!< ޯ0` 7: O޲0 */
    uint32_t :24;				/*!< ޯ8`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} DSU_CID0_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DSU_CID0_OFFSET				0x1FF0			/**< \brief (DSU_CID0 offset)\i0 */
#define DSU_CID0_RESETVALUE			0x0000000D		/**< \brief (DSU_CID0 reset_value)\i0 */

#define DSU_CID0_PREAMBLEB0_Pos		0				/**< \brief (DSU_CID0)O޲0 */
#define DSU_CID0_PREAMBLEB0_Msk		(0xFFu << DSU_CID0_PREAMBLEB0_Pos)
#define DSU_CID0_PREAMBLEB0(value)  ((DSU_CID0_PREAMBLEB0_Msk & ((value) << DSU_CID0_PREAMBLEB0_Pos)))
#define DSU_CID0_MASK				0x000000FFu		/**< \brief (DSU_CID0)Օڼ޽ */

/* -------- DSU_CID1 : (DSUψ:0x1FF4) (R/  32)\i1 -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t PREAMBLE:4;		/*!< ޯ0` 3: O */
    uint32_t CCLASS:4;			/*!< ޯ4` 7: \i */
    uint32_t :24;				/*!< ޯ8`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} DSU_CID1_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DSU_CID1_OFFSET				0x1FF4			/**< \brief (DSU_CID1 offset)\i1 */
#define DSU_CID1_RESETVALUE			0x00000010		/**< \brief (DSU_CID1 reset_value)\i1 */

#define DSU_CID1_PREAMBLE_Pos		0				/**< \brief (DSU_CID1)O */
#define DSU_CID1_PREAMBLE_Msk		(0xFu << DSU_CID1_PREAMBLE_Pos)
#define DSU_CID1_PREAMBLE(value)	((DSU_CID1_PREAMBLE_Msk & ((value) << DSU_CID1_PREAMBLE_Pos)))
#define DSU_CID1_CCLASS_Pos			4				/**< \brief (DSU_CID1)\i */
#define DSU_CID1_CCLASS_Msk			(0xFu << DSU_CID1_CCLASS_Pos)
#define DSU_CID1_CCLASS(value)		((DSU_CID1_CCLASS_Msk & ((value) << DSU_CID1_CCLASS_Pos)))
#define DSU_CID1_MASK				0x000000FFu		/**< \brief (DSU_CID1)Օڼ޽ */

/* -------- DSU_CID2 : (DSUψ:0x1FF8) (R/  32)\i2 -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t PREAMBLEB2:8;		/*!< ޯ0` 7: O޲2 */
    uint32_t :24;				/*!< ޯ8`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} DSU_CID2_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DSU_CID2_OFFSET				0x1FF8			/**< \brief (DSU_CID2 offset)\i2 */
#define DSU_CID2_RESETVALUE			0x00000005		/**< \brief (DSU_CID2 reset_value)\i2 */

#define DSU_CID2_PREAMBLEB2_Pos		0				/**< \brief (DSU_CID2)O޲2 */
#define DSU_CID2_PREAMBLEB2_Msk		(0xFFu << DSU_CID2_PREAMBLEB2_Pos)
#define DSU_CID2_PREAMBLEB2(value)	((DSU_CID2_PREAMBLEB2_Msk & ((value) << DSU_CID2_PREAMBLEB2_Pos)))
#define DSU_CID2_MASK				0x000000FFu		/**< \brief (DSU_CID2)Օڼ޽ */

/* -------- DSU_CID3 : (DSUψ:0x1FFC) (R/  32)\i3 -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t PREAMBLEB3:8;		/*!< ޯ0` 7: O޲3 */
    uint32_t :24;				/*!< ޯ8`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} DSU_CID3_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define DSU_CID3_OFFSET				0x1FFC			/**< \brief (DSU_CID3 offset)\i3 */
#define DSU_CID3_RESETVALUE			0x000000B1		/**< \brief (DSU_CID3 reset_value)\i3 */

#define DSU_CID3_PREAMBLEB3_Pos		0				/**< \brief (DSU_CID3)O޲3 */
#define DSU_CID3_PREAMBLEB3_Msk		(0xFFu << DSU_CID3_PREAMBLEB3_Pos)
#define DSU_CID3_PREAMBLEB3(value)	((DSU_CID3_PREAMBLEB3_Msk & ((value) << DSU_CID3_PREAMBLEB3_Pos)))
#define DSU_CID3_MASK				0x000000FFu		/**< \brief (DSU_CID3)Օڼ޽ */

/** \brief DSU hardware registers */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  __O  DSU_CTRL_Type		CTRL;			/**< \briefψ:0x0000 ( /W  8) */
  __IO DSU_STATUSA_Type		STATUSA;		/**< \briefψ:0x0001 (R/W  8)A */
  __I  DSU_STATUSB_Type		STATUSB;		/**< \briefψ:0x0002 (R/   8)B */
	   RoReg8				Reserved1[0x1];
  __IO DSU_ADDR_Type		ADDR;			/**< \briefψ:0x0004 (R/W 32)ڽ */
  __IO DSU_LENGTH_Type		LENGTH;			/**< \briefψ:0x0008 (R/W 32) */
  __IO DSU_DATA_Type		DATA;			/**< \briefψ:0x000C (R/W 32)ް */
  __IO DSU_DCC_Type			DCC[2];			/**< \briefψ:0x0010 (R/W 32)ޯޒʐMn */
  __I  DSU_DID_Type			DID;			/**< \briefψ:0x0018 (R/  32)޲ */
	   RoReg8				Reserved2[0xFE4];
  __I  DSU_ENTRY_Type		ENTRY[2];		/**< \briefψ:0x1000 (R/  32)Coresight ROM\o^n */
  __I  DSU_END_Type			END;			/**< \briefψ:0x1008 (R/  32)Coresight ROM\I */
	   RoReg8				Reserved3[0xFC0];
  __I  DSU_MEMTYPE_Type		MEMTYPE;		/**< \briefψ:0x1FCC (R/  32)Coresight ROM\،^ */
  __I  DSU_PID4_Type		PID4;			/**< \briefψ:0x1FD0 (R/  32)Ӌ@\4 */
	   RoReg8				Reserved4[0xC];
  __I  DSU_PID0_Type		PID0;			/**< \briefψ:0x1FE0 (R/  32)Ӌ@\0 */
  __I  DSU_PID1_Type		PID1;			/**< \briefψ:0x1FE4 (R/  32)Ӌ@\1 */
  __I  DSU_PID2_Type		PID2;			/**< \briefψ:0x1FE8 (R/  32)Ӌ@\2 */
  __I  DSU_PID3_Type		PID3;			/**< \briefψ:0x1FEC (R/  32)Ӌ@\3 */
  __I  DSU_CID0_Type		CID0;			/**< \briefψ:0x1FF0 (R/  32)\i0 */
  __I  DSU_CID1_Type		CID1;			/**< \briefψ:0x1FF4 (R/  32)\i1 */
  __I  DSU_CID2_Type		CID2;			/**< \briefψ:0x1FF8 (R/  32)\i2 */
  __I  DSU_CID3_Type		CID3;			/**< \briefψ:0x1FFC (R/  32)\i3 */
} Dsu;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

#endif /* _SAMD21_DSU_COMPONENT_ */
