/**
 * \file
 *
 * \brief GCLKp\iLq
 *
 * 쌠 (c) 2013 - 2014 Atmel Corporation. s
 *
 * \asf_license_start
 *
 * \page 
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. Atmel̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳAtmelϲ ۰אiƂ̊֌WłĕzĎgp邱Ƃ
 *	  ܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * AtmelɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂAtmel̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂAtmelɐӔC
 * Ȃł傤B
 *
 * \asf_license_stop
 *
 */

#ifndef _SAMD21_GCLK_COMPONENT_
#define _SAMD21_GCLK_COMPONENT_

/* ========================================================================== */
/** GCLKpĳAPI` */
/* ========================================================================== */
/** \addtogroup SAMD21_GCLK ʸۯ */
/*@{*/

#define GCLK_U2102
#define REV_GCLK						0x210

/* -------- GCLK_CTRL : (GCLKψ:0x0) (R/W  8) -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  SWRST:1;			/*!< ޯ   0: ĳ ؾ */
    uint8_t  :7;				/*!< ޯ1`7: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} GCLK_CTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define GCLK_CTRL_OFFSET				0x0				/**< \brief (GCLK_CTRL offset) */
#define GCLK_CTRL_RESETVALUE			0x00			/**< \brief (GCLK_CTRL reset_value) */

#define GCLK_CTRL_SWRST_Pos				0				/**< \brief (GCLK_CTRL)ĳ ؾ */
#define GCLK_CTRL_SWRST					(0x1u << GCLK_CTRL_SWRST_Pos)
#define GCLK_CTRL_MASK					0x01u 			/**< \brief (GCLK_CTRL)Օڼ޽ */

/* -------- GCLK_STATUS : (GCLKψ:0x1) (R/   8) -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint8_t  :7;				/*!< ޯ0`6: \ */
    uint8_t  SYNCBUSY:1;		/*!< ޯ   7: Z */
  } bit;						/*!< ޯ Ɏgp\ */
  uint8_t reg;					/*!< ڼ޽ Ɏgp^ */
} GCLK_STATUS_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define GCLK_STATUS_OFFSET				0x1				/**< \brief (GCLK_STATUS offset) */
#define GCLK_STATUS_RESETVALUE			0x00			/**< \brief (GCLK_STATUS reset_value) */

#define GCLK_STATUS_SYNCBUSY_Pos		7				/**< \brief (GCLK_STATUS)Z */
#define GCLK_STATUS_SYNCBUSY			(0x1u << GCLK_STATUS_SYNCBUSY_Pos)
#define GCLK_STATUS_MASK				0x80u 			/**< \brief (GCLK_STATUS)Օڼ޽ */

/* -------- GCLK_CLKCTRL : (GCLKψ:0x2) (R/W 16)ʸۯ -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint16_t ID:6;				/*!< ޯ0` 5: ʸۯIID */
    uint16_t :2;				/*!< ޯ  6,7: \ */
    uint16_t GEN:4;				/*!< ޯ8`11: ʸۯ */
    uint16_t :2;				/*!< ޯ12,13: \ */
    uint16_t CLKEN:1;			/*!< ޯ   14: ۯ */
    uint16_t WRTLOCK:1;			/*!< ޯ   15: ݎ{ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint16_t reg;					/*!< ڼ޽ Ɏgp^ */
} GCLK_CLKCTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define GCLK_CLKCTRL_OFFSET				0x2				/**< \brief (GCLK_CLKCTRL offset)ʸۯ */
#define GCLK_CLKCTRL_RESETVALUE			0x0000			/**< \brief (GCLK_CLKCTRL reset_value)ʸۯ */

#define GCLK_CLKCTRL_ID_Pos				0				/**< \brief (GCLK_CLKCTRL)ʸۯIID */
#define GCLK_CLKCTRL_ID_Msk				(0x3Fu << GCLK_CLKCTRL_ID_Pos)
#define GCLK_CLKCTRL_ID(value)			((GCLK_CLKCTRL_ID_Msk & ((value) << GCLK_CLKCTRL_ID_Pos)))
#define GCLK_CLKCTRL_GEN_Pos			8				/**< \brief (GCLK_CLKCTRL)ʸۯ */
#define GCLK_CLKCTRL_GEN_Msk			(0xFu << GCLK_CLKCTRL_GEN_Pos)
#define GCLK_CLKCTRL_GEN(value)			((GCLK_CLKCTRL_GEN_Msk & ((value) << GCLK_CLKCTRL_GEN_Pos)))
#define   GCLK_CLKCTRL_GEN_GCLK0_Val		0x0u 		/**< \brief (GCLK_CLKCTRL)ʸۯ0 */
#define   GCLK_CLKCTRL_GEN_GCLK1_Val		0x1u 		/**< \brief (GCLK_CLKCTRL)ʸۯ1 */
#define   GCLK_CLKCTRL_GEN_GCLK2_Val		0x2u 		/**< \brief (GCLK_CLKCTRL)ʸۯ2 */
#define   GCLK_CLKCTRL_GEN_GCLK3_Val		0x3u 		/**< \brief (GCLK_CLKCTRL)ʸۯ3 */
#define   GCLK_CLKCTRL_GEN_GCLK4_Val		0x4u 		/**< \brief (GCLK_CLKCTRL)ʸۯ4 */
#define   GCLK_CLKCTRL_GEN_GCLK5_Val		0x5u 		/**< \brief (GCLK_CLKCTRL)ʸۯ5 */
#define   GCLK_CLKCTRL_GEN_GCLK6_Val		0x6u 		/**< \brief (GCLK_CLKCTRL)ʸۯ6 */
#define   GCLK_CLKCTRL_GEN_GCLK7_Val		0x7u 		/**< \brief (GCLK_CLKCTRL)ʸۯ7 */
#define GCLK_CLKCTRL_GEN_GCLK0			(GCLK_CLKCTRL_GEN_GCLK0_Val << GCLK_CLKCTRL_GEN_Pos)
#define GCLK_CLKCTRL_GEN_GCLK1			(GCLK_CLKCTRL_GEN_GCLK1_Val << GCLK_CLKCTRL_GEN_Pos)
#define GCLK_CLKCTRL_GEN_GCLK2			(GCLK_CLKCTRL_GEN_GCLK2_Val << GCLK_CLKCTRL_GEN_Pos)
#define GCLK_CLKCTRL_GEN_GCLK3			(GCLK_CLKCTRL_GEN_GCLK3_Val << GCLK_CLKCTRL_GEN_Pos)
#define GCLK_CLKCTRL_GEN_GCLK4			(GCLK_CLKCTRL_GEN_GCLK4_Val << GCLK_CLKCTRL_GEN_Pos)
#define GCLK_CLKCTRL_GEN_GCLK5			(GCLK_CLKCTRL_GEN_GCLK5_Val << GCLK_CLKCTRL_GEN_Pos)
#define GCLK_CLKCTRL_GEN_GCLK6			(GCLK_CLKCTRL_GEN_GCLK6_Val << GCLK_CLKCTRL_GEN_Pos)
#define GCLK_CLKCTRL_GEN_GCLK7			(GCLK_CLKCTRL_GEN_GCLK7_Val << GCLK_CLKCTRL_GEN_Pos)
#define GCLK_CLKCTRL_CLKEN_Pos			14				/**< \brief (GCLK_CLKCTRL)ۯ */
#define GCLK_CLKCTRL_CLKEN				(0x1u << GCLK_CLKCTRL_CLKEN_Pos)
#define GCLK_CLKCTRL_WRTLOCK_Pos		15				/**< \brief (GCLK_CLKCTRL)ݎ{ */
#define GCLK_CLKCTRL_WRTLOCK			(0x1u << GCLK_CLKCTRL_WRTLOCK_Pos)
#define GCLK_CLKCTRL_MASK				0xCF3Fu			/**< \brief (GCLK_CLKCTRL)Օڼ޽ */

/* -------- GCLK_GENCTRL : (GCLKψ:0x4) (R/W 32)ʸۯ퐧 -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t ID:4;				/*!< ޯ 0` 3: ʸۯI */
    uint32_t :4;				/*!< ޯ 4` 7: \ */
    uint32_t SRC:5;				/*!< ޯ 8`12: I */
    uint32_t :3;				/*!< ޯ13`15: \ */
    uint32_t GENEN:1;			/*!< ޯ    16: ʸۯ틖 */
    uint32_t IDC:1;				/*!< ޯ    17: ޭè ىP */
    uint32_t OOV:1;				/*!< ޯ    18: oOFFl */
    uint32_t OE:1;				/*!< ޯ    19: o͋ */
    uint32_t DIVSEL:1;			/*!< ޯ    20: I */
    uint32_t RUNSTDBY:1;		/*!< ޯ    21: ޲ős */
    uint32_t :10;				/*!< ޯ22`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} GCLK_GENCTRL_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define GCLK_GENCTRL_OFFSET				0x4				/**< \brief (GCLK_GENCTRL offset)ʸۯ퐧 */
#define GCLK_GENCTRL_RESETVALUE			0x00000000		/**< \brief (GCLK_GENCTRL reset_value)ʸۯ퐧 */

#define GCLK_GENCTRL_ID_Pos				0				/**< \brief (GCLK_GENCTRL)ʸۯI */
#define GCLK_GENCTRL_ID_Msk				(0xFu << GCLK_GENCTRL_ID_Pos)
#define GCLK_GENCTRL_ID(value)			((GCLK_GENCTRL_ID_Msk & ((value) << GCLK_GENCTRL_ID_Pos)))
#define GCLK_GENCTRL_SRC_Pos			8				/**< \brief (GCLK_GENCTRL)I */
#define GCLK_GENCTRL_SRC_Msk			(0x1Fu << GCLK_GENCTRL_SRC_Pos)
#define GCLK_GENCTRL_SRC(value)			((GCLK_GENCTRL_SRC_Msk & ((value) << GCLK_GENCTRL_SRC_Pos)))
#define   GCLK_GENCTRL_SRC_XOSC_Val			0x0u 		/**< \brief (GCLK_GENCTRL)XOSCUo */
#define   GCLK_GENCTRL_SRC_GCLKIN_Val		0x1u 		/**< \brief (GCLK_GENCTRLU߯ */
#define   GCLK_GENCTRL_SRC_GCLKGEN1_Val		0x2u 		/**< \brief (GCLK_GENCTRL)ʸۯ1 output */
#define   GCLK_GENCTRL_SRC_OSCULP32K_Val	0x3u 		/**< \brief (GCLK_GENCTRL)OSCULP32KUo */
#define   GCLK_GENCTRL_SRC_OSC32K_Val		0x4u 		/**< \brief (GCLK_GENCTRL)OSC32KUo */
#define   GCLK_GENCTRL_SRC_XOSC32K_Val		0x5u 		/**< \brief (GCLK_GENCTRL)XOSC32KUo */
#define   GCLK_GENCTRL_SRC_OSC8M_Val		0x6u 		/**< \brief (GCLK_GENCTRL)OSC8MUo */
#define   GCLK_GENCTRL_SRC_DFLL48M_Val		0x7u 		/**< \brief (GCLK_GENCTRL)DFLL48Mo */
#define GCLK_GENCTRL_SRC_XOSC			(GCLK_GENCTRL_SRC_XOSC_Val				<< GCLK_GENCTRL_SRC_Pos)
#define GCLK_GENCTRL_SRC_GCLKIN			(GCLK_GENCTRL_SRC_GCLKIN_Val	<< GCLK_GENCTRL_SRC_Pos)
#define GCLK_GENCTRL_SRC_GCLKGEN1		(GCLK_GENCTRL_SRC_GCLKGEN1_Val	<< GCLK_GENCTRL_SRC_Pos)
#define GCLK_GENCTRL_SRC_OSCULP32K		(GCLK_GENCTRL_SRC_OSCULP32K_Val	<< GCLK_GENCTRL_SRC_Pos)
#define GCLK_GENCTRL_SRC_OSC32K			(GCLK_GENCTRL_SRC_OSC32K_Val	<< GCLK_GENCTRL_SRC_Pos)
#define GCLK_GENCTRL_SRC_XOSC32K		(GCLK_GENCTRL_SRC_XOSC32K_Val	<< GCLK_GENCTRL_SRC_Pos)
#define GCLK_GENCTRL_SRC_OSC8M			(GCLK_GENCTRL_SRC_OSC8M_Val		<< GCLK_GENCTRL_SRC_Pos)
#define GCLK_GENCTRL_SRC_DFLL48M		(GCLK_GENCTRL_SRC_DFLL48M_Val	<< GCLK_GENCTRL_SRC_Pos)
#define GCLK_GENCTRL_GENEN_Pos			16				/**< \brief (GCLK_GENCTRL)ʸۯ틖 */
#define GCLK_GENCTRL_GENEN				(0x1u << GCLK_GENCTRL_GENEN_Pos)
#define GCLK_GENCTRL_IDC_Pos			17				/**< \brief (GCLK_GENCTRL)ޭè ىP */
#define GCLK_GENCTRL_IDC				(0x1u << GCLK_GENCTRL_IDC_Pos)
#define GCLK_GENCTRL_OOV_Pos			18				/**< \brief (GCLK_GENCTRL)oOFFl */
#define GCLK_GENCTRL_OOV				(0x1u << GCLK_GENCTRL_OOV_Pos)
#define GCLK_GENCTRL_OE_Pos				19				/**< \brief (GCLK_GENCTRL)o͋ */
#define GCLK_GENCTRL_OE					(0x1u << GCLK_GENCTRL_OE_Pos)
#define GCLK_GENCTRL_DIVSEL_Pos			20				/**< \brief (GCLK_GENCTRL)I */
#define GCLK_GENCTRL_DIVSEL				(0x1u << GCLK_GENCTRL_DIVSEL_Pos)
#define GCLK_GENCTRL_RUNSTDBY_Pos		21				/**< \brief (GCLK_GENCTRL)޲ős */
#define GCLK_GENCTRL_RUNSTDBY			(0x1u << GCLK_GENCTRL_RUNSTDBY_Pos)
#define GCLK_GENCTRL_MASK				0x003F1F0Fu		/**< \brief (GCLK_GENCTRL)Օڼ޽ */

/* -------- GCLK_GENDIV : (GCLKψ:0x8) (R/W 32)ʸۯ핪 -------- */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef union {
  struct {
    uint32_t ID:4;				/*!< ޯ 0` 3: ʸۯI  */
    uint32_t :4;				/*!< ޯ 4` 7: \ */
    uint32_t DIV:16;			/*!< ޯ 8`23: W */
    uint32_t :8;				/*!< ޯ24`31: \ */
  } bit;						/*!< ޯ Ɏgp\ */
  uint32_t reg;					/*!< ڼ޽ Ɏgp^ */
} GCLK_GENDIV_Type;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

#define GCLK_GENDIV_OFFSET				0x8				/**< \brief (GCLK_GENDIV offset)ʸۯ핪 */
#define GCLK_GENDIV_RESETVALUE			0x00000000		/**< \brief (GCLK_GENDIV reset_value)ʸۯ핪 */

#define GCLK_GENDIV_ID_Pos				0				/**< \brief (GCLK_GENDIV)ʸۯI */
#define GCLK_GENDIV_ID_Msk				(0xFu << GCLK_GENDIV_ID_Pos)
#define GCLK_GENDIV_ID(value)			((GCLK_GENDIV_ID_Msk & ((value) << GCLK_GENDIV_ID_Pos)))
#define GCLK_GENDIV_DIV_Pos				8				/**< \brief (GCLK_GENDIV)W */
#define GCLK_GENDIV_DIV_Msk				(0xFFFFu << GCLK_GENDIV_DIV_Pos)
#define GCLK_GENDIV_DIV(value)			((GCLK_GENDIV_DIV_Msk & ((value) << GCLK_GENDIV_DIV_Pos)))
#define GCLK_GENDIV_MASK				0x00FFFF0Fu		/**< \brief (GCLK_GENDIV)Օڼ޽ */

/** \brief GCLKʰ޳ ڼ޽ */
#if !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__))
typedef struct {
  __IO GCLK_CTRL_Type		CTRL;		/**< \briefψ:0x0 (R/W  8) */
  __I  GCLK_STATUS_Type		STATUS;		/**< \briefψ:0x1 (R/   8) */
  __IO GCLK_CLKCTRL_Type	CLKCTRL;	/**< \briefψ:0x2 (R/W 16)ʸۯ */
  __IO GCLK_GENCTRL_Type	GENCTRL;	/**< \briefψ:0x4 (R/W 32)ʸۯ퐧 */
  __IO GCLK_GENDIV_Type		GENDIV;		/**< \briefψ:0x8 (R/W 32)ʸۯ핪 */
} Gclk;
#endif /* !(defined(__ASSEMBLY__) || defined(__IAR_SYSTEMS_ASM__)) */

/*@}*/

#endif /* _SAMD21_GCLK_COMPONENT_ */
